Package: simona
Type: Package
Title: Semantic Similarity on Bio-Ontologies
Version: 1.10.0
Date: 2026-01-30
Authors@R: person("Zuguang", "Gu", email = "guzuguang@suat-sz.edu.cn", role = c("aut", "cre"),
                  comment = c('ORCID'="0000-0002-7395-8709"))
Depends: R (>= 4.1.0)
Imports: methods, Rcpp, matrixStats, GetoptLong, grid, GlobalOptions,
        igraph, Polychrome, S4Vectors, xml2 (>= 1.3.3), circlize,
        ComplexHeatmap, grDevices, stats, utils, shiny, fastmatch
Suggests: knitr, testthat, BiocManager, GO.db, org.Hs.eg.db, proxyC,
        AnnotationDbi, Matrix, DiagrammeR, ragg, png,
        InteractiveComplexHeatmap, UniProtKeywords, simplifyEnrichment,
        AnnotationHub, jsonlite
LinkingTo: Rcpp
VignetteBuilder: knitr
Description: This package implements infrastructures for ontology analysis by offering 
    efficient data structures, fast ontology traversal methods, and elegant visualizations. 
    It provides a robust toolbox supporting over 70 methods for semantic similarity analysis.
biocViews: Software, Annotation, GO, BiomedicalInformatics
URL: https://github.com/jokergoo/simona
BugReports: https://github.com/jokergoo/simona/issues
SystemRequirements: Perl, Java
License: MIT + file LICENSE
RoxygenNote: 7.3.2
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
git_url: https://git.bioconductor.org/packages/simona
git_branch: RELEASE_3_23
git_last_commit: 3c729fd
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-29 00:44:33 UTC; biocbuild
Author: Zuguang Gu [aut, cre] (ORCID: <https://orcid.org/0000-0002-7395-8709>)
Maintainer: Zuguang Gu <guzuguang@suat-sz.edu.cn>

#' Distance on the DAG
#' 
#' @param dag An `ontology_DAG` object.
#' @param terms A vector of term names.
#' @param verbose Whether to print messages.
#' 
#' @details
#' Denote two terms as `a` and `b`, a common ancestor as `c`, and the distance function `d()` calculates the longest
#' distance or the shortest distance depending on the function.
#' 
#' - `shortest_distances_via_NCA()`: It calculates the smallest `d(c, a) + d(c, b)` where `d()` calculates the shortest distance between two terms. In this case,
#'     `c` is the NCA (nearest common ancestor) of `a` and `b`.
#' - `longest_distances_via_LCA()`: It calculates the largest `d(c, a) + d(c, b)` where `d()` calculates the longest distance between two terms *via the LCA (lowest common ancestor) term*. In this case,
#'     `c` is the LCA of `a` and `b`.
#' - `shortest_distances_directed()`: It calculates `d(a, b)` where `d()` calculates the shortest distance between two terms. The distance is only calculated when `a` is an ancestor of `b`, otherwise the distance value is -1.
#' - `longest_distances_directed()`: It calculates `d(a, b)` where `d()` calculates the longest distance between two terms. The distance is only calculated when `a` is an ancestor of `b`, otherwise the distance value is -1.
#' @rdname distance
#' @export
#' @returns A numeric distance matrix.
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' shortest_distances_via_NCA(dag, letters[1:6])
#' longest_distances_via_LCA(dag, letters[1:6])
#' shortest_distances_directed(dag, letters[1:6])
#' longest_distances_directed(dag, letters[1:6])
shortest_distances_via_NCA = function(dag, terms, verbose = simona_opt$verbose) {
	if(is.character(terms)) {
		id = term_to_node_id(dag, terms, strict = FALSE)
	} else {
		id = terms
	}
	if(any(duplicated(id))) {
		stop("`term` should not be duplicated.")
	}
	d = exec_under_message_condition({
		cpp_shortest_distances_via_NCA(dag, id)
	}, verbose = verbose)

	dimnames(d) = list(dag@terms[id], dag@terms[id])
	d
}

#' @rdname distance
#' @export
longest_distances_via_LCA = function(dag, terms, verbose = simona_opt$verbose) {
	if(is.character(terms)) {
		id = term_to_node_id(dag, terms, strict = FALSE)
	} else {
		id = terms
	}
	if(any(duplicated(id))) {
		stop("`term` should not be duplicated.")
	}
	d = exec_under_message_condition({
		cpp_max_ancestor_path_sum_value(dag, id, dag_depth(dag), rep(1, dag@n_terms)) - 1
	}, verbose = verbose)

	dimnames(d) = list(dag@terms[id], dag@terms[id])
	d
}

#' @rdname distance
#' @export
shortest_distances_directed = function(dag, terms, verbose = simona_opt$verbose) {
	if(is.character(terms)) {
		id = term_to_node_id(dag, terms, strict = FALSE)
	} else {
		id = terms
	}
	if(any(duplicated(id))) {
		stop("`term` should not be duplicated.")
	}
	d = exec_under_message_condition({
		cpp_shortest_distances_directed(dag, id)
	}, verbose = verbose)

	dimnames(d) = list(dag@terms[id], dag@terms[id])
	d
}

#' @rdname distance
#' @export
longest_distances_directed = function(dag, terms, verbose = simona_opt$verbose) {
	if(is.character(terms)) {
		id = term_to_node_id(dag, terms, strict = FALSE)
	} else {
		id = terms
	}
	if(any(duplicated(id))) {
		stop("`term` should not be duplicated.")
	}
	d = exec_under_message_condition({
		cpp_longest_distances_directed(dag, id)
	}, verbose = verbose)

	dimnames(d) = list(dag@terms[id], dag@terms[id])
	d
}


longest_distances_from_LCA = function(dag, id, verbose = simona_opt$verbose) {
	exec_under_message_condition({
		cpp_longest_distances_from_LCA(dag, id)
	}, verbose = verbose)
}

library(testthat)


#### test a small dag

#   b--d--f
#  / \
# a---c--e
# upstream -> downstream
annotation = list(
	"a" = 1:3,
	"b" = 3:4,
	"c" = 5,
	"d" = 7,
	"e" = 4:7,
	"f" = 8
)

parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")

dag = create_ontology_DAG(parents, children, relations = c("is_a", "part_of", "is_a", "part_of", "is_a", "part_of"), 
	annotation = annotation)


group1 = c("c", "e", "d")
group2 = c("b", "d", "f")


for(method in all_group_sim_methods()) {
	cat(method, "\n")
	print(group_sim(dag, group1, group2, method = method))
}

#' Number of annotated items
#' 
#' @param dag An `ontology_DAG` object.
#' @param terms A vector of term names. If it is set, the returned vector will be subsetted to the terms that have been set here.
#' @param uniquify Whether to uniquify items that are annotated to the term? See **Details**. It is suggested to always be `TRUE`.
#' @param use_cache Internally used.
#' 
#' @details
#' Due to the nature of the DAG, a parent term includes all annotated items of its child terms, and an ancestor term includes
#' all annotated items from its offspring recursively. In current tools, there are two different implementations to deal with
#' such recursive merging.
#' 
#' For a term `t`, denote `S_1`, `S_2`, ... as the sets of annotated items for its child 1, 2, ..., also denote `S_t` as the set
#' of items that are **directly** annotated to `t`. The first method takes the union of annotated items on `t` and all its child terms:
#' 
#' ```
#' n = length(union(S_t, S_1, S_2, ...))
#' ```
#' 
#' And the second method takes the sum of numbers of items on `t` and on all its child terms:
#' 
#' ```
#' n = sum(length(s_t) + length(S_1) + length(S_2) + ...)
#' ```
#' 
#' In `n_annotations()`, when `uniquify = TRUE`, the first method is used; and when `uniquify = FALSE`, the second method is used.
#' 
#' For some annotation sources, it is possible that an item is annotated to multiple terms, thus, the second method which simply
#' adds numbers of all its child terms may not be proper because an item may be counted duplicatedly, thus over-estimating `n`. The two methods
#' are identical only if an item is annotated to a unique term in the DAG.
#' 
#' We suggest to always set `uniquify = TRUE` (the default), and the scenario of `uniquify = FALSE` is only for the testing or benchmarking purpose. 
#' 
#' @returns `n_annotations()` returns an integer vector.
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' annotation = list(
#'     "a" = c("t1", "t2", "t3"),
#'     "b" = c("t3", "t4"),
#'     "c" = "t5",
#'     "d" = "t7",
#'     "e" = c("t4", "t5", "t6", "t7"),
#'     "f" = "t8"
#' )
#' dag = create_ontology_DAG(parents, children, annotation = annotation)
#' n_annotations(dag)
n_annotations = function(dag, terms = NULL, uniquify = simona_opt$anno_uniquify, use_cache = simona_opt$use_cache) {
	if(!uniquify && is.null(dag@term_env$n_annotations)) {
		use_cache = FALSE
	} else if(uniquify && is.null(dag@term_env$n_annotations_unique)) {
		use_cache = FALSE
	}
	if(!use_cache) {
		validate_dag_has_annotation(dag)
	
		n = cpp_n_annotations(dag, uniquify)
		
		attr(n, "N") = max(n)

		if(uniquify) {
			dag@term_env$n_annotations_unique = n
		} else {
			dag@term_env$n_annotations = n
		}
	}
	
	if(uniquify) {
		n = structure(dag@term_env$n_annotations_unique, names = dag@terms)
	} else {
		n = structure(dag@term_env$n_annotations, names = dag@terms)
	}	
	
	if(!is.null(terms)) {
		i = term_to_node_id(dag, terms)
		n[i]
	} else {
		n
	}

}

#' @rdname n_annotations
#' @returns `has_annotation()` returns a logical scalar.
has_annotation = function(dag) {
	length(dag@annotation$list) > 0
}

validate_dag_has_annotation = function(dag) {
	if(length(dag@annotation$list) == 0) {
		stop("`annotation` should be set in `create_ontology_DAG()`.")
	}
}


# remove terms with zero annotation
validate_annotated_terms = function(dag, id) {
	n_anno = n_annotations(dag)[id]

	l1 = n_anno == 0
	if(any(l1)) {
		message("remove ", sum(l1), " terms with no annotation.")
		
		if(length(sum(!l1)) == 0) {
			stop("No term is left.")
		}
	}

	!l1 
}


#' Term-item associations
#' 
#' @param dag An `ontology_DAG` object.
#' @param terms A vector of term names.
#' @param return Whether the returned object is a list or a matrix?
#' 
#' @details
#' If an item is annotated to a term, all this term's ancestor terms are also annotated.
#' 
#' @rdname annotation
#' @return
#' A list or a binary matrix showing annotation relations between terms and items.
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' annotation = list(
#'     "a" = c("t1", "t2", "t3"),
#'     "b" = c("t3", "t4"),
#'     "c" = "t5",
#'     "d" = "t7",
#'     "e" = c("t4", "t5", "t6", "t7"),
#'     "f" = "t8"
#' )
#' dag = create_ontology_DAG(parents, children, annotation = annotation)
#' term_annotations(dag, letters[1:6])
#' term_annotations(dag, letters[1:6], return = "matrix")
#' annotated_terms(dag, c("t1", "t2", "t3"))
#' annotated_terms(dag, c("t1", "t2", "t3"), return = "matrix")
term_annotations = function(dag, terms, return = "list") {
	validate_dag_has_annotation(dag)

	id = term_to_node_id(dag, terms, strict = FALSE)

	m = cpp_get_term_annotations(dag, id)
	rownames(m) = dag@terms[id]
	colnames(m) = dag@annotation$names
	
	if(return == "matrix") {
		m
	} else {
		cn = colnames(m)
		apply(m, 1, function(x) {
			cn[x > 0]
		}, simplify = FALSE)
	}
}

#' @param anno A vector of annotated item names.
#' 
#' @rdname annotation
#' @export
annotated_terms = function(dag, anno, return = "list") {
	validate_dag_has_annotation(dag)

	id = which(dag@annotation$names %in% anno)
	if(length(id) == 0) {
		stop("Cannot find `anno` in DAG annotations.")
	}

	m = cpp_get_annotated_terms(dag, id)
	rownames(m) = dag@annotation$names[id]
	colnames(m) = dag@terms

	if(return == "matrix") {
		m
	} else {
		cn = colnames(m)
		apply(m, 1, function(x) {
			cn[x > 0]
		}, simplify = FALSE)
	}
}

#' Reduce the DAG to a tree
#' 
#' @param dag An `ontology_DAG` object.
#' @param verbose Whether to print messages.
#' 
#' @details
#' A tree is a reduced DAG where a child only has one parent. The reducing is applied by a breadth-first searching
#' 
#' Starting from the root and on a certain depth (the depth is the maximal distance to root), for every term `t` on this depth,
#' its child term `c` and parent-child relation are kept only when `depth(c) == depth(t) + 1`. If `c` is selected, it is
#' marked as visited and will not be checked again.
#' 
#' In this way, depths of all terms in the orignal DAG are still identical to the depths in the tree (see the Examples section).
#' 
#' @returns A tree is also an `ontology_DAG` object.
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' tree = dag_treelize(dag)
#' d1 = dag_depth(dag)
#' d2 = dag_depth(tree)
#' identical(d1, d2)
#' 
#' dend = dag_as_dendrogram(tree)
#' dend
dag_treelize = function(dag, verbose = simona_opt$verbose) {

	if(dag_is_tree(dag)) {
		return(dag)
	}

	lt_children2 = exec_under_message_condition({
		cpp_mark_tree_links(dag)
	}, verbose = verbose)

	lt_parents2 = cpp_tree_lt_parents_from_children(lt_children2)
	lt_children2 = lapply(lt_children2, function(x) {
		abs(x[x < 0])
	})
	
	tree = dag

	tree@lt_children = lt_children2
	tree@lt_parents = lt_parents2

	tree@lt_children_relations = list()
	tree@relations_DAG = NULL
	tree@source = paste0(tree@source, ", treelized")

	n_terms = dag@n_terms

	tree@n_relations = sum(vapply(tree@lt_children, length, FUN.VALUE = integer(1)))

	tree@leaves = which(vapply(lt_children2, length, FUN.VALUE = integer(1)) == 0)

	tree@term_env = new.env(parent = emptyenv())

	tree@term_env$n_parents = vapply(lt_parents2, length, FUN.VALUE = integer(1))
	tree@term_env$n_children = vapply(lt_children2, length, FUN.VALUE = integer(1))

	tpl_order = order(dag_depth(tree), tree@term_env$n_children, tree@term_env$n_parents, tree@terms)
	tree@tpl_sorted = seq_len(n_terms)[tpl_order]
	tree@tpl_pos = seq_len(n_terms)
	
	# pos has the same order as terms, but the value are the positions on `sorted`, i.e. the rank
	tree@tpl_pos[tpl_order] = seq_len(n_terms)

	depth = dag_depth(tree)
	tb1 = table(depth)
	aspect_ratio1 = max(tb1)/quantile(depth, 0.99)
	aspect_ratio1 = round(aspect_ratio1, 2)

	tree@aspect_ratio = c(aspect_ratio1, aspect_ratio1)

	tree
}

#' @rdname dag_treelize
#' @export
#' @details
#' `dag_as_dendrogram()` coverts the tree to a `dendrogram` object.
dag_as_dendrogram = function(dag) {

	if(!dag_is_tree(dag)) {
		stop("dag is not a tree. run `dag_treelize()` first.")
	}

	add_dend = function(node, lt_children, height) {
		if(length(lt_children[[node]]) == 0) {			
			dend = node
			attributes(dend) = list(members = 1, 
				                    height = height, 
				                    label = dag@terms[node], 
				                    term_id = node, 
				                    n_nodes = 1,
				                    max_dist_to_leaf = 0,
				                    leaf = TRUE, 
				                    class = "dendrogram")
		} else {
			dend = lapply(lt_children[[node]], add_dend, lt_children, height - 1)
			attributes(dend) = list(members = length(unlist(dend)), 
				                    height = height, 
				                    label = dag@terms[node], 
				                    term_id = node, 
				                    n_nodes = 1 + sum(vapply(dend, function(x) attr(x, "n_nodes"), FUN.VALUE = numeric(1))),
				                    max_dist_to_leaf = 1 + max(vapply(dend, function(x) attr(x, "max_dist_to_leaf"), FUN.VALUE = numeric(1))),
				                    leaf = FALSE, 
				                    class = "dendrogram")
		}
		dend
	}

	max_depth = max(dag_depth(dag))
	dend = add_dend(dag@root, dag@lt_children, max_depth)

	dend = dend_set_midpoint(dend)
	class(dend) = c("ontology_tree", "dendrogram")

	dend
}


#' @param x An `ontology_DAG` object.
#' @param ... Ignored.
#' @rdname dag_treelize
#' @export
print.ontology_tree = function(x, ...) {
	cat("This is a normal `dendrogram` object, but with several more attributes attached to each node:\n")
	cat("  - label: term name\n")
	cat("  - term_id: the integer index of the term\n")
	cat("  - n_nodes: number of offspring terms, including itself\n")
	cat("  - members: this is the standard attribute, which is the number of leaves the term can reach to\n")
	cat("  - max_dist_to_leaf: max distance to the term's leaves\n")
	cat(" \n")
	getFromNamespace("print.dendrogram", "stats")(x)
}

dend_add_x = function(dend) {

	env = new.env(parent = emptyenv())
	i_leaf = 0

	add_x = function(dend) { # current sub-dend
		if(attr(dend, "leaf")) {
			i_leaf <<- i_leaf + 1
			x = i_leaf
			attr(dend, "x") = x
			attr(dend, "width") = 0
		} else {
			k = length(dend) # number of sub-dend
			for(i in seq_len(k)) {
				dend[[i]] = add_x(dend[[i]])
			}
			x = (attr(dend[[1]], "x") + attr(dend[[k]], "x"))/2
			attr(dend, "x") = x
			attr(dend, "width") = attr(dend[[k]], "x") - attr(dend[[1]], "x")
		}
		dend
	}

	add_x(dend)
}

dend_set_midpoint = function(dend) {

	dend = dend_add_x(dend)
	
	add_midpoint = function(dend) {
		if(attr(dend, "leaf")) {
			attr(dend, "midpoint") = 0
		} else {
			k = length(dend)
			for(i in seq_len(k)) {
				dend[[i]] = add_midpoint(dend[[i]])
			}
			midpoint = attr(dend[[1]], "midpoint") + attr(dend, "width")/2
			
			attr(dend, "midpoint") = midpoint
		}
		dend
	}

	add_midpoint(dend)
}


dend_sort = function(dend, by = "n_nodes", decreasing = TRUE) {

	if(!by %in% names(attributes(dend))) {
		stop("cannot find attribute:", by)
	}

	reorder = function(dend) {
		k = length(dend)
		if(k > 1) {
			v = vapply(dend, function(x) attr(x, by), FUN.VALUE = numeric(1))
			attr = attributes(dend)

			dend = dend[order(v, decreasing = decreasing)]
			attributes(dend) = attr
			attr(dend, "width") = attr(dend[[k]], "x") - attr(dend[[1]], "x")

			for(i in seq_len(k)) {
				dend[[i]] = reorder(dend[[i]])
			}
		}
		dend
	}

	dend = reorder(dend)
	dend_set_midpoint(dend)
}

dag = create_ontology_DAG(c("a-h", "a-b", "a-c", "a-d", "b-e", "b-f", "c-g", "h-g", "d-e"))



lt_children2 = cpp_mark_tree_links(dag)
lt_children2 = lapply(lt_children2, function(x) {
	abs(x[x < 0])
})

n = length(lt_children2)
parents = rep(seq_len(n), times = vapply(lt_children2, length, FUN.VALUE = integer(1)))
children = unlist(lt_children2)

tree1 = create_ontology_DAG(dag@terms[parents], dag@terms[children])
	
tree2 = dag_treelize(dag)


test_that("test dag_treelize", {
	expect_identical(tree1@lt_children, tree2@lt_children)
	expect_identical(tree1@lt_parents, tree2@lt_parents)
	expect_identical(dag@terms, tree1@terms)
	expect_identical(dag@terms, tree2@terms)
})

#' @importFrom utils packageDescription
.onAttach = function(libname, pkgname) {
    version = packageDescription(pkgname, fields = "Version")

    msg = paste0("========================================
", pkgname, " version ", version, "
Bioconductor page: http://bioconductor.org/packages/simona/
Github page: https://github.com/jokergoo/simona
Documentation: https://jokergoo.github.io/simona/

If you use it in published research, please cite:
Gu, Z. simona: a Comprehensive R package for Semantic Similarity 
  Analysis on Bio-Ontologies. BMC Genomics, 2024.

This message can be suppressed by:
  suppressPackageStartupMessages(library(simona))
========================================
")  

    packageStartupMessage(msg)
}


finalize = function(env) {
   if(!is.null(simona_opt$robot_jar)) {
		if(grepl("robot_temp_", simona_opt$robot_jar)) {
			if(file.exists(simona_opt$robot_jar)) {
				file.remove(simona_opt$robot_jar)
				simona_opt$robot_jar = NULL
			}
		}
	}
}

.onLoad = function(libname, pkgname) {
   parent = parent.env(environment())
   reg.finalizer(parent, finalize, onexit = TRUE)
}

.onUnload = function(libpath) {
	if(!is.null(simona_opt$robot_jar)) {
		if(grepl("robot_temp_", simona_opt$robot_jar)) {
			if(file.exists(simona_opt$robot_jar)) {
				file.remove(simona_opt$robot_jar)
				simona_opt$robot_jar = NULL
			}
		}
	}
}

#' Partition the DAG
#' 
#' @param dag An `ontology_DAG` object.
#' @param level Depth in the DAG to cut. The DAG is cut below terms (or cut the links to their child terms) with `depth == level`.
#' @param from A list of terms to cut. If it is set, `level` is ignored.
#' @param term_pos Internally used.
#' 
#' @details
#' Let's call the terms below the `from` term as "top terms" because they will be on top of the sub-DAGs after the partitioning.
#' It is possible that a term in the middle of the DAG can be traced back to more than one top terms.
#' To partition all terms exclusively, a term partitioned to the sub-DAG from the top term with the largest distance to the term.
#' If a term has the same largest distances to several top terms, a random top term is selected.
#' 
#' In `partition_by_size()`, the DAG is first reduced to a tree where a child term only has one parent. 
#' The partition is done recursively by cutting into its child-trees. 
#' The splitting stops when all the child-trees have size less than `size`.
#' 
#' `NA` is assigned to the `from` terms, their ancestor terms, and terms having infinite directed distance to `from` terms.
#' 
#' @export
#' @returns A character vector of top terms in each partition.
#' @examples
#' \donttest{
#' dag = create_ontology_DAG_from_GO_db()
#' pa = partition_by_level(dag)
#' table(pa)
#' pa = partition_by_size(dag, size = 1000)
#' table(pa)
#' }
#' 1
partition_by_level = function(dag, level = 1, from = NULL, term_pos = NULL) {

	if(is.null(from)) {
		depth = dag_depth(dag)
		max_depth = max(depth)
		if(level < 0 && level >= max_depth) {
			stop("wrong value of `level`.")
		}
		from = which(depth == level)
	} else {
		from = term_to_node_id(dag, from, strict = FALSE)
	}

	if(is.null(term_pos)) {
		if(dag_is_tree(dag)) {
			tree = dag
		} else {
			tree = dag_treelize(dag)
		}
		term_pos = cpp_node_pos_in_tree(tree, n_offspring(dag), 1, 360) ## in polar coordinate
	}

	from = from[order(term_pos[from, "h"])]
	range = data.frame(left = term_pos[from, "x"] - term_pos[from, "width"]/2,
		               right = term_pos[from, "x"] + term_pos[from, "width"]/2)

	partition = rep(NA_character_, dag@n_terms)
	all_offspring = setdiff(seq_len(dag@n_terms), dag_ancestors(dag, from, in_labels = FALSE))
	l_offspring = rep(FALSE, dag@n_terms)
	l_offspring[all_offspring] =  TRUE
	for(i in seq_along(from)) {
		l = term_pos$x >= range$left[i] & term_pos$x <= range$right[i] & l_offspring
		partition[l] =  dag@terms[ from[i] ]
	}

	partition
}

#' @param size Number of terms in a cluster. The splitting stops on a term if all its child-trees are smaller than `size`.
#' @rdname partition_by_level
#' @importFrom stats dendrapply
#' @export
partition_by_size = function(dag, size = round(dag_n_terms(dag)/5)) {
	
	tree = dag_treelize(dag)
	
	pa = cpp_partition_by_size(tree, as.integer(size))
	pa[pa < 0] = NA

	tree@terms[pa]
}

library(testthat)


dag = create_ontology_DAG(
	c("a - b",
	  "a - c",
	  "a - d",
	  "b - e",
	  "b - f",
	  "c - g", 
	  "d - h",
	  "g - i",
	  "g - j",
	  "h - k",
	  "h - l",
	  "i - m",
	  "j - n",
	  "k - o",
	  "l - p")
)

test_that("test partition_by_level", {
	expect_equal(
		partition_by_level(dag, level = 0),
		rep("a", 16)
	)
	expect_equal(
		partition_by_level(dag, level = 1),
		c(NA, "b", "c", "d", "b", "b", "c", "d", "c", "c", "d", "d", "c", "c", "d", "d")
	)
	expect_equal(
		partition_by_level(dag, level = 2),
		c(NA, NA, NA, NA, "e", "f", "g", "h", "g", "g", "h", "h", "g", "g", "h", "h")
	)
	
})

test_that("test partition_by_size", {
	expect_equal(
		partition_by_size(dag, size = 3),
		c(NA, "b", NA, NA, "b", "b", "g", "h", "g", "g", "h", "h", "g", "g", "h", "h")
	)

	expect_equal(
		partition_by_size(dag, size = 6),
		c(NA, "b", "c", "d", "b", "b", "c", "d", "c", "c", "d", "d", "c", "c", "d", "d")
	)
})

## uniprot keywords


library(UniProtKeywords)

data(kw_parents)

parents = unlist(kw_parents)
children = rep(names(kw_parents), times = sapply(kw_parents, length))

dag = create_ontology_DAG(parents, children)

data(kw_terms)

meta = data.frame(
	id = sapply(kw_terms, function(x) x$Identifier),
	accession = sapply(kw_terms, function(x) x$Accession),
	name = sapply(kw_terms, function(x) x$Identifier),
	description = sapply(kw_terms, function(x) x$Description),
	category = sapply(kw_terms, function(x) paste(x$Category, collapse = "; "))
)
rownames(meta) = meta$id
meta = meta[dag@terms, ]
rownames(meta)[nrow(meta)] = simona:::SUPER_ROOT

mcols(dag) = meta

annotation = load_keyword_genesets("9606")
dag = add_annotation(dag, annotation)


## The Human Phenotype Ontology

# https://hpo.jax.org/app/data/annotations

dag = import_obo("https://github.com/obophenotype/human-phenotype-ontology/releases/download/v2023-10-09/hp-base.obo")

tb = read.table(url("https://github.com/obophenotype/human-phenotype-ontology/releases/download/v2023-10-09/genes_to_phenotype.txt"), sep = "\t", header = TRUE)
annotation = split(tb$ncbi_gene_id, tb$hpo_id)

dag = add_annotation(dag, annotation)


## Pathway ontology and many

# https://download.rgd.mcw.edu/ontology/

library(rvest)

html = read_html("https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/")
tb = html %>% html_element("table") %>% html_table()
fn = tb[grep("_genes_", tb[[2]]), ][[2]]
tb = data.frame(org = gsub("_.*$", "", fn),
	            onto = gsub("^.*_", "", fn))
tb = tb[!tb$onto %in% c("go", "nbo", "mp", "cmo"), ]
tb = tb[order(tb$onto), ]

tb$anno_url = paste0("https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/", tb$org, "_genes_", tb$onto)

onto = c("chebi" = "https://purl.obolibrary.org/obo/chebi.obo",
	     "pw" = "https://download.rgd.mcw.edu/ontology/pathway/pathway.obo",
	     "rdo" = "https://download.rgd.mcw.edu/ontology/disease/RDO.obo",
	     "vt" = "https://purl.obolibrary.org/obo/vt.owl",
	     "hp" = "https://purl.obolibrary.org/obo/hp.obo")

tb$onto_url = onto[tb$onto]
## MeSH

dag = import_ttl("https://data.bioontology.org/ontologies/MESH/submissions/26/download?apikey=8b5b7825-538d-40e0-9e9e-5ab9274a9aeb")

	      
#' Import ontology file to an ontology_DAG object
#' 
#' @param file Path of the ontology file or an URL.
#' @param relation_type Semantic relation types to include. Note `is_a` relation is always included.
#' @param inherit_relations Relations may also be structured as a DAG. It controls whether to merge with a relations's offspring relations.
#' @param verbose Whether to print messages.
#' @param ... Pass to [`create_ontology_DAG()`].
#' 
#' @details 
#' 
#' Public bio-ontologies can be obtained from [Ontology Foundry](http://obofoundry.org/) or [BioPortal](https://bioportal.bioontology.org/). 
#' 
#' The `import_obo()` function parses the ontology file in `.obo` format. To parse other formats, external tool `robot.jar` is required.
#' 
#' @return An `ontology_DAG` object.
#' @export
#' @importFrom utils read.csv
#' @examples
#' \donttest{
#' # The plant ontology: http://obofoundry.org/ontology/po.html 
#' import_obo("https://raw.githubusercontent.com/Planteome/plant-ontology/master/po.obo")
#' }
import_obo = function(file, relation_type = character(0), inherit_relations = TRUE, verbose = simona_opt$verbose, ...) {
	
	if(grepl("^(http|https|ftp)://.*\\.gz$", file)) {
		op = getOption("timeout")
		options(timeout = 999999999)
		on.exit(options(timeout = op))
		con = url(file)
		con2 = gzcon(con)
		ln = readLines(con2)
		close(con)
		close(con2)
	} else if(grepl("\\.gz$", file)) {
		con2 = gzfile(file)
		ln = readLines(con2)
		close(con2)
	} else if(grepl("^(http|https|ftp)://", file)) {
		op = getOption("timeout")
		options(timeout = 999999999)
		on.exit(options(timeout = op))
		con = url(file)
		ln = readLines(con)
		close(con)
	} else {
		ln = readLines(file)
	}

	ind_stanza = c(grep("^\\[.*\\]$", ln), length(ln))

	### relations ###
	ind1 = grep("^\\[Typedef\\]$", ln)
	ind2 = cpp_match_index(ind1, ind_stanza[-1]-1)
	n = length(ind1)

	if(n) {

		lt_relations = vector("list", n)
		for(i in seq_len(n)) {
			if(i %% 1000 == 0) {
				if(verbose) message(strrep("\b", 100), "Parsing [Typedef] sections in the obo file [", i, "/", n, "]", appendLF = FALSE)
			}
			lt_relations[[i]] = process_obo_stanza(ln[seq(ind1[i], ind2[i])])
		}
		if(verbose) message(strrep("\b", 100), "Parsing [Typedef] sections in the obo file [", n, "/", n, "]", appendLF = TRUE)

		## relations
		lt = .wrap_relations(lt_relations, type = "relation")
		relation_meta = lt$meta
		relation_relations = lt$relations
		alternative_terms = lt$alternative_terms
	} else {
		relation_meta = data.frame()
		relation_relations = data.frame()
		alternative_terms = list()
	}

	relations_id_to_name = structure(ifelse(is.na(relation_meta$name), relation_meta$id, relation_meta$name), names = relation_meta$id)
	relations_id_to_name["is_a"] = "is_a"
	
	if(nrow(relation_relations)) {
		
		relation_relations$parent = unname(relations_id_to_name[relation_relations$parent])
		relation_relations$child = unname(relations_id_to_name[relation_relations$child])

		suppressWarnings(suppressMessages(relations_DAG <- create_ontology_DAG(relation_relations$parent, relation_relations$child)))

		if(inherit_relations) {
			relation_type = merge_offspring_relation_types(relations_DAG, relation_type)
		}
	} else {
		relations_DAG = NULL
	}

	### term ###
	ind1 = grep("^\\[Term\\]$", ln)
	ind2 = cpp_match_index(ind1, ind_stanza[-1]-1)
	n = length(ind1)

	if(n == 0) {
		stop("Cannot find any [Term].")
	}

	lt_terms = vector("list", n)
	for(i in seq_len(n)) {
		if(i %% 1000 == 0) {
			if(verbose) message(strrep("\b", 100), "Parsing [Term] sections in the obo file [", i, "/", n, "]", appendLF = FALSE)
		}
		lt_terms[[i]] = process_obo_stanza(ln[seq(ind1[i], ind2[i])], relation_type)
	}
	if(verbose) message(strrep("\b", 100), "Parsing [Term] sections in the obo file [", n, "/", n, "]", appendLF = TRUE)

	lt = .wrap_relations(lt_terms, type = "term")
	term_meta = lt$meta
	term_relations = lt$relations
	alternative_terms = lt$alternative_terms

	term_relations$relation = unname(relations_id_to_name[term_relations$relation])

	## some meta for the whole ontology
	for(i in seq_along(ln)) {
		if(grepl("^\\[", ln[i])) {
			break
		}
	}
	version = gsub("data-version: ", "", grep("^data-version:", ln[seq_len(i-1)], value = TRUE))
	ontology = gsub("ontology: ", "", grep("^ontology:", ln[seq_len(i-1)], value = TRUE))
	default_namespace = gsub("default-namespace: ", "", grep("^default-namespace:", ln[seq_len(i-1)], value = TRUE))

	if(length(default_namespace)) {
		term_meta$namespace[is.na(term_meta$namespace)] = default_namespace
	}

	term_meta = term_meta[term_meta$id %in% c(term_relations$parent, term_relations$child), , drop = FALSE]
	internal_id = term_meta$short_id
	dd = internal_id[duplicated(internal_id)]
	ldd = internal_id %in% dd
	internal_id[ldd] = term_meta$id[ldd]
	idmap = structure(internal_id, names = term_meta$id)
	
	dag = create_ontology_DAG(parents = idmap[term_relations$parent], children = idmap[term_relations$child], relations = term_relations$relation,
		source = paste0(ontology, ", ", version), relations_DAG = relations_DAG, alternative_terms = alternative_terms, verbose = verbose, ...)
	rownames(term_meta) = internal_id

	term_meta = term_meta[dag@terms, , drop = FALSE]
	
	if(dag_root(dag) == SUPER_ROOT) {
		term_meta$id[dag@root] = SUPER_ROOT
		term_meta$name[dag@root] = SUPER_ROOT
		term_meta$short_id[dag@root] = SUPER_ROOT
	}

	mcols(dag) = term_meta

	dag
}

# validate relations
.validate_relations = function(lt_data) {
	is_obsolete = vapply(lt_data, "[[", "is_obsolete", FUN.VALUE = character(1)) == "true"
	if(any(is_obsolete)) {
		message("remove ", sum(is_obsolete), " obsolete terms")
	}
	lt_data = lt_data[!is_obsolete]

	all_terms = vapply(lt_data, "[[", "id", FUN.VALUE = character(1))
	n_terms = length(all_terms)
	
	lt = lapply(lt_data, "[[", "relationship")

	lt2 = intersectToList_logical(lt, all_terms)
	for(i in seq_len(n_terms)) {
		if(any(lt2[[i]])) {
			lt_data[[i]]$relationship = lt_data[[i]]$relationship[ lt2[[i]] ]
		} else {
			lt_data[[i]]$relationship = character(0)
		}
	}

	lt_data
}

.wrap_relations = function(lt_data, type = "term") {

	if(type == "term") {		
		l = sapply(lt_data, function(x) x$is_obsolete == "true" && (length(x$replaced_by) > 0 || length(x$consider) > 0))
		alternative_terms = lt_data[l]
		names(alternative_terms) = sapply(alternative_terms, function(x) x$id)
		alternative_terms = lapply(alternative_terms, function(x) {
			if(length(x$replaced_by)) {
				x["replaced_by"]
			} else {
				x["consider"]
			}
		})
		alternative_terms = lapply(alternative_terms, function(x) unname(unlist(x)))

		l = sapply(lt_data, function(x) length(x$alt_id) > 0)
		if(any(l)) {
			alternative_terms2 = lt_data[l]
			alt_lt = lapply(alternative_terms2, function(x) {
				data.frame(id = rep(x$id, length(x$alt_id)), alt_id = x$alt_id)
			})
			alternative_terms2 = do.call(rbind, alt_lt)
			alternative_terms2 = split(alternative_terms2$id, alternative_terms2$alt_id)

			alternative_terms = c(alternative_terms, alternative_terms2)
		}
		
	} else {
		alternative_terms = list()
	}

	## terms
	lt_data = .validate_relations(lt_data)
	all_elements = vapply(lt_data, "[[", "id", FUN.VALUE = character(1))

	if(type == "term") {
		meta = data.frame(
			id = all_elements,
			short_id = vapply(lt_data, "[[", "short_id", FUN.VALUE = character(1)),
			name = vapply(lt_data, "[[", "name", FUN.VALUE = character(1)),
			namespace = vapply(lt_data, "[[", "namespace", FUN.VALUE = character(1)),
			definition = vapply(lt_data, "[[", "def", FUN.VALUE = character(1))
		)
	} else {
		meta = data.frame(
			id = all_elements,
			short_id = vapply(lt_data, "[[", "short_id", FUN.VALUE = character(1)),
			name = vapply(lt_data, "[[", "name", FUN.VALUE = character(1)),
			namespace = vapply(lt_data, "[[", "namespace", FUN.VALUE = character(1)),
			definition = vapply(lt_data, "[[", "def", FUN.VALUE = character(1))
		)
	}
	
	rl = lapply(lt_data, "[[", "relationship")
	nr = vapply(rl, length, FUN.VALUE = integer(1))
	child = rep(all_elements, times = nr)
	parent = unlist(rl)
	
	relations = data.frame(child = child, parent = unname(parent), relation = names(parent))
	relations = relations[relations$child != relations$parent, , drop = FALSE]

	list(meta = meta, relations = relations, alternative_terms = alternative_terms)
}

process_obo_stanza = function(ln, relation_type = "part_of") {

	lt = list()
	i = grep("^id:", ln)
	lt$id = gsub("^id: (\\S+)(\\s*.*)$", "\\1", ln[i])[1]
	lt$short_id = basename(lt$id)

	i = grep("^name:", ln)
	if(length(i)) {
		lt$name = gsub("^name: (.*)$", "\\1", ln[i])[1]
	} else {
		i = grep("^property_value: prefLabel", ln)
		if(length(i)) {
			lt$name = gsub('^property_value: prefLabel "(.*)".*$', "\\1", ln[i])[1]
		} else {
			lt$name = NA_character_
		}
	}

	i = grep("^alt_id:", ln)
	if(length(i)) {
		lt$alt_id = gsub("^alt_id: (.*)$", "\\1", ln[i])
	} else {
		lt$alt_id = character(0)
	}

	i = grep("^namespace:", ln)
	if(length(i)) {
		lt$namespace = gsub("^namespace: (.*)$", "\\1", ln[i])[1]
	} else {
		lt$namespace = NA_character_
	}

	i = grep("^def:", ln)
	if(length(i)) {
		lt$def = gsub('^def: "(.*)" ?\\[.*\\].*$', "\\1", ln[i])[1]
	} else {
		i = grep("^property_value: definition", ln)
		if(length(i)) {
			lt$def = gsub('^property_value: definition "(.*)" ?\\[.*\\].*$', "\\1", ln[i])[1]
		} else {
			lt$def = NA_character_
		}
	}

	lt$relationship = character(0)
	i = grep("^is_a:", ln)
	i = i[!grepl("gci_(filter|relation)", ln[i])] # https://github.com/jokergoo/simona/issues/8
	if(length(i)) {
		is_a = gsub("^is_a: (\\S+)\\b.*$", "\\1", ln[i])
		is_a = unique(is_a)
		lt$relationship = c(lt$relationship, structure(is_a, names = rep("is_a", length(is_a))))
	}

	i = grep("^relationship:", ln)
	if(length(i)) {

		rl = strsplit(ln[i], " ")
		rl = lapply(rl, function(x) c(x, ""))
		rl_type = vapply(rl, "[[", 2, FUN.VALUE = character(1))
		rl_term = vapply(rl, "[[", 3, FUN.VALUE = character(1))

		l1 = !grepl("^\\{", vapply(rl, "[[", 4, FUN.VALUE = character(1)))
		l2 = rl_type %in% relation_type
		l = l1 & l2
		rl_type = rl_type[l]
		rl_term = rl_term[l]

		lt$relationship = c(lt$relationship, structure(rl_term, names = rl_type))
	}

	i = grep("^is_obsolete:", ln)
	if(length(i)) {
		lt$is_obsolete = gsub("^is_obsolete: (.*)$", "\\1", ln[i])

		i = grep("^replaced_by:", ln)
		if(length(i)) {
			lt$replaced_by = gsub("^replaced_by: (.*)$", "\\1", ln[i])
		} else {
			lt$replaced_by = character(0)
		}

		if(length(lt$replaced_by) == 0) {
			i = grep("^consider:", ln)
			if(length(i)) {
				lt$consider = gsub("^consider: (.*)$", "\\1", ln[i])
			} else {
				lt$consider = character(0)
			}
		} else {
			lt$consider = character(0)
		}
	} else {
		lt$is_obsolete = "false"
		lt$replaced_by = character(0)
		lt$consider = character(0)
	}

	# specific for Typedef
	i = grep("^is_transitive:", ln)
	if(length(i)) {
		lt$is_transitive = gsub("^is_transitive: (.*)$", "\\1", ln[i])[1]
	} else {
		lt$is_transitive = "false"
	}

	i = grep("^inverse_of:", ln)
	if(length(i)) {
		lt$inverse_of = gsub("^inverse_of: (\\S+)(\\s*.*)$", "\\1", ln[i])[1]
	} else {
		lt$inverse_of = ""
	}

	lt
}


.owl_get_text = function(nodes, xpath, default = NA_character_, return_list = FALSE, ...) {
	if(return_list) {
		lapply(xml_find_all(nodes, xpath, flatten = FALSE, ...), function(x) {
			if(length(x) == 0) {
				character(0)
			} else {
				xml_text(x)
			}
		})
	} else {
		vapply(xml_find_all(nodes, xpath, flatten = FALSE, ...), function(x) {
			if(length(x) == 0) {
				default
			} else {
				xml_text(x)[1]
			}
		}, FUN.VALUE = character(1))
	}
}

.owl_get_attr = function(nodes, xpath, attr, default = NA_character_, ...) {
	lapply(xml_find_all(nodes, xpath, flatten = FALSE, ...), function(x) {
		xml_attr(x, attr)
	})
}

#' @rdname import_obo
#' @details `import_owl()` only recognizes `<owl:Class>` and `<owl:ObjectProperty>`. If the .owl file does not contain these tags,
#'     please use `import_ontology()` directly.
#' @export
#' @importFrom xml2 read_xml xml_find_all xml_attr xml_text xml_ns
#' @export
#' @examples
#' \donttest{
#' import_owl("http://purl.obolibrary.org/obo/po.owl") 
#' }
import_owl = function(file, relation_type = character(0), inherit_relations = TRUE, verbose = simona_opt$verbose, ...) {
	
	owl = read_xml(file, options = "HUGE")

	####### relation / ObjectProperty ########
	ObjectProperty = xml_find_all(owl, ".//owl:ObjectProperty")
	
	if(verbose) message("Parsing ", length(ObjectProperty), " <owl:ObjectProperty> ...")
	id = xml_attr(ObjectProperty, "about")
	short_id = .owl_get_text(ObjectProperty, ".//*[local-name()='id']", NA_character_)
	short_id = ifelse(is.na(short_id), gsub("^.*#", "", basename(id)), short_id)
	name = .owl_get_text(ObjectProperty, ".//rdfs:label[@xml:lang='en'] | .//rdfs:label[not(@xml:lang)]", NA_character_); name = gsub(" ", "_", name);
	def = .owl_get_text(ObjectProperty, ".//*[local-name()='IAO_0000115']", NA_character_)
	namespace = .owl_get_text(ObjectProperty, ".//*[local-name()='hasOBONamespace']", NA_character_)
	is_obsolete = .owl_get_text(ObjectProperty, ".//owl:deprecated", "false")
	is_a = .owl_get_text(ObjectProperty, ".//rdfs:subPropertyOf[@rdf:resource]/@rdf:resource", character(0), return_list = TRUE)
	is_a = lapply(is_a, function(x) {
		structure(x, names = rep("is_a", length(x)))
	})
	
	lt_relations = vector("list", length(id))
	for(i in seq_along(id)) {
		lt_relations[[i]]$id = id[i]
		lt_relations[[i]]$short_id = short_id[i]
		lt_relations[[i]]$name = name[i]
		lt_relations[[i]]$def = def[i]
		lt_relations[[i]]$namespace = namespace[i]
		lt_relations[[i]]$is_obsolete = is_obsolete[i]
		lt_relations[[i]]$relationship = is_a[[i]]
	}

	## relations
	if(length(lt_relations)) {
		lt = .wrap_relations(lt_relations, type = "relation")
		relation_meta = lt$meta
		relation_relations = lt$relations
	} else {
		relation_meta = data.frame()
		relation_relations = data.frame()
	}

	relations_id_to_name = structure(ifelse(is.na(relation_meta$name), relation_meta$short_id, relation_meta$name), names = relation_meta$id)
	relations_id_to_name[is.na(relations_id_to_name)] = relation_meta$id[is.na(relations_id_to_name)]
	relations_id_to_name["is_a"] = "is_a"

	if(nrow(relation_relations)) {
		
		relation_relations$parent = unname(relations_id_to_name[relation_relations$parent])
		relation_relations$child = unname(relations_id_to_name[relation_relations$child])

		suppressWarnings(suppressMessages(relations_DAG <- create_ontology_DAG(relation_relations$parent, relation_relations$child)))

		if(inherit_relations) {
			relation_type = merge_offspring_relation_types(relations_DAG, relation_type)
		}
	} else {
		relations_DAG = NULL
	}


	### Class #####
	Class = xml_find_all(owl, ".//owl:Class")
	id = xml_attr(Class, "about")
	l = !is.na(id)

	id = id[l]
	Class = Class[l]

	n = length(Class)

	if(n == 0) {
		stop("Cannot find any owl:Class. Consider to use `import_ontology()` directly.")
	}

	if(verbose) message("Parsing ", length(Class), " <owl:Class> ...")
	id = xml_attr(Class, "about")
	short_id = .owl_get_text(Class, ".//*[local-name()='id']", NA_character_)
	short_id = ifelse(is.na(short_id), gsub("^.*#", "", basename(id)), short_id)
	name = .owl_get_text(Class, ".//rdfs:label[@xml:lang='en'] | .//rdfs:label[not(@xml:lang)]", NA_character_)
	def = .owl_get_text(Class, ".//*[local-name()='IAO_0000115']", NA_character_)
	namespace = .owl_get_text(Class, ".//*[local-name()='hasOBONamespace']", NA_character_)
	is_obsolete = .owl_get_text(Class, ".//owl:deprecated", "false")
	is_a = .owl_get_text(Class, ".//rdfs:subClassOf[@rdf:resource]/@rdf:resource", character(0), return_list = TRUE)
	is_a = lapply(is_a, function(x) {
		structure(x, names = rep("is_a", length(x)))
	})
	value = .owl_get_attr(Class, ".//rdfs:subClassOf/owl:Restriction/*[self::owl:someValuesFrom or self::owl:allValuesFrom or self::owl:onClass]", "resource")
	property = .owl_get_attr(Class, ".//rdfs:subClassOf/owl:Restriction/*[self::owl:someValuesFrom or self::owl:allValuesFrom or self::owl:onClass]/preceding-sibling::owl:onProperty", "resource")

	short_id = gsub("_(?!.*_.*)", ":", short_id, perl = TRUE)

	ns = xml_ns(owl)
	obo_ns = names(ns)[ns == "http://purl.obolibrary.org/obo/"]
	oboInOwl_ns = names(ns)[ns == "http://www.geneontology.org/formats/oboInOwl#"]

	replaced_by = .owl_get_attr(Class, paste0(".//", obo_ns, ":IAO_0100001"), "resource", character(0))
	consider = .owl_get_text(Class, paste0(".//", oboInOwl_ns, ":consider"), character(0), return_list = TRUE)

	lt_terms = vector("list", length(id))
	for(i in seq_along(id)) {
		lt_terms[[i]]$id = id[i]
		lt_terms[[i]]$short_id = short_id[i]
		lt_terms[[i]]$name = name[i]
		lt_terms[[i]]$def = def[i]
		lt_terms[[i]]$namespace = namespace[i]
		lt_terms[[i]]$is_obsolete = is_obsolete[i]
		lt_terms[[i]]$replaced_by = replaced_by[[i]]
		lt_terms[[i]]$consider = consider[[i]]
		
		rlv = value[[i]]
		rlp = relations_id_to_name[ property[[i]] ]
		l = !is.na(rlv)
		rlv = rlv[l]
		rlp = rlp[l]

		l = rlp %in% relation_type
		rlv = rlv[l]
		rlp = rlp[l]

		lt_terms[[i]]$relationship = c(is_a[[i]], structure(rlv, names = rlp))
	}

	###### Description ######
	Description = xml_find_all(owl, ".//rdf:Description")

	if(length(Description)) {
		if(verbose) message("Parsing ", length(Description), " <rdf:Description> ...")
		id = xml_attr(Description, "about")
		name = .owl_get_text(Description, ".//*[local-name()='prefLabel']", NA_character_)
		def = .owl_get_text(Description, ".//*[local-name()='definition']", NA_character_)

		df_description = data.frame(id = id, name = name, def = def)
		df_description = df_description[!is.na(df_description$id), , drop = FALSE]
		df_description = df_description[!duplicated(df_description$id), , drop = FALSE]
		rownames(df_description) = df_description$id
	} else {
		df_description = data.frame()
	}


	## terms
	lt = .wrap_relations(lt_terms, "term")
	term_meta = lt$meta
	term_relations = lt$relations

	if(nrow(df_description) > 0) {
		ind = which(is.na(term_meta$name) & term_meta$id %in% df_description$id)
		if(length(ind)) {
			term_meta[ind, "name"] = df_description[ term_meta$id[ind], "name"]
			term_meta[ind, "definition"] = df_description[ term_meta$id[ind], "def"]
		}

		ind = which(is.na(term_relations$name) & term_meta$id %in% df_description$id)
		if(length(ind)) {
			term_relations[ind, "name"] = df_description[ term_relations$id[ind], "name"]
			term_relations[ind, "definition"] = df_description[ term_relations$id[ind], "def"]
		}
	}
	

	## some meta for the whole ontology
	version = xml_text(xml_find_all(owl, ".//owl:Ontology/owl:versionInfo"))
	if(length(version) == 0) {
		version = xml_attr(xml_find_all(owl, ".//owl:Ontology/owl:versionIRI"), "resource")
	}
	ontology = xml_text(xml_find_all(owl, ".//owl:Ontology/*[local-name()='title']"))
	if(length(ontology) == 0) {
		ontology = xml_attr(xml_find_all(owl, ".//owl:Ontology"), "about")
	}

	term_meta = term_meta[term_meta$id %in% c(term_relations$parent, term_relations$child), , drop = FALSE]
	internal_id = term_meta$short_id
	dd = internal_id[duplicated(internal_id)]
	ldd = internal_id %in% dd
	internal_id[ldd] = term_meta$id[ldd]
	idmap = structure(internal_id, names = term_meta$id)

	dag = create_ontology_DAG(parents = idmap[term_relations$parent], children = idmap[term_relations$child], relations = term_relations$relation,
		source = paste0(ontology, ", ", version), relations_DAG = relations_DAG, alternative_terms = lt$alternative_terms, verbose = verbose, ...)
	rownames(term_meta) = internal_id

	term_meta = term_meta[dag@terms, , drop = FALSE]
	
	if(dag_root(dag) == SUPER_ROOT) {
		term_meta$id[dag@root] = SUPER_ROOT
		term_meta$name[dag@root] = SUPER_ROOT
		term_meta$short_id[dag@root] = SUPER_ROOT
	}
	
	mcols(dag) = term_meta

	dag
	
}

#' @param robot_jar The path of the `robot.jar` file. It can be downloaded from https://github.com/ontodev/robot/releases.
#'         Internally, the file is converted to the obo format and parsed by `import_obo()`. The value of `robot_jar` can be
#'         set as a global option `simona_opt$robot_jar = ...`.
#' @param JAVA_ARGS Options for `java`. For example you can set `-Xmx20G` if you want to increase the memory to 20G for java.
#' @details
#' `robot.jar` can automatically recognize the following formats:
#' 
#' - `json`: OBO Graphs JSON
#' - `obo`: OBO Format
#' - `ofn`: OWL Functional
#' - `omn`: Manchester
#' - `owl`: RDF/XML
#' - `owx`: OWL/XML
#' - `ttl`: Turtle 
#' 
#' The description of the ROBOT tool is at \url{http://robot.obolibrary.org/convert}.
#' 
#' @rdname import_obo
#' @export
#' @importFrom utils download.file
#' @examples
#' \dontrun{
#' # The plant ontology: http://obofoundry.org/ontology/po.html 
#' dag = import_ontology("http://purl.obolibrary.org/obo/po.owl", robot_jar = ...)
#' }
import_ontology = function(file, robot_jar = simona_opt$robot_jar, JAVA_ARGS = "", verbose = simona_opt$verbose, ...) {

	if(grepl("\\.(obo|obo.gz)$", file, ignore.case = TRUE)) {
		return(import_obo(file, ...))
	}

	if(Sys.which("java") == "") {
		stop("Java is not available.")
	}

	if(is.null(robot_jar)) {
		message("`robot_jar` was not set. Download `robot.jar` from GitHub...")
		download_robot(verbose = verbose)
		robot_jar = simona_opt$robot_jar
		# stop_wrap("'robot.jar' has not been set. It can be downloaded from https://github.com/ontodev/robot/releases and set by simona_opt$robot_jar = ...")
	}

	if(!file.exists(robot_jar)) {
		stop_wrap(paste0("Cannot find '", robot_jar, "'. It can be downloaded from https://github.com/ontodev/robot/releases and set by simona_opt$robot_jar = ..."))
	}
	robot_jar = normalizePath(robot_jar)

	if(grepl("^(http|ftp)", file)) {
		op = getOption("timeout")
		options(timeout = 999999999)
		on.exit(options(timeout = op))
		if(verbose) message(qq("Downloading @{file}..."))
		file2 = tempfile(fileext = paste0("_", basename(file)))
		download.file(file, destfile = file2, quiet = TRUE)
		on.exit(file.remove(file2))

		file = file2
	}

	if(verbose) message("Converting ", basename(file), " to the obo format.")
	output = tempfile(fileext = ".obo.gz")

	file = normalizePath(file)
	java_path = Sys.which("java")
	cmd = qq("'@{java_path}' @{JAVA_ARGS} -jar '@{robot_jar}' convert --input '@{file}' --format obo --output '@{output}' --check false")
	if(verbose) message("  ", cmd)

	code = system2(java_path, c(JAVA_ARGS, "-jar", robot_jar, "convert", "--input", file, "--format", "obo", "--output", output, "--check", "false"))
	if(code != 0) {
		if(grepl("\\.owl$", file, ignore.case = TRUE)) {
			message("Consider to use `import_owl()`")
		} else if(grepl("\\.ttl$", file, ignore.case = TRUE)) {
			message("Consider to use `import_ttl()`")
		}
		stop("Executing 'robot.jar' failed.")
	}

	lt = import_obo(output, verbose = verbose, ...)

	if(file.exists(output)) {
		file.remove(output)
	}

	lt
}


#' @details
#' `import_ttl()` is a simple parser for the `.ttl` format files. It only recognizes
#' terms that have the `owl:Class` object. The "is_a" relation is recognized by the predicate `rdfs:subClassOf`
#' or an ontology-specific predicate that contains `.*/isa`. Other relation types are defined with
#' the predicate `owl:ObjectProperty`. The format is parsed by a Perl script `system.file("scripts", "parse_ttl.pl", package = "simona")`.
#' @rdname import_obo
#' @export
#' @examples
#' \donttest{
#' # file is from https://bioportal.bioontology.org/ontologies/MSTDE
#' import_ttl("https://jokergoo.github.io/simona/MSTDE.ttl")
#' }
import_ttl = function(file, relation_type = "part_of", verbose = simona_opt$verbose, ...) {

	if(Sys.which("perl") == "") {
		stop("Perl is not available.")
	}

	if(grepl("^(http|ftp)", file)) {

		message(qq("Downloading @{file}..."))
		file2 = tempfile(fileext = paste0("_", basename(file)))
		download.file(file, destfile = file2, quiet = TRUE)
		on.exit(file.remove(file2))

		file = file2
		source = basename(file2)
	} else {
		source = basename(file)
	}

	file = normalizePath(file)

	if(verbose) message("Parsing .ttl file...")
	perl_script = system.file("scripts", "parse_ttl.pl", package = "simona")
	cmd = qq("perl '@{perl_script}' '@{file}'")
	if(length(relation_type)) {
		cmd = paste0(cmd, " ", paste("'", relation_type, "'", sep = "", collapse = " "))
	}
	df = read.csv(pipe(cmd))
		
	if(verbose) message("Constructing the DAG_ontology object...")
	lt_parents = strsplit(df$parent, ",")
	children = rep(df$id, times = vapply(lt_parents, length, FUN.VALUE = integer(1)))
	parents = unlist(lt_parents)

	lt_relations = strsplit(df$relation_type, ",")
	relations = unlist(lt_relations)

	dag = create_ontology_DAG(parents = parents, children = children, relations = relations,
		source = source, verbose = verbose, ...)

	term_meta = df[, seq_len(4), drop = FALSE]
	colnames(term_meta) = c("id", "name", "short_id", "definition")

	rownames(term_meta) = term_meta$id
	term_meta = term_meta[dag@terms, , drop = FALSE]

	if(dag_root(dag) == SUPER_ROOT) {
		term_meta$id[dag@root] = SUPER_ROOT
		term_meta$name[dag@root] = SUPER_ROOT
		term_meta$short_id[dag@root] = SUPER_ROOT
	}
	
	mcols(dag) = term_meta

	dag
}


download_robot = function(verbose = TRUE) {

	check_pkg("jsonlite", bioc = FALSE)

	tb = jsonlite::fromJSON("https://api.github.com/repos/ontodev/robot/releases")
	id = tb[1, "id"]

	tb = jsonlite::fromJSON(paste0("https://api.github.com/repos/ontodev/robot/releases/", id, "/assets"))
	url = tb[1, "browser_download_url"]

	temp = tempfile(pattern = "robot_temp_", fileext = ".jar")
	download.file(url, destfile = temp, quiet = !verbose)
	simona_opt$robot_jar = temp
}

#' Various types of common ancestors
#' 
#' @param dag An `ontology_DAG` object.
#' @param terms A vector of term names.
#' @param IC_method An IC method. Valid values are in [`all_term_IC_methods()`].
#' @param in_labels Whether the terms are represented in their names or as integer indices?
#' @param distance If there are multiple LCA or MICA of two terms, whether to take the one with
#'   the longest distance of shortest distance to the two terms. Possible values are "longest" and "shortest".
#' @param verbose Whether to print messages.
#' 
#' @details
#' There are the following three types of common ancestors:
#' 
#' - MICA (most informative common ancestor): The common ancestor with the highest IC value.
#' - LCA (lowest common ancestor): The common ancestor with the largest depth (The depth of a term is the maximal distance from the root term). If there are multiple ancestors having
#'        the same max depth, the ancestor with the smallest distance to the two terms is used.
#' - NCA (nearest common ancestor): The common ancestor with the smallest distance to the two terms. If there are multiple
#'        ancestors with the same smallest distance, the ancestor with the largest depth is used.
#' 
#' `max_ancestor_v()` and `max_ancestor_id()` are more general functions which return common ancestors with
#' the highest value in `value`.
#' 
#' Given a path connecting two terms and their MICA/LCA, `max_ancestor_path_sum()` calculates the sum of terms along the path. The values
#' to be added in specified in `add_v` argument.
#' 
#' @return 
#' - `MICA_term()` returns an integer or a character matrix of the MICA terms depending on the value of `in_labels`. 
#' - `MICA_IC()` returns a numeric matrix of the IC of the MICA terms.
#' - `LCA_term()` returns an integer or a character matrix of the LCA term depending on the value of `in_labels`.
#' - `LCA_depth()` returns an integer matrix of the depth of the LCA terms.
#' - `NCA_term()` returns an integer or a character matrix of the NCA term depending on the value of `in_labels`. The shortest distance from NCA terms can be calculated by [`shortest_distances_via_NCA()`].
#' - `max_ancestor_v()` returns a numeric matrix.
#' - `max_ancestor_id()` returns an integer or a character matrix.
#' - `CA_terms()` returns a vector of term IDs.
#' 
#' @rdname common_ancestor
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' MICA_term(dag, letters[1:6], "IC_universal")
#' MICA_IC(dag, letters[1:6], "IC_universal")
#' LCA_term(dag, letters[1:6])
#' LCA_depth(dag, letters[1:6])
#' NCA_term(dag, letters[1:6])
#' CA_terms(dag, "c", "d")
MICA_term = function(dag, terms, IC_method, in_labels = TRUE, distance = "longest", verbose = simona_opt$verbose) {
	ic = term_IC(dag, IC_method, verbose = verbose)
	max_ancestor_id(dag, terms, ic, in_labels = in_labels, distance = distance, verbose = verbose)
}

#' @rdname common_ancestor
#' @export
MICA_IC = function(dag, terms, IC_method, verbose = simona_opt$verbose) {
	ic = term_IC(dag, IC_method, verbose = verbose)
	max_ancestor_v(dag, terms, ic, verbose = verbose)
}


#' @rdname common_ancestor
#' @export
LCA_term = function(dag, terms, in_labels = TRUE, distance = "longest", verbose = simona_opt$verbose) {
	depth = dag_depth(dag)
	
	max_ancestor_id(dag, terms, depth, in_labels = in_labels, distance = distance, verbose = verbose)
}

#' @rdname common_ancestor
#' @export
LCA_depth = function(dag, terms, verbose = simona_opt$verbose) {
	depth = dag_depth(dag)
	
	max_ancestor_v(dag, terms, depth, verbose = verbose)
}

#' @rdname common_ancestor
#' @export
NCA_term = function(dag, terms, in_labels = TRUE, verbose = simona_opt$verbose) {
	if(is.character(terms)) {
		id = term_to_node_id(dag, terms, strict = FALSE)
	} else {
		id = terms
	}
	if(any(duplicated(id))) {
		stop("`term` should not be duplicated.")
	}

	an = exec_under_message_condition({
		cpp_nearest_common_ancestor(dag, id)
	}, verbose = verbose)
	dimnames(an) = list(dag@terms[id], dag@terms[id])

	if(in_labels) {
		structure(dag@terms[an], dim = dim(an), dimnames = dimnames(an))
	} else {
		an
	}

}


#' @param value A numeric vector. The elements should corrrespond to terms in `dag_all_terms()` (should have the same length as the number of terms in the DAG).
#' 
#' @rdname common_ancestor
#' @export
max_ancestor_v = function(dag, terms, value, verbose = simona_opt$verbose) {

	if(length(value) != dag@n_terms) {
		stop("Length of `value` should be the same as number of total terms in the DAG.")
	}

	if(is.character(terms)) {
		id = term_to_node_id(dag, terms, strict = FALSE)
	} else {
		id = terms
	}
	if(any(duplicated(id))) {
		stop("`term` should not be duplicated.")
	}
	an = exec_under_message_condition({
		cpp_max_ancestor_v(dag, id, value)
	}, verbose = verbose)
	dimnames(an) = list(dag@terms[id], dag@terms[id])
	an
}


#' @rdname common_ancestor
#' @export
max_ancestor_id = function(dag, terms, value, in_labels = FALSE, distance = "longest", verbose = simona_opt$verbose) {

	if(length(value) != dag@n_terms) {
		stop("Length of `value` should be the same as number of total terms in the DAG.")
	}

	if(is.character(terms)) {
		id = term_to_node_id(dag, terms, strict = FALSE)
	} else {
		id = terms
	}
	if(any(duplicated(id))) {
		stop("`term` should not be duplicated.")
	}
	an = exec_under_message_condition({
		cpp_max_ancestor_id(dag, id, value, distance == "longest")
	}, verbose = verbose)
	dimnames(an) = list(dag@terms[id], dag@terms[id])

	if(in_labels) {
		structure(dag@terms[an], dim = dim(an), dimnames = dimnames(an))
	} else {
		an
	}
}


#' @param add_v Values to be added along the path to the MICA or LCA. The same format as `value`.
#' 
#' @export
#' @rdname common_ancestor
max_ancestor_path_sum = function(dag, terms, value, add_v, distance = "longest", verbose = simona_opt$verbose) {
	if(length(value) != dag@n_terms) {
		stop("Length of `value` should be the same as number of total terms in the DAG.")
	}
	if(length(add_v) != dag@n_terms) {
		stop("Length of `add_v` should be the same as number of total terms in the DAG.")
	}

	if(is.character(terms)) {
		id = term_to_node_id(dag, terms, strict = FALSE)
	} else {
		id = terms
	}
	if(any(duplicated(id))) {
		stop("`term` should not be duplicated.")
	}

	sv = exec_under_message_condition({
		cpp_max_ancestor_path_sum_value(dag, id, value, add_v, distance == "longest")
	}, verbose = verbose)

	dimnames(sv) = list(dag@terms[id], dag@terms[id])
	sv
}

#' @rdname common_ancestor
#' @param term1 A single term ID.
#' @param term2 A single term ID.
#' @export
CA_terms = function(dag, term1, term2, in_labels = TRUE) {
	ancestors1 = dag_ancestors(dag, term1, include_self = TRUE, in_labels = in_labels)
	ancestors2 = dag_ancestors(dag, term2, include_self = TRUE, in_labels = in_labels)
	intersect(ancestors1, ancestors2)
}

library(testthat)


## export all functions
if(!identical(topenv(), .GlobalEnv)) {
	pkg_env = asNamespace("simona")
	all_objs = ls(envir = pkg_env)
	for(obj in all_objs) {
		assign(obj, get(obj, envir = pkg_env, inherits = FALSE))
	}
}

#### test a small dag

#   b--d--f
#  / \
# a---c--e
# upstream -> downstream

parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")

dag = create_ontology_DAG(parents, children)

test_that("test cpp_max_ancestor_v", {
	m = max_ancestor_v(dag, 1:6, dag_depth(dag))
	expect_equal(
		m[upper.tri(m, diag = TRUE)],
		c(0, 0, 1, 0, 1, 2, 0, 1, 1, 2, 0, 1, 2, 1, 3, 0, 1, 1, 2, 1, 3)
	)

	m = max_ancestor_v(dag, c(2, 4, 5, 3), dag_depth(dag))
	expect_equal(
		m[upper.tri(m, diag = TRUE)],
		c(1, 1, 2, 1, 1, 3, 1, 1, 2, 2)
	)
})

test_that("test cpp_max_ancestor_id", {
	m = max_ancestor_id(dag, 1:6, dag_depth(dag))
	expect_equal(
		m[upper.tri(m, diag = TRUE)],
		c(1, 1, 2, 1, 2, 3, 1, 2, 2, 4, 1, 2, 3, 2, 5, 1, 2, 2, 4, 2, 6)
	)

	m = max_ancestor_id(dag, c(2, 4, 5, 3), dag_depth(dag))
	expect_equal(
		m[upper.tri(m, diag = TRUE)],
		c(2, 2,4, 2, 2, 5, 2, 2, 3, 3)
	)

	m = max_ancestor_id(dag, 1:6, rep(0, 6))
	expect_equal(
		m[upper.tri(m, diag = TRUE)],
		c(1, 1, 2, 1, 2, 3, 1, 2, 2, 4, 1, 2, 3, 2, 5, 1, 2, 2, 4, 2, 6)
	)

})

test_that("test cpp_distances", {
	m = shortest_distances_via_NCA(dag, 1:6)
	expect_equal(
		m[upper.tri(m, diag = TRUE)],
		c(0, 1, 0, 1, 1, 0, 2, 1, 2, 0, 2, 2, 1, 3, 0, 3, 2, 3, 1, 4, 0)
	)

	m2 = shortest_distances_via_NCA(dag, c(2, 4, 5, 3))
	m3 = m[c(2, 4, 5, 3), c(2, 4, 5, 3)]
	expect_equal(m2, m3)

	m = longest_distances_via_LCA(dag, 1:6)
	expect_equal(
		m[upper.tri(m, diag = TRUE)],
		c(0, 1, 0, 2, 1, 0, 2, 1, 2, 0, 3, 2, 1, 3, 0, 3, 2, 3, 1, 4, 0)
	)

	m2 = longest_distances_via_LCA(dag, c(2, 4, 5, 3))
	m3 = m[c(2, 4, 5, 3), c(2, 4, 5, 3)]
	expect_equal(m2, m3)

	lt = cpp_longest_distances_from_LCA(dag, 1:6)
	m = longest_distances_via_LCA(dag, 1:6)
	dimnames(m) = NULL

	expect_equal(m, lt$left + lt$right)
})

test_that("test distance_directed", {
	m = longest_distances_directed(dag, 1:6)
	expect_equal(
		m[upper.tri(m, diag = TRUE)],
		c(0, 1, 0, 2, 1, 0, 2, 1, -1, 0, 3, 2, 1, -1, 0, 3, 2, -1, 1, -1, 0)
	)

	m2 = longest_distances_directed(dag, c(2, 4, 5, 3))
	m3 = m[c(2, 4, 5, 3), c(2, 4, 5, 3)]
	expect_equal(m2, m3)

	expect_equal(
		m[lower.tri(m, diag = FALSE)],
		rep(-1, 15)
	)

	m = shortest_distances_directed(dag, 1:6)
	expect_equal(
		m[upper.tri(m, diag = TRUE)],
		c(0, 1, 0, 1, 1, 0, 2, 1, -1, 0, 2, 2, 1, -1, 0, 3, 2, -1, 1, -1, 0)
	)

	m2 = shortest_distances_directed(dag, c(2, 4, 5, 3))
	m3 = m[c(2, 4, 5, 3), c(2, 4, 5, 3)]
	expect_equal(m2, m3)

	expect_equal(
		m[lower.tri(m, diag = FALSE)],
		rep(-1, 15)
	)
})


test_that("test cpp_nearest_common_ancestor", {
	m = cpp_nearest_common_ancestor(dag, 1:6)
	expect_equal(
		m[upper.tri(m, diag = TRUE)],
		c(1, 1, 2, 1, 2, 3, 1, 2, 2, 4, 1, 2, 3, 2, 5, 1, 2, 2, 4, 2, 6)
	)

	m2 = cpp_nearest_common_ancestor(dag, c(2, 4, 5, 3))
	m3 = m[c(2, 4, 5, 3), c(2, 4, 5, 3)]
	expect_equal(m2, m3)
})


test_that("compare cpp_nearest_common_ancestor and cpp_max_ancestor_v", {
	parents = c("a", "b", "c", "c", "d", "f", "b", "b")
	children = c("b", "c", "d", "f", "e", "g", "e", "g")
	dag = create_ontology_DAG(parents, children)
	depth = dag_depth(dag)

	m1 = max_ancestor_id(dag, 1:7, depth)
	m2 = cpp_nearest_common_ancestor(dag, 1:7)

	expect_equal(m1[5, 7], 3)
	expect_equal(m2[5, 7], 2)

	expect_equal(m1[4, 6], 3)
	expect_equal(m2[4, 6], 3)
})



if(FALSE) {

dag = create_ontology_DAG_from_GO_db()

system.time(d <- LCA_term(dag, dag@terms)); rm(d); gc();
system.time(d <- LCA_depth(dag, dag@terms)); rm(d); gc();
system.time(d <- NCA_term(dag, dag@terms)); rm(d); gc();
system.time(d <- MICA_term(dag, dag@terms, "IC_universal")); rm(d); gc();
system.time(d <- MICA_IC(dag, dag@terms, "IC_universal")); rm(d); gc();

}

term_to_node_id = function(dag, term, strict = TRUE, add_name = FALSE) {
	if(is.numeric(term)) {
		id = term
	} else if(length(term) == 1) {
		i = which(dag@terms == term)

		if(length(i) == 0 && length(dag@alternative_terms)) {
			term2 = dag@alternative_terms[term]
			if(is.na(term2)) {
				stop("Cannot find term: ", term)
			} else {
				i = which(dag@terms == term2)
			}	
		}

		if(length(i) == 0) {
			stop("Cannot find term: ", term)
		} 

		id = i
	} else if(length(term) > 1) {
		unique_term = unique(term)
		l = dag@terms %in% unique_term
		if(sum(l) < length(unique_term) && length(dag@alternative_terms)) {
			unique_term2 = dag@alternative_terms[setdiff(unique_term, dag@terms[l])]
			unique_term2 = unique_term2[!is.na(unique_term2)]
			l2 = dag@terms %in% unique_term2
			l = l | l2
		}
		i = which(l)

		if(length(i) == 0) {
			stop("Cannot find all these terms.")
		}

		if(length(i) != length(unique_term)) {
			if(strict) {
				stop("Cannot find some of the terms in the DAG.")
			} else {
				message("removed ", length(unique_term) - length(i), " terms that cannot be found in the DAG.")
			}
		}

		id = unname(structure(i, names = dag@terms[i])[intersect(term, dag@terms[i])])
	}
	if(add_name) {
		structure(id, names = dag@terms[id])
	} else {
		id
	}
}


#' @importFrom GetoptLong qq
check_pkg = function(pkg, bioc = FALSE, github = NULL) {
	if(requireNamespace(pkg, quietly = TRUE)) {
		return(NULL)
	} else {

		if(!interactive()) {
			if(bioc) {
				stop_wrap(qq("You need to manually install package '@{pkg}' from Bioconductor."))
			} else {
				stop_wrap(qq("You need to manually install package '@{pkg}' from CRAN."))
			}
		}
	}
}


stop_wrap = function (...) {
    x = paste0(...)
    x = paste(strwrap(x), collapse = "\n")
    stop(x, call. = FALSE)
}

warning_wrap = function (...) {
    x = paste0(...)
    x = paste(strwrap(x), collapse = "\n")
    warning(x, call. = FALSE)
}

message_wrap = function (...) {
    x = paste0(...)
    x = paste(strwrap(x), collapse = "\n")
    message(x)
}

#' @importFrom grDevices col2rgb rgb
add_transparency = function (col, transparency = 0, alpha = TRUE) {
	if(alpha) {
    	rgb(t(col2rgb(col)/255), alpha = 1 - transparency)
    } else {

		m = col2rgb(col)
		m = 255 - (255-m)*(1-transparency)
		rgb(t(m), maxColorValue = 255)

    }
}


lt_children_to_lt_parents = function(lt_children) {
	n = length(lt_children)
	parents = rep(seq_len(n), times = vapply(lt_children, length, FUN.VALUE = integer(1)))
	children = unlist(lt_children)

	lt = split(parents, children)

	lt_parents = rep(list(integer(0)))
	lt_parents[ as.integer(names(lt)) ] = lt

	lt_parents
}

lt_parents_to_lt_children = function(lt_parents) {
	n = length(lt_parents)
	children = rep(seq_len(n), times = vapply(lt_parents, length, FUN.VALUE = integer(1)))
	parents = unlist(lt_parents)

	lt = split(children, parents)

	lt_children = rep(list(integer(0)))
	lt_children[ as.integer(names(lt)) ] = lt

	lt_children
}

dag_is_tree = function(dag) {
	n_terms = dag@n_terms
	n_relations = sum(vapply(dag@lt_children, length, FUN.VALUE = integer(1)))

	n_terms == n_relations + 1
}


merge_offspring_relation_types = function(relations_DAG, relations) {
	if(length(relations) == 0) {
		return(relations)
	}
	
	r1 = relations_DAG@terms
	rc = intersect(r1, relations)

	if(length(rc)) {
		unique(c(setdiff(relations, rc), dag_offspring(relations_DAG, rc, include_self = TRUE)))
	} else {
		relations
	}
}


# all offspring types are assigned to the same value
extend_contribution_factor = function(relations_DAG, contribution_factor) {

	cf = contribution_factor
	
	if(is.null(relations_DAG)) {
		return(cf)
	}

	for(nm in names(contribution_factor)) {
		if(nm %in% relations_DAG@terms) {
			offspring = dag_offspring(relations_DAG, nm)
			if(length(offspring)) {
				cf[offspring] = contribution_factor[nm]
			}
		}
	}

	cf
}


normalize_relation_type = function(x) {

	x = tolower(x)
	x = gsub("[- ~]", "_", x)
	x[x == "isa"] = "is_a"
	x[x == "part_a"] = "part_of"

	x
}

exec_under_message_condition = function(code, verbose = TRUE, envir = parent.frame()) {
	if(verbose) {
		eval(code, envir = envir)
	} else {
		suppressMessages(eval(code, envir = envir))
	}
}

get_IC_method = function(method, control = list()) {
	param = .ALL_IC_METHODS[[method]]
	if(is.null(param)) {
		i = grep(method, names(.ALL_IC_METHODS), ignore.case = TRUE, value = TRUE)
		if(length(i) != 1) {
			stop("method should be in `all_ic_methods()`.")
		}
		method = i
		param = .ALL_IC_METHODS[[i]]
	}

	f = get(method, envir = topenv(), inherits = FALSE)

	control = control[intersect(names(control), param)]
	
	function(dag) {
		do.call(f, c(list(dag = dag), control))
	}
}


get_term_sim_method = function(method, control = list()) {
	param = .ALL_TERM_SIM_METHODS[[method]]
	if(is.null(param)) {
		i = grep(method, names(.ALL_TERM_SIM_METHODS), ignore.case = TRUE, value = TRUE)
		if(length(i) != 1) {
			stop("method should be in `all_term_sim_methods()`.")
		}
		method = i
		param = .ALL_TERM_SIM_METHODS[[i]]
	}

	f = get(method, envir = topenv(), inherits = FALSE)

	control = control[intersect(names(control), param)]
	
	function(dag, terms) {
		do.call(f, c(list(dag = dag, terms = terms), control))
	}
}


get_group_sim_method = function(method, control = list()) {
	param = .ALL_GROUP_SIM_METHODS[[method]]
	if(is.null(param)) {
		i = grep(method, names(.ALL_GROUP_SIM_METHODS), ignore.case = TRUE, value= TRUE)
		if(length(i) != 1) {
			stop("method should be in `all_group_sim_methods()`.")
		}
		method = i
		param = .ALL_GROUP_SIM_METHODS[[i]]
	}

	f = get(method, envir = topenv(), inherits = FALSE)

	if(!"..." %in% param) {
		control = control[intersect(names(control), param)]
	}
	
	function(dag, group1, group2) {
		do.call(f, c(list(dag = dag, group1 = group1, group2 = group2), control))
	}
}



# cat(paste("#' @inheritSection", all_ic_methods(), "Methods") , sep = "\n")

#' Information content
#' 
#' @param dag An `ontology_DAG` object.
#' @param method An IC method. All available methods are in [`all_term_IC_methods()`].
#' @param terms A vector of term names. If it is set, the returned vector will be subsetted to the terms that have been set here.
#' @param control A list of parameters passing to individual methods. See the subsections.
#' @param verbose Whether to print messages.
#' 
#' @inheritSection IC_offspring Methods
#' @inheritSection IC_height Methods
#' @inheritSection IC_annotation Methods
#' @inheritSection IC_universal Methods
#' @inheritSection IC_Zhang_2006 Methods
#' @inheritSection IC_Seco_2004 Methods
#' @inheritSection IC_Zhou_2008 Methods
#' @inheritSection IC_Seddiqui_2010 Methods
#' @inheritSection IC_Sanchez_2011 Methods
#' @inheritSection IC_Meng_2012 Methods
#' @inheritSection IC_Wang_2007 Methods
#' 
#' @return A numeric vector.
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' annotation = list(
#'     "a" = c("t1", "t2", "t3"),
#'     "b" = c("t3", "t4"),
#'     "c" = "t5",
#'     "d" = "t7",
#'     "e" = c("t4", "t5", "t6", "t7"),
#'     "f" = "t8"
#' )
#' dag = create_ontology_DAG(parents, children, annotation = annotation)
#' term_IC(dag, "IC_annotation")
term_IC = function(dag, method, terms = NULL, control = list(), verbose = simona_opt$verbose) {
		
	if(missing(method)) {
		method = default_term_IC_method(dag)
	}

	if(is.null(control$verbose)) control$verbose = verbose
	
	IC_fun = get_IC_method(method, control)
	ic = IC_fun(dag)

	ic[ic == 0] = 0  # to change -0 to 0

	ic = structure(ic, names = dag@terms)

	if(!is.null(terms)) {
		i = term_to_node_id(dag, terms, strict = FALSE)
		ic[i]
	} else {
		ic
	}
}


# cat(paste("#' @inheritSection", all_term_sim_methods(), "Methods") , sep = "\n")

#' Semantic similarity
#' 
#' @param dag An `ontology_DAG` object.
#' @param terms A vector of term names.
#' @param method A term similarity method. All available methods are in [`all_term_sim_methods()`].
#' @param control A list of parameters passing to individual methods. See the subsections.
#' @param verbose Whether to print messages.
#' 
#' @inheritSection Sim_Lin_1998 Methods
#' @inheritSection Sim_Resnik_1999 Methods
#' @inheritSection Sim_FaITH_2010 Methods
#' @inheritSection Sim_Relevance_2006 Methods
#' @inheritSection Sim_SimIC_2010 Methods
#' @inheritSection Sim_XGraSM_2013 Methods
#' @inheritSection Sim_EISI_2015 Methods
#' @inheritSection Sim_AIC_2014 Methods
#' @inheritSection Sim_Zhang_2006 Methods
#' @inheritSection Sim_universal Methods
#' @inheritSection Sim_Wang_2007 Methods
#' @inheritSection Sim_GOGO_2018 Methods
#' @inheritSection Sim_Rada_1989 Methods
#' @inheritSection Sim_Resnik_edge_2005 Methods
#' @inheritSection Sim_Leocock_1998 Methods
#' @inheritSection Sim_WP_1994 Methods
#' @inheritSection Sim_Slimani_2006 Methods
#' @inheritSection Sim_Shenoy_2012 Methods
#' @inheritSection Sim_Pekar_2002 Methods
#' @inheritSection Sim_Stojanovic_2001 Methods
#' @inheritSection Sim_Wang_edge_2012 Methods
#' @inheritSection Sim_Zhong_2002 Methods
#' @inheritSection Sim_AlMubaid_2006 Methods
#' @inheritSection Sim_Li_2003 Methods
#' @inheritSection Sim_RSS_2013 Methods
#' @inheritSection Sim_HRSS_2013 Methods
#' @inheritSection Sim_Shen_2010 Methods
#' @inheritSection Sim_SSDD_2013 Methods
#' @inheritSection Sim_Jiang_1997 Methods
#' @inheritSection Sim_Kappa Methods
#' @inheritSection Sim_Jaccard Methods
#' @inheritSection Sim_Dice Methods
#' @inheritSection Sim_Overlap Methods
#' @inheritSection Sim_Ancestor Methods
#' 
#' @return A numeric symmetric matrix.
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' annotation = list(
#'     "a" = 1:3,
#'     "b" = 3:4,
#'     "c" = 5,
#'     "d" = 7,
#'     "e" = 4:7,
#'     "f" = 8
#' )
#' dag = create_ontology_DAG(parents, children, annotation = annotation)
#' term_sim(dag, dag_all_terms(dag), method = "Sim_Lin_1998")
term_sim = function(dag, terms, method, control = list(), verbose = simona_opt$verbose) {

	if(missing(method)) {
		method = default_term_sim_method(dag)
	}

	if(is.null(control$verbose)) control$verbose = verbose

	if(any(duplicated(terms))) {
		stop("`term` can not have duplicated elements.")
	}
	sim_fun = get_term_sim_method(method, control)

	sim_fun(dag, terms)
}


# cat(paste("#' @inheritSection", all_group_sim_methods(), "Methods") , sep = "\n")

#' Semantic similarity between two groups of terms
#' 
#' @param dag An `ontology_DAG` object.
#' @param group1 A vector of term names or a list of term vectors.
#' @param group2 A vector of term names or a list of term vectors..
#' @param method A group similarity method. All available methods are in [`all_group_sim_methods()`].
#' @param control A list of parameters passing to individual methods. The term similarity method is controlled by `term_sim_method`
#'     and the IC method is controlled by `IC_method`. Other term similarity related parameters can also be specified in `control`. See the subsections.
#' @param verbose Whether to print messages.
#' 
#' @section Methods:
#' 
#' @inheritSection GroupSim_pairwise_avg Methods
#' @inheritSection GroupSim_pairwise_max Methods
#' @inheritSection GroupSim_pairwise_BMA Methods
#' @inheritSection GroupSim_pairwise_BMM Methods
#' @inheritSection GroupSim_pairwise_ABM Methods
#' @inheritSection GroupSim_pairwise_HDF Methods
#' @inheritSection GroupSim_pairwise_MHDF Methods
#' @inheritSection GroupSim_pairwise_VHDF Methods
#' @inheritSection GroupSim_pairwise_Froehlich_2007 Methods
#' @inheritSection GroupSim_pairwise_Joeng_2014 Methods
#' @inheritSection GroupSim_SimALN Methods
#' @inheritSection GroupSim_SimGIC Methods
#' @inheritSection GroupSim_SimDIC Methods
#' @inheritSection GroupSim_SimUIC Methods
#' @inheritSection GroupSim_SimUI Methods
#' @inheritSection GroupSim_SimDB Methods
#' @inheritSection GroupSim_SimUB Methods
#' @inheritSection GroupSim_SimNTO Methods
#' @inheritSection GroupSim_SimCOU Methods
#' @inheritSection GroupSim_SimCOT Methods
#' @inheritSection GroupSim_SimLP Methods
#' @inheritSection GroupSim_Ye_2005 Methods
#' @inheritSection GroupSim_SimCHO Methods
#' @inheritSection GroupSim_SimALD Methods
#' @inheritSection GroupSim_Jaccard Methods
#' @inheritSection GroupSim_Dice Methods
#' @inheritSection GroupSim_Overlap Methods
#' @inheritSection GroupSim_Kappa Methods
#' 
#' @details
#' If `annotation` is set in `create_ontology_DAG()` and you want to directly calculate semantic similarity between two
#' annotated items, you can first get the associated terms of the two items by [`annotated_terms()`]:
#' 
#' ```
#' group1 = annotated_terms(dag, item1)[[1]]
#' group2 = annotated_terms(dag, item2)[[1]]
#' group_sim(dag, group1, group2, ...)
#' ```
#' 
#' @return A numeric scalar, a numeric vector or a matrix depending on the dat type of `group1` and `group2`.
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' annotation = list(
#'     "a" = c("t1", "t2", "t3"),
#'     "b" = c("t3", "t4"),
#'     "c" = "t5",
#'     "d" = "t7",
#'     "e" = c("t4", "t5", "t6", "t7"),
#'     "f" = "t8"
#' )
#' dag = create_ontology_DAG(parents, children, annotation = annotation)
#' group_sim(dag, c("c", "e"), c("d", "f"), 
#'     method = "GroupSim_pairwise_avg", 
#'     control = list(term_sim_method = "Sim_Lin_1998")
#' )
group_sim = function(dag, group1, group2, method, control = list(), verbose = simona_opt$verbose) {

	if(is.null(control$verbose)) control$verbose = verbose

	if(has_annotation(dag)) {
		if(!"term_sim_method" %in% names(control)) {
			control$term_sim_method = "Sim_Lin_1998"
			control$IC_method = "IC_annotation"
		}
	} else {
		if(!"term_sim_method" %in% names(control)) {
			control$term_sim_method = "Sim_WP_1994"
			control$IC_method = "IC_offspring"
		}
	}
	group_sim_fun = get_group_sim_method(method, control)

	if(!is.list(group1)) {
		group1 = list(group1 = group1)
	}
	if(!is.list(group2)) {
		group2 = list(group2 = group2)
	}

	group_sim_fun(dag, group1, group2)
}

default_term_IC_method = function(dag) {
	if(has_annotation(dag)) {
		"IC_annotation"
	} else {
		"IC_offspring"
	}
}


default_term_sim_method = function(dag) {
	if(has_annotation(dag)) {
		"Sim_Lin_1998"
	} else {
		"Sim_WP_1994"
	}
}

#' Generate a random DAG
#' 
#' @param n_children Number of children of a term. The value can also be a vector of
#'     length two representing the range of the number of child terms.
#' @param p_stop The probability of a term to stop growing.
#' @param max Maximal number of terms.
#' @param verbose Whether to print messages.
#' 
#' @details
#' `dag_random_tree()` generates a random DAG tree from the root term. In a certain step of
#' the growing, let's denote the set of all leaf terms as L, then in the next round of growing,
#' `floor(length(L)*p_stop)` leaf terms stop growing, and for the remaining leaf terms that
#' continue to grow, each term will add child terms with number in uniformly sampled within `[ n_children[1], n_children[2] ]`.
#' The growing stops when the total number of terms in the DAG exceeds `max`.
#' 
#' @returns An `ontology_DAG` object.
#' @rdname dag_random
#' @export
#' @examples
#' tree = dag_random_tree()
#' dag = dag_random()
dag_random_tree = function(n_children = 2, p_stop = 0, max = 2^10-1,
	verbose = simona_opt$verbose) {

	lt_children = list()

	n_children = unique(range(n_children))

	current_nodes = 1
	current_i = 1
	while(TRUE) {

		current_nodes2 = NULL

		k = length(current_nodes)

		ind_stop = sample(k, floor(k*p_stop))
		ind_continue = setdiff(sample(k, k), ind_stop)  # randomly permutated

		# number of children for each "continued" node
		if(length(n_children) == 1) {
			nc = rep(n_children, length(ind_continue))
		} else {
			nc = sapply(ind_continue, function(x) {
				sample(seq(n_children[1], n_children[2]), 1)
			})
		}

		# compare to max
		ll = cumsum(nc) <= max - current_i

		ind_stop = c(ind_stop, ind_continue[!ll])
		ind_continue = ind_continue[ll]
		nc = nc[ll]
		
		current_nodes2 = current_nodes[ind_stop]

		if(length(ind_continue) == 0) {
			break
		}

		for(i in seq_along(ind_continue)) {
			ni = current_nodes[ ind_continue[i] ]

			
			lt_children[[ni]] = current_i + seq_len(nc[i])

			# initialize new children of lt_children[[ni]]
			for(k in lt_children[[ni]]) {
				lt_children[[k]] = integer(0)
			}

			current_i = current_i + nc[i]

			current_nodes2 = c(current_nodes2, lt_children[[ni]])
		}
		current_nodes = current_nodes2
		
	}

	n = length(lt_children)
	parents = rep(1:n, times = sapply(lt_children, length))
	children = unlist(lt_children)

	parents = as.character(parents)
	children = as.character(children)

	create_ontology_DAG(parents, children, source = "dag_random_tree", verbose = verbose)
}


#' @param dag An `ontology_DAG` object.
#' @param p_add The probability to add children on each term.
#' @param new_children The number or range of numbers of new children if a term is selected to add more children.
#' @param add_random_children_fun A function to randomly add children from the DAG.
#' 
#' @details
#' `dag_add_random_children()` adds more links in a DAG. Each term is associated with a probability `p_add`
#' to add new links where the term, if it is selected, is as a parent term, linking to other terms in the DAG.
#' The number of new child terms is controlled by `new_children` which can be a single number of a range. By default,
#' new child terms of a term `t` are randomly selected from other terms that are lower than the term `t`
#' (check the function `simona:::add_random_children`). The way how to randomly select new child terms for `t`
#' can be controlled by a self-defined function for the `add_random_children_fun` argument.
#' 
#' @rdname dag_random
#' @importFrom stats runif
#' @export
dag_add_random_children = function(dag, p_add = 0.1, new_children = c(1, 4),
	add_random_children_fun = NULL, verbose = simona_opt$verbose) {

	if(p_add < 0) {
		return(dag)
	}

	if(length(new_children) == 1) {
		new_children = c(new_children, new_children)
	}

	depth = dag_depth(dag)
	lt_children = dag@lt_children
	n_terms = dag_n_terms(dag)

	if(!is.null(add_random_children_fun)) {
		for(i in 1:n_terms) {
			if(runif(1) < p_add) {
				lt_children[[i]] = c(lt_children[[i]], add_random_children_fun(dag, i))
			}
		}
	} else {
		for(i in 1:n_terms) {
			if(runif(1) < p_add) {
				lt_children[[i]] = c(lt_children[[i]], add_random_children(dag, i, new_children))
			}
		}
	}

	lt_children = lapply(lt_children, unname)

	parents = rep(1:n_terms, times = sapply(lt_children, length))
	children = unlist(lt_children)

	parents = dag@terms[parents]
	children = dag@terms[children]

	dag2 = create_ontology_DAG(parents, children, verbose = verbose)
	if(has_annotation(dag)) {
		dag2@annotation = dag@annotation
	}
	mcols(dag2) = mcols(dag)

	dag2@source = "dag_add_random_children"

	dag2
}


add_random_children = function(dag, i, new_children = c(1, 4)) {
	# add a link to nodes with depth > itself
	depth = dag_depth(dag)
	l = depth > depth[i] 
	if(length(dag@lt_children[[i]])) {
		l[dag@lt_children[[i]]] = FALSE
	}

	candidates = which(l)
	n_candidates = length(candidates)
	if(n_candidates) {
		if(n_candidates < new_children[1]) {
			integer(0)
		} else {
			sample(candidates, min(n_candidates, sample(seq(new_children[1], new_children[2]), 1)))
		}
	} else {
		integer(0)
	}	
}


#' @details
#' `dag_random()`: it simply wraps `dag_random_tree()` and `dag_add_random_children()`.
#' 
#' @rdname dag_random
#' @export
dag_random = function(n_children = 2, p_stop = 0, max = 2^10-1,
	p_add = 0.1, new_children = c(1, 4), verbose = simona_opt$verbose) {

	tree = dag_random_tree(n_children = n_children, p_stop = p_stop, max = max, verbose = verbose)
	dag_add_random_children(tree, p_add = p_add, new_children = new_children, verbose = verbose)
}

#' The ontology_DAG class
#' 
#' This class defines the DAG structure of an ontology.
#' 
#' @slot terms A character vector of length `n` of all term names. Other slots that store term-level information use the integer indices of terms.
#' @slot n_terms An integer scalar of the total number of terms in the DAG.
#' @slot n_relations An integer scalar of the total number of relations in the DAG.
#' @slot lt_parents A list of length `n`. Each element in the list is an integer index vector of the parent terms of the i^th term.
#' @slot lt_children A list of length `n`. Each element in the list is an integer index vector of the child terms of the i^th term.
#' @slot lt_children_relations A list of length `n`. Each element is a vector of the semantic relations between the i^th term and its child terms, e.g. a child "is_a" parent.
#'       The relations are represented as integers. The character name of the relations is in `attr(dag@lt_children_relations, "levels")`.
#' @slot relations_DAG A simple `ontology_DAG` object but constructed for relation types.
#' @slot source The source of the ontology. A character scalar only used as a mark of the returned object.
#' @slot root An integer scalar of the root term.
#' @slot leaves An integer vector of the indicies of leaf terms.
#' @slot alternative_terms A named character vector of mappings between alternative terms to DAG terms.
#' @slot tpl_sorted An integer vector of reordered term indices which has been topologically sorted in the DAG. Terms are sorted first by the depth (maximal
#'       distance from root), then the number of child terms, then the number of parent terms, and last the term names.
#' @slot tpl_pos The position of the original term in the topologically sorted path (similar as the rank), e.g. the value of the first element in the vector
#'       is the position of term 1 in the topologically sorted path.
#' @slot annotation A list of two elements: `list` and `names`. The `dag@annotation$list` element contains a list of length `n` and each element
#'       is a vector of integer indices of annotated items. The full list of annotated items is in `dag@annotation$names`.
#' @slot term_env An environment which contains various term-level statistics. It is mainly for cache purpose.
#' @slot aspect_ratio A numeric vector of length two. The aspect ratio is calculated as `w/h`. For each term, there is a distance to root, 
#'       `h` is the maximal distance of all terms, `w` is the maximal number of items with the same distance. The two values in the `aspect_ratio` slot
#'       use maximal distance to root (the height) and the shortest distance to root as the distance measure.
#' @slot elementMetadata An additional data frame with the same number of rows as the number of terms in DAG. Order of rows should be the same as order of terms in `dag@terms`.
#' 
#' @export ontology_DAG
#' @exportClass ontology_DAG
#' @returns An `ontology_DAG` object.
#' @examples
#' 1
#' # This function should not be used directly.
ontology_DAG = setClass("ontology_DAG",
	slots = c("terms" = "character",
		      "n_terms" = "integer",
		      "n_relations" = "integer",
		      "lt_parents" = "list",
		      "lt_children" = "list",
		      "lt_children_relations" = "list",
		      "relations_DAG" = "ANY",
		      "source" = "character",
		      "root" = "integer",
		      "leaves" = "integer",
		      "alternative_terms" = "character",
		      "tpl_sorted" = "integer",
		      "tpl_pos" = "integer",
		      "annotation" = "list",
		      "term_env" = "environment",
		      "aspect_ratio" = "numeric",
		      "elementMetadata" = "ANY"
		      )
)

#' Create the ontology_DAG object
#' 
#' @param parents A character vector of parent terms. You can also construct the `ontology_DAG` object by a list of parent-child links. See **Examples**.
#' @param children A character vector of child terms. 
#' @param relations A character vector of parent-child relations, e.g. "is_a", "part_of", or self-defined semantic relations.
#'        If it is set, it should have the same length as `parents` and `children`.
#' @param relations_DAG If the relation types have hierarchical relations, it can also be constructed by `create_ontology_DAG()` first. See **Examples**.
#'          When the DAG for relation types is provided, the ancestor/offspring relationship of relation types will be taken into consideration automatically.
#' @param source Source of the ontology. It is only used as a label of the object.
#' @param annotation A list of character vectors which contain items annotated to the terms. Names of the list should be the term names. In the DAG, items
#'                   annotated to a term will also be annotated to its parents. Such merging
#'                   is applied automatically in the package.
#' @param remove_cyclic_paths Whether to remove cyclic paths If a cyclic path is represented as `[a, b, ..., z, a]`,
#'       the last link (i.e. `z->a`) is simply removed. If the value is set to `FALSE` and if there are cyclic paths, there
#'       will be an error that lists all cyclic paths.
#' @param remove_rings There might be rings that are isolated to the main DAG where there are no roots on the rings, thus they cannot be attached to the main DAG. If the value
#'        of `remove_rings` is set to `TRUE`, such rings are removed.
#' @param alternative_terms A named list or vector that contains mappings from alternative term IDs to terms used in the DAG. In an ontology, there
#'            might be old terms IDs marked as "replaced_by", "consider" or "alt_id" in ".obo" file. You can provide mappings from old term iDs to current term IDs with this argument. 
#'            If it is a one-to-one mapping, the mapping
#'            can be a named vector where alternative term IDs are names and DAG term IDs are values. It it is a one-to-many mapping, the variable
#'            should be a named list where each member vector will first be matched to the DAG terms. If the mapping is still one-to-many, the first one is selected.
#' @param verbose Whether to print messages.
#' 
#' @return An `ontology_DAG` object.
#' @export
#' @importFrom methods new
#' @importFrom stats quantile
#' @import Rcpp
#' @useDynLib simona, .registration = TRUE
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' 
#' # with annotations
#' annotation = list(
#'     "a" = c("t1", "t2", "t3"),
#'     "b" = c("t3", "t4"),
#'     "c" = "t5",
#'     "d" = "t7",
#'     "e" = c("t4", "t5", "t6", "t7"),
#'     "f" = "t8"
#' )
#' dag = create_ontology_DAG(parents, children, annotation = annotation)
#' 
#' # with relations
#' dag = create_ontology_DAG(parents, children, 
#'     relations = c("is_a", "part_of", "is_a", "part_of", "is_a", "part_of"))
#' 
#' # with relations_DAG
#' relations_DAG = create_ontology_DAG(c("r2", "r2"), c("r3", "r4"))
#' dag = create_ontology_DAG(parents, children, 
#'     relations = c("r1", "r2", "r1", "r3", "r1", "r4"),
#'     relations_DAG = relations_DAG)
#' 
#' # with a list of parent-child relations
#' dag = create_ontology_DAG(c("a-b", "a-c", "b-c", "b-d", "c-e", "e-f"))
create_ontology_DAG = function(parents, children, relations = NULL, relations_DAG = NULL,
	source = "Ontology", annotation = NULL, remove_cyclic_paths = FALSE, remove_rings = FALSE,
	alternative_terms = list(), verbose = simona_opt$verbose) {

	if(missing(children)) {
		if(any(grepl("\\s+-\\s+", parents))) {
			lt = strsplit(parents, "\\s+-\\s+")
		} else {
			lt = strsplit(parents, "\\s*-\\s*")
		}
		
		parents = sapply(lt, function(x) x[1])
		children = sapply(lt, function(x) x[2])
	}

	if(!is.character(parents)) {
		stop("`parents` should be in character mode.")
	}

	if(!is.character(children)) {
		stop("`children` should be in character mode.")
	}

	l = parents == children
	if(any(l)) {
		if(verbose) {
			message("removed ", sum(l), " relations where parents are the same as children.")
		}
		parents = parents[!l]
		children = children[!l]
	}

	if(length(parents) == 0 || length(children) == 0) {
		stop("There is no relation.")
	}

	has_relations = !is.null(relations)
	lt_relations = list()

	if(has_relations && any(l)) {
		relations = relations[!l]
	}

	terms = sort(unique(c(parents, children)))
	n_terms = length(terms)
	terms2ind = structure(seq_along(terms), names = terms)

	lt_parents2 = split(unname(terms2ind[parents]), children)
	lt_children2 = split(unname(terms2ind[children]), parents)
	if(has_relations) {
		relations = normalize_relation_type(relations)
		relations = as.factor(relations)
		relation_levels = levels(relations)
		relations = as.integer(relations)
		lt_relations2 = split(relations, parents)
	}

	lt_parents = rep(list(integer(0)), n_terms)
	lt_children = lt_parents
	lt_parents[ terms2ind[names(lt_parents2)] ] = lt_parents2
	lt_children[ terms2ind[names(lt_children2)] ] = lt_children2
	if(has_relations) {
		lt_relations = rep(list(integer(0)), n_terms)
		lt_relations[ terms2ind[names(lt_relations2)] ] = lt_relations2
		attr(lt_relations, "levels") = relation_levels
	}

	root = which(vapply(lt_parents, length, FUN.VALUE = integer(1)) == 0)
	leaves = which(vapply(lt_children, length, FUN.VALUE = integer(1)) == 0)

	if(length(root) == 0) {
		stop("Cannot find the root. There might exist a cycle.")
	}
	
	if(length(root) > 1) {
		if(length(root) > 5) {
			txt = strwrap(paste(terms[root][seq_len(5)], collapse = ", "), width = 80)
			txt[length(txt)] = paste0(txt[length(txt)], ",")
			txt = c(txt, qq("  and other @{length(root)-5} term@{ifelse(length(root)-5 == 1, '', 's')} ..."))
		} else {
			txt = strwrap(paste(terms[root], collapse = ", "), width = 80)
		}
		txt = paste(paste0("  ", txt), collapse = "\n")
		if(verbose) {
			message("There are more than one root:\n", txt, "\n  A super root (", SUPER_ROOT, ") is added.")
		}
		
		super_root = n_terms + 1L
		lt_parents[[super_root]] = integer(0)
		for(r in root) {
			lt_parents[[r]] = super_root
		}

		lt_children[[super_root]] = root
		if(has_relations) lt_relations[[super_root]] = rep(which(relation_levels == "is_a"), length(root))
		terms = c(terms, SUPER_ROOT)
		root = super_root
		n_terms = n_terms + 1
	}

	if(!is.null(relations_DAG)) {
		if(!inherits(relations_DAG, "ontology_DAG")) {
			stop("`relations_DAG` should be constructed by `create_ontology_DAG()`.")
		}
	}

	alt_var = character(0)
	if(length(alternative_terms)) {
		# change alternative_terms to a named vector
		if(is.atomic(alternative_terms)) {
			if(is.null(names(alternative_terms))) {
				stop("`alternative_terms` should be a named vector.")
			}

			alt_var = alternative_terms[alternative_terms %in% terms]
			alt_var = alt_var[!is.na(alt_var)]
		} else if(is.list(alternative_terms)) {
			if(is.null(names(alternative_terms))) {
				stop("`alternative_terms` should be a named list.")
			}
			alternative_terms = lapply(alternative_terms, function(x) {
				x = x[!is.na(x)]
				intersect(x, terms)
			})
			alternative_terms = alternative_terms[sapply(alternative_terms, length) > 0]

			if(length(alternative_terms)) {
				alt_var = sapply(alternative_terms, function(x) x[1])
			}
		} else {
			stop("`alternative_terms` should be a named vector of a named list.")
		}
	}

	dag = ontology_DAG(
		terms = terms,
		n_terms = length(terms),
		n_relations = sum(vapply(lt_children, length, FUN.VALUE = integer(1))),
		lt_parents = lt_parents,
		lt_children = lt_children,
		lt_children_relations = lt_relations, 
		relations_DAG = relations_DAG,
		source = source,
		root = root,
		leaves = leaves,
		alternative_terms = alt_var,
		term_env = new.env(parent = emptyenv())
	)

	cyclic_paths = cpp_check_cyclic_node(dag)

	if(length(cyclic_paths)) {
		if(remove_cyclic_paths) {
			message_wrap(qq("Removed @{length(cyclic_paths)} cyclic path@{ifelse(length(cyclic_paths) == 1, '', 's')}."))
			removed_p = vapply(cyclic_paths, function(x) x[length(x)-1], FUN.VALUE = integer(1))
			removed_c = vapply(cyclic_paths, function(x) x[length(x)], FUN.VALUE = integer(1))

			for(ir in seq_along(cyclic_paths)) {
				ip = removed_p[ir]
				ic = removed_c[ir]

				lt_parents[[ic]] = setdiff(lt_parents[[ic]], ip)
				ind = lt_children[[ip]] != ic
				lt_children[[ip]] = lt_children[[ip]][ind]
				if(length(lt_relations)) {
					lt_relations[[ip]] = lt_relations[[ip]][ind]
				}
			}
			root = which(vapply(lt_parents, length, FUN.VALUE = integer(1)) == 0)
			leaves = which(vapply(lt_children, length, FUN.VALUE = integer(1)) == 0)

			dag = ontology_DAG(
				terms = terms,
				n_terms = length(terms),
				n_relations = sum(vapply(lt_children, length, FUN.VALUE = integer(1))),
				lt_parents = lt_parents,
				lt_children = lt_children,
				lt_children_relations = lt_relations, 
				relations_DAG = relations_DAG,
				source = source,
				root = root,
				leaves = leaves,
				alternative_terms = alt_var,
				term_env = new.env(parent = emptyenv())
			)
		} else {
			if(verbose) {
				print_cyclic_paths(cyclic_paths, terms)
			}
			stop_wrap("Found cyclic nodes (paths are listed above). Set `remove_cyclic_paths = TRUE` to remove them.")
		}
	}

	dag@term_env$n_parents = vapply(lt_parents, length, FUN.VALUE = integer(1))
	dag@term_env$n_children = vapply(lt_children, length, FUN.VALUE = integer(1))

	tpl_order = order(dag_depth(dag), dag@term_env$n_children, dag@term_env$n_parents, dag@terms)
	dag@tpl_sorted = seq_len(n_terms)[tpl_order]
	dag@tpl_pos = seq_len(n_terms)
	
	# pos has the same order as terms, but the value are the positions on `sorted`, i.e. the rank
	dag@tpl_pos[tpl_order] = seq_len(n_terms)

	dag@annotation = list(list = vector("list", 0), names = character(0))
	dag = add_annotation(dag, annotation)

	depth = dag_depth(dag)
	tb1 = table(depth)
	aspect_ratio1 = max(tb1)/quantile(depth, 0.99)
	aspect_ratio1 = round(aspect_ratio1, 2)

	dist = cpp_dag_dist_from_root(dag)
	tb2 = table(dist)
	aspect_ratio2 = max(tb2)/quantile(dist, 0.99)
	aspect_ratio2 = round(aspect_ratio2, 2)

	dag@aspect_ratio = c(aspect_ratio1, aspect_ratio2)

	iring = which(depth < 0)
	if(length(iring)) {
		if(remove_rings) {
			if(verbose) {
				message_wrap(qq("Removed @{length(iring)} terms in isolated rings."))
			}
			return(dag[[dag_root(dag)]])
		} else {
			for(i in iring) {
				cyclic_paths = cpp_check_cyclic_node(dag, i)
				print_cyclic_paths(cyclic_paths[1], terms)
				stop_wrap("Found isolated rings (one path is listed above). Set `remove_rings = TRUE` to remove them.")
			}	
		}
	}

	return(dag)
}

singleton_ontology = function(term) {
	ontology_DAG(
		terms = term,
		n_terms = 1L,
		n_relations = 0L,
		lt_parents = list(integer(0)),
		lt_children = list(integer(0)),
		source = "singleton",
		root = 1L,
		leaves = 1L,
		term_env = new.env(parent = emptyenv())
	)
}

#' Add annotations to the DAG object
#' 
#' @param dag An `ontology_DAG` object.
#' @param annotation A list of character vectors which contain items annotated to the terms. Names of the list should be the term names. In the DAG, items
#'                   annotated to a term will also be annotated to its parents. Such merging
#'                   is applied automatically in the package.
#' 
#' @return An `ontology_DAG` object.
#' @export
add_annotation = function(dag, annotation) {
	if(!is.null(annotation)) {
		annotation = lapply(annotation, as.character)
		all_anno = unique(unlist(annotation))
		n_all_anno = length(all_anno)
		anno2ind = structure(seq_along(all_anno), names = all_anno)
		annotation = lapply(annotation, function(x) unname(anno2ind[as.character(x)]))

		n_terms = dag@n_terms
		annotation2 = rep(list(integer(0)), n_terms)
		term2ind = structure(seq_along(dag@terms), names = dag@terms)

		cn = intersect(dag@terms, names(annotation))
		if(length(cn) == 0) {
			stop("No overlap between annotation names and terms.")
		}
		annotation2[ term2ind[cn] ] = annotation[cn]

		dag@annotation = list(list = annotation2,
			                  names = all_anno)
	} else {
		dag@annotation = list(list = vector("list", 0), names = character(0))
	}
	dag
}

print_cyclic_paths = function(cyclic_paths, terms) {
	for(i in seq_len(length(cyclic_paths))) {
		message("[", appendLF = FALSE)
		msg = paste(terms[cyclic_paths[[i]]], collapse = " ~ ")
		message(msg, appendLF = FALSE)
		message("]", appendLF = TRUE)
	}
}

#' Print the ontology_DAG object
#' 
#' @param object An `ontology_DAG` object.
#' @returns No value is returned.
#' @exportMethod show
setMethod("show",
	signature = "ontology_DAG",
	definition = function(object) {

		n_terms = object@n_terms
		n_relations = object@n_relations

		cat("An ontology_DAG object:\n")
		cat("  Source:", object@source, "\n")
		if(n_terms == n_relations + 1) {
			cat("  ", n_terms, " terms / ", n_relations, " relations / a tree\n", sep = "")
		} else {
			cat("  ", n_terms, " terms / ", n_relations, " relations\n", sep = "")
		}

		cat("  Root:", paste(object@terms[object@root], collapse = ", "), "\n")
		txt = strwrap(paste(c(object@terms[seq_len(min(4, object@n_terms))], "..."), collapse = ", "), width = 60)
		txt[1] = paste0("  Terms: ", txt[1])
		txt[-1] = paste0("         ", txt[-1])
		cat(txt, sep = "\n")
		
		if(!is.null(object@term_env$dag_depth)) {
			depth = object@term_env$dag_depth
			cat("  Max depth:", max(depth), "\n")
		}

		if(n_terms > 1) {
			if(n_terms == n_relations + 1) {
				cat("  Aspect ratio: ", object@aspect_ratio[1], ":1\n", sep = "")
			} else {
				cat("  Avg number of parents: ", sprintf("%.2f", mean(n_parents(object)[-dag_root(object, in_labels = FALSE)])), "\n", sep = "")
				cat("  Avg number of children: ", sprintf("%.2f", mean(n_parents(object)[-dag_leaves(object, in_labels = FALSE)])), "\n", sep = "")
				cat("  Aspect ratio: ", object@aspect_ratio[1], ":1 (based on the longest distance from root)\n", sep = "")
				cat("                ", object@aspect_ratio[2], ":1 (based on the shortest distance from root)\n", sep = "")
			}
		}

		if(length(object@lt_children_relations)) {
			rel_levels = attr(object@lt_children_relations, "levels")
			txt = strwrap(paste(rel_levels, collapse = ", "), width = 60)
			txt[1] = paste0( "  Relations: ", txt[1])
			txt[-1] = paste0("             ", txt[-1])
			cat(txt, sep = "\n")

			if(!is.null(object@relations_DAG)) {
				if(length(intersect(object@relations_DAG@terms, attr(object@lt_children_relations, "levels")))) {
					cat("  Relation types may have hierarchical relations.\n")
				}
			}
		}

		if(length(object@annotation$list)) {
			cat("  Annotations:", length(object@annotation$names), "items\n")
			txt = strwrap(paste(c(object@annotation$names[seq_len(min(4, length(object@annotation$names)))], "..."), collapse = ", "), width = 60)
			txt = paste0("               ", txt)
			cat(txt, sep = "\n")
		}

		if(!is.null(object@elementMetadata)) {
			cat("\n")
			cat("With the following columns in the metadata data frame:\n")
			txt = strwrap(paste(colnames(object@elementMetadata), collapse = ", "), width = 60)
			txt = paste0("  ", txt)
			cat(txt, sep = "\n")
		}
	}
)


#' Names of all terms
#' 
#' @param dag An `ontology_DAG` object.
#' 
#' @return `dag_all_terms()` returns a vector of term names. `dag_n_terms()` returns
#'      a single iteger.
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' dag_all_terms(dag)
#' dag_n_terms(dag)
dag_all_terms = function(dag) {
	dag@terms
}

#' @rdname dag_all_terms
#' @export
dag_n_terms = function(dag) {
	dag@n_terms
}

#' @rdname dag_all_terms
#' @export
dag_n_relations = function(dag) {
	sum(sapply(dag@lt_children, length))
}

#' @rdname dag_all_terms
#' @export
dag_n_leaves = function(dag) {
	length(dag@leaves)
}

#' Root or leaves of the DAG
#' 
#' @param dag An `ontology_DAG` object.
#' @param in_labels Whether the terms are represented in their names or as integer indices?
#' 
#' @return A character or an integer vector.
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' dag_root(dag)
#' dag_leaves(dag)
dag_root = function(dag, in_labels = TRUE) {
	if(in_labels) {
		dag@terms[dag@root]
	} else {
		dag@root
	}
}

#' @rdname dag_root
#' @export
dag_leaves = function(dag, in_labels = TRUE) {
	if(in_labels) {
		dag@terms[dag@leaves]
	} else {
		dag@leaves
	}
}

#' @param terms A vector of term names.
#' 
#' @rdname dag_root
#' @export
dag_is_leaf = function(dag, terms) {
	id = term_to_node_id(dag, terms)
	l = id %in% dag@leaves
	structure(l, names = dag@terms[id])
}

#' Convert to an igraph object
#' 
#' @param dag An `ontology_DAG` object.
#' 
#' @details If `relations` is already set in [`create_ontology_DAG()`], relations are also set as an edge attribute in the [`igraph::igraph`] object.
#' 
#' @return An [`igraph::igraph`] object.
#' @export
#' @import igraph
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' dag_as_igraph(dag)
dag_as_igraph = function(dag) {

	check_pkg("igraph")

	lt_children = dag@lt_children
	children = unlist(lt_children)
	parents = rep(seq_along(dag@terms), times = vapply(lt_children, length, FUN.VALUE = integer(1)))
	if(length(dag@lt_children_relations) > 0) {
		relation_levels = attr(dag@lt_children_relations, "levels")
		relations = unlist(dag@lt_children_relations)
		relations = relation_levels[relations]
	} else {
		relations = NULL
	}

	g = graph_from_edgelist(cbind(parents, children))
	V(g)$name = dag@terms

	if(!is.null(relations)) {
		g = set_edge_attr(g, "relation", value = relations)
	}

	g
}


#' Get or set meta columns on DAG
#' 
#' @param x An `ontology_DAG` object.
#' @param use.names Please ignore.
#' @param ... Other argument. For `mcols()`, it can be a vector of column names in the meta data frame.
#' @exportMethod mcols
#' @importMethodsFrom S4Vectors mcols
#' @rdname mcols_ontology_DAG
#' @returns A data frame.
setMethod("mcols", 
	signature = "ontology_DAG",
	definition = function(x, use.names = TRUE, ...) {
	columns = unlist(list(...))
	if(length(columns)) {
		x@elementMetadata[, columns]
	} else {
		x@elementMetadata
	}
})


#' @param x An `ontology_DAG` object.
#' @param ... Other argument. For `mcols()`, it can be a vector of column names in the meta data frame.
#' @param value A data frame or a matrix where rows should correspond to terms in `x@terms`.
#' @exportMethod 'mcols<-'
#' @importMethodsFrom S4Vectors 'mcols<-'
#' @rdname mcols_ontology_DAG
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' mcols(dag) = data.frame(id = letters[1:6], v = 1:6)
#' mcols(dag)
#' mcols(dag, "id")
#' dag
setMethod("mcols<-", 
	signature = "ontology_DAG",
	definition = function(x, ..., value) {

	if(is.null(value)) {
		return(x)
	}
	
	df = as.data.frame(value)

	if(nrow(df) != x@n_terms) {
		if(dag_root(x) == SUPER_ROOT) {
			df2 = df[seq_len(nrow(df)+1), , drop = FALSE]
			rownames(df2)[nrow(df2)] = SUPER_ROOT
			
			if(! (nrow(df) == x@n_terms - 1 || nrow(df) == x@n_terms) ) {
				stop("value should be a table with the same number of rows as the number of terms in DAG.")
			}

			df = df2
		} else {
			if(nrow(df) != x@n_terms) {
				stop("value should be a table with the same number of rows as the number of terms in DAG.")
			}
		}
	}

	rownames(df) = x@terms

	x@elementMetadata = as(df, "DataFrame")
	invisible(x)
})


dag_namespaces = function(dag) {
	df = mcols(dag)
	if(is.null(df)) {
		return(NULL)
	}

	if(!"namespace" %in% colnames(df)) {
		return(NULL)
	}

	unique(df$namespace)
}

#' Create the ontology_DAG object from the igraph object
#' 
#' @param g An [`igraph::igraph`] object.
#' @param relations A vector of relation types. The length of the vector should be the same as the number of edges in `g`.
#' @param verbose Whether to print messages.
#' 
#' @return An `ontology_DAG` object.
#' @export
#' @import igraph
create_ontology_DAG_from_igraph = function(g, relations = NULL, verbose = simona_opt$verbose) {

	if(!is_dag(g)) {
		stop("The graph object should be a DAG.")
	}

	edges = get.edgelist(g)
	create_ontology_DAG(as.character(edges[, 1]), as.character(edges[, 2]), relations = relations, 
		source = "igraph object", verbose = verbose)
}


#' Whether the terms exist in the DAG
#' 
#' @param dag An `ontology_DAG` object.
#' @param terms A vector of term IDs.
#' 
#' @return A logical vector.
#' @export
dag_has_terms = function(dag, terms) {
	terms %in% c(dag@terms, names(dag@alternative_terms))
}

library(testthat)

test_that("test cyclic_node", {
	parents = c("a", "b", "c", "d")
	children = c("b", "c", "d", "b")
	expect_error(
		create_ontology_DAG(parents, children),
		"Found cyclic nodes"
	)

	parents = c("a", "b", "c", "g", "h")
	children = c("b", "c", "d", "h", "i")
	expect_message(
		dag <- create_ontology_DAG(parents, children),
		"more than one root"
	)
	expect_equal(
		length(dag@terms),
		length(unique(c(parents, children))) + 1
	)

	parents = c("a", "b", "c", "d")
	children = c("b", "c", "d", "a")
	expect_error(
		create_ontology_DAG(parents, children),
		"There might exist a cycle"
	)
})


#   b--d--f
#  / \
# a---c--e
# upstream -> downstream

parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")

dag = create_ontology_DAG(parents, children)

test_that("test sub-DAG", {
	expect_identical(
		dag[["c"]]@terms,
		c("c", "e")
	)
	expect_identical(
		dag[["b"]]@terms,
		c("b", "c", "d", "e", "f")
	)
	expect_error(
		dag["l"]
	)

	expect_identical(
		dag["f"]@terms, 
		"~~singleton~~"
	)
})


test_that("test DAG filter", {
	expect_identical(
		dag_filter(dag, terms = c("b", "d", "f"))@terms,
		c("b", "d", "f")
	)
	expect_identical(
		dag_filter(dag, root = "b")@terms,
		c("b", "c", "d", "e", "f")
	)
	expect_identical(
		dag_filter(dag, root = c("b", "c"))@terms,
		c("b", "c", "d", "e", "f")
	)
	expect_identical(
		dag_filter(dag, leaves = c("c", "d"))@terms,
		c("a", "b", "c", "d")
	)
	expect_identical(
		dag_filter(dag, leaves = c("b", "c"))@terms,
		c("a", "b", "c")
	)
	expect_identical(
		dag_filter(dag, root = "b", leaves = "e")@terms,
		c("b", "c", "e")
	)
})


parents  = c("a", "b", "c", "d", "e")
children = c("b", "c", "d", "e", "b")

test_that("test cyclic path", {
	expect_error(
		create_ontology_DAG(parents, children), 
		"Found cyclic nodes"
	)

	expect_message(
		create_ontology_DAG(parents, children, remove_cyclic_paths = TRUE), 
		"Remove"
	)
})

parents  = c("a", "b", "c", "d", "f", "g", "h")
children = c("b", "c", "d", "e", "g", "h", "f")

test_that("test isolated rings", {
	expect_error(
		create_ontology_DAG(parents, children),
		"Found isolated rings"
	)

	expect_message(
		create_ontology_DAG(parents, children, remove_rings = TRUE), 
		"Remove"
	)
})

setwd("~/workspace/ontology")


# http://obofoundry.org/


dir.create("OBOFoundry", showWarnings = FALSE)
setwd("OBOFoundry")

library(jsonlite)

lt = fromJSON("http://obofoundry.org/registry/ontologies.jsonld")
tb = lt$ontologies
saveRDS(tb, file = "OBOFoundry_meta_table.rds")

library(rvest)
options(timeout = 9999999)

for(i in seq_len(nrow(tb))) {
	qqcat("============ @{tb[i, 'id']} [@{i}/@{nrow(tb)}] ============\n")

	html = read_html(qq("http://obofoundry.org/ontology/@{tb[i, 'id']}.html"))
	nodes = html %>% html_elements(xpath = "//div[contains (text(), 'Products')]/following-sibling::table/*/tr/td[1]/a[@href]")
	file = nodes %>% html_text()
	url = nodes %>% html_attr("href")

	dir.create(tb$id[i], showWarnings = FALSE)

	for(j in seq_along(file)) {
		dest = qq("@{tb$id[i]}/@{basename(file[j])}")

		oe = try(header <- curlGetHeaders(url[j]))
		if(!inherits(oe, "try-error")) {
			ln2 = header[grepl("Content-Length", header, ignore.case = TRUE)]

			filesize = max(as.numeric(gsub('^Content-Length: (\\d+)\\s*$', "\\1", ln2, ignore.case = TRUE)))
			
			if(file.exists(dest)) {
				if(file.info(dest)[1, "size"] == filesize) {
					qqcat("already downloaded, skip.\n")
					next
				}
			}
		}
		oe = try(download.file(url[j], dest = dest))
		if(inherits(oe, "try-error")) {
			file.remove(dest)
		}
	}
}



##########################

setwd("~/workspace/ontology")

dir.create("BioPortal", showWarnings = FALSE)
setwd("BioPortal")

options(timeout = 9999999)

## https://bioportal.bioontology.org/
apikey = 
js = fromJSON(qq("https://data.bioontology.org/ontologies?apikey=@{apikey}"))

saveRDS(js, file = "BioPortal_meta_table.rds")


for(i in seq_len(nrow(js))) {
	acronym = js$acronym[i]
	submissions = js$links$submissions[i]

	qqcat("============ @{acronym} [@{i}/@{nrow(js)}] ============\n")

	oe = try(sub <- fromJSON(qq("@{submissions}?apikey=@{apikey}")))

	if(inherits(oe, "try-error")) {
		next
	}

	if(length(sub) == 0) {
		next
	}

	hasOntologyLanguage = sub$hasOntologyLanguage[1]
	submission_id = sub[1, "@id"]

	url = qq("@{submission_id}/download?apikey=@{apikey}")
	header = curlGetHeaders(url)
	ln = header[grepl("Content-Disposition: attachment; filename", header, ignore.case = TRUE)]
	ln2 = header[grepl("Content-Length", header, ignore.case = TRUE)]

	if(length(ln)) {
		dest = gsub('^Content-Disposition: attachment; filename="(.*)".*$', "\\1", ln, ignore.case = TRUE)
		filesize = as.numeric(gsub('^Content-Length: (\\d+)\\s*$', "\\1", ln2, ignore.case = TRUE))
	} else {
		next
	}

	dest = qq("@{acronym}/@{dest}")

	dir.create(acronym, showWarnings = FALSE)

	if(file.exists(dest)) {
		qqcat("already downloaded, skip.\n")
		if(file.info(dest)[1, "size"] == filesize) {
			next
		}
	}

	qqcat("  hasOntologyLanguage: @{hasOntologyLanguage}\n")
	qqcat("  download: @{submission_id}/download\n")
	qqcat("  local: @{dest}\n")
	cat("\n")

	download.file(qq("@{submission_id}/download?apikey=@{apikey}"), dest = dest)
}

#' Sim_Lin_1998
#' 
#' @section Methods:
#' ## Sim_Lin_1998
#' 
#' The similarity between two terms `a` and `b` is calculated as the IC of their MICA term `c` normalized by the average of the IC of the two terms:
#' 
#' ```
#' sim = IC(c)/((IC(a) + IC(b))/2) 
#'     = 2*IC(c)/(IC(a) + IC(b))
#' ```
#' 
#' Although any IC method can be used here, in more applications, it is normally used together with the *IC_annotation* method.
#' 
#' Paper link: \doi{10.5555/645527.657297}.
#' 
#' @rdname temp__Sim_Lin_1998
Sim_Lin_1998 = function(dag, terms, IC_method = "IC_annotation", verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_Lin_1998")
	}
	id = term_to_node_id(dag, terms, strict = FALSE)
	ic = term_IC(dag, IC_method, verbose = FALSE)[id]

	if(IC_method == "IC_annotation") {
		l = validate_annotated_terms(dag, id)
		id = id[l]
		ic = ic[l]

		if(verbose) {
			if(any(!l)) {
				message(sum(!l), " terms are removed because of no annotation.")
			}
		}
	}

	ic_mica = MICA_IC(dag, id, IC_method, verbose = verbose)

	sim = 2*ic_mica/cross_sum(ic)
	sim[is.na(sim)] = 1
	dimnames(sim) = list(dag@terms[id], dag@terms[id])
	
	sim
}
ADD_TERM_SIM_METHOD("Sim_Lin_1998")


#' Sim_Resnik_1999
#' 
#' @section Methods:
#' ## Sim_Resnik_1999
#' 
#' The IC method is fixed to `IC_annotation`.
#' 
#' The original Resnik similarity is the IC of the MICA term. There are three ways to normalize the Resnik similarity into the scale of `[0, 1]`:
#' 
#' 1. *Nunif*
#' 
#' ```
#' sim = IC(c)/log(N)
#' ```
#' 
#' where `N` is the total number of items annotated to the whole DAG, i.e. number of items annotated to the root. Then the IC
#' of a term with only one item annotated is `-log(1/N)` = log(N)` which is the maximal IC value in the DAG. 
#' 
#' 2. *Nmax*
#' 
#' `IC_max` is the maximal IC of all terms. If there is a term with only one item annotated, `Nmax` is identical to the `Nunif* method.
#' 
#' ```
#' sim = IC(c)/IC_max
#' ``` 
#' 
#' 3. *Nunivers*
#' 
#' The IC is normalized by the maximal IC of term `a` and `b`.
#' 
#' ```
#' sim = IC(c)/max(IC(a), IC(b))
#' ```
#' 
#' Paper link: \doi{10.1613/jair.514}, \doi{10.1186/1471-2105-9-S5-S4}, \doi{10.1186/1471-2105-11-562}, \doi{10.1155/2013/292063}.
#' 
#' The normalization method can be set with the `norm_method` parameter:
#' 
#' ```
#' term_sim(dag, terms, control = list(norm_method = "Nmax"))
#' ```
#' 
#' Possible values for the `norm_method` parameter are "Nunif", "Nmax", "Nunivers" and "none".
#' 
#' @rdname temp__Sim_Resnik_1999
Sim_Resnik_1999 = function(dag, terms, norm_method = "Nmax", verbose = simona_opt$verbose) {
	IC_method = "IC_annotation"

	if(!norm_method %in% c("Nunif", "Nmax", "Nunivers", "none")) {
		stop("`norm_method` can only be in 'Nunif', 'Nmax', 'Nunivers, 'none'.")
	}

	if(verbose) {
		message("term_sim_method: ", "Sim_Resnik_1999 +", norm_method)
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	ic = term_IC(dag, IC_method, verbose = FALSE)[id]
	
	l = validate_annotated_terms(dag, id)
	id = id[l]
	ic = ic[l]

	ic_mica = MICA_IC(dag, id, IC_method, verbose = verbose)

	if(norm_method == "Nunif") {
		max_n = attr(n_annotations(dag), "N")
		sim = ic_mica/log(max_n)
	} else if(norm_method == "Nmax") {
		sim = ic_mica/max(ic)
	} else if(norm_method == "Nunivers") {
		sim = ic_mica/cross_max(ic)
	} else  if(norm_method == "none") {
		sim = ic_mica
	}
	dimnames(sim) = list(dag@terms[id], dag@terms[id])
	
	sim[is.na(sim)] = 1
	sim
}
ADD_TERM_SIM_METHOD("Sim_Resnik_1999", require_anno = TRUE)


#' Sim_FaITH_2010
#' 
#' @section Methods:
#' ## Sim_FaITH_2010
#' 
#' It is calculated as:
#' 
#' ```
#' sim = IC(c)/(IC(a) + IC(b) - IC(c))
#' ```
#' 
#' The relation between *FaITH_2010* similarity and *Lin_1998* similarity is:
#' 
#' ```
#' sim_FaITH = sim_Lin/(2 - sim_Lin)
#' ```
#' 
#' Paper link: \doi{10.1007/978-3-642-17746-0_39}.
#' 
#' @rdname temp__Sim_FaITH_2010
Sim_FaITH_2010 = function(dag, terms, IC_method = "IC_annotation", verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_FaITH_2010")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	ic = term_IC(dag, IC_method, verbose = FALSE)[id]

	l = validate_annotated_terms(dag, id)
	id = id[l]
	ic = ic[l]

	ic_mica = MICA_IC(dag, id, IC_method, verbose = verbose)

	sim = ic_mica/(cross_sum(ic) - ic_mica)
	dimnames(sim) = list(dag@terms[id], dag@terms[id])
	
	sim[is.na(sim)] = 1
	sim
}
ADD_TERM_SIM_METHOD("Sim_FaITH_2010")


#' Sim_Relevance_2006
#' 
#' @section Methods:
#' ## Sim_Relevance_2006
#' 
#' The IC method is fixed to `IC_annotation`.
#' 
#' If thinking *Lin_1998* is a measure of how close term `a` and `b` to their MICA term `c`, the relevance method corrects it by multiplying
#' a factor which considers the specificity of how `c` brings the information. The factor is calculated as `1-p(c)` where `p(c)` is the annotation-based
#' probability `p(c) = k/N` where `k` is the number of items annotated to `c` and `N` is the total number of items annotated to the DAG. Then
#' the Relevance semantic similarity is calculated as:
#' 
#' ```
#' sim = (1 - p(c)) * IC_Lin 
#'     = (1 - p(c)) * 2*IC(c)/(IC(a) + IC(b))
#' ```
#' 
#' Paper link: \doi{10.1186/1471-2105-7-302}.
#' 
#' @rdname temp__Sim_Relevance_2006
Sim_Relevance_2006 = function(dag, terms, IC_method = "IC_annotation", verbose = simona_opt$verbose) {
	
	if(verbose) {
		message("term_sim_method: ", "Sim_Relevance_2006")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	ic = term_IC(dag, IC_method, verbose = FALSE)[id]

	l = validate_annotated_terms(dag, id)
	id = id[l]
	ic = ic[l]

	ic_mica = MICA_IC(dag, id, IC_method, verbose = verbose)

	sim = 2*ic_mica/cross_sum(ic)
	sim[is.na(sim)] = 1
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	eps = 1 - exp(-ic_mica)
	eps*sim
}
ADD_TERM_SIM_METHOD("Sim_Relevance_2006")


#' Sim_SimIC_2010
#' 
#' @section Methods:
#' ## Sim_SimIC_2010
#' 
#' The IC method is fixed to `IC_annotation`.
#' 
#' The SimIC method is an improved correction method of the Relevance method because the latter works bad when `p(c)` is very small. The SimIC
#' correction factor for MICA term `c` is:
#' 
#' ```
#' 1 - 1/(1 + IC(c))
#' ```
#' 
#' Then the similarity is:
#' 
#' ```
#' sim = (1 - 1/(1 + IC(c))) * IC_Lin 
#'     = (1 - 1/(1 + IC(c))) * 2*IC(c)/(IC(a) + IC(b))
#' ```
#' 
#' Paper link: \doi{10.48550/arXiv.1001.0958}.
#' 
#' @rdname temp__Sim_SimIC_2010
Sim_SimIC_2010 = function(dag, terms, IC_method = "IC_annotation", verbose = simona_opt$verbose) {
	
	if(verbose) {
		message("term_sim_method: ", "Sim_SimIC_2010")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	ic = term_IC(dag, IC_method, verbose = FALSE)[id]

	l = validate_annotated_terms(dag, id)
	id = id[l]
	ic = ic[l]

	ic_mica = MICA_IC(dag, id, IC_method, verbose = verbose)

	sim = 2*ic_mica/cross_sum(ic)
	sim[is.na(sim)] = 1
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	eps = 1 - 1/(1 + ic_mica)
	eps*sim
}
ADD_TERM_SIM_METHOD("Sim_SimIC_2010")


#' Sim_XGraSM_2013
#' 
#' @section Methods:
#' ## Sim_XGraSM_2013
#' 
#' The IC method is fixed to `IC_annotation`.
#' 
#' Being different from the "Relevance" and "SimIC_2010" methods that only use the IC of the MICA term, the *XGraSM_2013* uses IC of all common ancestor terms of `a` and `b`.
#' First it calculates the mean IC of all common ancestor terms with positive IC values:
#' 
#' ```
#' IC_mean = mean_t(IC(t)) where t is an ancestor of both a and b, and IC(t) > 0
#' ```
#' 
#' then similar to the *Lin_1998* method, normalize to the average IC of `a` and `b`:
#' 
#' ```
#' sim = IC_mean*2/(IC(a) + IC(b))
#' ```
#' 
#' Paper link: \doi{10.1186/1471-2105-14-284}.
#' 
#' @rdname temp__Sim_XGraSM_2013
Sim_XGraSM_2013 = function(dag, terms, IC_method = "IC_annotation", verbose = simona_opt$verbose) {
	
	if(verbose) {
		message("term_sim_method: ", "Sim_XGraSM_2013")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	ic = term_IC(dag, IC_method, verbose = verbose)
	ic[is.na(ic)] = 0
	
	l = validate_annotated_terms(dag, id)
	id = id[l]
	
	mean_ic = exec_under_message_condition({
		cpp_common_ancestor_mean_IC_XGraSM(dag, id, ic)
	}, verbose = verbose)

	sim = mean_ic/cross_sum(ic[id])*2
	sim[is.na(sim)] = 0
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_XGraSM_2013")



#' Sim_EISI_2015
#' 
#' @section Methods:
#' ## Sim_EISI_2015
#' 
#' The IC method is fixed to `IC_annotation`.
#' 
#' It also selects a subset of common ancestors of terms `a` and `b`. It only selects common ancestors which can reach `a` or `b` via one of its child terms
#' that does not belong to the common ancestors. In other words, from the common ancestor, there exist a path where
#' the information is uniquely transmitted to `a` or `b`, not passing the other.
#' 
#' Then the mean IC of the subset common ancestors is calculated and normalized by the *Lin_1998* method.
#' 
#' Paper link: \doi{10.1016/j.gene.2014.12.062}.
#' 
#' @rdname temp__Sim_EISI_2015
Sim_EISI_2015 = function(dag, terms, IC_method = "IC_annotation", verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_EISI_2015")
	}
	
	id = term_to_node_id(dag, terms, strict = FALSE)
	ic = term_IC(dag, IC_method, verbose = verbose)
	ic[is.na(ic)] = 0

	l = validate_annotated_terms(dag, id)
	id = id[l]

	mean_ic = exec_under_message_condition({
		cpp_common_ancestor_mean_IC_EISI(dag, id, ic)
	}, verbose = verbose)

	sim = mean_ic/cross_sum(ic[id])*2
	sim[is.na(sim)] = 0
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_EISI_2015")


#' Sim_AIC_2014
#' 
#' @section Methods:
#' ## Sim_AIC_2014
#' 
#' It uses the aggregate information content from ancestors. First define the semantic weight (`Sw`) of a term `t` in the DAG:
#' 
#' ```
#' Sw = 1/(1 + exp(-1/IC(t)))
#' ```
#' 
#' Then calculate the aggregation only in the common ancestors and the aggregationn
#' in the ancestors of the two terms `a` and `b` separatedly:
#' 
#' ```
#' SV_{common ancestors} = sum_{t in common ancestors}(Sw(t))
#' SV_a = sum{a' in a's ancestors}(Sw(a'))
#' SV_b = sum{b' in b's ancestors}(Sw(b'))
#' ```
#' 
#' The similarity is calculated as the ratio between the aggregation on the common ancestors and the average on `a`'s ancestors and `b`'s ancestors separatedly.
#' 
#' ```
#' sim = 2*SV_{common_ancestors}/(SV_a + SV_b)
#' ```
#' 
#' Paper link: \doi{10.1109/tcbb.2013.176}.
#' 
#' @rdname temp__Sim_AIC_2014
Sim_AIC_2014 = function(dag, terms, IC_method = "IC_annotation", verbose = simona_opt$verbose) {
	
	if(verbose) {
		message("term_sim_method: ", "Sim_AIC_2014")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	ic = term_IC(dag, IC_method, verbose = verbose)
	
	l = validate_annotated_terms(dag, id)
	id = id[l]
	ic[ic == 0] = 0  # get rid of -0

	sim = exec_under_message_condition({
		cpp_sim_aic(dag, id, ic)
	}, verbose = verbose)

	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_AIC_2014")


#' Sim_Zhang_2006
#' 
#' @section Methods:
#' ## Sim_Zhang_2006
#' 
#' It uses the *IC_Zhang_2006* IC method and the *Lin_1998* method to calculate similarities:
#' 
#' ```
#' sim = 2*IC_zhang(c)/(IC_zhang(a) + IC_zhang(b))
#' ```
#' 
#' @rdname temp__Sim_Zhang_2006
Sim_Zhang_2006 = function(dag, terms, verbose = simona_opt$verbose) {
	IC_method = "IC_Zhang_2006"

	if(verbose) {
		message("term_sim_method: ", "Sim_Zhang_2006")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	ic = term_IC(dag, IC_method, verbose = FALSE)[id]

	ic_mica = MICA_IC(dag, id, IC_method, verbose = verbose)
	
	sim = 2*ic_mica/cross_sum(ic)
	
	dimnames(sim) = list(dag@terms[id], dag@terms[id])
	
	sim
}
ADD_TERM_SIM_METHOD("Sim_Zhang_2006", require_anno = TRUE)


#' Sim_universal
#' 
#' @section Methods:
#' ## Sim_universal
#' 
#' It uses the *IC_universal* IC method and the *Nunivers* method to calculate similarities:
#' 
#' ```
#' sim = IC_universal(c)/max(IC_universal(a), IC_universal(b))
#' ```
#' 
#' @rdname temp__Sim_universal
Sim_universal = function(dag, terms, verbose = simona_opt$verbose) {
	IC_method = "IC_universal"

	if(verbose) {
		message("term_sim_method: ", "Sim_universal")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	ic = term_IC(dag, IC_method, verbose = FALSE)[id]

	ic_mica = MICA_IC(dag, id, IC_method, verbose = verbose)

	sim = 2*ic_mica/cross_max(ic)
	dimnames(sim) = list(dag@terms[id], dag@terms[id])
	
	sim
}
ADD_TERM_SIM_METHOD("Sim_universal")


#' Sim_Wang_2007
#' 
#' @section Methods:
#' ## Sim_Wang_2007
#' 
#' First, S-value of an ancestor term `c` on a term `a` (`S(c->a)`) is calculated (the definition of the S-value can be found in the help page of [`term_IC()`]).
#' Similar to the *Sim_AIC_2014*, aggregation only to common ancestors, to `a`'s ancestors and to `b`'s ancestors are calculated.
#' 
#' ```
#' SV_{common ancestors} = sum_{c in common ancestors}(S(c->a) + S(c->b))
#' SV_a = sum{a' in a's ancestors}(S(a'->a))
#' SV_b = sum{b' in b's ancestors}(S(b'->b))
#' ```
#' 
#' Then the similarity is calculated as:
#' 
#' ```
#' sim = SV_{common_ancestors}*2/(SV_a + SV_b)
#' ```
#' 
#' Paper link: \doi{10.1093/bioinformatics/btm087}.
#' 
#' The contribution of different semantic relations can be set with the `contribution_factor` parameter. The value should be a named numeric
#' vector where names should cover the relations defined in `relations` set in [`create_ontology_DAG()`]. For example, if there are two relations
#' "relation_a" and "relation_b" set in the DAG, the value for `contribution_factor` can be set as:
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_Wang_2007", 
#'     control = list(contribution_factor = c("relation_a" = 0.8, "relation_b" = 0.6)))
#' ```
#' 
#' @rdname temp__Sim_Wang_2007
#' @import igraph
Sim_Wang_2007 = function(dag, terms, contribution_factor = c("is_a" = 0.8, "part_of" = 0.6), 
	calc_by = "igraph", verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_Wang_2007")
	}

	if(length(dag@lt_children_relations) == 0) {
		stop("`relations` is not set when creating the ontology_DAG object.")
	}
	relation_levels = attr(dag@lt_children_relations, "levels")
	if(is.null(names(contribution_factor))) {
		stop("`contribution_factor` should be a named numeric vector where names should correspond to all relations.")
	}

	names(contribution_factor) = normalize_relation_type(names(contribution_factor))
	
	contribution_factor = extend_contribution_factor(dag@relations_DAG, contribution_factor)
	if(length(setdiff(relation_levels, names(contribution_factor)))) {
		stop("Contribution factor should be provided for all relations.")
	}

	if(any(contribution_factor >= 1)) {
		stop("All values in `contribution_factor` should be smaller than 1.")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	sim = matrix(0, nrow = length(id), ncol = length(id))
	dimnames(sim) = list(dag@terms[id], dag@terms[id])
	diag(sim) = 1

	if(length(id) <= 1) {
		return(sim)
	}

	if(calc_by == "igraph") {
		g = dag_as_igraph(dag)
		E(g)$weight = contribution_factor[E(g)$relation]
		all_ancestors = cpp_ancestors_of_a_group(dag, id, include_self = TRUE)
		d = distances(g, v = all_ancestors, to = id, mode = "out", weights = -log(E(g)$weight))
		s = exp(-d)  # rows are ancestors
		sim = cpp_wang_sv_to_sim(s)
	} else {
		sim = cpp_sim_wang(dag, id, unname(contribution_factor[relation_levels]))
		
	}
	dimnames(sim) = list(dag@terms[id], dag@terms[id])
	
	sim
}
ADD_TERM_SIM_METHOD("Sim_Wang_2007")


#' Sim_GOGO_2018
#' 
#' @section Methods:
#' ## Sim_GOGO_2018
#' 
#' It is very similar as _Sim_Wang_2007_, but with a corrected contribution factor when calculating the S-value.
#' From a parent term to a child term, _Sim_Wang_2007_ directly uses a weight for the relation between the parent
#' and the child, e.g. 0.8 for "is_a" relation type and 0.6 for "part_of" relation type. In _Sim_GOGO_2018_, the weight
#' is also scaled by the total number of children of that parent:
#' 
#' ```
#' w = 1/(c + nc) + w_0
#' ```
#' 
#' where w_0 is the original contribution factor, `nc` is the number of child terms of the parent, `c` is calculated to ensure that 
#' maximal value of `w` is no larger than 1, i.e. `c = max(w_0)/(1 - max(w_0))`, assuming minimal value of `nc` is 1. By default _Sim_GOGO_2018_
#' sets contribution factor of 0.4 for "is_a" and 0.3 for "part_of", then `w = 1/(2/3 + nc) + w_0`.
#' 
#' Paper link: \doi{10.1038/s41598-018-33219-y}.
#' 
#' The contribution of different semantic relations can be set with the `contribution_factor` parameter. The value should be a named numeric
#' vector where names should cover the relations defined in `relations` set in [`create_ontology_DAG()`]. For example, if there are two relations
#' "relation_a" and "relation_b" set in the DAG, the value for `contribution_factor` can be set as:
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_GOGO_2018", 
#'     control = list(contribution_factor = c("relation_a" = 0.4, "relation_b" = 0.3)))
#' ```
#' 
#' @rdname temp__Sim_GOGO_2018
Sim_GOGO_2018 = function(dag, terms, contribution_factor = c("is_a" = 0.4, "part_of" = 0.3), 
	calc_by = "igraph", verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_GOGO_2018")
	}

	if(length(dag@lt_children_relations) == 0) {
		stop("`relations` is not set when creating the ontology_DAG object.")
	}
	relation_levels = attr(dag@lt_children_relations, "levels")
	if(is.null(names(contribution_factor))) {
		stop("`contribution_factor` should be a named numeric vector where names should correspond to all relations.")
	}

	names(contribution_factor) = normalize_relation_type(names(contribution_factor))
	
	contribution_factor = extend_contribution_factor(dag@relations_DAG, contribution_factor)
	if(length(setdiff(relation_levels, names(contribution_factor)))) {
		stop("Contribution factor should be provided for all relations.")
	}

	if(any(contribution_factor >= 1)) {
		stop("All values in `contribution_factor` should be smaller than 1.")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	sim = matrix(0, nrow = length(id), ncol = length(id))
	dimnames(sim) = list(dag@terms[id], dag@terms[id])
	diag(sim) = 1

	if(length(id) <= 1) {
		return(sim)
	}

	if(calc_by == "igraph") {
		g = dag_as_igraph(dag)
		em = get.edgelist(g)
		c = max(contribution_factor)/(1 - max(contribution_factor))
		nc = n_children(dag)
		E(g)$weight = contribution_factor[E(g)$relation] + 1/(c + nc[em[, 1]])
		all_ancestors = cpp_ancestors_of_a_group(dag, id, include_self = TRUE)
		d = distances(g, v = all_ancestors, to = id, mode = "out", weights = -log(E(g)$weight))
		s = exp(-d)  # rows are ancestors
		sim = cpp_wang_sv_to_sim(s)
	} else {
		sim = cpp_sim_wang(dag, id, unname(contribution_factor[relation_levels]), TRUE)
		
	}
	dimnames(sim) = list(dag@terms[id], dag@terms[id])
	
	sim
}
ADD_TERM_SIM_METHOD("Sim_GOGO_2018")



###########################################
#### edge-based
###########################################

#' Sim_Rada_1989
#' 
#' @section Methods:
#' ## Sim_Rada_1989
#' 
#' It is based on the distance between term `a` and `b`. It is defined as:
#' 
#' ```
#' sim = 1/(1 + d(a, b))
#' ```
#' 
#' The distance can be the shortest distance between `a` and `b` or the longest distance via the LCA term.
#' 
#' Paper link: \doi{10.1109/21.24528}.
#' 
#' There is a parameter `distance` which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_Rada_1989",
#'     control = list(distance = "shortest_distances_via_NCA"))
#' ```
#' 
#' @rdname temp__Sim_Rada_1989
Sim_Rada_1989 = function(dag, terms, distance = "longest_distances_via_LCA", verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_Rada_1989")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)

	if(distance == "shortest_distances_via_NCA") {
		dist = shortest_distances_via_NCA(dag, id, verbose = verbose)
	} else if(distance == "longest_distances_via_LCA") {
		dist = longest_distances_via_LCA(dag, id, verbose = verbose)
	} else {
		stop("`distance` can only be in 'shortest_distances_via_NCA' or 'longest_distances_via_LCA'.")
	}

	sim = 1/(1 + dist)
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_Rada_1989")


#' Sim_Resnik_edge_2005
#' 
#' @section Methods:
#' ## Sim_Resnik_edge_2005
#' 
#' It is also based on the distance between term `a` and `b`:
#' 
#' ```
#' sim = 1 - d(a, b)/2/max_depth
#' ```
#' 
#' where `max_depth` is the maximal depth (maximal distance from root) in the DAG. Similarly, `d(a, b)` can be the shortest
#' distance or the longest distance via LCA.
#' 
#' Paper link: \doi{10.1145/1097047.1097051}.
#' 
#' There is a parameter `distance` which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_Resnik_edge_2005",
#'     control = list(distance = "shortest_distances_via_NCA"))
#' ```
#' 
#' @rdname temp__Sim_Resnik_edge_2005
Sim_Resnik_edge_2005 = function(dag, terms, distance = "longest_distances_via_LCA", verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_Resnik_edge_2005")
	}

	id = term_to_node_id(dag, terms)

	max_depth = max(dag_depth(dag))
	if(distance == "shortest_distances_via_NCA") {
		dist = shortest_distances_via_NCA(dag, id, verbose = verbose)
	} else if(distance == "longest_distances_via_LCA") {
		dist = longest_distances_via_LCA(dag, id, verbose = verbose)
	} else {
		stop("`distance` can only be in 'shortest_distances_via_NCA' or 'longest_distances_via_LCA'.")
	}

	sim = 1 - dist/2/max_depth
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_Resnik_edge_2005")


#' Sim_Leocock_1998
#' 
#' @section Methods:
#' ## Sim_Leocock_1998
#' 
#' It is similar as the *Sim_Resnik_edge_2005* method, but it applies log-transformation on the distance and the depth:
#' 
#' ```
#' sim = 1 - log(d(a, b) + 1)/log(2*max_depth + 1)
#' ```
#' 
#' Paper link: \doi{10.1186/1471-2105-13-261}.
#' 
#' There is a parameter `distance` which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_Leocock_1998",
#'     control = list(distance = "shortest_distances_via_NCA"))
#' ```
#' 
#' @rdname temp__Sim_Leocock_1998
Sim_Leocock_1998 = function(dag, terms, distance = "longest_distances_via_LCA", verbose = simona_opt$verbose) {
	
	if(verbose) {
		message("term_sim_method: ", "Sim_Leocock_1998")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)

	max_depth = max(dag_depth(dag))
	if(distance == "shortest_distances_via_NCA") {
		dist = shortest_distances_via_NCA(dag, id, verbose = verbose)
	} else if(distance == "longest_distances_via_LCA") {
		dist = longest_distances_via_LCA(dag, id, verbose = verbose)
	} else {
		stop("`distance` can only be in 'shortest_distances_via_NCA' or 'longest_distances_via_LCA'.")
	}

	sim = 1 - log(dist + 1)/log(2*max_depth + 1)
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_Leocock_1998")


#' Sim_WP_1994
#' 
#' @section Methods:
#' ## Sim_WP_1994
#' 
#' It is based on the depth of the LCA term `c` and the longest distance between term `a` and `b`:
#' 
#' ```
#' sim = 2*depth(c)/(len_c(a, b) + 2*depth(c))
#' ```
#' 
#' where `len_c(a, b)` is the longest distance between `a` and `b` via LCA `c`. The denominator in the equation can also be written as:
#' 
#' ```
#' len_c(a, b) + 2*depth(c) = depth(c) + len(c, a) + depth(c) + len(c, b)
#'                          = depth_c(a) + depth_c(b)
#' ```
#' 
#' where `depth_c(a)` is the longest distance from root to `a` passing through `c`.
#' 
#' Paper link: \doi{10.3115/981732.981751}.
#' 
#' @rdname temp__Sim_WP_1994
Sim_WP_1994 = function(dag, terms, verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_WP_1994")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	
	lca_depth = LCA_depth(dag, id, verbose = verbose)
	sim = 2*lca_depth/(longest_distances_via_LCA(dag, id, verbose = verbose) + 2*lca_depth)
	
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	l = which(id %in% dag@root)
	if(any(l)) {
		sim[l, l] = 1
	}

	sim
}
ADD_TERM_SIM_METHOD("Sim_WP_1994")


#' Sim_Slimani_2006
#' 
#' @section Methods:
#' ## Sim_Slimani_2006
#' 
#' It is a correction of the *Sim_WP_1994* method. The correction factor for term `a` and `b` regarding to their LCA `t` is:
#' 
#' ```
#' CF(a, b) = (1-lambda)*(min(depth(a), depth(b)) - depth(c)) + 
#'            lambda/(1 + abs(depth(a) - depth(b)))
#' ```
#' 
#' `lambda` takes value of 1 if `a` and `b` are in ancestor-offspring relation, or else it takes 0. 
#' 
#' Paper link: <https://zenodo.org/record/1075130>.
#' 
#' @rdname temp__Sim_Slimani_2006
Sim_Slimani_2006 = function(dag, terms, verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_Slimani_2006")
	}
	
	id = term_to_node_id(dag, terms, strict = FALSE)
	lca_depth = LCA_depth(dag, id, verbose = verbose)
	depth = dag_depth(dag)

	sim_wp = 2*lca_depth/(longest_distances_via_LCA(dag, id, verbose = verbose) + 2*lca_depth)

	lambda = cpp_is_reachable(dag, id)
	ltd = longest_distances_from_LCA(dag, id, verbose = verbose)
	dist_left = ltd$left
	dist_right = ltd$right

	cf = (1 - lambda)*(pmin(dist_left, dist_right) + 1) + 
	     lambda/(dist_left + dist_right)  ## the two terms are ancestor/offspring, and one of `dist_left` and dist_right is zero
	diag(cf) = 1

	sim = cf * sim_wp
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_Slimani_2006")


#' Sim_Shenoy_2012
#' 
#' @section Methods:
#' ## Sim_Shenoy_2012
#' 
#' It is a correction of the *Sim_WP_1994* method. The correction factor for term `a` and `b` is:
#' 
#' ```
#' CF(a, b) = exp(-lambda*d(a, b)/max_depth)
#' ```
#' 
#' `lambda` takes value of 1 if `a` and `b` are in ancestor-offspring relation, or else it takes 0. `d(a, b)
#' 
#' Paper link: \doi{10.48550/arXiv.1211.4709}.
#' 
#' There is a parameter `distance` which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_Leocock_1998",
#'     control = list(distance = "shortest_distances_via_NCA"))
#' ```
#' 
#' @rdname temp__Sim_Shenoy_2012
Sim_Shenoy_2012 = function(dag, terms, distance = "longest_distances_via_LCA", verbose = simona_opt$verbose) {
		
	if(verbose) {
		message("term_sim_method: ", "Sim_Shenoy_2012")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	lca_depth = LCA_depth(dag, id, verbose = verbose)
	depth = dag_depth(dag)

	if(distance == "longest_distances_via_LCA") {
		sim_wp = 2*lca_depth/(longest_distances_via_LCA(dag, id, verbose = verbose) + 2*lca_depth)
	} else if(distance == "shortest_distances_via_NCA") {
		sim_wp = 2*lca_depth/(shortest_distances_via_NCA(dag, id, verbose = verbose) + 2*lca_depth)
	} else {
		stop("`distance` can only be in 'shortest_distances_via_NCA' or 'longest_distances_via_LCA'.")
	}

	lambda = cpp_is_reachable(dag, id)

	max_depth = max(dag_depth(dag))
	dist = longest_distances_via_LCA(dag, id, verbose = verbose)

	cf = exp(- lambda*dist/max_depth)
	diag(cf) = 1

	sim = cf * sim_wp
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_Shenoy_2012")


#' Sim_Pekar_2002
#' 
#' @section Methods:
#' ## Sim_Pekar_2002
#' 
#' It is very similar to the *Sim_WP_1994* method:
#' 
#' ```
#' sim = depth(c)/(len_c(a, b) + depth(c))
#'     = d(root, c)/(d(c, a) + d(c, b) + d(root, c))
#' ```
#' 
#' where `d(a, b)` is the longest distance between `a` and `b`.
#' 
#' Paper link: <https://aclanthology.org/C02-1090/>.
#' 
#' @rdname temp__Sim_Pekar_2002
Sim_Pekar_2002 = function(dag, terms, verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_Pekar_2002")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	lca_depth = LCA_depth(dag, id, verbose = verbose)

	sim = lca_depth/(longest_distances_via_LCA(dag, id, verbose = verbose) + lca_depth)
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_Pekar_2002")


#' Sim_Stojanovic_2001
#' 
#' @section Methods:
#' ## Sim_Stojanovic_2001
#' 
#' It is purely based on the depth of term `a`, `b` and their LCA `c`.
#' 
#' ```
#' sim = depth(c)/(depth(a) + depth(b) - depth(c))
#' ```
#' 
#' The similarity value might be negative because there is no restrction that the path from root to `a` or `b` must pass `c`.
#' 
#' Paper link: \doi{10.1145/500737.500762}.
#' 
#' @rdname temp__Sim_Stojanovic_2001
Sim_Stojanovic_2001 = function(dag, terms, verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_Stojanovic_2001")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)

	l = which(id %in% dag@root)
	if(any(l)) {
		if(verbose) message("remove root term.")
		id = id[!l]
	}

	depth = dag_depth(dag)
	lca_term = max_ancestor_id(dag, id, depth, in_labels = FALSE, verbose = verbose)
	lca_depth = structure(depth[lca_term], dim = dim(lca_term))
	
	sim = lca_depth/(cross_sum(depth[id]) - lca_depth)
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_Stojanovic_2001")


#' Sim_Wang_edge_2012
#' 
#' @section Methods:
#' ## Sim_Wang_edge_2012
#' 
#' It is calculated as:
#' 
#' ```
#' sim = depth(c)^2/depth_c(a)/depth_c(b)
#' ```
#' 
#' where `depth_c(a)` is the longest distance between root to `a` passing through `c`.
#' 
#' Paper link: \doi{10.1186/1477-5956-10-s1-s18}.
#' 
#' @rdname temp__Sim_Wang_edge_2012
Sim_Wang_edge_2012 = function(dag, terms, verbose = simona_opt$verbose) {
	
	if(verbose) {
		message("term_sim_method: ", "Sim_Wang_edge_2012")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)

	sim = cpp_sim_wang_edge(dag, id)
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_Wang_edge_2012")


#' Sim_Zhong_2002
#' 
#' @section Methods:
#' ## Sim_Zhong_2002
#' 
#' For a term `x`, it first calculates a "mile-stone" value as 
#' 
#' ```
#' m(x) = 0.5/2^depth(x)
#' ```
#' 
#' The the distance bewteen term `a` and `b` via LCA term `c` is:
#' 
#' ```
#' D(c, a) + D(c, b) = m(c) - m(a) + m(c) - m(b)
#'                   = 2*m(c) - m(a) - m(b)
#'                   = 1/2^depth(c) - 0.5/2^depth(a) - 0.5/2^depth(b)
#' ```
#' 
#' We change the original `depth(a)` to let it go through LCA term `c` when calculating the depth:
#' 
#' ```
#' 1/2^depth(c) - 0.5/2^depth(a) - 0.5/2^depth(b) 
#'     = 1/2^depth(c)- 0.5/2^(depth(c) + len(c, a)) - 0.5/2^(depth(c) + len(c, b))
#'     = 1/2^depth(c) * (1 - 1/2^(len(c, a) + 1) - 1/2^(len(c, b) + 1))
#'     = 2^-depth(c) * (1 - 2^-(len(c, a) + 1) - 2^-(len(c, b) + 1))
#' ```
#' 
#' And the final similarity is `1 - distance`:
#' 
#' ```
#' sim = 1 - 2^-depth(c) * (1 - 2^-(len(c, a) + 1) - 2^-(len(c, b) + 1))
#' ```
#' 
#' Paper link: \doi{10.1007/3-540-45483-7_8}.
#' 
#' There is a parameter `depth_via_LCA` that can be set to `TRUE` or `FALSE`. IF it is set to `TRUE`, `depth(a)` is re-defined
#' as should pass the LCA term `c`. If it is `FALSE`, it goes to the original similarity definition in the paper and note the 
#' similarity might be negative.
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_Zhong_2002",
#'     control = list(depth_via_LCA = FALSE))
#' ```
#' 
#' @rdname temp__Sim_Zhong_2002
Sim_Zhong_2002 = function(dag, terms, depth_via_LCA = TRUE, verbose = simona_opt$verbose) {
	
	if(verbose) {
		message("term_sim_method: ", "Sim_Zhong_2002")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)

	if(!depth_via_LCA) {
		d = dag_depth(dag)
		sim = 1 - ( 2^(-LCA_depth(dag, id, verbose = verbose)) - 0.5*cross_sum(2^(-d[id])) )
	} else {
		sim = cpp_sim_zhong(dag, id, depth_via_LCA)
	}

	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_Zhong_2002")


#' Sim_AlMubaid_2006
#' 
#' @section Methods:
#' ## Sim_AlMubaid_2006
#' 
#' It also takes accout of the distance between term `a` and `b`, and the depth of the LCA term `c` in the DAG.
#' The distance is calculated as:
#' 
#' ```
#' D(a, b) = log(1 + d(a, b)*(max_depth - depth(c)))
#' ```
#' 
#' Here `d(a, b)` can be the shortest distance between `a` and `b` or the longst distance via LCA `c`.
#' 
#' Then the distance is transformed into the similarity value scaled by the possible maximal and minimal values of `D(a, b)` from the DAG:
#' 
#' ```
#' D_max = log(1 + 2*max_depth * max_depth)
#' ```
#' 
#' And the minimal value of `D(a, b)` is zero when `a` is identical to `b`. Then the similarity value is scaled as:
#' 
#' ```
#' sim = 1 - D(a, b)/D_max
#' ```
#' 
#' Paper link: \doi{10.1109/IEMBS.2006.259235}.
#'
#' There is a parameter `distance` which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_AlMubaid_2006",
#'     control = list(distance = "shortest_distances_via_NCA"))
#' ```
#' 
#' @rdname temp__Sim_AlMubaid_2006
Sim_AlMubaid_2006 = function(dag, terms, distance = "longest_distances_via_LCA", verbose = simona_opt$verbose) {
	
	if(verbose) {
		message("term_sim_method: ", "Sim_AlMubaid_2006")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	lca_depth = LCA_depth(dag, id, verbose = verbose)
	max_depth = max(dag_depth(dag))

	if(distance == "shortest_distances_via_NCA") {
		dsp = shortest_distances_via_NCA(dag, id, verbose = verbose)
	} else if(distance == "longest_distances_via_LCA") {
		dsp = longest_distances_via_LCA(dag, id, verbose = verbose)
	} else {
		stop("`distance` can only be in 'shortest_distances_via_NCA' or 'longest_distances_via_LCA'.")
	}

	dist = log(1 + dsp*(max_depth - lca_depth))
	max_dist = log(1 + 2*max_depth*max_depth)
	sim = 1 - dist/max_dist
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_AlMubaid_2006")


#' Sim_Li_2003
#' 
#' @section Methods:
#' ## Sim_Li_2003
#' 
#' It is similar to the *Sim_AlMubaid_2006* method, but uses a non-linear form:
#' 
#' ```
#' sim = exp(0.2*d(a, b)) * atan(0.6*depth(c))
#' ```
#' 
#' where `d(a, b)` can be the shortest distance or the longest distance via LCA.
#' 
#' Paper link: \doi{10.1109/TKDE.2003.1209005}.
#' 
#' There is a parameter `distance` which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_Li_2003",
#'     control = list(distance = "shortest_distances_via_NCA"))
#' ```
#' 
#' @rdname temp__Sim_Li_2003
Sim_Li_2003 = function(dag, terms, distance = "longest_distances_via_LCA", verbose = simona_opt$verbose) {
	
	if(verbose) {
		message("term_sim_method: ", "Sim_Li_2003")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	lca_depth = LCA_depth(dag, id, verbose = verbose)

	if(distance == "shortest_distances_via_NCA") {
		dsp = shortest_distances_via_NCA(dag, id, verbose = verbose)
	} else if(distance == "longest_distances_via_LCA") {
		dsp = longest_distances_via_LCA(dag, id, verbose = verbose)
	} else {
		stop("`distance` can only be in 'shortest_distances_via_NCA' or 'longest_distances_via_LCA'.")
	}

	alpha = 0.2
	beta = 0.8

	sim = exp(-alpha*dsp)*atan(beta*lca_depth)
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_Li_2003")


###########################################
#### hybrid
###########################################

#' Sim_RSS_2013
#' 
#' @section Methods:
#' ## Sim_RSS_2013
#' 
#' The similarity is adjusted by the positions of term `a`, `b` and the LCA term `c` in the DAG. The similarity is defined as:
#' 
#' ```
#' sim = max_depth/(max_depth + d(a, b)) * alpha/(alpha + beta)
#' ```
#' 
#' where `d(a, b)` is the distance between `a` and `b` which can be the shortest distance or the longest distance via LCA.
#' 
#' In the tuning factor, `alpha` is the distance of LCA to root, which is `depth(c)`. `beta` is the distance to leaves, which
#' is the minimal distance (or the minimal height) of term `a` and `b`:
#' 
#' ```
#' alpha/(alpha + beta) = depth(c)/(depth(c) + min(height(a), height(b)))
#' ```
#' 
#' Paper link: \doi{10.1371/journal.pone.0066745}.
#' 
#' There is a parameter `distance` which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_RSS_2013",
#'     control = list(distance = "shortest_distances_via_NCA"))
#' ```
#' 
#' @rdname temp__Sim_RSS_2013
Sim_RSS_2013 = function(dag, terms, distance = "longest_distances_via_LCA", verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_RSS_2013")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)

	lca_depth = LCA_depth(dag, id, verbose = verbose)
	max_depth = max(dag_depth(dag))
	height = dag_height(dag)[id]

	if(distance == "shortest_distances_via_NCA") {
		dsp = shortest_distances_via_NCA(dag, id, verbose = verbose)
	} else if(distance == "longest_distances_via_LCA") {
		dsp = longest_distances_via_LCA(dag, id, verbose = verbose)
	} else {
		stop("`distance` can only be in 'shortest_distances_via_NCA' or 'longest_distances_via_LCA'.")
	}

	sim = max_depth/(max_depth + dsp) * lca_depth/(lca_depth + cross_min(height) + 1)
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_RSS_2013")


#' Sim_HRSS_2013
#' 
#' @section Methods:
#' ## Sim_HRSS_2013
#' 
#' It is similar as the *Sim_RSS_2013* method, but it uses information content instead of the distance to adjust the similarity.
#' 
#' It first defines the semantic distance between term `a` and `b` as the sum of the distance to their MICA term `c`:
#' 
#' ```
#' D(a, b) = D(c, a) + D(c, b)
#' ```
#' 
#' And the distance between an ancestor to a term is:
#' 
#' ```
#' D(c, a) = IC(a) - IC(c)  # if c is an ancestor of a
#' D(a, b) = D(c, a) + D(c, b) = IC(a) + IC(b) - 2*IC(c) # if c is the MICA of a and b
#' ```
#' 
#' Similarly, the similarity is also corrected by the position of MICA term and `a` and `b` in the DAG:
#' 
#' ```
#' 1/(1 + D(a, b)) * alpha/(alph + beta)
#' ```
#' 
#' Now `alpha` is the IC of the MICA term:
#' 
#' ```
#' alpha = IC(c)
#' ```
#' 
#' And `beta` is the average of the maximal semantic distance of `a` and `b` to leaves.
#' 
#' ```
#' beta = 0.5*(IC(l_a) - IC(a) + IC(l_b) - IC(b))
#' ```
#' 
#' where `l_a` is the leaf that `a` can reach with the highest IC (i.e. most informative leaf), and so is `l_b`.
#' 
#' Paper link: \doi{10.1371/journal.pone.0066745}.
#' 
#' @rdname temp__Sim_HRSS_2013
Sim_HRSS_2013 = function(dag, terms, verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_HRSS_2013")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)

	IC_method = "IC_annotation"
	if(IC_method == "IC_annotation") {
		l = validate_annotated_terms(dag, id)
		id = id[l]
	}
	ic = term_IC(dag, IC_method, verbose = FALSE)
	ic_mica = MICA_IC(dag, id, IC_method, verbose = verbose)

	MIL_term = cpp_max_leaves_id(dag, id, ic)

	alpha = abs(ic[dag@root] - ic_mica)
	ic_dist_leaf = abs(ic[id] - ic[MIL_term])
	beta = cross_sum(ic_dist_leaf)/2

	sim = 1/(1 + abs(cross_minus(ic[id])))*alpha/(alpha + beta + 1)
	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_HRSS_2013", require_anno = TRUE)


#' Sim_Shen_2010
#' 
#' @section Methods:
#' ## Sim_Shen_2010
#' 
#' It is based on the information content of terms on the path connecting term `a` and `b` via their MICA term `c`.
#' 
#' Denote a list of terms `a, ..., c, ..., b` which are composed by the shortest path from `a` to `c` and from `b` to `c`, the difference
#' between `a` and `b` is the sum of `1/IC` of the terms on the path:
#' 
#' ```
#' sum_{x in the path}(1/IC(x))
#' ```
#' 
#' Then the distance is scaled into `[0, 1]` by an arctangent tarnsformation:
#' 
#' ```
#' atan(sum_{x in the path}(1/IC(x)))/(pi/2)
#' ```
#' 
#' And finally the similarity is:
#' 
#' ```
#' sim = 1 - atan(sum_{x in the path}(1/IC(x)))/(pi/2)
#' ``` 
#' 
#' Paper link: \doi{10.1109/BIBM.2010.5706623}.
#' 
#' @rdname temp__Sim_Shen_2010
Sim_Shen_2010 = function(dag, terms, IC_method = "IC_annotation", distance = "shortest_distances_via_NCA", verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_Shen_2010")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)

	if(IC_method == "IC_annotation") {
		l = validate_annotated_terms(dag, id)
		id = id[l]
	}
	ic = term_IC(dag, IC_method, verbose = FALSE)

	sim = max_ancestor_path_sum(dag, id, ic, 1/ic, distance = ifelse(distance == "longest_distances_via_LCA", "longest", "shortest"), verbose = verbose)
	sim = 1 - atan(sim)/pi*2

	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_Shen_2010")


#' Sim_SSDD_2013
#' 
#' @section Methods:
#' ## Sim_SSDD_2013
#' 
#' It is similar as the *Sim_Shen_2010* which also sums content along the path passing through LCA term.
#' Instead of summing the information content, the *Sim_SSDD_2013* sums up a so-called "T-value":
#' 
#' ```
#' sim = 1 - atan(sum_{x in the path}(T(x)))/(pi/2)
#' ``` 
#' 
#' Each term has a T-value and it measures the semantic content a term averagely inherited from its parents
#' and distributed to its offsprings. The T-value of root is 1. Assume a term `t` has two parents `p1` and `p1`,
#' The T-value for term `t` is averaged from its
#' 
#' ```
#' (w1*T(p1) + w2*T(p2))/2
#' ```
#' 
#' Since the parent may have other child terms, a factor `w1` or `w2` is multiplied to `T(p1)` and `T(p2)`. Taking
#' `p1` as an example, it has `n_p` offsprings (including itself) and `t` has `n_t` offsprings (including itself),
#' this means `n_t/n_p` of information is transmitted from `p1` to downstream via `t`, thus `w1` is defined as `n_t/n_p`.
#' 
#' Paper link: \doi{10.1016/j.ygeno.2013.04.010}.
#' 
#' @rdname temp__Sim_SSDD_2013
Sim_SSDD_2013 = function(dag, terms, distance = "shortest_distances_via_NCA", verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_SSDD_2013")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)
	t = totipotency(dag)

	sim = 1 - atan(max_ancestor_path_sum(dag, id, dag_depth(dag), t, distance = ifelse(distance == "longest_distances_via_LCA", "longest", "shortest"), verbose = verbose))/pi*2
	dimnames(sim) = list(dag@terms[id], dag@terms[id])
	sim
}
ADD_TERM_SIM_METHOD("Sim_SSDD_2013")


#' Sim_Jiang_1997
#' 
#' @section Methods:
#' ## Sim_Jiang_1997
#' 
#' First semantic distance between term `a` and `b` via MICA term `c` is defined as:
#' 
#' ```
#' D(a, b) = IC(a) + IC(b) - 2*IC(c)
#' ```
#' 
#' Then there are several normalization method to change the distance to similarity and to scale it into the range of `[0, 1]`.
#' 
#' - max: `1 - D(a, b)/2/IC_max`
#' - Couto: `min(1, D(a, b)/IC_max)`
#' - Lin: `1 - D(a, b)/(IC(a) + IC(b))` which is the same as the *Sim_Lin_1998* method
#' - Garla: `1 - log(D(a, b) + 1)/log(2*IC_max + 1)`
#' - log-Lin: `1 - log(D(a, b) + 1)/log(IC(a) + IC(b) + 1)`
#' - Rada: `1/(1 + D(a, b))`
#' 
#' Paper link: <https://aclanthology.org/O97-1002/>.
#' 
#' There is a parameter `norm_method` which takes value in "max", "Couto", "Lin", "Carla", "log-Lin", "Rada":
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_Jiang_1997",
#'     control = list(norm_method = "Lin"))
#' ```
#' 
#' @rdname temp__Sim_Jiang_1997
Sim_Jiang_1997 = function(dag, terms, IC_method = "IC_annotation", norm_method = "max", verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_Jiang_1997 + ", norm_method)
	}

	id = term_to_node_id(dag, terms, strict = FALSE)

	l = validate_annotated_terms(dag, id)
	id = id[l]

	ic_mica = MICA_IC(dag, id, IC_method, verbose = verbose)
	ic = term_IC(dag, IC_method, verbose = FALSE)
	max_ic = max(ic, na.rm = TRUE)  # IC_annotation generates NA
	ic = ic[id]

	dist = cross_sum(ic) - 2*ic_mica
	if(norm_method == "max") {
		sim = 1 - dist/2/max_ic
	} else if(norm_method == "Couto") {
		sim = dist/max_ic
		sim[sim > 1] = 1
		sim = 1 - sim
	} else if(norm_method == "Lin") {
		sim = 2*ic_mica/cross_sum(ic)
	} else if(norm_method == "Garla") {
		sim = 1 - log(dist + 1)/log(2*max_ic + 1)
	} else if(norm_method == "log-Lin") {
		sim = 1 - log(dist + 1)/log(cross_sum(ic) + 1)
	} else if(norm_method == "Rada") {
		sim = 1/(1 + dist)
	} else {
		stop("wrong norm_method")
	}

	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_Jiang_1997")

######################
## count-based
######################

#' Sim_Kappa
#' 
#' @section Methods:
#' ## Sim_Kappa
#' 
#' Denote two sets `A` and `B` as the items annotated to term `a` and `b`. The similarity value is [the kappa coeffcient](https://en.wikipedia.org/wiki/Cohen%27s_kappa)
#' of the two sets. 
#' 
#' The universe or the background can be set via parameter `anno_universe`:
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_kappa",
#'     control = list(anno_universe = ...))
#' ```
#' 
#' @rdname temp__Sim_Kappa
Sim_Kappa = function(dag, terms, anno_universe = NULL, verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_Kappa")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)

	l = validate_annotated_terms(dag, id)
	id = id[l]
	.sim_overlap(dag, id, anno_universe, method = "kappa")
}
ADD_TERM_SIM_METHOD("Sim_Kappa", require_anno = TRUE)


#' Sim_Jaccard
#' 
#' @section Methods:
#' ## Sim_Jaccard
#' 
#' Denote two sets `A` and `B` as the items annotated to term `a` and `b`. The similarity value is the Jaccard coeffcient
#' of the two sets, defined as `length(intersect(A, B))/length(union(A, B))`.
#' 
#' The universe or the background can be set via parameter `anno_universe`:
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_Jaccard",
#'     control = list(anno_universe = ...))
#' ```
#' 
#' @rdname temp__Sim_Jaccard
Sim_Jaccard = function(dag, terms, anno_universe = NULL, verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_Jaccard")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)

	l = validate_annotated_terms(dag, id)
	id = id[l]
	.sim_overlap(dag, id, anno_universe, method = "jaccard")
}
ADD_TERM_SIM_METHOD("Sim_Jaccard", require_anno = TRUE)


#' Sim_Dice
#' 
#' @section Methods:
#' ## Sim_Dice
#' 
#' Denote two sets `A` and `B` as the items annotated to term `a` and `b`. The similarity value is the Dice coeffcient
#' of the two sets, defined as `2*length(intersect(A, B))/(length(A) + length(B))`.
#' 
#' The universe or the background can be set via parameter `anno_universe`:
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_Dice",
#'     control = list(anno_universe = ...))
#' ```
#' 
#' @rdname temp__Sim_Dice
Sim_Dice = function(dag, terms, anno_universe = NULL, verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_Dice")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)

	l = validate_annotated_terms(dag, id)
	id = id[l]
	.sim_overlap(dag, id, anno_universe, method = "dice")
}
ADD_TERM_SIM_METHOD("Sim_Dice", require_anno = TRUE)


#' Sim_Overlap
#' 
#' @section Methods:
#' ## Sim_Overlap
#' 
#' Denote two sets `A` and `B` as the items annotated to term `a` and `b`. The similarity value is the overlap coeffcient
#' of the two sets, defined as `length(intersect(A, B))/min(length(A), length(B))`.
#' 
#' The universe or the background can be set via parameter `anno_universe`:
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_Overlap",
#'     control = list(anno_universe = ...))
#' ```
#' 
#' @rdname temp__Sim_Overlap
Sim_Overlap = function(dag, terms, anno_universe = NULL, verbose = simona_opt$verbose) {

	if(verbose) {
		message("term_sim_method: ", "Sim_Overlap")
	}

	id = term_to_node_id(dag, terms, strict = FALSE)

	l = validate_annotated_terms(dag, id)
	id = id[l]
	.sim_overlap(dag, id, anno_universe, method = "overlap")
}
ADD_TERM_SIM_METHOD("Sim_Overlap", require_anno = TRUE)


#' @importFrom methods as
.sim_overlap = function(dag, id, anno_universe = NULL, method = c("kappa", "jaccard", "dice", "overlap")) {

	check_pkg("proxyC", bioc = FALSE)

	if(!is.null(anno_universe)) {
		anno_universe = which(dag@annotation$names %in% anno_universe)
	} else {
		anno_universe = seq_along(dag@annotation$names)
	}

	if(length(dag@annotation$list) == 0) {
		stop("`annotation` should be set in `create_ontology_DAG()`.")
	}

	mg = cpp_get_term_annotations(dag, id)
	mg = mg[, anno_universe, drop = FALSE]

	mg = as(mg, "sparseMatrix")

	method = match.arg(method)[1]
	if(method == "kappa") {
		mat = kappa_dist(mg)
	} else if(method == "overlap") {
		mat = overlap_dist(mg)
	} else {
		mat = proxyC::simil(mg, method = method)
	}

	mat = as.matrix(mat)
	diag(mat) = 1
	rownames(mat) = colnames(mat) = dag@terms[id]
	return(mat)
}

kappa_dist = function(m) {
	tab = ncol(m)
	oab = proxyC::simil(m, method = "simple matching")
	m1 = Matrix::rowSums(m)
	m2 = abs(Matrix::rowSums(m - 1))
	aab = (cross_multiply(m1) + cross_multiply(m2))/tab/tab
	k = (oab - aab)/(1 - aab)
	return(k)
}

overlap_dist = function(m) {
	n = Matrix::rowSums(m)
	proxyC::simil(m, method = "dice")*cross_sum(n)/2/cross_min(n)
}

##############

#' Sim_Ancestor
#' 
#' @section Methods:
#' ## Sim_Ancestor
#' 
#' Denote `S_a` and `S_b` are two sets of ancestor terms of term `a` and `b` (including `a` and `b`), the 
#' semantic similarity is defined as:
#' 
#' ```
#' length(intersect(S_a, S_b))/length(union(S_a, S_b))
#' ```
#' 
#' ```
#' term_sim(dag, terms, method = "Sim_Ancestor")
#' ```
#' 
#' @rdname temp__Sim_Ancestor
Sim_Ancestor = function(dag, terms, verbose = simona_opt$verbose) {
	id = term_to_node_id(dag, terms, strict = FALSE)
	sim = cpp_sim_ancestor(dag, id)

	dimnames(sim) = list(dag@terms[id], dag@terms[id])

	sim
}
ADD_TERM_SIM_METHOD("Sim_Ancestor")

.ALL_IC_METHODS = NULL
.ALL_TERM_SIM_METHODS = NULL
.ALL_GROUP_SIM_METHODS = NULL

SUPER_ROOT = "~~all~~"  # make sure it is always the last term after sorting

ADD_IC_METHOD = function(method, require_anno = FALSE) {
	fun = get(method, envir = topenv(), inherits = FALSE)
	param = names(formals(fun)[-1])
	attr(param, "require_anno") = require_anno
	.ALL_IC_METHODS[[method]] <<- param
}

ADD_TERM_SIM_METHOD = function(method, require_anno = FALSE) {
	fun = get(method, envir = topenv(), inherits = FALSE)
	param = names(formals(fun)[-(1:2)])
	attr(param, "require_anno") = require_anno
	.ALL_TERM_SIM_METHODS[[method]] <<- param
}

ADD_GROUP_SIM_METHOD = function(method, require_anno = FALSE) {
	fun = get(method, envir = topenv(), inherits = FALSE)
	param = names(formals(fun)[-(1:3)])
	attr(param, "require_anno") = require_anno
	.ALL_GROUP_SIM_METHODS[[method]] <<- param
}


#' Supported methods
#' 
#' @param require_anno If it is set to `TRUE`, methods that require external annotations are only returned. If 
#'    it is set to `FALSE`, methods that do not require annotations are returned. A value of `NULL` returns both.
#' 
#' @details
#' - `all_term_IC_methods()`: A vector of all supported IC methods.
#' - `all_term_sim_methods()`: A vector of all supported term similarity methods.
#' - `all_group_sim_methods()`: A vector of all supported group similarity methods.
#' 
#' @rdname all_methods
#' @export
#' @return A character vector of all supported methods.
#' @examples
#' all_term_IC_methods()
#' all_term_sim_methods()
#' all_group_sim_methods()
all_term_IC_methods = function(require_anno = NULL) {
	if(is.null(require_anno)) {
		names(.ALL_IC_METHODS)
	} else if(require_anno) {
		names(.ALL_IC_METHODS)[vapply(.ALL_IC_METHODS, function(x) attr(x, "require_anno"), FUN.VALUE = logical(1))]
	} else {
		names(.ALL_IC_METHODS)[!vapply(.ALL_IC_METHODS, function(x) attr(x, "require_anno"), FUN.VALUE = logical(1))]
	}
}

#' @export
#' @rdname all_methods
all_term_sim_methods = function(require_anno = NULL) {
	if(is.null(require_anno)) {
		names(.ALL_TERM_SIM_METHODS)
	} else if(require_anno) {
		names(.ALL_TERM_SIM_METHODS)[vapply(.ALL_TERM_SIM_METHODS, function(x) attr(x, "require_anno"), FUN.VALUE = logical(1))]
	} else {
		names(.ALL_TERM_SIM_METHODS)[!vapply(.ALL_TERM_SIM_METHODS, function(x) attr(x, "require_anno"), FUN.VALUE = logical(1))]
	}
}

#' @export
#' @rdname all_methods
all_group_sim_methods = function(require_anno = NULL) {
	if(is.null(require_anno)) {
		names(.ALL_GROUP_SIM_METHODS)
	} else if(require_anno) {
		names(.ALL_GROUP_SIM_METHODS)[vapply(.ALL_GROUP_SIM_METHODS, function(x) attr(x, "require_anno"), FUN.VALUE = logical(1))]
	} else {
		names(.ALL_GROUP_SIM_METHODS)[!vapply(.ALL_GROUP_SIM_METHODS, function(x) attr(x, "require_anno"), FUN.VALUE = logical(1))]
	}
}

#' All Papameters of a given method
#' 
#' @param IC_method A single IC method name.
#' @param term_sim_method A single term similarity method name.
#' @param group_sim_method A single group similarity method name.
#' 
#' @return A vector of parameter names.
#' @export
#' @examples
#' method_param(IC_method = "IC_annotation")
#' method_param(term_sim_method = "Sim_Wang_2007")
method_param = function(IC_method = NULL, term_sim_method = NULL, group_sim_method = NULL) {
	if(!is.null(IC_method)) {
		p = .ALL_IC_METHODS[[IC_method]]
	} else if(!is.null(term_sim_method)) {
		p = .ALL_TERM_SIM_METHODS[[term_sim_method]]
	} else if(!is.null(group_sim_method)) {
		p = .ALL_GROUP_SIM_METHODS[[group_sim_method]]
	} else {
		return(NULL)
	}

	attributes(p) = NULL
	p
}


#' Global options
#' 
#' @param RESET Reset to default option values.
#' @param READ.ONLY Only return read only options.
#' @param LOCAL Only return local options.
#' @param ADD Add new options.
#' @param ... Name-value pairs for options.
#' 
#' @details
#' There are the following global options:
#' 
#' - `use_cache`: By default, information content of all terms is cached and reused. If `use_cache` is set to `FALSE`, IC will be re-calculated.
#' - `verbose`: Whether to print messages?
#' - `anno_uniquify`: In the annotation-based IC method, the union of items annotated to the term as well as all its offspring terms is used, which means
#'      the set of annotated items for the term is uniquified. If `anno_uniquify` is set to `FALSE`, the uniquification is not applied, we simply add the number
#'      of items annotated to the term and the numbers of items annotated to each of its offspring terms.
#' - `robot_jar`: Path of the `robot.jar` file. The file can be found from \url{https://github.com/ontodev/robot/releases}.
#' 
#' To set an option, you can use `$`:
#' 
#' ```
#' simona_opt$verbose = FALSE
#' ```
#' 
#' or use it as a function:
#' 
#' ```
#' simona_opt(verbose = FALSE)
#' ```
#' 
#' @export
#' @import GlobalOptions
#' @returns A single option value.
#' @examples
#' simona_opt
simona_opt = GlobalOptions::setGlobalOptions(
	use_cache = list(
		.value = TRUE,
		.class = "logical",
		.length = 1
	),
	verbose = list(
		.value = TRUE,
		.class = "logical",
		.length = 1
	),
	anno_uniquify = list(
		.value = TRUE,
		.class = "logical",
		.length = 1
	),
	verbose = list(
		.value = TRUE,
		.class = "logical",
		.length = 1
	),
	robot_jar = list(
		.value = NULL,
		.validate = function(x) {
			if(is.null(x)) {
				TRUE
			} else {
				file.exists(x)
			}
		}
	)
)

#' Import ontologies already having gene annotations
#' 
#' @param organism Organism.
#' @param gene_annotation Whether to add gene annotations to the DAG.
#' @param verbose Whether to print messages?
#' @param ... Pass to [`create_ontology_DAG()`].
#' 
#' @details
#' There are the following ontologies:
#' 
#' - `ontology_kw()`: UniProt Keywords. The list of supported organisms can be found in [`UniProtKeywords::load_keyword_genesets()`].
#' - `ontology_chebi()`: Chemical Entities of Biological Interest.
#' - `ontology_hp()`: The Human Phenotype Ontology.
#' - `ontology_pw()`: Pathway Ontology.
#' - `ontology_rdo()`: RGD Disease Ontology.
#' - `ontology_vt()`: Vertebrate Trait Ontology.
#' 
#' The source of the original files can be found with `simona:::RGD_TB`.
#' 
#' @export
#' @importFrom utils data read.table
#' @rdname ontology
ontology_kw = function(organism = "human", gene_annotation = TRUE, verbose = simona_opt$verbose, ...) {

	check_pkg("UniProtKeywords", bioc = TRUE)

	if(verbose) {
		message("Obtaining ontology relations from the UniProtKeywords package...")
	}
	kw_parents = NULL
	load(system.file("data", "kw_parents.rda", package = "UniProtKeywords"))

	parents = unlist(kw_parents)
	children = rep(names(kw_parents), times = sapply(kw_parents, length))

	kw_terms = NULL
	load(system.file("data", "kw_terms.rda", package = "UniProtKeywords"))

	id = sapply(kw_terms, function(x) x$Identifier)
	accession = sapply(kw_terms, function(x) x$Accession)
	map = structure(accession, names = id)
	parents = map[parents]
	children = map[children]

	dag = create_ontology_DAG(parents, children, source = "UniProt Keywords", verbose = verbose, ...)

	meta = data.frame(
		id = sapply(kw_terms, function(x) x$Identifier),
		accession = sapply(kw_terms, function(x) x$Accession),
		name = sapply(kw_terms, function(x) x$Identifier),
		description = sapply(kw_terms, function(x) x$Description),
		category = sapply(kw_terms, function(x) paste(x$Category, collapse = "; "))
	)
	rownames(meta) = meta$accession
	meta = meta[dag@terms, ]
	rownames(meta)[nrow(meta)] = SUPER_ROOT

	mcols(dag) = meta

	if(gene_annotation) {
		annotation = UniProtKeywords::load_keyword_genesets(organism)
		names(annotation) = map[names(annotation)]
		dag = add_annotation(dag, annotation)
	}
	
	dag
}


RGD_TB = read.table(textConnection(
"org	onto	anno_url	onto_url
canis	chebi	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/canis_genes_chebi	https://purl.obolibrary.org/obo/chebi.obo
homo	chebi	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/homo_genes_chebi	https://purl.obolibrary.org/obo/chebi.obo
mus	chebi	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/mus_genes_chebi	https://purl.obolibrary.org/obo/chebi.obo
rattus	chebi	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/rattus_genes_chebi	https://purl.obolibrary.org/obo/chebi.obo
sus	chebi	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/sus_genes_chebi	https://purl.obolibrary.org/obo/chebi.obo
homo	hp	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/homo_genes_hp	https://purl.obolibrary.org/obo/hp.obo
mus	hp	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/mus_genes_hp	https://purl.obolibrary.org/obo/hp.obo
canis	pw	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/canis_genes_pw	https://download.rgd.mcw.edu/ontology/pathway/pathway.obo
chinchilla	pw	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/chinchilla_genes_pw	https://download.rgd.mcw.edu/ontology/pathway/pathway.obo
chlorocebus	pw	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/chlorocebus_genes_pw	https://download.rgd.mcw.edu/ontology/pathway/pathway.obo
heterocephalus	pw	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/heterocephalus_genes_pw	https://download.rgd.mcw.edu/ontology/pathway/pathway.obo
homo	pw	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/homo_genes_pw	https://download.rgd.mcw.edu/ontology/pathway/pathway.obo
ictidomys	pw	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/ictidomys_genes_pw	https://download.rgd.mcw.edu/ontology/pathway/pathway.obo
mus	pw	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/mus_genes_pw	https://download.rgd.mcw.edu/ontology/pathway/pathway.obo
pan	pw	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/pan_genes_pw	https://download.rgd.mcw.edu/ontology/pathway/pathway.obo
rattus	pw	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/rattus_genes_pw	https://download.rgd.mcw.edu/ontology/pathway/pathway.obo
sus	pw	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/sus_genes_pw	https://download.rgd.mcw.edu/ontology/pathway/pathway.obo
canis	rdo	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/canis_genes_rdo	https://download.rgd.mcw.edu/ontology/disease/RDO.obo
chinchilla	rdo	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/chinchilla_genes_rdo	https://download.rgd.mcw.edu/ontology/disease/RDO.obo
chlorocebus	rdo	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/chlorocebus_genes_rdo	https://download.rgd.mcw.edu/ontology/disease/RDO.obo
heterocephalus	rdo	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/heterocephalus_genes_rdo	https://download.rgd.mcw.edu/ontology/disease/RDO.obo
homo	rdo	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/homo_genes_rdo	https://download.rgd.mcw.edu/ontology/disease/RDO.obo
ictidomys	rdo	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/ictidomys_genes_rdo	https://download.rgd.mcw.edu/ontology/disease/RDO.obo
mus	rdo	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/mus_genes_rdo	https://download.rgd.mcw.edu/ontology/disease/RDO.obo
pan	rdo	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/pan_genes_rdo	https://download.rgd.mcw.edu/ontology/disease/RDO.obo
rattus	rdo	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/rattus_genes_rdo	https://download.rgd.mcw.edu/ontology/disease/RDO.obo
sus	rdo	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/sus_genes_rdo	https://download.rgd.mcw.edu/ontology/disease/RDO.obo
canis	vt	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/canis_genes_vt	https://purl.obolibrary.org/obo/vt.owl
chinchilla	vt	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/chinchilla_genes_vt	https://purl.obolibrary.org/obo/vt.owl
chlorocebus	vt	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/chlorocebus_genes_vt	https://purl.obolibrary.org/obo/vt.owl
heterocephalus	vt	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/heterocephalus_genes_vt	https://purl.obolibrary.org/obo/vt.owl
homo	vt	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/homo_genes_vt	https://purl.obolibrary.org/obo/vt.owl
ictidomys	vt	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/ictidomys_genes_vt	https://purl.obolibrary.org/obo/vt.owl
mus	vt	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/mus_genes_vt	https://purl.obolibrary.org/obo/vt.owl
pan	vt	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/pan_genes_vt	https://purl.obolibrary.org/obo/vt.owl
rattus	vt	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/rattus_genes_vt	https://purl.obolibrary.org/obo/vt.owl
sus	vt	https://download.rgd.mcw.edu/ontology/annotated_rgd_objects_by_ontology/sus_genes_vt	https://purl.obolibrary.org/obo/vt.owl
"), header = TRUE)


read_table_from_url = function(url, ...) {
	con = url(url)
	oe = try(res <- read.table(con, ...), silent = TRUE)

	if(inherits(oe, "try-error")) {
		if(grepl("Timeout", oe)) {
			stop_wrap(qq("URL '@{url}': Timeout of 60 seconds was reached. Please increase `options(timeout = ...)`."))
		} else {
			stop(oe)
		}
	} else {
		return(res)
	}
}

organism_map = c("human" = "homo",
	             "mouse" = "mus",
	             "rat" = "rattus",
	             "pig" = "sus", 
	             "dog" = "canis", 
	             "chimpanzee" = "pan")

#' @rdname ontology
#' @export
ontology_chebi = function(
	organism = c("human", "mouse", "rat", "pig", "dog"), 
	gene_annotation = TRUE,
	verbose = simona_opt$verbose, ...) {
	
	organism = match.arg(organism)[1]
	organism = organism_map[organism]

	i = which(RGD_TB$org == organism & RGD_TB$onto == "chebi")
	onto_url = RGD_TB$onto_url[i]
	anno_url = RGD_TB$anno_url[i]

	if(verbose) {
		message(qq("Downloading ontology file from @{onto_url}..."))
	}
	dag = import_ontology(onto_url, verbose = verbose, ...)

	if(gene_annotation) {
		if(verbose) {
			message(qq("Downloading annotation file from @{anno_url}..."))
		}
		anno_tb = read_table_from_url(anno_url, comment.char = "!", sep = "\t", quote = "")
		anno = split(anno_tb[[3]], anno_tb[[5]])

		dag = add_annotation(dag, anno)
	}

	dag
}


#' @rdname ontology
#' @export
ontology_hp = function(
	organism = c("human", "mouse"), gene_annotation = TRUE,
	verbose = simona_opt$verbose, ...) {
	
	organism = match.arg(organism)[1]
	organism = organism_map[organism]

	i = which(RGD_TB$org == organism & RGD_TB$onto == "hp")
	onto_url = RGD_TB$onto_url[i]
	anno_url = RGD_TB$anno_url[i]

	if(verbose) {
		message(qq("Downloading ontology file from @{onto_url}..."))
	}
	dag = import_ontology(onto_url, verbose = verbose, ...)

	if(gene_annotation) {
		if(verbose) {
			message(qq("Downloading annotation file from @{anno_url}..."))
		}
		anno_tb = read_table_from_url(anno_url, comment.char = "!", sep = "\t", quote = "")
		anno = split(anno_tb[[3]], anno_tb[[5]])

		dag = add_annotation(dag, anno)
	}

	dag
}

#' @rdname ontology
#' @export
ontology_pw = function(
	organism = c("human", "mouse", "rat", "pig", "dog", "chimpanzee"),
	gene_annotation = TRUE,
	verbose = simona_opt$verbose, ...) {
	
	organism = match.arg(organism)[1]
	organism = organism_map[organism]

	i = which(RGD_TB$org == organism & RGD_TB$onto == "pw")
	onto_url = RGD_TB$onto_url[i]
	anno_url = RGD_TB$anno_url[i]

	if(verbose) {
		message(qq("Downloading ontology file from @{onto_url}..."))
	}
	dag = import_ontology(onto_url, verbose = verbose, ...)

	if(gene_annotation) {
		if(verbose) {
			message(qq("Downloading annotation file from @{anno_url}..."))
		}
		anno_tb = read_table_from_url(anno_url, comment.char = "!", sep = "\t", quote = "")
		anno = split(anno_tb[[3]], anno_tb[[5]])

		dag = add_annotation(dag, anno)
	}

	dag
}

#' @rdname ontology
#' @export
ontology_rdo = function(
	organism = c("human", "mouse", "rat", "pig", "dog", "chimpanzee"),
	gene_annotation = TRUE,
	verbose = simona_opt$verbose, ...) {
	
	organism = match.arg(organism)[1]
	organism = organism_map[organism]

	i = which(RGD_TB$org == organism & RGD_TB$onto == "rdo")
	onto_url = RGD_TB$onto_url[i]
	anno_url = RGD_TB$anno_url[i]

	if(verbose) {
		message(qq("Downloading ontology file from @{onto_url}..."))
	}
	dag = import_ontology(onto_url, verbose = verbose, ...)

	if(gene_annotation) {
		if(verbose) {
			message(qq("Downloading annotation file from @{anno_url}..."))
		}
		anno_tb = read_table_from_url(anno_url, comment.char = "!", sep = "\t", quote = "")
		anno = split(anno_tb[[3]], anno_tb[[5]])

		dag = add_annotation(dag, anno)
	}

	dag
}

#' @rdname ontology
#' @export
ontology_vt = function(
	organism = c("human", "mouse", "rat", "pig", "dog", "chimpanzee"),
	gene_annotation = TRUE,
	verbose = simona_opt$verbose, ...) {
	
	organism = match.arg(organism)[1]
	organism = organism_map[organism]

	i = which(RGD_TB$org == organism & RGD_TB$onto == "vt")
	onto_url = RGD_TB$onto_url[i]
	anno_url = RGD_TB$anno_url[i]

	if(verbose) {
		message(qq("Downloading ontology file from @{onto_url}..."))
	}
	dag = import_owl(onto_url, verbose = verbose, ...)

	if(gene_annotation) {
		if(verbose) {
			message(qq("Downloading annotation file from @{anno_url}..."))
		}
		anno_tb = read_table_from_url(anno_url, comment.char = "!", sep = "\t", quote = "")
		anno = split(anno_tb[[3]], anno_tb[[5]])

		dag = add_annotation(dag, anno)
	}

	dag
}

#' @details
#' `ontology_go()` is an alias of [`create_ontology_DAG_from_GO_db()`]. All arguments go there.
#' @rdname ontology
#' @export
ontology_go = function(...) {
	create_ontology_DAG_from_GO_db(...)
}


#' @rdname ontology
#' @export
#' @details
#' Valid values for `organism` argument in `ontology_reactome()` are 
#' 
#' ```
#' c("BTA", "CEL", "CFA", "DRE", "DDI", "DME", "GGA", "HSA", "MMU", 
#'   "MTU", "PFA", "RNO", "SCE", "SPO", "SSC", "XTR")
#' ```
#' 
ontology_reactome = function(
	organism = "HSA",
	gene_annotation = TRUE,
	verbose = simona_opt$verbose, ...) {

	if(!organism %in% c("BTA", "CEL", "CFA", "DRE", "DDI", "DME", "GGA", "HSA", "MMU", 
                        "MTU", "PFA", "RNO", "SCE", "SPO", "SSC", "XTR")) {
        stop("Specified organism is not support.")
    }

    if(verbose) {
		message("Downloading pathway name file from https://reactome.org/download/current/ReactomePathways.txt...")
	}
    tb = read.table(url("https://reactome.org/download/current/ReactomePathways.txt"), sep = "\t", comment.char = "", quote = "")
    tb = tb[grepl(organism, tb[, 1]), ]
    pathway_names = structure(tb[, 2], names = tb[, 1])

    if(verbose) {
		message("Downloading parent-child relation file from https://reactome.org/download/current/ReactomePathwaysRelation.txt...")
	}
    df = read.table(url("https://reactome.org/download/current/ReactomePathwaysRelation.txt"), sep = "\t")
    df = df[grepl(organism, df[, 1]) & grepl(organism, df[, 2]), ]
    dag = create_ontology_DAG(df[, 1], df[, 2])
    mcols(dag, "name") = pathway_names[dag_all_terms(dag)]

    if(gene_annotation) {
	    if(verbose) {
			message("Downloading annotation file from https://reactome.org/download/current/NCBI2Reactome.txt...")
		}
	    tb = read.table(url("https://reactome.org/download/current/NCBI2Reactome.txt"), sep = "\t", comment.char = "", quote = "")
	    tb2 = tb[grepl(organism, tb[, 2]), ]
	    gs = split(tb2[, 1], tb2[, 2])
	    gs = lapply(gs, function(x) unique(as.character(x)))
	    
	    dag = add_annotation(dag, gs)
	}
	dag
}

#' Reorder the DAG
#' 
#' @param dag An `ontology_Dag` object.
#' @param value A vector of numeric values. See the **Details** section.
#' @param verbose Whether to print messages.
#' 
#' @details
#' In `dag_reorder()`, there are two ways to set the `value` argument. It can be a vector corresponding
#' to all terms (in the same order as in [`dag_all_terms()`]) or a vector corresponding
#' to all leaf terms (in the same order as in [`dag_leaves()`]). If `value` corresponds
#' to all terms, the score associates to each term is the average value of all its offspring terms.
#' And if `value` corresponds to all leaf terms, the score for each term is the average of all its
#' connectable leaves.
#' 
#' The reordering is simply applied on each term to reorder its child terms.
#' 
#' @return An `ontology_DAG` object.
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' # by default, c and e locate on the left side, d and f locate on the right side
#' dag = create_ontology_DAG(parents, children)
#' dag_children(dag, "b")
#'
#' # move c and e to the right side of the diagram
#' dag2 = dag_reorder(dag, value = c(1, 1, 10, 1, 10, 1))
#' dag_children(dag2, "b")
#'
#' # we can also only set values for leaf terms
#' # there are two leaf terms c and e
#' # we let v(c) > v(e) to move c to the right side of the diagram
#' dag3 = dag_reorder(dag, value = c(10, 1))
#' dag_children(dag3, "b")
dag_reorder = function(dag, value, verbose = simona_opt$verbose) {
	n_terms = dag_n_terms(dag)
	n_leaves = dag_n_leaves(dag)


	if(length(value) == n_terms) {
		v = value
		k = n_offspring(dag, include_self = TRUE)
	} else if(length(value) == n_leaves) {
		v = rep(0, n_terms)
		v[dag@leaves] = value
		k = n_connected_leaves(dag)
	} else {
		stop("Length of `value` should be the same as the total number of terms or the leaves.")
	}

	exec_under_message_condition({
		s <- cpp_offspring_aggregate(dag, v, 2L)
	}, verbose = verbose)

	s = s/k
	s[is.na(s)] = -Inf
	dag@lt_children = cpp_reorder_by_score(dag@lt_children, s)

	dag
}

#' @rdname dag_reorder
#' 
#' @details
#' `dag_permutate_children()` randomly permute child terms under a term.
#' @export
dag_permutate_children = function(dag, verbose = simona_opt$verbose) {
	dag@lt_children = cpp_permutate_children(dag@lt_children)

	dag
}


#### will be implemented in the future ####

# theta: in degree
.calc_force = function(theta, rho) {
	theta*rho
}

get_force = function(dag, window_size_fun = n_connected_leaves, verbose = verbose) {
	tree = dag_treelize(dag, verbose = FALSE)
	term_pos = exec_under_message_condition({
		cpp_node_pos_in_tree(tree, window_size_fun(tree), 0, 360) ## in polar coordinate
	}, verbose = FALSE)
	theta = term_pos$theta
	depth = dag_depth(dag)
	force = numeric(dag@n_terms)
	for(i in seq_len(dag@n_terms)) {

		pa = dag_parents(dag, i, in_labels = FALSE)
		pa = setdiff(pa, dag@root)
		ch = dag_offspring(dag, i, in_labels = FALSE, include_self = TRUE)

		if(length(ch) == 0) { # leaf
			terms = pa
		} else {
			terms = c(pa, ch)
		}

		if(length(ch)) {
			## ch's other parents that is not i
			cp = setdiff(dag_parents(dag, ch, in_labels = FALSE), i)
			terms = unique(c(terms, cp))
		}

		t = theta[terms]

		t1 = t - theta[i]
		t2 = t + 360 - theta[i]
		t3 = t - 360 - theta[i]

		l = t1 < -180
		t1[l] = t2[l]
		l = t1 > 180
		t1[l] = t3[l]

		t1[abs(t1) < 5] = 0
		force[i] = sum(.calc_force(t1, depth[i]))
		
	}
	force[is.na(force)] = 0
	force
}

reorder_on_circle = function(dag, term_pos, times = 1, window_size_fun = n_connected_leaves, verbose = TRUE) {

	theta = term_pos$x
	width = term_pos$width
	n_off = n_offspring(dag, include_self = TRUE)

	depth = dag_depth(dag)
	total_force = 0
	for(k in seq_len(times)) {
		if(verbose) message("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\badjusting branches on the DAG... ", k, ".", appendLF = FALSE)
		force = get_force(dag, window_size_fun = window_size_fun, verbose = verbose)

		if(k == 1) {
			total_force = sum(abs(force))
		} else {
			r = abs(sum(abs(force)) - total_force)/total_force
			if( r > 0.01) {
				total_force = sum(abs(force))
			} else {
				if(verbose) message(" Done.")
				return(theta)
			}
		}

		for(i in seq_len(dag@n_terms)) {

			ch = dag@lt_children[[i]]
			if(length(ch) > 1) {
				dag@lt_children[[i]] = .adjust_children(ch, force, width, depth, n_off)
			}
		}

		tree = dag_treelize(dag, verbose = FALSE)
		term_pos = exec_under_message_condition({
			cpp_node_pos_in_tree(tree, window_size_fun(tree), 0, 360)
		}, verbose = FALSE)
		theta = term_pos$x
		width = term_pos$width
	}
	if(verbose) message(" Done.")

	theta
}

.move_index = function(x, i, j) {  # i: from, j : to
	n = length(x)
	if(i == n && j == 1) {
		x[c(n, seq(1, n - 1))]
	} else if(i == n) {
		x[c(seq(1, j-1), n, seq(j, n-1))]
	} else if(j == 1) {
		x[c(i, seq(1, i-1), seq(i+1, n))]
	} else if(i > j) {
		x[c(seq(1, j-1), i, seq(j, i-1), seq(i+1, n))]
	} else if(i == 1 && j == n) {
		x[c(seq(2, n), 1)]
	} else if(i == 1) {
		x[c(seq(2, j-1), i, seq(j, n))]
	} else if(j == n) {
		x[c(seq(1, i-1), seq(i+1, n), i)]
	} else if(i < j) {
		x[c(seq(1, i-1), seq(i+1, j), i, seq(j+1, n))]
	}
}

.adjust_children = function(ch, force, width, depth, n_off, min_force = 0) {
	f = force[ch]
	n = length(ch)

	od = order(abs(f), decreasing = TRUE)

	ind = seq_len(n)  # the original index order
	cur_pos_left = 1
	cur_pos_right = n

	force1 = f
	ch2 = ch
	for(i in 1:n) {
		
		if(abs(f[od[i]]) < min_force) next
		ind2 = ind
		if(f[od[i]] > 0) {
			ind = .move_index(ind, od[i], cur_pos_right)
			cur_pos_right = cur_pos_right - 1
		} else {
			ind = .move_index(ind, od[i], cur_pos_left)
			cur_pos_left = cur_pos_left - 1
		}
		
		ch2 = ch[ind]
		force2 = f[ind]
	
		offset = (cumsum(width[ch2]) + cumsum(c(0, width[ch2][-n])))/2 - 
		         (cumsum(width[ch]) + cumsum(c(0, width[ch][-n])))/2
		f2 = sapply(seq_along(ch2), function(x) {
			force2[x] + n_off[ch2[x]]*.calc_force(offset[x], depth[ch2[x]])
		})

		if(abs(sum(force1)) > abs(sum(f2))) {
			return(ch[ind2])
		}	
		
		force1 = f2  ## prevous sum of force
	}
	return(ch2)
}

#' IC_offspring
#' 
#' @section Methods:
#' ## IC_offspring
#' Denote `k` as the number of offspring terms plus the term itself and `N` is such value for root (or the total number of terms in the DAG), the information
#' content is calculated as:
#' 
#' ```
#' IC = -log(k/N)
#' ```
#' 
#' @rdname temp__IC_offspring
IC_offspring = function(dag, use_cache = simona_opt$use_cache, verbose = simona_opt$verbose) {

	if(verbose) {
		message("IC_method: ", "IC_offspring")
	}

	if(is.null(dag@term_env$IC_offspring)) {
		use_cache = FALSE
	} 
	if(!use_cache) {

		n = n_offspring(dag, include_self = TRUE)
		
		p = n/max(n)
		ic = -log(p)
		dag@term_env$IC_offspring = ic
		
	}
	
	dag@term_env$IC_offspring
}
ADD_IC_METHOD("IC_offspring")


#' IC_depth
#' 
#' @section Methods:
#' ## IC_height
#' For a term `t` in the DAG, denote `d` as the maximal distance from root (i.e. the depth) and `h` as the maximal distance to leaves (i.e. the height),
#' the relative position `p` on the longest path from root to leaves via term `t` is calculated as:
#' 
#' ```
#' p = (h + 1)/(h + d + 1)
#' ```
#' 
#' In the formula where 1 is added gets rid of `p = 0`. Then the information content is:
#' 
#' ```
#' IC = -log(p) 
#'    = -log((h+1)/(h+d+1))
#' ```
#' 
#' @rdname temp__IC_height
IC_height = function(dag, use_cache = simona_opt$use_cache, verbose = simona_opt$verbose) {

	if(verbose) {
		message("IC_method: ", "IC_height")
	}
	
	if(is.null(dag@term_env$IC_height)) {
		use_cache = FALSE
	} 
	if(!use_cache) {

		ic = -log((dag_height(dag) + 1)/(dag_depth(dag) + dag_height(dag) + 1))
		dag@term_env$IC_height = ic
		
	}
	
	
	dag@term_env$IC_height
}
ADD_IC_METHOD("IC_height")


#' IC_annotation
#' 
#' @section Methods:
#' ## IC_annotation
#' Denote `k` as the number of items annotated to a term `t`, and `N` is the number of items annotated to the root (which is
#' the total number of items annotated to the DAG), IC for term `t` is calculated as:
#' 
#' ```
#' IC = -log(k/N)
#' ```
#' 
#' In current implementations in other tools, there is an inconsistency of defining `k` and `N`. 
#' Please see [`n_annotations()`] for explanation.
#' 
#' `NA` is assigned to terms with no item annotated.
#' 
#' @rdname temp__IC_annotation
IC_annotation = function(dag, uniquify = simona_opt$anno_uniquify, use_cache = simona_opt$use_cache, verbose = simona_opt$verbose) {

	if(verbose) {
		message("IC_method: ", "IC_annotation")
	}

	if(!uniquify && is.null(dag@term_env$IC_annotation)) {
		use_cache = FALSE
	} else if(uniquify && is.null(dag@term_env$IC_annotation_unique)) {
		use_cache = FALSE
	}
	if(!use_cache) {

		n = n_annotations(dag, uniquify = uniquify, use_cache = use_cache)
		
		p = n/max(n)
		ic = ifelse(n == 0, NA_real_, -log(p))
		
		if(uniquify) {
			dag@term_env$IC_annotation_unique = ic
		} else {
			dag@term_env$IC_annotation = ic
		}
	}
	
	if(uniquify) {
		dag@term_env$IC_annotation_unique
	} else {
		dag@term_env$IC_annotation
	}
}
ADD_IC_METHOD("IC_annotation", require_anno = TRUE)



##########################
### IC universal

#' IC_universal
#' 
#' @section Methods:
#' ## IC_universal
#' 
#' It measures the probability of a term getting full transmission from the root. Each term is associated with a p-value and the root has
#' the p-value of 1.
#' 
#' For example, an intermediate term `t` has two parent terms `parent1` and `parent2`, also assume `parent1` has `k1` children
#' and `parent2` has `k2` children, assume a parent transmits information equally to all its children, then respectively `parent1` only transmits `1/k1` and
#' `parent2` only transmits `1/k2` of its content to term `t`, or the probability of a parent to reach `t` is `1/k1` or `1/k2`. 
#' Let's say `p1` and `p2` are the accumulated contents from the root to `parnet1` and `parent2` respectively (or the probability 
#' of the two parent terms getting full transmission from root), then the probability of reaching `t` via a full transmission graph from `parent1`
#' is the multiplication of `p1` and `1/k1`, which is `p1/k1`, and same for `p2/k2`. Then, for term `t`, if getting transmitted from `parent1` and
#' `parent2` are independent, the probability of `t` (denoted as `p_t`) to get transmitted from both parents is:
#' 
#' ```
#' p_t = (p1/k1) * (p2/k2)
#' ```
#' 
#' Since the two parents are the full set of `t`'s parents, `p_t` is the probability of `t` getting full transmission from root. And the final
#' information content is:
#' 
#' ```
#' IC = -log(p_t)
#' ```
#' 
#' Paper link: \doi{10.1155/2012/975783}.
#' 
#' @rdname temp__IC_universal
IC_universal = function(dag, use_cache = simona_opt$use_cache, verbose = simona_opt$verbose) {

	if(verbose) {
		message("IC_method: ", "IC_universal")
	}
	
	if(is.null(dag@term_env$IC_universal) || !use_cache) {
		lt_parents = dag@lt_parents

		n_children = dag@term_env$n_children

		n_terms = dag@n_terms

		e = new.env()
		d = rep(NA, n_terms)

		root = dag@root
		d[root] = 0

		depth = dag_depth(dag)

		current_depth = 0
		while(1) {
			current_depth = current_depth + 1
			l = depth == current_depth
			if(sum(l) == 0) {
				break
			}

			for(i in which(l)) {
				p = lt_parents[[i]]
				d[i] = sum(d[p] + log(n_children[p]))
			}
		}
		dag@term_env$IC_universal = d
	}

	dag@term_env$IC_universal
}
ADD_IC_METHOD("IC_universal")


##############################################
### reachability is the number of ways for a node to reach the leaves
reachability = function(dag, use_cache = simona_opt$use_cache) {
	if(is.null(dag@term_env$reachability) || !use_cache) {
		lt_children = dag@lt_children

		n_terms = dag@n_terms

		reach = rep(NA, n_terms)

		all_leaves = dag@leaves
		reach[all_leaves] = 1

		height = dag_height(dag)

		current_height = 0
		while(1) {
			current_height = current_height + 1
			l = height == current_height
			if(sum(l) == 0) {
				break
			}

			for(i in which(l)) {
				reach[i] = sum(reach[ lt_children[[i]] ])
			}
		}
		dag@term_env$reachability = reach
	}
	dag@term_env$reachability
}

########################################
### Zhang et al

#' IC_Zhang_2006
#' 
#' @section Methods:
#' ## IC_Zhang_2006
#' 
#' It measures the number of ways from a term to reach leaf terms. E.g. in the following DAG:
#' 
#' ```
#'      a      upstream
#'     /|\
#'    b | c
#'      |/
#'      d      downstream
#' ```
#' 
#' term `a` has three ways to reach leaf, which are `a->b`, `a->d` and `a->c->d`.
#' 
#' Let's denote `k` as the number of ways for term `t` to reach leaves and `N` as the maximal value of `k` which
#' is associated to the root term, the information content is calculated as 
#' 
#' ```
#' IC = -log(k/N) 
#'    = log(N) - log(k)
#' ``` 
#' 
#' Paper link: \doi{10.1186/1471-2105-7-135}.
#' 
#' @rdname temp__IC_Zhang_2006
IC_Zhang_2006 = function(dag, use_cache = simona_opt$use_cache, verbose = simona_opt$verbose) {
	if(verbose) {
		message("IC_method: ", "IC_Zhang_2006")
	}
	
	if(is.null(dag@term_env$IC_Zhang_2006) || !use_cache) {
		re = reachability(dag, use_cache)
		dag@term_env$IC_Zhang_2006 = -log(re/max(re))
	}
	dag@term_env$IC_Zhang_2006
}
ADD_IC_METHOD("IC_Zhang_2006")


########################################
### Seco et al

#' IC_Seco_2004
#' 
#' @section Methods:
#' ## IC_Seco_2004
#' 
#' It is based on the number of offspring terms of term `t`.
#' The information content is calculated as:
#' 
#' ```
#' IC = 1 - log(k+1)/log(N)
#' ```
#' 
#' where `k` is the number of offspring terms of `t`, or you can think `k+1` is the number of `t`'s offspring terms plus itself.
#' `N` is the total number of terms on the DAG.
#' 
#' Paper link: \doi{10.5555/3000001.3000272}.
#' 
#' @rdname temp__IC_Seco_2004
IC_Seco_2004 = function(dag, use_cache = simona_opt$use_cache, verbose = simona_opt$verbose) {

	if(verbose) {
		message("IC_method: ", "IC_Seco_2004")
	}
	
	if(is.null(dag@term_env$IC_Seco_2004) || !use_cache) {
		n = n_offspring(dag, include_self = TRUE)
		dag@term_env$IC_Seco_2004 = 1 - log(n)/log(dag@n_terms) # dag@n_terms == max(n)
	}
	dag@term_env$IC_Seco_2004
}
ADD_IC_METHOD("IC_Seco_2004")


########################################
### Zhou et al

#' IC_Zhou_2008
#' 
#' @section Methods:
#' ## IC_Zhou_2008
#' 
#' It is a correction of *IC_Seco_2004* which considers the depth of a term in the DAG.
#' The information content is calculated as:
#' 
#' ```
#' IC = 0.5*IC_Seco + 0.5*log(depth)/log(max_depth)
#' ```
#' 
#' where `depth` is the depth of term `t` in the DAG, defined as the maximal distance from root. `max_depth` is the largest depth in the DAG.
#' So IC is composed with two parts: the numbers of offspring terms and positions in the DAG.
#' 
#' Paper link: \doi{10.1109/FGCNS.2008.16}.
#' 
#' @rdname temp__IC_Zhou_2008
IC_Zhou_2008 = function(dag, use_cache = simona_opt$use_cache, verbose = simona_opt$verbose) {

	if(verbose) {
		message("IC_method: ", "IC_Zhou_2008")
	}
	
	if(is.null(dag@term_env$IC_Zhou_2008) || !use_cache) {
		depth = dag_depth(dag, use_cache = use_cache)
		ic_seco = IC_Seco_2004(dag, use_cache = use_cache, verbose = FALSE)
		
		sigma = 0.5
		dag@term_env$IC_Zhou_2008 = sigma*ic_seco + (1-sigma)*log(ifelse(depth == 0, 1, depth))/log(max(depth))
	}
	dag@term_env$IC_Zhou_2008
}
ADD_IC_METHOD("IC_Zhou_2008")


# ########################################
# ### Seddiqui et al

#' IC_Seddiqui_2010
#' 
#' @section Methods:
#' ## IC_Seddiqui_2010
#' 
#' It is also a correction to *IC_Seco_2004*, but considers number of relations connecting a term (i.e. number of parent terms and child terms).
#' The information content is defined as:
#' 
#' ```
#' (1-sigma)*IC_Seco + sigma*log((n_parents + n_children + 1)/log((total_edges + 1))
#' ```
#' 
#' where `n_parents` and `n_children` are the numbers of parents and children of term `t`. The tuning factor `sigma` is defined as 
#' 
#' ```
#' sigma = log(total_edges+1)/(log(total_edges) + log(total_terms))
#' ```
#' 
#' where `total_edges` is the number of all relations (all parent-child relations)
#' and `total_terms` is the number of all terms in the DAG. 
#' 
#' Paper link: \doi{10.5555/1862330.1862343}.
#' 
#' @rdname temp__IC_Seddiqui_2010
IC_Seddiqui_2010 = function(dag, use_cache = simona_opt$use_cache, verbose = simona_opt$verbose) {

	if(verbose) {
		message("IC_method: ", "IC_Seddiqui_2010")
	}
	
	if(is.null(dag@term_env$IC_Seddiqui_2010) || !use_cache) {
		n_relations = dag@term_env$n_parents + dag@term_env$n_children
		n_edges = sum(dag@term_env$n_parents)
		n_nodes = dag@n_terms

		ic_seco = IC_Seco_2004(dag, use_cache, verbose = FALSE)

		sigma = log(n_edges + 1)/( log(n_edges) + log(n_nodes) )
		dag@term_env$IC_Seddiqui_2010 = (1 - sigma)*ic_seco + sigma*log(n_relations + 1)/log(n_edges + 1)
	}
	dag@term_env$IC_Seddiqui_2010
}
ADD_IC_METHOD("IC_Seddiqui_2010")



#########################################
### Sanchez et al: information pass to leaves

#' IC_Sanchez_2011
#' 
#' @section Methods:
#' ## IC_Sanchez_2011
#' 
#' It measures the average contribution of term `t` on leaf terms. First denote `zeta` as the number of leaf terms that
#' can be reached from term `t` (or `t`'s offspring that are leaves.). Since all `t`'s ancestors can also
#' reach `t`'s leaves, the contribution of `t` on leaf terms is scaled by `n_ancestors` which is the number of `t`'s ancestor terms.
#' The final information content is normalized by the total number of leaves in the DAG, which is the possible maximal value of `zeta`.
#' The complete definition of information content is:
#' 
#' ```
#' IC = -log( (zeta/n_ancestor) / n_all_leaves)
#' ```
#' 
#' Paper link: \doi{10.1016/j.knosys.2010.10.001}.
#' 
#' @rdname temp__IC_Sanchez_2011
IC_Sanchez_2011 = function(dag, use_cache = simona_opt$use_cache, verbose = simona_opt$verbose) {

	if(verbose) {
		message("IC_method: ", "IC_Sanchez_2011")
	}
	
	if(is.null(dag@term_env$IC_Sanchez_2011) || !use_cache) {
		nl = length(dag@leaves)
		n_connected_leaves = n_connected_leaves(dag)

		na = n_ancestors(dag)
		na[na == 0] = 1

		dag@term_env$IC_Sanchez_2011 = -log( (n_connected_leaves+1)/na/nl )
	}
	dag@term_env$IC_Sanchez_2011
}
ADD_IC_METHOD("IC_Sanchez_2011")



#########################################
### Meng et al

#' IC_Meng_2012
#' 
#' @section Methods:
#' ## IC_Meng_2012
#' 
#' It has a complex form which takes account of the term depth and the downstream of the term.
#' The first factor is calculated as:
#' 
#' ```
#' f1 = log(depth)/long(max_depth)
#' ``` 
#' 
#' The second factor is calculated as:
#' 
#' ```
#' f1 = 1 - log(1 + sum_{x => t's offspring}(1/depth_x))/log(total_terms)
#' ```
#' 
#' In the equation, the summation goes over `t`'s offspring terms.
#' 
#' The final information content is the multiplication of `f1` and `f2`:
#' 
#' ```
#' IC = f1 * f2
#' ```
#' 
#' Paper link: <http://article.nadiapub.com/IJGDC/vol5_no3/6.pdf>.
#' 
#' There is one parameter `correct`. If it is set to `TRUE`, the first factor `f1` is calculated as:
#' 
#' ```
#' f1 = log(depth + 1)/long(max_depth + 1)
#' ```
#' 
#' `correct` can be set as:
#' 
#' ```
#' term_IC(dag, method = "IC_Meng_2012", control = list(correct = TRUE))
#' ```
#' 
#' @rdname temp__IC_Meng_2012
IC_Meng_2012 = function(dag, correct = FALSE, use_cache = simona_opt$use_cache, verbose = simona_opt$verbose) {

	if(verbose) {
		message("IC_method: ", "IC_Meng_2012")
	}
	
	if(is.null(dag@term_env$IC_Meng_2012) || !use_cache) {
		dag@term_env$IC_Meng_2012 = cpp_ic_meng(dag, correct)
	}
	dag@term_env$IC_Meng_2012
}
ADD_IC_METHOD("IC_Meng_2012")



###############################
### totipotency
totipotency = function(dag, use_cache = simona_opt$use_cache) {

	if(is.null(dag@term_env$totipotency) || !use_cache) {
		lt_parents = dag@lt_parents

		n_offspring = n_offspring(dag) + 1
		n_terms = dag@n_terms

		t = rep(NA, n_terms)

		root = dag@root
		t[root] = 1

		depth = dag_depth(dag)

		current_depth = 0
		while(1) {
			current_depth = current_depth + 1
			l = depth == current_depth
			if(sum(l) == 0) {
				break
			}

			for(i in which(l)) {
				p = lt_parents[[i]]
				t[i] = mean(n_offspring[i]/n_offspring[p] * t[p])
			}
		}

		dag@term_env$totipotency = t
	}
	dag@term_env$totipotency
}


#' IC_Wang_2007
#' 
#' @section Methods:
#' ## IC_Wang_2007
#' 
#' Each relation is weighted by a value less than 1 based on the semantic relation, i.e. 0.8 for "is_a" and 0.6 for "part_of".
#' For a term `t` and one of its ancestor term `a`, it first calculates an "S-value" which corresponds to a path from `a` to `t` where
#' the accumulated multiplication of weights along the path reaches maximal:
#' 
#' ```
#' S(a->t) = max_{path}(prod_{node on the paty}(w))
#' ```
#' 
#' Here `max` goes over all possible paths from `a` to `t`, and `prod()` multiplies edge weights in a certain path.
#' 
#' The formula can be transformed as (we simply rewrite `S(a->t)` to `S`):
#' 
#' ```
#' 1/S = min(prod(1/w))
#' log(1/S) = log(min(prod(1/w)))
#'          = min(sum(log(1/w)))
#' ```
#' 
#' Since `w < 1`, `log(1/w)` is positive. According to the equation, the path (`a->...->t`) is actually the shortest path from `a` to `t` by taking
#' `log(1/w)` as the weight, and `log(1/S)` is the weighted shortest distance.
#' 
#' If `S(a->t)` can be thought as the maximal semantic contribution from `a` to `t`, the information content is calculated
#' as the sum from all `t`'s ancestors (including `t` itself):
#' 
#' ```
#' IC = sum_{a in t's ancestors + t}(S(a->t))
#' ```
#' 
#' Paper link: \doi{10.1093/bioinformatics/btm087}.
#' 
#' The contribution of different semantic relations can be set with the `contribution_factor` parameter. The value should be a named numeric
#' vector where names should cover the relations defined in `relations` set in [`create_ontology_DAG()`]. For example, if there are two relations
#' "relation_a" and "relation_b" set in the DAG, the value for `contribution_factor` can be set as:
#' 
#' ```
#' term_IC(dag, method = "IC_Wang", 
#'     control = list(contribution_factor = c("relation_a" = 0.8, "relation_b" = 0.6)))
#' ```
#' 
#' Note the **IC_Wang_2007** method is normally used within the **Sim_Wang_2007** semantic similarity method.
#' 
#' @rdname temp__IC_Wang_2007
IC_Wang_2007 = function(dag, contribution_factor = c("is_a" = 0.8, "part_of" = 0.6), 
	use_cache = simona_opt$use_cache, verbose = simona_opt$verbose) {

	if(verbose) {
		message("IC_method: ", "IC_Wang_2007")
	}
	
	if(is.null(dag@term_env$IC_Wang_2007) || !use_cache) {
		if(length(dag@lt_children_relations) == 0) {
			stop("`relations` is not set when creating the ontology_DAG object.")
		}
		relation_levels = attr(dag@lt_children_relations, "levels")
		if(is.null(names(contribution_factor))) {
			stop("`contribution_factor` should be a named numeric vector where names should correspond to all relations.")
		}
		
		names(contribution_factor) = normalize_relation_type(names(contribution_factor))

		if(any(contribution_factor >= 1)) {
			stop("All values in `contribution_factor` should be smaller than 1.")
		}

		contribution_factor = extend_contribution_factor(dag@relations_DAG, contribution_factor)
		if(length(setdiff(relation_levels, names(contribution_factor)))) {
			stop("Contribution factor should be provided for all relations.")
		}

		dag@term_env$IC_Wang_2007 = exec_under_message_condition({
			cpp_ic_wang(dag, unname(contribution_factor[relation_levels]))
		}, verbose = verbose)
	}
	dag@term_env$IC_Wang_2007
}
ADD_IC_METHOD("IC_Wang_2007")

library(testthat)


## export all functions
if(!identical(topenv(), .GlobalEnv)) {
	pkg_env = asNamespace("simona")
	all_objs = ls(envir = pkg_env)
	for(obj in all_objs) {
		assign(obj, get(obj, envir = pkg_env, inherits = FALSE))
	}
}

#### test a small dag

#   b--d--f
#  / \
# a---c--e
# upstream -> downstream

parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")

dag = create_ontology_DAG(parents, children)


test_that("test IC_universal", {
	expect_equal(
		IC_universal(dag, use_cache = FALSE),
		-log(c(1, 1/2, 1/8, 1/4, 1/8, 1/4))
	)
})

test_that("test reachability", {
	expect_equal(
		reachability(dag, use_cache = FALSE),
		c(3, 2, 1, 1, 1, 1)
	)
})

test_that("test totipotency", {
	expect_equal(
		totipotency(dag, use_cache = FALSE),
		c(1, 5/6, 1/3, 1/3, 1/6, 1/6)
	)
})

test_that("test IC_Meng_2012", {
	expect_equal(
		IC_Meng_2012(dag, correct = FALSE, FALSE),
		c(0, 0, log(2)/log(3)*(1-log(4/3)/log(6)), log(2)/log(3)*(1-log(4/3)/log(6)), 1, 1)
	)
	expect_equal(
		IC_Meng_2012(dag, correct = TRUE, FALSE),
		c(0, log(1+1)/log(3+1)*(1-log(8/3)/log(6)), log(2+1)/log(3+1)*(1-log(4/3)/log(6)), log(2+1)/log(3+1)*(1-log(4/3)/log(6)), 1, 1)
	)
})
IC_Zhou_2008(dag, use_cache = FALSE)
IC_Seco_2004(dag, use_cache = FALSE)
IC_Zhang_2006(dag, use_cache = FALSE)
# IC_Seddiqui_2010(dag, use_cache = FALSE)
IC_Sanchez_2011(dag, use_cache = FALSE)

test_that("test IC_Wang_2007", {
	expect_error(
		IC_Wang_2007(dag, use_cache = FALSE),
		"not set"
	)
})



parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")

annotation = list(
	"a" = 1:3,
	"b" = 3:4,
	"c" = 5,
	"d" = 7,
	"e" = 4:7,
	"f" = 8
)

annotation2 = list(
	"a" = c(1, 2, 3, 4, 5, 7, 6, 8), 
	"b" = c(3, 4, 5, 7, 6, 8), 
	"c" = c(5, 4, 6, 7), 
	"d" = 7:8, 
	"e" = 4:7, 
	"f" = 8
)

dag1 = create_ontology_DAG(parents, children, annotation = annotation)
dag2 = create_ontology_DAG(parents, children, annotation = annotation2)

remove_attr = function(x) {
	attributes(x) = NULL
	x
}

test_that("test IC_annotation", {
	expect_equal(
		n_annotations(dag1, use_cache = FALSE),
		n_annotations(dag2, use_cache = FALSE)
	)
	expect_equal(
		remove_attr(IC_annotation(dag1, use_cache = FALSE)),
		-c(log(8/8), log(6/8), log(4/8), log(2/8), log(4/8), log(1/8))
	)
})

#####################
#   b--d--f
#  / \
# a---c--e
# upstream -> downstream

parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")


dag = create_ontology_DAG(parents, children, relations = c("isa", "part of", "isa", "part of", "isa", "part of"), 
	annotation = annotation)
test_that("test IC_Wang_2007", {
	expect_equal(
		IC_Wang_2007(dag, c("is_a" = 0.7, "part of" = 0.6), use_cache = FALSE),
		c(1, 1.7, 2.3, 2.02, 2.61, 2.212)
	)
})

library(igraph)
g = dag_as_igraph(dag)
E(g)$weight = c("is_a" = 0.7, "part_of" = 0.6)[E(g)$relation]
d = distances(g, mode = "out", weights = -log(E(g)$weight))
s = exp(-d)
test_that("test IC_Wang_2007 and shortest path weighted by 1/w", {
	expect_equal(
		IC_Wang_2007(dag, c("is_a" = 0.7, "part of" = 0.6), use_cache = FALSE),
		unname(colSums(s))
	)
})

### test annotation
dag = create_ontology_DAG_from_GO_db("BP", org_db = "org.Hs.eg.db")
n = n_annotations(dag)
test_that("test n_annotations", {
	for(i in 1:10) {
		x = sample(dag@terms, 1)
		an = dag_ancestors(dag, x)
		expect_true(
			all(n[an] >= n[x])
		)
	}
})

if(FALSE) {

dag = create_ontology_DAG_from_GO_db("BP", org_db = "org.Hs.eg.db")
lt = lapply(all_ic_methods(), function(method) {
	cat("=====", method, "=====\n")
	term_IC(dag, method)
})
names(lt) = all_ic_methods()

df = as.data.frame(lt)
pairs(df, pch = ".", col = dag_depth(dag))

}

#' @importFrom matrixStats rowMaxs colMaxs
.GroupSim_pairwise = function(dag, group1, group2, term_sim_method = NULL, IC_method = NULL, group_sim_method = "avg", verbose = simona_opt$verbose, ...) {
	if(is.null(term_sim_method)) {
		term_sim_method = default_term_sim_method(dag)
	}
	if(is.null(IC_method)) {
		IC_method = default_term_IC_method(dag)
	}

	group1 = lapply(group1, function(x) term_to_node_id(dag, x, strict = FALSE))
	group2 = lapply(group2, function(x) term_to_node_id(dag, x, strict = FALSE))

	id = unique(unlist(c(group1, group2)))

	control = list(...)
	control$IC_method = IC_method
	if(is.null(control$verbose)) control$verbose = verbose

	sim = term_sim(dag, id, term_sim_method, control = control)
	rownames(sim) = colnames(sim) = dag@terms[id]

	.calc = function(g1, g2) {
		if(length(g1) == 0 || length(g2) == 0) {
			return(0)
		}
		sim = sim[g1, g2, drop = FALSE]

		group_sim_method = tolower(group_sim_method)

		best_match1 = rowMaxs(sim)
		best_match2 = colMaxs(sim)

		# avg
		if(group_sim_method == "avg") {
			mean(sim)
		} else if(group_sim_method == "max") {
			# max
			max(sim)
		} else if(group_sim_method == "bma") {
			#bma
			(mean(best_match1) + mean(best_match2))/2
		} else if(group_sim_method == "bmm") {
			# bmm
			max(mean(best_match1), mean(best_match2))
		} else if(group_sim_method == "abm") {
			# abm
			(sum(best_match1) + sum(best_match2))/(nrow(sim) + ncol(sim))
		} else if(group_sim_method == "hdf") {
			# hdf
			1 - max(1 - min(best_match1), 1 - min(best_match2))
		} else if(group_sim_method == "mhdf") {
			# MHDF
			1 - max(1 - mean(best_match1), 1 - mean(best_match2))
		} else if(group_sim_method == "vhdf") {
			1 - 0.5 * (sqrt( mean((1 - best_match1)^2)) + sqrt( mean((1 - best_match2)^2)))
		} else if(group_sim_method == "froehlich_2007") {
			exp(- max(1 - min(best_match1), 1 - min(best_match2)))
		} else if(group_sim_method == "joeng_2014") {
			0.5 * (sqrt( mean(best_match1^2)) + sqrt( mean(best_match2^2)))
		} else {
			stop("method not supported.")
		}
	}

	n1 = length(group1)
	n2 = length(group2)
	m = matrix(nrow = n1, ncol = n2)
	rownames(m) = names(group1)
	colnames(m) = names(group2)

	for(i in seq(1, length(group1))) {
		for(j in seq(1, length(group2))) {
			m[i, j] = .calc(dag@terms[ group1[[i]] ], dag@terms[ group2[[j]] ])
		}
	}
	m
}

#' GroupSim_pairwise_avg
#' 
#' @section Methods:
#' ## GroupSim_pairwise_avg
#' 
#' Denote `S(a, b)` as the semantic similarity between terms `a` and `b` where `a` is from `group1` and `b` is from `group2`, 
#' The similarity between `group1` and `group2` is the average similarity of every pair of individual terms in the two groups:
#' 
#' ```
#' group_sim = mean_{a in group1, b in group2}(S(a, b))
#' ```
#' 
#' The term semantic similarity method and the IC method can be set via `control` argument:
#' 
#' ```
#' group_sim(dag, group1, group2, method = "GroupSim_pairwise_avg"
#'     control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
#' ```
#' 
#' Other parameters for the `term_sim_method` can also be set in the `control` list.
#' 
#' Pape link: \doi{10.1093/bioinformatics/btg153}.
#' 
#' @rdname temp__GroupSim_pairwise_avg
GroupSim_pairwise_avg = function(dag, group1, group2, term_sim_method = NULL, IC_method = NULL, verbose = simona_opt$verbose, ...) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_pairwise_avg")
	}
	.GroupSim_pairwise(dag, group1, group2, term_sim_method = term_sim_method, IC_method = IC_method, 
		group_sim_method = "avg", verbose = verbose, ...)
}
ADD_GROUP_SIM_METHOD("GroupSim_pairwise_avg")


#' GroupSim_pairwise_max
#' 
#' @section Methods:
#' ## GroupSim_pairwise_max
#' 
#' This is the maximal `S(a, b)` among all pairs of terms in `group1` and `group2`:
#' 
#' ```
#' group_sim = max_{a in group1, b in group2}(S(a, b))
#' ```
#' 
#' The term semantic similarity method and the IC method can be set via `control` argument:
#' 
#' ```
#' group_sim(dag, group1, group2, method = "GroupSim_pairwise_max"
#'     control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
#' ```
#' 
#' Other parameters for the `term_sim_method` can also be set in the `control` list.
#' 
#' Paper link: \doi{10.1109/TCBB.2005.50}.
#' 
#' @rdname temp__GroupSim_pairwise_max
GroupSim_pairwise_max = function(dag, group1, group2, term_sim_method = NULL, IC_method = NULL, verbose = simona_opt$verbose, ...) {
	
	if(verbose) {
		message("group_sim_method: ", "GroupSim_pairwise_max")
	}
	.GroupSim_pairwise(dag, group1, group2, term_sim_method = term_sim_method, IC_method = IC_method, 
		group_sim_method = "max", verbose = verbose, ...)
}
ADD_GROUP_SIM_METHOD("GroupSim_pairwise_max")

#' GroupSim_pairwise_BMA
#' 
#' @section Methods:
#' ## GroupSim_pairwise_BMA
#' 
#' BMA stands for "best-match average". First define similarity of a term to a group of terms as
#' 
#' ```
#' S(x, group) = max_{y in group}(x, y)
#' ```
#' 
#' which is the most similar terms in `group` to `x`.
#' 
#' Then the BMA similarity is calculated as:
#' 
#' ```
#' group_sim = 0.5*(mean_{a in group1}(S(a, group2)) + mean_{b in group2}(S(b, group1)))
#' ```
#' 
#' So it is the average of the similarity of every term in `group1` to the whole `group2` and every term in `group2` to the whole `group1`.
#' 
#' The term semantic similarity method and the IC method can be set via `control` argument:
#' 
#' ```
#' group_sim(dag, group1, group2, method = "GroupSim_pairwise_BMA"
#'     control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
#' ```
#' 
#' Other parameters for the `term_sim_method` can also be set in the `control` list.
#' 
#' Paper link: \doi{10.1155/2012/975783}.
#' 
#' @rdname temp__GroupSim_pairwise_BMA
GroupSim_pairwise_BMA = function(dag, group1, group2, term_sim_method = NULL, IC_method = NULL, verbose = simona_opt$verbose, ...) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_pairwise_BMA")
	}
	.GroupSim_pairwise(dag, group1, group2, term_sim_method = term_sim_method, IC_method = IC_method, 
		group_sim_method = "BMA", verbose = verbose, ...)
}
ADD_GROUP_SIM_METHOD("GroupSim_pairwise_BMA")


#' GroupSim_pairwise_BMM
#' 
#' @section Methods:
#' ## GroupSim_pairwise_BMM
#' 
#' BMM stands for "best-match max". It is defined as:
#' 
#' ```
#' group_sim = max(mean_{a in group1}(S(a, group2)), mean_{b in group2}(S(b, group1)))
#' ```
#' 
#' The term semantic similarity method and the IC method can be set via `control` argument:
#' 
#' ```
#' group_sim(dag, group1, group2, method = "GroupSim_pairwise_BMM"
#'     control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
#' ```
#' 
#' Other parameters for the `term_sim_method` can also be set in the `control` list.
#' 
#' Paper link: \doi{10.1186/1471-2105-7-302}.
#' 
#' @rdname temp__GroupSim_pairwise_BMM
GroupSim_pairwise_BMM = function(dag, group1, group2, term_sim_method = NULL, IC_method = NULL, verbose = simona_opt$verbose, ...) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_pairwise_BMM")
	}
	.GroupSim_pairwise(dag, group1, group2, term_sim_method = term_sim_method, IC_method = IC_method, 
		group_sim_method = "BMM", verbose = verbose, ...)
}
ADD_GROUP_SIM_METHOD("GroupSim_pairwise_BMM")


#' GroupSim_pairwise_ABM
#' 
#' @section Methods:
#' ## GroupSim_pairwise_ABM
#' 
#' ABM stands for "average best-match". It is defined as:
#' 
#' ```
#' group_sim = (sum_{a in group1}(S(a, group2)) + sum_{b in group2}(S(b, group1)))/(n1 + n2)
#' ```
#' 
#' where `n1` and `n2` are the number of terms in `group1` and `group2`.
#' 
#' The term semantic similarity method and the IC method can be set via `control` argument:
#' 
#' ```
#' group_sim(dag, group1, group2, method = "GroupSim_pairwise_ABM"
#'     control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
#' ```
#' 
#' Other parameters for the `term_sim_method` can also be set in the `control` list.
#' 
#' Paper link: \doi{10.1186/1471-2105-14-284}.
#' 
#' @rdname temp__GroupSim_pairwise_ABM
GroupSim_pairwise_ABM = function(dag, group1, group2, term_sim_method = NULL, IC_method = NULL, verbose = simona_opt$verbose, ...) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_pairwise_ABM")
	}
	.GroupSim_pairwise(dag, group1, group2, term_sim_method = term_sim_method, IC_method = IC_method, 
		group_sim_method = "ABM", verbose = verbose, ...)
}
ADD_GROUP_SIM_METHOD("GroupSim_pairwise_ABM")


#' GroupSim_pairwise_HDF
#' 
#' @section Methods:
#' ## GroupSim_pairwise_HDF
#' 
#' First define the distance of a term to a group of terms:
#' 
#' ```
#' D(x, group) = 1 - S(x, group)
#' ```
#' 
#' Then the Hausdorff distance between two groups are:
#' 
#' ```
#' HDF = max(max_{a in group1}(D(a, group2)), max_{b in group2}(D(b, group1)))
#' ```
#' 
#' This final similarity is:
#' 
#' ```
#' group_sim = 1 - HDF
#' ```
#' 
#' The term semantic similarity method and the IC method can be set via `control` argument:
#' 
#' ```
#' group_sim(dag, group1, group2, method = "GroupSim_pairwise_HDF"
#'     control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
#' ```
#' 
#' Other parameters for the `term_sim_method` can also be set in the `control` list.
#' 
#' @rdname temp__GroupSim_pairwise_HDF
GroupSim_pairwise_HDF = function(dag, group1, group2, term_sim_method = NULL, IC_method = NULL, verbose = simona_opt$verbose, ...) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_pairwise_HDF")
	}
	.GroupSim_pairwise(dag, group1, group2, term_sim_method = term_sim_method, IC_method = IC_method, 
		group_sim_method = "HDF", verbose = verbose, ...)
}
ADD_GROUP_SIM_METHOD("GroupSim_pairwise_HDF")


#' GroupSim_pairwise_MHDF
#' 
#' @section Methods:
#' ## GroupSim_pairwise_MHDF
#' 
#' Instead of using the maximal distance from a group to the other group, MHDF uses mean distance:
#' 
#' ```
#' MHDF = max(mean_{a in group1}(D(a, group2)), mean_{b in group2}(D(b, group1)))
#' ```
#' 
#' This final similarity is:
#' 
#' ```
#' group_sim = 1 - MHDF
#' ```
#' 
#' The term semantic similarity method and the IC method can be set via `control` argument:
#' 
#' ```
#' group_sim(dag, group1, group2, method = "GroupSim_pairwise_MHDF"
#'     control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
#' ```
#' 
#' Other parameters for the `term_sim_method` can also be set in the `control` list.
#' 
#' Paper link: \doi{10.1109/ICPR.1994.576361}.
#' 
#' @rdname temp__GroupSim_pairwise_MHDF
GroupSim_pairwise_MHDF = function(dag, group1, group2, term_sim_method = NULL, IC_method = NULL, verbose = simona_opt$verbose, ...) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_pairwise_MHDF")
	}
	.GroupSim_pairwise(dag, group1, group2, term_sim_method = term_sim_method, IC_method = IC_method, 
		group_sim_method = "MHDF", verbose = verbose, ...)
}
ADD_GROUP_SIM_METHOD("GroupSim_pairwise_MHDF")



#' GroupSim_pairwise_VHDF
#' 
#' @section Methods:
#' ## GroupSim_pairwise_VHDF
#' 
#' It is defined as:
#' 
#' ```
#' VHDF = 0.5*(sqrt(mean_{a in group1}(D(a, group2)^2)) + sqrt(mean_{b in group2}(D(b, group1)^2)))
#' group_sim = 1 - VHDF
#' ```
#' 
#' The term semantic similarity method and the IC method can be set via `control` argument:
#' 
#' ```
#' group_sim(dag, group1, group2, method = "GroupSim_pairwise_VHDF"
#'     control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
#' ```
#' 
#' Other parameters for the `term_sim_method` can also be set in the `control` list.
#' 
#' Paper link: \doi{10.1073/pnas.0702965104}.
#' 
#' @rdname temp__GroupSim_pairwise_VHDF
GroupSim_pairwise_VHDF = function(dag, group1, group2, term_sim_method = NULL, IC_method = NULL, verbose = simona_opt$verbose, ...) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_pairwise_VHDF")
	}
	.GroupSim_pairwise(dag, group1, group2, term_sim_method = term_sim_method, IC_method = IC_method, 
		group_sim_method = "VHDF", verbose = verbose, ...)
}
ADD_GROUP_SIM_METHOD("GroupSim_pairwise_VHDF")


#' GroupSim_pairwise_Froehlich_2007
#' 
#' @section Methods:
#' ## GroupSim_pairwise_Froehlich_2007
#' 
#' The similarity is:
#' 
#' ```
#' group_sim = exp(-HDF(group1, group2))
#' ```
#' 
#' The term semantic similarity method and the IC method can be set via `control` argument:
#' 
#' ```
#' group_sim(dag, group1, group2, method = "GroupSim_pairwise_Froehlich_2007"
#'     control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
#' ```
#' 
#' Other parameters for the `term_sim_method` can also be set in the `control` list.
#' 
#' Paper link: \doi{10.1186/1471-2105-8-166}.
#' 
#' @rdname temp__GroupSim_pairwise_Froehlich_2007
GroupSim_pairwise_Froehlich_2007 = function(dag, group1, group2, term_sim_method = NULL, IC_method = NULL, verbose = simona_opt$verbose, ...) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_pairwise_Froehlich_2007")
	}
	.GroupSim_pairwise(dag, group1, group2, term_sim_method = term_sim_method, IC_method = IC_method, 
		group_sim_method = "froehlich_2007", verbose = verbose, ...)
}
ADD_GROUP_SIM_METHOD("GroupSim_pairwise_Froehlich_2007")


#' GroupSim_pairwise_Joeng_2014
#' 
#' @section Methods:
#' ## GroupSim_pairwise_Joeng_2014
#' 
#' Similar to *VHDF*, but it directly uses the similarity:
#' 
#' ```
#' group_sim = 0.5*(sqrt(mean_{a in group1}(S(a, group2)^2)) + sqrt(mean_{b in group2}(S(b, group1)^2)))
#' ```
#' 
#' The term semantic similarity method and the IC method can be set via `control` argument:
#' 
#' ```
#' group_sim(dag, group1, group2, method = "GroupSim_pairwise_Joeng_2014"
#'     control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
#' ```
#' 
#' Other parameters for the `term_sim_method` can also be set in the `control` list.
#' 
#' Paper link: \doi{10.1109/TCBB.2014.2343963}.
#' 
#' @rdname temp__GroupSim_pairwise_Joeng_2014
GroupSim_pairwise_Joeng_2014 = function(dag, group1, group2, term_sim_method = NULL, IC_method = NULL, verbose = simona_opt$verbose, ...) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_pairwise_Joeng_2014")
	}

	.GroupSim_pairwise(dag, group1, group2, term_sim_method = term_sim_method, IC_method = IC_method, 
		group_sim_method = "joeng_2014", verbose = verbose, ...)
}
ADD_GROUP_SIM_METHOD("GroupSim_pairwise_Joeng_2014")


#' GroupSim_SimALN
#' 
#' @section Methods:
#' ## GroupSim_SimALN
#' 
#' It is based on the average distances between every pair of terms in the two groups:
#' 
#' ```
#' exp(-mean_{a in group1, b in group2}(d(a, b)))
#' ```
#' 
#' `d(a, b)` is the distance between `a` and `b`, which can be the shortest distance between the two terms or
#' the longest distnace via LCA.
#' 
#' There is a parameter `distance` which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":
#' 
#' ```
#' group_sim(dag, group1, group2, method = "GroupSim_SimALN",
#'     control = list(distance = "shortest_distances_via_NCA"))
#' ```
#' 
#' Paper link: \doi{10.1109/ISCC.2008.4625763}.
#' 
#' @rdname temp__GroupSim_SimALN
GroupSim_SimALN = function(dag, group1, group2, distance = "longest_distances_via_LCA", verbose = simona_opt$verbose) {

	if(verbose) {
		message("group_sim_method: ", "GroupSim_SimALN")
	}

	group1 = lapply(group1, function(x) term_to_node_id(dag, x, strict = FALSE))
	group2 = lapply(group2, function(x) term_to_node_id(dag, x, strict = FALSE))

	id = unique(unlist(c(group1, group2)))
	
	if(distance == "shortest_distances_via_CA") {
		d = shortest_distances_via_NCA(dag, id, verbose = verbose)
	} else if(distance == "longest_distances_via_LCA") {
		d = longest_distances_via_LCA(dag, id, verbose = verbose)
	} else {
		stop("`distance` can only be in 'shortest_distances_via_CA' or 'longest_distances_via_LCA'.")
	}
	dimnames(d) = list(dag@terms[id], dag@terms[id])

	n1 = length(group1)
	n2 = length(group2)
	m = matrix(nrow = n1, ncol = n2)
	rownames(m) = names(group1)
	colnames(m) = names(group2)

	for(i in seq(1, length(group1))) {
		for(j in seq(1, length(group2))) {
			d2 = d[dag@terms[ group1[[i]] ], dag@terms[ group2[[j]] ] , drop = FALSE]
			m[i, j] = exp(-mean(d2))
		}
	}
	m
}
ADD_GROUP_SIM_METHOD("GroupSim_SimALN")




GROUPSIM_ANCESTORS_UNION = 1
GROUPSIM_ANCESTORS_INTERSECT = 2


.GroupSim_IC_based = function(dag, group1, group2, IC_method = NULL, group_sim_method = "avg", use_IC = FALSE, verbose = simona_opt$verbose) {

	if(is.null(IC_method)) {
		IC_method = default_term_IC_method(dag)
	}
	group1 = lapply(group1, function(x) term_to_node_id(dag, x, strict = FALSE))
	group2 = lapply(group2, function(x) term_to_node_id(dag, x, strict = FALSE))

	if(use_IC) {
		weight = term_IC(dag, IC_method, verbose = verbose)
	} else {
		weight = rep(1, dag@n_terms)
	}
	names(weight) = dag@terms

	.calc = function(g1, g2) {
		if(group_sim_method == "jaccard") {
			sum(weight[intersect(g1, g2)])/sum(weight[union(g1, g2)])
		} else if(group_sim_method == "dice") {
			2*sum(weight[intersect(g1, g2)])/(sum(weight[g1]) + sum(weight[g2]))
		} else if(group_sim_method == "universal") {
			sum(weight[intersect(g1, g2)])/max(sum(weight[g1]), sum(weight[g2]))
		} else if(group_sim_method == "overlap") {
			sum(weight[intersect(g1, g2)])/min(sum(weight[g1]), sum(weight[g2]))
		} else if(group_sim_method == "cosine") {
			sum(weight[intersect(g1, g2)]^2)/sqrt(sum(weight[g1]^2))/sqrt(sum(weight[g2]^2))
		} else if(group_sim_method == "cosine2") {
			v = sum(weight[intersect(g1, g2)]^2)
			v/(sum(weight[g1]^2) + sum(weight[g2]^2) - v)
		}
	}

	n1 = length(group1)
	n2 = length(group2)
	m = matrix(nrow = n1, ncol = n2)
	rownames(m) = names(group1)
	colnames(m) = names(group2)

	for(i in seq(1, length(group1))) {
		for(j in seq(1, length(group2))) {
			m[i, j] = .calc(dag@terms[ group1[[i]] ], dag@terms[ group2[[j]] ])
		}
	}
	m

}

#' GroupSim_SimGIC
#' 
#' @section Methods:
#' ## GroupSim_SimGIC
#' 
#' Denote `A` and `B` as the two sets of ancestors terms of terms in `group1` and `group2` respectively,
#' the SimGIC is:
#' 
#' ```
#' group_sim = sum_{x in intersect(A, B)}(IC(x))/sum_{x in union(A, B)}(IC(x))
#' ```
#' 
#' IC method can be set via `control = list(IC_method = ...)`.
#' 
#' @rdname temp__GroupSim_SimGIC
GroupSim_SimGIC = function(dag, group1, group2, IC_method = NULL, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_SimGIC")
	}
	.GroupSim_IC_based(dag, group1, group2, IC_method, group_sim_method = "jaccard", use_IC = TRUE, verbose = verbose)
}
ADD_GROUP_SIM_METHOD("GroupSim_SimGIC")


#' GroupSim_SimDIC
#' 
#' @section Methods:
#' ## GroupSim_SimDIC
#' 
#' Similar as *GroupSim_SimGIC*, it calculates the Dice coeffcient:
#' 
#' ```
#' group_sim = 2*sum_{x in intersect(A, B)}(IC(x))/(sum_{x in A}(IC(x)) + sum_{x in B}(IC(x)))
#' ```
#' 
#' IC method can be set via `control = list(IC_method = ...)`.
#' 
#' @rdname temp__GroupSim_SimDIC
GroupSim_SimDIC = function(dag, group1, group2, IC_method = NULL, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_SimDIC")
	}
	.GroupSim_IC_based(dag, group1, group2, IC_method, group_sim_method = "dice", use_IC = TRUE, verbose = verbose)
}
ADD_GROUP_SIM_METHOD("GroupSim_SimDIC")


#' GroupSim_SimUIC
#' 
#' @section Methods:
#' ## GroupSim_SimUIC
#' 
#' Similar as *GroupSim_SimGIC*, it is calculated as:
#' 
#' ```
#' group_sim = sum_{x in intersect(A, B)}(IC(x))/max(sum_{x in A}(IC(x)), sum_{x in B}(IC(x)))
#' ```
#' 
#' IC method can be set via `control = list(IC_method = ...)`.
#' 
#' @rdname temp__GroupSim_SimUIC
GroupSim_SimUIC = function(dag, group1, group2, IC_method = NULL, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_SimUIC")
	}
	.GroupSim_IC_based(dag, group1, group2, IC_method, group_sim_method = "universal", use_IC = TRUE, verbose = verbose)
}
ADD_GROUP_SIM_METHOD("GroupSim_SimUIC")


#' GroupSim_SimUI
#' 
#' @section Methods:
#' ## GroupSim_SimUI
#' 
#' It is only based on the number of terms. `A` is the set of all ancestors of group1 terms and `B`
#' is the set of all ancestors of group2 terms.
#' 
#' ```
#' group_sim = length(intersect(A, B))/length(union(A, B))
#' ```
#' 
#' @rdname temp__GroupSim_SimUI
GroupSim_SimUI = function(dag, group1, group2, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_SimUI")
	}
	.GroupSim_IC_based(dag, group1, group2, group_sim_method = "jaccard", use_IC = FALSE, verbose = verbose)
}
ADD_GROUP_SIM_METHOD("GroupSim_SimUI")


#' GroupSim_SimDB
#' 
#' @section Methods:
#' ## GroupSim_SimDB
#' 
#' It is:
#' 
#' ```
#' group_sim = 2*length(intersect(A, B))/(length(A) + length(B))
#' ```
#' 
#' @rdname temp__GroupSim_SimDB
GroupSim_SimDB = function(dag, group1, group2, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_SimDB")
	}
	.GroupSim_IC_based(dag, group1, group2, group_sim_method = "dice", use_IC = FALSE, verbose = verbose)
}
ADD_GROUP_SIM_METHOD("GroupSim_SimDB")


#' GroupSim_SimUB
#' 
#' @section Methods:
#' ## GroupSim_SimUB
#' 
#' It is:
#' 
#' ```
#' group_sim = length(intersect(A, B))/max(length(A), length(B))
#' ```
#' 
#' @rdname temp__GroupSim_SimUB
GroupSim_SimUB = function(dag, group1, group2, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_SimUB")
	}
	.GroupSim_IC_based(dag, group1, group2, group_sim_method = "universal", use_IC = FALSE, verbose = verbose)
}
ADD_GROUP_SIM_METHOD("GroupSim_SimUB")


#' GroupSim_SimNTO
#' 
#' @section Methods:
#' ## GroupSim_SimNTO
#' 
#' It is:
#' 
#' ```
#' group_sim = length(intersect(A, B))/min(length(A), length(B))
#' ```
#' 
#' @rdname temp__GroupSim_SimNTO
GroupSim_SimNTO = function(dag, group1, group2, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_SimNTO")
	}
	.GroupSim_IC_based(dag, group1, group2, group_sim_method = "overlap", use_IC = FALSE, verbose = verbose)
}
ADD_GROUP_SIM_METHOD("GroupSim_SimNTO")


#' GroupSim_SimCOU
#' 
#' @section Methods:
#' ## GroupSim_SimCOU
#' 
#' It is based on the dot product of two vectors `p` and `q` which correspond to terms in `group1` and `group2`. 
#' `p` and `q` have the same length as the total number of terms. Value of position i in `p` or `q` corresponds to term `t`. The value
#' takes `IC(t)` if `t` is an ancestor of any term in `p` or `q`, and the value takes zero if `t` is not. The
#' similarity betweem `group1` terms and `group2` terms is calculated as:
#' 
#' ```
#' <p,q>/||p||/||q||
#' ``` 
#' 
#' where `<p,q>` is the dot product between the two, and `||p||` or `||q||` is the norm of the vector.
#' The equation can be written as:
#' 
#' ```
#' group_sim = sum_{x in intersect(A, B)}(IC(x)^2) / 
#'               sqrt(sum_{x in A}(IC(x)^2)) / 
#'               sqrt(sum_{x in B}(IC(x)^2))
#' ```
#' 
#' IC method can be set via `control = list(IC_method = ...)`.
#' 
#' @rdname temp__GroupSim_SimCOU
GroupSim_SimCOU = function(dag, group1, group2, IC_method = NULL, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_SimCOU")
	}
	.GroupSim_IC_based(dag, group1, group2, IC_method, group_sim_method = "cosine", use_IC = TRUE, verbose = verbose)
}
ADD_GROUP_SIM_METHOD("GroupSim_SimCOU")


#' GroupSim_SimCOT
#' 
#' @section Methods:
#' ## GroupSim_SimCOT
#' 
#' Similar as *GroupSim_SimCOU*, the similarity is:
#' 
#' ```
#' <p,q>/(||p||^2 + ||q||^2 - <p,q>)
#' ``` 
#' 
#' And it can be rewritten as:
#' 
#' ```
#' group_sim = sum_{x in intersect(A, B)}(IC(x)^2) /
#'     (sum_{x in A}(IC(x)^2) + sum_{x in B}(IC(x)^2) - sum_{x in intersect(A, B)}(IC(x)^2))
#' ```
#' 
#' IC method can be set via `control = list(IC_method = ...)`.
#' 
#' @rdname temp__GroupSim_SimCOT
GroupSim_SimCOT = function(dag, group1, group2, IC_method = NULL, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_SimCOT")
	}
	.GroupSim_IC_based(dag, group1, group2, IC_method, group_sim_method = "cosine2", use_IC = TRUE, verbose = verbose)
}
ADD_GROUP_SIM_METHOD("GroupSim_SimCOT")



.GroupSim_edge_based = function(dag, group1, group2, group_sim_method = "lp") {

	group1 = lapply(group1, function(x) term_to_node_id(dag, x, strict = FALSE))
	group2 = lapply(group2, function(x) term_to_node_id(dag, x, strict = FALSE))

	depth = dag_depth(dag)
	names(depth) = dag@terms

	max_depth = max(depth)
	min_depth = min(depth)

	.calc = function(g1, g2) {
		if(group_sim_method == "lp") {
			max(depth[c(g1, g2)])
		} else if(group_sim_method == "ye") {
			(max(depth[c(g1, g2)]) - min_depth)/(max_depth - min_depth)
		} 
	}

	n1 = length(group1)
	n2 = length(group2)
	m = matrix(nrow = n1, ncol = n2)
	rownames(m) = names(group1)
	colnames(m) = names(group2)

	for(i in seq(1, length(group1))) {
		for(j in seq(1, length(group2))) {
			m[i, j] = .calc(dag@terms[ group1[[i]] ], dag@terms[ group2[[j]] ])
		}
	}
	m

}

#' GroupSim_SimLP
#' 
#' @section Methods:
#' ## GroupSim_SimLP
#' 
#' It is the longest depth for the terms in `intersect(A, B)`.
#' 
#' 
#' ```
#' group_sim = max(depth(intersect(A, B)))
#' ```
#' 
#' @rdname temp__GroupSim_SimLP
GroupSim_SimLP = function(dag, group1, group2, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_SimLP")
	}
	.GroupSim_edge_based(dag, group1, group2, group_sim_method = "lp")
}
ADD_GROUP_SIM_METHOD("GroupSim_SimLP")


#' GroupSim_Ye_2005
#' 
#' @section Methods:
#' ## GroupSim_Ye_2005
#' 
#' It is a normalized version of *GroupSim_SimLP*:
#' 
#' ```
#' group_sim = max(depth(intersect(A, B)))/max_depth
#' ```
#' 
#' Since the minimal depth is zero for root.
#' 
#' @rdname temp__GroupSim_Ye_2005
GroupSim_Ye_2005 = function(dag, group1, group2, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_Ye_2005")
	}
	.GroupSim_edge_based(dag, group1, group2, group_sim_method = "ye")
}
ADD_GROUP_SIM_METHOD("GroupSim_Ye_2005")



.GroupSim_annotation_based = function(dag, group1, group2, group_sim_method = "cho") {

	group1 = lapply(group1, function(x) term_to_node_id(dag, x, strict = FALSE))
	group2 = lapply(group2, function(x) term_to_node_id(dag, x, strict = FALSE))

	n = n_annotations(dag)
	names(n) = dag@terms

	.calc = function(g1, g2) {
		i_intersect = intersect(g1, g2)
		
		if(group_sim_method == "cho") {
			if(length(i_intersect) == 0) {
				0
			} else {
				log(min(n[i_intersect])/max(n))/log(min(n)/max(n))
			}

		} else if(group_sim_method == "ald") {

			if(length(i_intersect) == 0) {
				0
			} else {
				max(1 - n[i_intersect]/max(n))
			}
		}
	}

	n1 = length(group1)
	n2 = length(group2)
	m = matrix(nrow = n1, ncol = n2)
	rownames(m) = names(group1)
	colnames(m) = names(group2)

	for(i in seq(1, length(group1))) {
		for(j in seq(1, length(group2))) {
			m[i, j] = .calc(dag@terms[ group1[[i]] ], dag@terms[ group2[[j]] ])
		}
	}
	m

}

#' GroupSim_SimCHO
#' 
#' @section Methods:
#' ## GroupSim_SimCHO
#' 
#' It is based on the annotated items. Denote `sigma(t)` as the total annotated items of `t`. The similarity is calculated as
#' 
#' ```
#' group_sim = log(C/sigma_max)/log(sigma_min/sigma_max)
#' ```
#' 
#' where `C` is `min(sigma_{x in intersect(A, B)}(x))`, i.e., the minimal sigma in the intersection of group1 and group2. Note
#' Now `A` and `B` are just two sets of terms in `group1` and `group2`.
#' `sigma_max` is the total number of items annotated to the DAG, `sig_min` is the minimal number of items annotated to a term, which
#' is mostly 1.
#' 
#' @rdname temp__GroupSim_SimCHO
GroupSim_SimCHO = function(dag, group1, group2, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_SimCHO")
	}
	.GroupSim_annotation_based(dag, group1, group2, group_sim_method = "cho")
}
ADD_GROUP_SIM_METHOD("GroupSim_SimCHO")


#' GroupSim_SimALD
#' 
#' @section Methods:
#' ## GroupSim_SimALD
#' 
#' `A` and `B` are just two sets of terms in `group1` and `group2`. The similarity is calculated as:
#' 
#' ```
#' group_sim = max_{t in intersect(A, B)}(1 - sigma(t)/N)
#' ```
#' 
#' @rdname temp__GroupSim_SimALD
GroupSim_SimALD = function(dag, group1, group2, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_SimALD")
	}
	.GroupSim_annotation_based(dag, group1, group2, group_sim_method = "ald")
}
ADD_GROUP_SIM_METHOD("GroupSim_SimALD")



.GroupSim_count_based = function(dag, group1, group2, group_sim_method = "jaccard", universe = NULL) {

	group1 = lapply(group1, function(x) {
		id = term_to_node_id(dag, x, strict = FALSE)
		l = validate_annotated_terms(dag, id)
		id[l]
	})
	group2 = lapply(group2, function(x) {
		id = term_to_node_id(dag, x, strict = FALSE)
		l = validate_annotated_terms(dag, id)
		id[l]
	})

	.calc = function(g1, g2) {
		.sim_overlap_from_two_groups(dag, g1, g2, universe, method = group_sim_method)
	}

	n1 = length(group1)
	n2 = length(group2)
	m = matrix(nrow = n1, ncol = n2)
	rownames(m) = names(group1)
	colnames(m) = names(group2)

	for(i in seq(1, length(group1))) {
		for(j in seq(1, length(group2))) {
			m[i, j] = .calc(group1[[i]], group2[[j]])
		}
	}
	m

}


#' GroupSim_Jaccard
#' 
#' @section Methods:
#' ## GroupSim_Jaccard
#' 
#' Say `A` is the set of items annotated to terms in `group1` and `B` is the set of items annotated to `group2`.
#' This is the Jaccard coeffcient between two sets.
#' 
#' 
#' The universe/background can be set via `control = list(universe = ...)`.
#' 
#' @rdname temp__GroupSim_Jaccard
GroupSim_Jaccard = function(dag, group1, group2, universe = NULL, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_Jaccard")
	}
	.GroupSim_count_based(dag, group1, group2, group_sim_method = "jaccard", universe = universe)
}
ADD_GROUP_SIM_METHOD("GroupSim_Jaccard")


#' GroupSim_Dice
#' 
#' @section Methods:
#' ## GroupSim_Dice
#' 
#' It is the Dice coeffcient between `A` and `B`.
#' 
#' The universe/background can be set via `control = list(universe = ...)`.
#' 
#' @rdname temp__GroupSim_Dice
GroupSim_Dice = function(dag, group1, group2, universe = NULL, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_Dice")
	}
	.GroupSim_count_based(dag, group1, group2, group_sim_method = "dice", universe = universe)
}
ADD_GROUP_SIM_METHOD("GroupSim_Dice")


#' GroupSim_Overlap
#' 
#' @section Methods:
#' ## GroupSim_Overlap
#' 
#' It is the Overlap coeffcient between `A` and `B`.
#' 
#' The universe/background can be set via `control = list(universe = ...)`.
#' 
#' @rdname temp__GroupSim_Overlap
GroupSim_Overlap = function(dag, group1, group2, universe = NULL, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_Overlap")
	}
	.GroupSim_count_based(dag, group1, group2, group_sim_method = "overlap", universe = universe)
}
ADD_GROUP_SIM_METHOD("GroupSim_Overlap")


#' GroupSim_Kappa
#' 
#' @section Methods:
#' ## GroupSim_Kappa
#' 
# It is the kappa coeffcient between `A` and `B`.
#' 
#' The universe/background can be set via `control = list(universe = ...)`.
#' 
#' @rdname temp__GroupSim_Kappa
GroupSim_Kappa = function(dag, group1, group2, universe = NULL, verbose = simona_opt$verbose) {
	if(verbose) {
		message("group_sim_method: ", "GroupSim_Kappa")
	}
	.GroupSim_count_based(dag, group1, group2, group_sim_method = "kappa", universe = universe)
}
ADD_GROUP_SIM_METHOD("GroupSim_Kappa")


.sim_overlap_from_two_groups = function(dag, id1, id2, universe = NULL, method = c("kappa", "jaccard", "dice", "overlap")) {

	check_pkg("proxyC", bioc = FALSE)

	if(!is.null(universe)) {
		universe = which(dag@terms %in% universe)
	} else {
		universe = seq_along(dag@terms)
	}

	if(length(dag@annotation$list) == 0) {
		stop("`annotation` should be set in `create_ontology_DAG()`.")
	}

	mg1 = cpp_get_term_annotations(dag, id1)
	mg1 = mg1[, universe, drop = FALSE]

	mg2 = cpp_get_term_annotations(dag, id2)
	mg2 = mg2[, universe, drop = FALSE]

	mg = rbind( (colSums(mg1) > 0) + 0, (colSums(mg2) > 0) + 0)
	mg = as(mg, "sparseMatrix")

	method = match.arg(method)[1]
	if(method == "kappa") {
		mat = kappa_dist(mg)
	} else if(method == "overlap") {
		mat = overlap_dist(mg)
	} else {
		mat = proxyC::simil(mg, method = method)
	}

	mat = as.matrix(mat)
	return(mat[1, 2])
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

cpp_n_annotations <- function(dag, unify = TRUE) {
    .Call(`_simona_cpp_n_annotations`, dag, unify)
}

cpp_n_annotations_with_intersect <- function(dag, anno_id) {
    .Call(`_simona_cpp_n_annotations_with_intersect`, dag, anno_id)
}

cpp_get_term_annotations <- function(dag, nodes) {
    .Call(`_simona_cpp_get_term_annotations`, dag, nodes)
}

cpp_get_annotated_terms <- function(dag, anno_id) {
    .Call(`_simona_cpp_get_annotated_terms`, dag, anno_id)
}

cpp_max_ancestor_v <- function(dag, nodes, v) {
    .Call(`_simona_cpp_max_ancestor_v`, dag, nodes, v)
}

cpp_max_ancestor_id <- function(dag, nodes, v, use_max_dist = TRUE) {
    .Call(`_simona_cpp_max_ancestor_id`, dag, nodes, v, use_max_dist)
}

cpp_max_ancestor_path_sum_value <- function(dag, nodes, v, addv, use_max_dist = TRUE) {
    .Call(`_simona_cpp_max_ancestor_path_sum_value`, dag, nodes, v, addv, use_max_dist)
}

cpp_longest_distances_from_LCA <- function(dag, nodes) {
    .Call(`_simona_cpp_longest_distances_from_LCA`, dag, nodes)
}

cpp_longest_distances_directed <- function(dag, nodes) {
    .Call(`_simona_cpp_longest_distances_directed`, dag, nodes)
}

cpp_shortest_distances_directed <- function(dag, nodes) {
    .Call(`_simona_cpp_shortest_distances_directed`, dag, nodes)
}

cpp_nearest_common_ancestor <- function(dag, nodes) {
    .Call(`_simona_cpp_nearest_common_ancestor`, dag, nodes)
}

cpp_shortest_distances_via_NCA <- function(dag, nodes) {
    .Call(`_simona_cpp_shortest_distances_via_NCA`, dag, nodes)
}

cpp_tpl_shortest_path_length <- function(dag, from, to) {
    .Call(`_simona_cpp_tpl_shortest_path_length`, dag, from, to)
}

cpp_tpl_longest_path_length <- function(dag, from, to) {
    .Call(`_simona_cpp_tpl_longest_path_length`, dag, from, to)
}

cpp_tpl_shortest_path <- function(dag, from, to) {
    .Call(`_simona_cpp_tpl_shortest_path`, dag, from, to)
}

cpp_tpl_longest_path <- function(dag, from, to) {
    .Call(`_simona_cpp_tpl_longest_path`, dag, from, to)
}

cpp_tpl_shortest_path_sum_value <- function(dag, from, to, value) {
    .Call(`_simona_cpp_tpl_shortest_path_sum_value`, dag, from, to, value)
}

cpp_tpl_longest_path_sum_value <- function(dag, from, to, value) {
    .Call(`_simona_cpp_tpl_longest_path_sum_value`, dag, from, to, value)
}

intersectToList_logical <- function(lt, x) {
    .Call(`_simona_intersectToList_logical`, lt, x)
}

cpp_partition_by_size <- function(tree, size) {
    .Call(`_simona_cpp_partition_by_size`, tree, size)
}

cpp_random_aggregatioin <- function(size, value, perm) {
    .Call(`_simona_cpp_random_aggregatioin`, size, value, perm)
}

cpp_node_pos_in_tree <- function(tree, bin_size, start = 1, end = 360) {
    .Call(`_simona_cpp_node_pos_in_tree`, tree, bin_size, start, end)
}

cpp_calc_n_neighbours <- function(x, range) {
    .Call(`_simona_cpp_calc_n_neighbours`, x, range)
}

cpp_reorder_by_score <- function(lt_children, score) {
    .Call(`_simona_cpp_reorder_by_score`, lt_children, score)
}

cpp_permutate_children <- function(lt_children) {
    .Call(`_simona_cpp_permutate_children`, lt_children)
}

cpp_get_force_counterpart <- function(lt_children_dag, lt_parents_dag, lt_children_tree, lt_parents_tree, root) {
    .Call(`_simona_cpp_get_force_counterpart`, lt_children_dag, lt_parents_dag, lt_children_tree, lt_parents_tree, root)
}

cpp_get_force <- function(lt_counterpart, x, depth, on_circle = FALSE) {
    .Call(`_simona_cpp_get_force`, lt_counterpart, x, depth, on_circle)
}

move_index <- function(x, sorted_od, k, decreasing = TRUE) {
    .Call(`_simona_move_index`, x, sorted_od, k, decreasing)
}

calc_x_offset <- function(children, prev_od, new_od, width) {
    .Call(`_simona_calc_x_offset`, children, prev_od, new_od, width)
}

reorder_children <- function(children, n_cp, force, width, depth, new_x, lt_children) {
    .Call(`_simona_reorder_children`, children, n_cp, force, width, depth, new_x, lt_children)
}

cpp_reorder_tree_x <- function(tree, lt_counterpart, x, width, times = 1L) {
    .Call(`_simona_cpp_reorder_tree_x`, tree, lt_counterpart, x, width, times)
}

n_links_from_two_groups_of_nodes <- function(dag, nodes1, nodes2) {
    .Call(`_simona_n_links_from_two_groups_of_nodes`, dag, nodes1, nodes2)
}

cpp_sim_aic <- function(dag, nodes, ic) {
    .Call(`_simona_cpp_sim_aic`, dag, nodes, ic)
}

cpp_sim_wang <- function(dag, nodes, contribution, correct = FALSE) {
    .Call(`_simona_cpp_sim_wang`, dag, nodes, contribution, correct)
}

cpp_wang_sv_to_sim <- function(sv) {
    .Call(`_simona_cpp_wang_sv_to_sim`, sv)
}

cpp_sim_wang_edge <- function(dag, nodes) {
    .Call(`_simona_cpp_sim_wang_edge`, dag, nodes)
}

cpp_sim_zhong <- function(dag, nodes, depth_via_LCA) {
    .Call(`_simona_cpp_sim_zhong`, dag, nodes, depth_via_LCA)
}

cpp_common_ancestor_mean_IC_XGraSM <- function(dag, nodes, ic) {
    .Call(`_simona_cpp_common_ancestor_mean_IC_XGraSM`, dag, nodes, ic)
}

cpp_common_ancestor_mean_IC_EISI <- function(dag, nodes, ic) {
    .Call(`_simona_cpp_common_ancestor_mean_IC_EISI`, dag, nodes, ic)
}

cpp_sim_ancestor <- function(dag, nodes) {
    .Call(`_simona_cpp_sim_ancestor`, dag, nodes)
}

cpp_ic_meng <- function(dag, correct) {
    .Call(`_simona_cpp_ic_meng`, dag, correct)
}

cpp_ic_wang <- function(dag, contribution) {
    .Call(`_simona_cpp_ic_wang`, dag, contribution)
}

cpp_max_leaves_id <- function(dag, nodes, v) {
    .Call(`_simona_cpp_max_leaves_id`, dag, nodes, v)
}

cpp_ancestors <- function(dag, node, include_self = FALSE) {
    .Call(`_simona_cpp_ancestors`, dag, node, include_self)
}

cpp_ancestors_within_background <- function(dag, node, background, include_self = FALSE) {
    .Call(`_simona_cpp_ancestors_within_background`, dag, node, background, include_self)
}

cpp_offspring <- function(dag, node, include_self = FALSE) {
    .Call(`_simona_cpp_offspring`, dag, node, include_self)
}

cpp_all_offspring <- function(dag, include_self = FALSE) {
    .Call(`_simona_cpp_all_offspring`, dag, include_self)
}

cpp_offspring_within_background <- function(dag, node, background, include_self = FALSE) {
    .Call(`_simona_cpp_offspring_within_background`, dag, node, background, include_self)
}

cpp_connected_leaves <- function(dag, node) {
    .Call(`_simona_cpp_connected_leaves`, dag, node)
}

cpp_n_ancestors <- function(dag, include_self = FALSE) {
    .Call(`_simona_cpp_n_ancestors`, dag, include_self)
}

cpp_n_ancestors_on_tree <- function(dag, include_self = FALSE) {
    .Call(`_simona_cpp_n_ancestors_on_tree`, dag, include_self)
}

cpp_n_offspring <- function(dag, include_self = FALSE) {
    .Call(`_simona_cpp_n_offspring`, dag, include_self)
}

cpp_n_offspring_on_tree <- function(dag, include_self = FALSE) {
    .Call(`_simona_cpp_n_offspring_on_tree`, dag, include_self)
}

cpp_n_offspring_with_intersect <- function(dag, nodes, include_self = FALSE) {
    .Call(`_simona_cpp_n_offspring_with_intersect`, dag, nodes, include_self)
}

cpp_n_leaves <- function(dag) {
    .Call(`_simona_cpp_n_leaves`, dag)
}

cpp_n_leaves_on_tree <- function(dag) {
    .Call(`_simona_cpp_n_leaves_on_tree`, dag)
}

cpp_ancestors_of_a_group <- function(dag, nodes, type = 1L, include_self = FALSE) {
    .Call(`_simona_cpp_ancestors_of_a_group`, dag, nodes, type, include_self)
}

cpp_ancestors_of_two_groups <- function(dag, nodes1, nodes2, type, include_self = FALSE) {
    .Call(`_simona_cpp_ancestors_of_two_groups`, dag, nodes1, nodes2, type, include_self)
}

cpp_offspring_of_a_group <- function(dag, nodes, include_self = FALSE) {
    .Call(`_simona_cpp_offspring_of_a_group`, dag, nodes, include_self)
}

cpp_offspring_aggregate <- function(dag, value, method = 1L) {
    .Call(`_simona_cpp_offspring_aggregate`, dag, value, method)
}

cpp_is_reachable <- function(dag, nodes, directed = FALSE) {
    .Call(`_simona_cpp_is_reachable`, dag, nodes, directed)
}

cpp_dag_depth <- function(dag) {
    .Call(`_simona_cpp_dag_depth`, dag)
}

cpp_dag_dist_from_root <- function(dag) {
    .Call(`_simona_cpp_dag_dist_from_root`, dag)
}

cpp_dag_longest_dist_to_offspring <- function(dag, from_node, l_background = logical(0)) {
    .Call(`_simona_cpp_dag_longest_dist_to_offspring`, dag, from_node, l_background)
}

cpp_dag_shortest_dist_to_offspring <- function(dag, from_node, l_background = logical(0)) {
    .Call(`_simona_cpp_dag_shortest_dist_to_offspring`, dag, from_node, l_background)
}

cpp_dag_height <- function(dag) {
    .Call(`_simona_cpp_dag_height`, dag)
}

cpp_dag_dist_to_leaves <- function(dag) {
    .Call(`_simona_cpp_dag_dist_to_leaves`, dag)
}

cpp_dag_longest_dist_from_ancestors <- function(dag, to_node, l_background = logical(0)) {
    .Call(`_simona_cpp_dag_longest_dist_from_ancestors`, dag, to_node, l_background)
}

cpp_dag_shortest_dist_from_ancestors <- function(dag, to_node, l_background = logical(0)) {
    .Call(`_simona_cpp_dag_shortest_dist_from_ancestors`, dag, to_node, l_background)
}

cpp_check_cyclic_node <- function(dag, node = -1L) {
    .Call(`_simona_cpp_check_cyclic_node`, dag, node)
}

cpp_dag_shortest_path_to_offspring_sum_value <- function(dag, from_node, value, l_background = logical(0)) {
    .Call(`_simona_cpp_dag_shortest_path_to_offspring_sum_value`, dag, from_node, value, l_background)
}

cpp_mark_tree_links <- function(dag) {
    .Call(`_simona_cpp_mark_tree_links`, dag)
}

cpp_tree_lt_parents_from_children <- function(lt_children) {
    .Call(`_simona_cpp_tree_lt_parents_from_children`, lt_children)
}

cpp_match_index <- function(ind1, ind2) {
    .Call(`_simona_cpp_match_index`, ind1, ind2)
}

cross_sum <- function(x) {
    .Call(`_simona_cross_sum`, x)
}

cross_multiply <- function(x) {
    .Call(`_simona_cross_multiply`, x)
}

cross_minus <- function(x) {
    .Call(`_simona_cross_minus`, x)
}

cross_max <- function(x) {
    .Call(`_simona_cross_max`, x)
}

cross_min <- function(x) {
    .Call(`_simona_cross_min`, x)
}

library(testthat)


## export all functions
if(!identical(topenv(), .GlobalEnv)) {
	pkg_env = asNamespace("simona")
	all_objs = ls(envir = pkg_env)
	for(obj in all_objs) {
		assign(obj, get(obj, envir = pkg_env, inherits = FALSE))
	}
}

#### test a small dag

#   b--d--f
#  / \
# a---c--e
# upstream -> downstream

parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")

dag = create_ontology_DAG(parents, children)

test_that("test tpl paths", {
	expect_equal(
		cpp_tpl_shortest_path_length(dag, 1, 3),
		1
	)
	expect_equal(
		cpp_tpl_shortest_path_length(dag, 1, 5),
		2
	)
	expect_equal(
		cpp_tpl_longest_path_length(dag, 1, 3),
		2
	)
	expect_equal(
		cpp_tpl_longest_path_length(dag, 1, 5),
		3
	)
	expect_equal(
		cpp_tpl_shortest_path_length(dag, 1, 4),
		cpp_tpl_longest_path_length(dag, 1, 4)
	)

	## path
	expect_equal(
		cpp_tpl_shortest_path(dag, 1, 3),
		c(1, 3)
	)
	expect_equal(
		cpp_tpl_shortest_path_sum_value(dag, 1, 3, 1:6),
		4
	)
	expect_equal(
		cpp_tpl_shortest_path(dag, 1, 5),
		c(1, 3, 5)
	)
	expect_equal(
		cpp_tpl_shortest_path_sum_value(dag, 1, 5, 1:6),
		9
	)
	expect_equal(
		cpp_tpl_longest_path(dag, 1, 3),
		c(1, 2, 3)
	)
	expect_equal(
		cpp_tpl_longest_path_sum_value(dag, 1, 3, 1:6),
		6
	)
	expect_equal(
		cpp_tpl_longest_path(dag, 1, 5),
		c(1, 2, 3, 5)
	)
	expect_equal(
		cpp_tpl_longest_path_sum_value(dag, 1, 5, 1:6),
		11
	)
	expect_equal(
		cpp_tpl_shortest_path(dag, 1, 4),
		cpp_tpl_longest_path(dag, 1, 4)
	)

	## test the other distance method
	m = cpp_longest_distances_directed(dag, 1:6)
	for(i in 1:6) {
		for(j in 1:6) {
			expect_equal(
				m[i, j],
				cpp_tpl_longest_path_length(dag, i, j)
			)
		}
	}
	
	m = cpp_shortest_distances_directed(dag, 1:6)
	for(i in 1:6) {
		for(j in 1:6) {
			expect_equal(
				m[i, j],
				cpp_tpl_shortest_path_length(dag, i, j)
			)
		}
	}
})

### test on GO BP

dag = create_ontology_DAG_from_GO_db()
depth = dag_depth(dag)

test_that("test two dist methods with GO BP", {
	for(i in 1:10) {
		go_id_1 = sample(dag@terms[depth > 5], 1)
		go_id_2 = sample(dag_ancestors(dag, go_id_1), 1)
		j = which(dag@terms == go_id_1)
		i = which(dag@terms == go_id_2)

		expect_equal(
			cpp_tpl_shortest_path_length(dag, i, j),
			cpp_shortest_distances_directed(dag, c(i, j))[1, 2]
		)

		expect_equal(
			cpp_tpl_longest_path_length(dag, i, j),
			cpp_longest_distances_directed(dag, c(i, j))[1, 2]
		)
	}
})



if(FALSE) {

dag = create_ontology_DAG_from_GO_db()
system.time(d1 <- shortest_distances_via_NCA(dag, dag@terms[1:1000])); rm(d1); gc();
system.time(d2 <- longest_distances_via_LCA(dag, dag@terms[1:1000])); rm(d2); gc();
system.time(d3 <- shortest_distances_directed(dag, dag@terms[1:1000])); rm(d3); gc();
system.time(d4 <- longest_distances_directed(dag, dag@terms[1:1000])); rm(d4); gc();

}

x = runif(10)

test_that("test cross_*", {
	expect_equal(
		simona:::cross_sum(x),
		outer(x, x, "+")
	)

	expect_equal(
		simona:::cross_multiply(x),
		outer(x, x, "*")
	)

	expect_equal(
		simona:::cross_minus(x),
		outer(x, x, "-")
	)

	expect_equal(
		simona:::cross_min(x),
		outer(x, x, pmin)
	)

	expect_equal(
		simona:::cross_max(x),
		outer(x, x, pmax)
	)

})

library(testthat)




parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")

dag = create_ontology_DAG(parents, children)

test_that("test dag_reorder", {
	dag2 = dag_reorder(dag, value = c(1, 1, 10, 1, 10, 1))
	expect_equal(dag2@lt_children[[2]], rev(dag@lt_children[[2]]))

	dag3 = dag_reorder(dag, value = c(10, 1))
	expect_equal(dag3@lt_children[[2]], rev(dag@lt_children[[2]]))
})


dag = create_ontology_DAG(c("a-b", "a-c", "a-d", "a-e", "a-f", "b-g", "b-h", "b-i", "b-j"))
dag2 = dag_permutate_children(dag)
dag_children(dag2, "a")
dag_children(dag2, "b")

dag = create_ontology_DAG(c("a-h", "a-b", "a-c", "a-d", "b-e", "b-f", "c-g", "h-g", "d-e"))
tree = dag_treelize(dag)
lt = cpp_get_force_counterpart(dag@lt_children, dag@lt_parents, tree@lt_children, tree@lt_parents, dag@root)

test_that("test cpp_get_force_counterpart", {
	expect_equal(lt[[1]], integer(0))
	expect_equal(lt[[2]], 4)
	expect_equal(lt[[3]], 8)
	expect_equal(lt[[4]], 5)
	expect_equal(lt[[5]], 4)
	expect_equal(lt[[6]], integer(0))
	expect_equal(lt[[7]], 8)
	expect_equal(lt[[8]], 7)
})

test_that("test move_index", {
	x = c(2, 1, 5, 4, 3)
	od = order(-abs(x))
	expect_equal(x[move_index(x, od-1, 1) + 1], c(5, 2, 1, 4, 3))
	expect_equal(x[move_index(x, od-1, 2) + 1], c(5, 4, 2, 1, 3))
	expect_equal(x[move_index(x, od-1, 3) + 1], c(5, 4, 3, 2, 1))
	expect_equal(x[move_index(x, od-1, 4) + 1], c(5, 4, 3, 2, 1))
	expect_equal(x[move_index(x, od-1, 5) + 1], c(5, 4, 3, 2, 1))

	x = c(-2, -1, -5, -4, -3)
	od = order(-abs(x))
	expect_equal(x[move_index(x, od-1, 1) + 1], c(-2, -1, -4, -3, -5))
	expect_equal(x[move_index(x, od-1, 2) + 1], c(-2, -1, -3, -4, -5))
	expect_equal(x[move_index(x, od-1, 3) + 1], c(-2, -1, -3, -4, -5))
	expect_equal(x[move_index(x, od-1, 4) + 1], c(-1, -2, -3, -4, -5))
	expect_equal(x[move_index(x, od-1, 5) + 1], c(-1, -2, -3, -4, -5))

	x = c(-2, 1, 5, -4, 3)
	od = order(-abs(x))
	expect_equal(x[move_index(x, od-1, 1) + 1], c(5, -2, 1, -4, 3))
	expect_equal(x[move_index(x, od-1, 2) + 1], c(5, -2, 1, 3, -4))
	expect_equal(x[move_index(x, od-1, 3) + 1], c(5, 3, -2, 1, -4))
	expect_equal(x[move_index(x, od-1, 4) + 1], c(5, 3, 1, -2, -4))
	expect_equal(x[move_index(x, od-1, 5) + 1], c(5, 3, 1, -2, -4))

	x = c(3, 1, 5, -4, -2)
	od = order(-abs(x))
	expect_equal(x[move_index(x, od-1, 1, FALSE) + 1], c(3, 1, -4, -2, 5))
	expect_equal(x[move_index(x, od-1, 2, FALSE) + 1], c(-4, 3, 1, -2, 5))
	expect_equal(x[move_index(x, od-1, 3, FALSE) + 1], c(-4, 1, -2, 3, 5))
	expect_equal(x[move_index(x, od-1, 4, FALSE) + 1], c(-4, -2, 1, 3, 5))
	expect_equal(x[move_index(x, od-1, 5, FALSE) + 1], c(-4, -2, 1, 3, 5))
})


test_that("test calc_x_offset", {
	prev_od = 1:5
	new_od = 1:5
	expect_equal(calc_x_offset(1:5, prev_od - 1, new_od - 1, 1:5),
		         c(0, 0, 0, 0, 0))

	prev_od = 1:5
	new_od = c(2, 1, 3, 4, 5)
	expect_equal(calc_x_offset(1:5, prev_od - 1, new_od - 1, 1:5),
		         c(2, -1, 0, 0, 0))

	prev_od = 1:5
	new_od = 5:1
	expect_equal(calc_x_offset(1:5, prev_od - 1, new_od - 1, 1:5),
		         c(14, 11, 6, -1, -10))
})


# pos = cpp_node_pos_in_tree(tree, n_connected_leaves(tree))
# lt_counterpart = cpp_get_force_counterpart(dag@lt_children, dag@lt_parents, tree@lt_children, tree@lt_parents, dag@root)


# force = cpp_get_force(lt_counterpart, pos$x, dag_depth(tree))
# test_that("test cpp_get_force", {
# 	expect_equal(sign(force), c(0, 1, -1, -1, 1, 0, -1, 1))
# })


# n_cp = sapply(lt_counterpart, length)
# x = pos$x
# test_that("test reorder_children", {
# 	expect_equal(reorder_children(tree@lt_children[[1]], n_cp, force, pos$width, dag_depth(tree), x, tree@lt_children),
# 		         c(3, 4, 2, 8))
# 	expect_equal(order(x[c(3, 4, 2, 8)]), 1:4)
# })


# pos = cpp_node_pos_in_tree(tree, n_connected_leaves(tree))
# cpp_reorder_tree_x(tree, lt_counterpart, pos$x, pos$width)

polar2Cartesian = function(d) {
    theta = d[, 1]/180*pi
    rou = d[, 2]
    x = rou * cos(theta)
    y = rou * sin(theta)
    return(cbind(x, y))
}

calc_n_neighbours_on_circle = function(theta, width = 1) {
	od = order(order(theta))
	theta2 = sort(theta)

	k = cpp_calc_n_neighbours(theta2, width)
	k[od]
}

default_edge_transparency = function(dag) {
	n_relations = sum(sapply(dag@lt_children, length))
	if(n_relations < 3000) {
		0.5
	} else if(n_relations > 50000) {
		0.95
	} else {
		(0.95-0.5)/(50000 - 3000)*(n_relations - 5000) + 0.5
	}
}

#' Visualize the DAG
#' 
#' @param dag An `ontology_Dag` object.
#' @param highlight A vector of terms to be highlighted on the DAG.
#' @param start Start of the circle, measured in degree.
#' @param end End of the circle, measured in degree.
#' @param partition_by_level If `node_col` is not set, users can cut the DAG into clusters with different node colors. The partitioning is applied by [`partition_by_level()`].
#' @param partition_by_size Similar as `partition_by_level`, but the partitioning is applied by [`partition_by_size()`].
#' @param node_col Colors of nodes. If the value is a vector, the order should correspond to terms in [`dag_all_terms()`].
#' @param node_transparency Transparency of nodes. The same format as `node_col`.
#' @param node_size Size of nodes. The same format as `node_col`.
#' @param edge_col A named vector where names correspond to relation types.
#' @param edge_transparency A named vector where names correspond to relation types.
#' @param legend_labels_from If partitioning is applied on the DAG, a legend is generated showing different top
#'         terms. By default, the legend labels are the term IDs. If there are additionally column stored
#'         in the meta data frame of the DAG object, the column name can be set here to replace the term IDs as
#'         legend labels.
#' @param legend_labels_max_width Maximal width of legend labels measured by the number of characters per line. Labels are wrapped into
#'        multiple lines if the widths exceed it.
#' @param other_legends A list of legends generated by [`ComplexHeatmap::Legend()`].
#' @param use_raster Whether to first write the circular image into a temporary png file, then add to the plot
#'      as a raster object?
#' @param newpage Whether call [`grid::grid.newpage()`] to create a new plot?
#' @param verbose Whether to print messages.
#' 
#' @details
#' `dag_circular_viz()` uses a circular layout for visualizing large DAGs. `dag_graphviz()`
#' uses a hierarchical layout for visualizing small DAGs.
#' 
#' @import grid
#' @importFrom Polychrome alphabet.colors
#' @import ComplexHeatmap
#' @importFrom grDevices dev.size dev.off png
#' @rdname dag_viz
#' @export
#' @examples
#' \donttest{
#' dag = create_ontology_DAG_from_GO_db()
#' dag_circular_viz(dag)
#' }
#' 1
dag_circular_viz = function(dag, highlight = NULL, 
	start = 0, end = 360,
	partition_by_level = 1, partition_by_size = NULL,
	node_col = NULL, node_transparency = 0.4, node_size = NULL, 
	edge_col = NULL, edge_transparency = default_edge_transparency(dag),
	legend_labels_from = NULL, legend_labels_max_width = 50, other_legends = list(),
	use_raster = dag_n_terms(dag) > 10000, newpage = TRUE,
	verbose = simona_opt$verbose) {

	if(use_raster) {
		check_pkg("png", bioc = FALSE)
	}

	if(end < start) {
		stop_wrap("`end` should be larger than `start`.")
	}

	n_terms = dag@n_terms

	has_highlight = FALSE
	if(!is.null(highlight)) {
		has_highlight = TRUE
		l_highlight = dag@terms %in% highlight
	}

	if(dag_is_tree(dag)) {
		tree = dag
	} else {
		if(verbose) message("converting DAG to a tree...")
		tree = dag_treelize(dag, verbose = verbose)
	}
	if(verbose) message("calculating term positions on the DAG...")	
	term_pos = exec_under_message_condition({
		cpp_node_pos_in_tree(tree, n_connected_leaves(tree), start, end) ## in polar coordinate
	}, verbose = verbose)

	# if(!dag_is_tree(dag) && !test) {  ## reordering is only applied when DAG is not a tree
	# 	lt_counterpart = cpp_get_force_counterpart(dag@lt_children, dag@lt_parents, tree@lt_children, tree@lt_parents, dag@root)

	# 	theta = cpp_reorder_tree_x(tree, lt_counterpart, term_pos$x, term_pos$width, times)
	# 	term_pos$x = theta
	# }

	# term_pos$n_neighbours = 0
	# all_levels = sort(unique(term_pos$h))
	# all_levels = all_levels[!is.na(all_levels)]
	# for(level in all_levels) {
	# 	l = term_pos$h == level
	# 	if(verbose) message(strrep("\b", 100), appendLF = FALSE)
	# 	if(verbose) message(qq("calculating numbers of neighbours within 1 degree neighbourhood on level @{level}/@{max(all_levels)}, @{sum(l)} terms..."), appendLF = FALSE)
	# 	term_pos[l, "n_neighbours"] = cpp_calc_n_neighbours(term_pos$x[l], width = 0.5)
	# }
	# if(verbose) message("")

	node_col_map = NULL
	l_uncolored_nodes = NULL
	if(is.null(node_col)) {
		if(is.null(partition_by_size)) {
			group = partition_by_level(dag, level = partition_by_level, term_pos = term_pos)
		} else {
			group = partition_by_size(dag, size = partition_by_size)
		}
		level1 = unique(group); level1 = level1[!is.na(level1)]
		n_levels = length(level1)
		
		ind = which( dag@terms %in% level1)
		level1 = dag@terms[ind][order(term_pos[ind, "x"])]

		if(n_levels <= 7) {
			default_col = c("#DF536B", "#61D04F", "#2297E6", "#28E2E5", "#CD0BBC", "#F5C710", "#9E9E9E")
			node_col_map = default_col[seq_len(n_levels)]
		} else if(n_levels <= 26) {
			node_col_map = alphabet.colors(n_levels)
		} else {
			node_col_map = rand_color(n_levels)
		}

		names(node_col_map) = level1
		node_col = node_col_map[as.character(group)]
		l_uncolored_nodes = unname(is.na(node_col))
		node_col[is.na(node_col)] = "#CCCCCC"
	}

	if(is.null(node_size)) {
		if(has_highlight) {
			node_size = rep(8, n_terms)
			node_size_by_n_children = FALSE
		} else {
			n_children = dag@term_env$n_children
			node_size = .scale(n_children, c(0, quantile(n_children, 0.99)+1), c(2, 10))
			node_size_by_n_children = TRUE
		}
	} else {
		node_size_by_n_children = FALSE
	}

	if(!length(node_col) %in% c(1, n_terms)) {
		stop_wrap(qq("Length of `node_col` should be one or @{n_terms} (number of terms in the DAG)."))
	}
	if(!length(node_transparency) %in% c(1, n_terms)) {
		stop_wrap(qq("Length of `node_transparency` should be one or @{n_terms} (number of terms in the DAG)."))
	}
	if(!length(node_size) %in% c(1, n_terms)) {
		stop_wrap(qq("Length of `node_size` should be one or @{n_terms} (number of terms in the DAG)."))
	}

	# node_transparency = .scale(term_pos$n_neighbours, c(1, quantile(term_pos$n_neighbours, 0.9)+1), c(0.9, 0.5))

	node_col = add_transparency(node_col, node_transparency)

	if(length(dag@lt_children_relations) > 0) {
		relation_levels = attr(dag@lt_children_relations, "levels")
		v_relations = unlist(dag@lt_children_relations)
		v_relations = relation_levels[v_relations]
		n_levels = length(relation_levels)

		if(is.null(edge_col)) {
			if(n_levels <= 8) {
				default_col = c("#000000", "#DF536B", "#61D04F", "#2297E6", "#28E2E5", "#CD0BBC", "#F5C710", "#9E9E9E")
				edge_col = structure(default_col[seq_len(n_levels)], names = relation_levels)
			} else if(n_levels <= 26) {
				edge_col = structure(alphabet.colors(n_levels), names = relation_levels)	
			} else {
				edge_col = structure(rand_color(n_levels), names = relation_levels)
			}
		} else if(is.atomic(edge_col)) {
			if(length(edge_col) == 1) {
				edge_col = structure(rep(edge_col, n_levels), names = relation_levels)
			}
		}

		if(length(setdiff(names(edge_col), relation_levels))) {
			stop("names in `edge_col` should cover all relation types.")
		}

		if(is.atomic(edge_transparency)) {
			if(length(edge_transparency) == 1) {
				edge_transparency = structure(rep(edge_transparency, n_levels), names = relation_levels)
			}
		}

		if(!is.null(names(edge_transparency))) {
			if(length(setdiff(names(edge_transparency), relation_levels))) {
				stop("names in `edge_transparency` should cover all relation types.")
			}
			edge_transparency = edge_transparency[v_relations]
		}

		if(length(l_uncolored_nodes)) {
			l_uncolored_edges = rep(l_uncolored_nodes, times = sapply(dag@lt_children, length))
			edge_transparency = ifelse(l_uncolored_edges, pmax(0.96, edge_transparency), edge_transparency)
		}

		edge_col_v = add_transparency(edge_col[v_relations], edge_transparency)
	} else {

		if(length(l_uncolored_nodes)) {
			l_uncolored_edges = rep(l_uncolored_nodes, times = sapply(dag@lt_children, length))
			edge_transparency = ifelse(l_uncolored_edges, pmax(0.96, edge_transparency), edge_transparency)
		}
		if(is.null(edge_col)) {
			edge_col_v = "black"
		}
		edge_col_v = add_transparency(edge_col_v, edge_transparency)
	}

	if(has_highlight) {
		node_col[!l_highlight] = add_transparency("black", 0.95)
		node_col[l_highlight] = add_transparency(node_col[l_highlight], 0)
		node_size[!l_highlight] = 2
	}
	
	lt_children = dag@lt_children
	n = dag@n_terms
	df_edge = data.frame(from = rep(seq_len(n), times = vapply(lt_children, length, FUN.VALUE = integer(1))),
		                 to = unlist(lt_children))
	# df_edge2 = data.frame(from = rep(seq_len(n), times = vapply(tree@lt_children, length, FUN.VALUE = integer(1))),
	# 	                 to = unlist(tree@lt_children))
	# adjust rho
	tb = log(table(term_pos$h)+1); tb = tb[names(tb) != "0"]
	rho2 = cumsum(tb)/sum(tb); rho2["0"] = 0
	term_pos$h = rho2[as.character(term_pos$h)]

	term_pos2 = polar2Cartesian(term_pos) ## xy coordinate

	x1 = term_pos2[df_edge$from, 1]
	y1 = term_pos2[df_edge$from, 2]
	x2 = term_pos2[df_edge$to, 1]
	y2 = term_pos2[df_edge$to, 2]

	# x10 = term_pos2[df_edge2$from, 1]
	# y10 = term_pos2[df_edge2$from, 2]
	# x20 = term_pos2[df_edge2$to, 1]
	# y20 = term_pos2[df_edge2$to, 2]

	max_depth = max(abs(term_pos$h))

	if(verbose) message("making plot...")

	lgd_list = list()
	if(!is.null(node_col_map)) {

		if(has_highlight) {
			node_col_map = node_col_map[intersect(names(node_col_map), group[l_highlight])]
		} else {
			sector_width = term_pos[vapply(names(node_col_map), function(x) which(dag@terms == x), FUN.VALUE = integer(1)), "width"]
			if(sum(sector_width > 1) > 0) {
				node_col_map = node_col_map[sector_width > 1]
			}
		}
		# if(length(node_col_map) > 20) {
		# 	n_offspring = n_offspring(dag)
		# 	node_col_map = node_col_map[ order(-n_offspring[names(node_col_map)])[seq_len(20)] ]
		# }
		if(is.null(legend_labels_from)) {
			if("name" %in% colnames(mcols(dag))) {
				legend_labels = mcols(dag)[names(node_col_map), "name"]
			} else {
				legend_labels = names(node_col_map)
			}
		} else {
			legend_labels = mcols(dag)[names(node_col_map), legend_labels_from]
		}
		legend_labels = vapply(legend_labels, function(x) {
			x = strwrap(x, width = legend_labels_max_width)
			if(length(x) > 1) {
				x[-1] = paste0("  ", x[-1])
			}
			paste(x, collapse = "\n")
		}, FUN.VALUE = character(1))
		ii = which(is.na(legend_labels) | legend_labels == "NA")
		if(length(ii)) {
			legend_labels[ii] = names(node_col_map)[ii]
		}

		lgd_list = c(lgd_list, list(Legend(title = "Top terms", labels = legend_labels,
			type = "points", pch = 16,
			background = add_transparency(node_col_map, 0.9, FALSE), 
			legend_gp = gpar(col = node_col_map))))
	}
	if(!is.null(edge_col)) {
		legend_labels = names(edge_col)
		legend_labels = vapply(legend_labels, function(x) {
			x = strwrap(x, width = legend_labels_max_width)
			if(length(x) > 1) {
				x[-1] = paste0("  ", x[-1])
			}
			paste(x, collapse = "\n")
		}, FUN.VALUE = character(1))
		lgd_list = c(lgd_list, list(Legend(title = "Relations", labels = legend_labels, type = "lines", legend_gp = gpar(col = edge_col))))
	}
	if(node_size_by_n_children) {
		n_children = dag@term_env$n_children
		lgd_breaks = grid.pretty(c(1, quantile(n_children, 0.99)+1), n = 3)
		lgd_node_size = .scale(lgd_breaks, c(0, quantile(n_children, 0.99)+1), c(2, 10))
		lgd_labels = lgd_breaks
		if(max(lgd_breaks) != max(n_children)) {
			lgd_labels[length(lgd_labels)] = paste0(">= ", max(lgd_breaks), ", max = ", max(n_children))
		}
		lgd_list = c(lgd_list, list(Legend(title = "Number of child terms", labels = lgd_labels, type = "points", size = unit(lgd_node_size, "pt"))))
	}

	if(length(other_legends)) {
		if(inherits(other_legends, "Legend")) {
			lgd_list = c(lgd_list, list(other_legends))
		} else {
			lgd_list = c(lgd_list, other_legends)
		}
	}

	if(length(lgd_list)) {
		lgd = packLegend(list = lgd_list)
		lgd_width = width.Legends(lgd)
	} else {
		lgd_width = unit(0, "pt")
	}
	if(newpage) {
		grid.newpage()
	}

	# legend
	if(length(lgd_list)) {
		pushViewport(viewport(x = unit(1, "npc"), width = lgd_width + unit(4, "pt"), just = "right"))
		draw(lgd, x = unit(0, "npc"), just = "left")
		popViewport()
	}

	pushViewport(viewport(x = unit(0, "npc"), width = unit(1, "npc") - lgd_width - unit(4, "pt"), just = "left"))

	if(use_raster) {
		if(verbose) {
			message("saving the circular plot into a temporary png file...")
		}
		temp_png = tempfile()
		vp_width = convertWidth(unit(1, "snpc") - unit(8, "pt"), "in", valueOnly = TRUE)
		vp_height = convertHeight(unit(1, "snpc") - unit(8, "pt"), "in", valueOnly = TRUE)
		if(vp_width < 1) {
			vp_width = vp_height = 1
		}
		png(temp_png, width = vp_width*1.5, height = vp_height*1.5, units = "in", res = 72*1.5)
	}
	oe = try({
		pushViewport(viewport(width = unit(1, "snpc") - unit(8, "pt"), height = unit(1, "snpc") - unit(8, "pt"), 
			xscale = c(-max_depth, max_depth), yscale = c(-max_depth, max_depth)))
		if(!is.null(node_col_map)) {
			for(nm in names(node_col_map)) {
				i = which(dag@terms == nm)
				draw_sector(term_pos[i, "x"] - term_pos[i, "width"]/2,
					        term_pos[i, "x"] + term_pos[i, "width"]/2,
					        max_depth, gp = gpar(fill = add_transparency(node_col_map[[nm]], 0.9, FALSE), col = NA))
			}
		}

		theta = seq(0, pi*2, length = 50)
		for(i in unique(term_pos$rho)) {
			grid.lines(cos(theta)*i, sin(theta)*i, default.units = "native", gp = gpar(col = "#CCCCCC", lty = 3))
		}

		if(has_highlight) {
			grid.segments(x1, y1, x2, y2, default.units = "native", gp = gpar(col = edge_col_v))
			grid.points(term_pos2[!l_highlight, 1], term_pos2[!l_highlight, 2], default.units = "native", pch = 16, 
				gp = gpar(col = node_col[!l_highlight]), size = unit(node_size[!l_highlight], "pt"))
			grid.points(term_pos2[l_highlight, 1], term_pos2[l_highlight, 2], default.units = "native", pch = 16, 
				gp = gpar(col = node_col[l_highlight]), size = unit(node_size[l_highlight], "pt"))
		} else {
			if(verbose) message("adding links...")
			# grid.segments(x1, y1, x2, y2, default.units = "native", gp = gpar(col = "red"))
			grid.segments(x1, y1, x2, y2, default.units = "native", gp = gpar(col = edge_col_v))
			if(verbose) message("adding terms...")
			grid.points(term_pos2[, 1], term_pos2[, 2], default.units = "native", pch = 16, 
				gp = gpar(col = node_col), size = unit(node_size, "pt"))
			# grid.text(1:nrow(term_pos2), term_pos2[, 1], term_pos2[, 2], default.units = "native")
		}

		popViewport()
	}, silent = TRUE)

	if(use_raster) {
		dev.off()

		image = png::readPNG(temp_png)
		file.remove(temp_png)

		grid.raster(image, width = unit(1, "snpc") - unit(8, "pt"), height = unit(1, "snpc") - unit(8, "pt"))

	}

	if(inherits(oe, "try-error")) {
		stop(oe)
	}

	popViewport()

	if(verbose) {
		ds = dev.size()
		w = unit(ds[2], "in") + lgd_width + unit(4, "pt")
		w = convertWidth(w, "in", valueOnly = TRUE)

		message(qq("Best device size: @{round(w, 2)} x @{round(ds[2], 2)} inches."))
	}

}

.scale = function(v, range, map) {
	v[v > range[2]] = range[2]
	v[v < range[1]] = range[1]

	(map[2] - map[1])/(range[2] - range[1])*(v - range[1]) + map[1]
}

.normalize_node_graphics_parameter = function(value, default, all_terms, name) {
	n = length(all_terms)
	if(!is.null(names(value))) {
		value2 = rep(default, n)
		names(value2) = all_terms

		cn = intersect(names(value), names(value2))
		if(length(cn) == 0) {
			stop_wrap(qq("Since `@{name}` is a named vector, the names should correspond to the term names in the DAG."))
		}
		value2[cn] = value[cn]

		value = unname(value2)
	}

	if(!length(value) %in% c(1, n)) {
		stop_wrap(qq("Length of `@{name}` should be one or @{n} (number of terms in the DAG)."))
	}

	value
}

.normalize_edge_graphics_parameter = function(value, default, parents, children, v_relations, name) {
	n = length(parents)

	# name can use the relation type or "parent -> child"
	if(!is.null(names(value))) {
		value2 = rep(default, n)

		lt = strsplit(names(value), " +<?->? +")
		len = sapply(lt, length)

		l = len == 1
		if(any(l)) {
			for(i in which(l)) {
				value2[ v_relations == names(value)[i] ] = value[i]
			}
		}

		for(i in which(!l)) {
			value2[ parents == lt[[i]][1] & children == lt[[i]][2] ] = value[i]
			value2[ children == lt[[i]][1] & parents == lt[[i]][2] ] = value[i]
		}

		value = value2
	}

	if(!length(value) %in% c(1, n)) {
		stop_wrap(qq("Length of `@{name}` should be one or @{n} (number of edges in the DAG)."))
	}

	value
}


default_node_param = list(
	color = "black", 
	fillcolor = "lightgrey", 
	style = "solid",
	fontcolor = "black", 
	fontsize = 10, 
	shape = "box"
)

default_edge_param = list(
	color = "black",
	style = "solid",
	dir = "back"
)

#' @param node_param A list of parameters. Each parameter has the same format. The value can be
#'      a single scalar, a full length vector with the same order as in [`dag_all_terms()`],
#'             or a named vector that contains a subset of terms that need to be customized. 
#'        The full set of parameters can be found at \url{https://graphviz.org/docs/nodes/}.
#' @param edge_param A list of parameters. Each parameter has the same format. The value can be a single
#'     scalar, or a named vector that contains a subset of terms that need to be customized. 
#'        The full set of parameters can be found at \url{https://graphviz.org/docs/edges/}.
#'     If the parameter is set to a named vector, it can be named by relation types `c("is_a" = ...)`,
#'     or directly relations `c("a -> b" = ...)`. Please see the vignette for details.
#' @param rankdir The direction of the layout. Only four values are allowed: `"TB"`, `"LR"`, `"BT"` and `"RL"`.
#'
#' @seealso \url{http://magjac.com/graphviz-visual-editor/} is nice place to try the DOT code.
#' @details `dag_as_DOT()` generates the DOT code of the DAG.
#' @importFrom circlize rand_color
#' @export
#' @returns
#' `dag_as_DOT()` returns a vector of DOT code.
#' @rdname dag_viz
dag_as_DOT = function(dag, node_param = default_node_param,
	edge_param = default_edge_param, rankdir = c("TB", "LR", "BT", "RL")) {

	for(nm in names(default_node_param)) {
		if(is.null(node_param[[nm]])) {
			node_param[[nm]] = default_node_param[[nm]]
		}
	}
	for(nm in names(node_param)) {
		if(is.null(default_node_param[[nm]])) {
			node_param[[nm]] = .normalize_node_graphics_parameter(node_param[[nm]], NA, dag@terms, nm)
		} else {
			node_param[[nm]] = .normalize_node_graphics_parameter(node_param[[nm]], default_node_param[[nm]], dag@terms, nm)
		}
	}

	name = NULL
	if(!is.null(mcols(dag))) {
		meta = mcols(dag)
		if("name" %in% colnames(meta)) {
			name = meta[, "name"]
			name = gsub("\"", "\\\\\"", name)
			name[is.na(name)] = ""
		}
	}

	n_nodes = dag_n_terms(dag)
	nodes = "  node [fontname = \"Helvetical\"]"
	for(i in seq_len(n_nodes)) {
		nodes = c(nodes, qq("  \"@{dag@terms[i]}\" ["))
	
		for(nm in names(node_param)) {
			v = node_param[[nm]]
			if(length(v) != 1) {
				v = v[i]
			}
			if(!is.na(v)) {
				nodes = c(nodes, qq("    @{nm} = \"@{v}\","))
			}
		}
		if(!is.null(name)) {
			nodes = c(nodes, qq("    tooltip = \"@{name[i]}\","))
		}
		nodes = c(nodes, "  ];")
	}
	
	lt_children = dag@lt_children
	children = unlist(lt_children)
	parents = rep(seq_along(dag@terms), times = vapply(lt_children, length, FUN.VALUE = integer(1)))
	children = dag@terms[children]
	parents = dag@terms[parents]

	if(length(dag@lt_children_relations) > 0) {
		relation_levels = attr(dag@lt_children_relations, "levels")
		v_relations = unlist(dag@lt_children_relations)
		v_relations = relation_levels[v_relations]
		n_levels = length(relation_levels)

	} else {
		v_relations = NULL
	}

	for(nm in names(default_edge_param)) {
		if(is.null(edge_param[[nm]])) {
			edge_param[[nm]] = default_edge_param[[nm]]
		}
	}
	for(nm in names(edge_param)) {
		if(is.null(default_edge_param[[nm]])) {
			edge_param[[nm]] = .normalize_edge_graphics_parameter(edge_param[[nm]], NA, parents, children, v_relations, nm)
		} else {
			edge_param[[nm]] = .normalize_edge_graphics_parameter(edge_param[[nm]], default_edge_param[[nm]], parents, children, v_relations, nm)
		}
	}

	n_edges = length(children)
	edges = "  # edges"
	for(i in seq_len(n_edges)) {
		edges = c(edges, qq("  \"@{parents[i]}\" -> \"@{children[i]}\" ["))
	
		for(nm in names(edge_param)) {
			v = edge_param[[nm]]
			if(length(v) != 1) {
				v = v[i]
			}
			if(!is.na(v)) {
				edges = c(edges, qq("    @{nm} = \"@{v}\","))
			}
		}
		if(!is.null(v_relations)) {
			edges = c(edges, qq("    tooltip = \"@{v_relations[i]}\","))
		}
		edges = c(edges, "  ];")
	}

	rankdir = match.arg(rankdir)[1]
	DOT = c(
		"digraph {",
		"  graph [",
	 qq("    rankdir = \"@{rankdir}\","),
		"    overlap = true",
		"  ]",
		"",
		nodes,
		"",
		edges,
		"}",
		""
	)

	dot = paste(DOT, collapse = "\n")
	class(dot) = "print_source"
	dot
}

#' Print the source
#' 
#' @param x An object in the `print_source` class.
#' @param ... Other arguments.
#' 
#' @details
#' Internally used.
print.print_source = function(x, ...) {
	cat(x)
}

#' @param ... Pass to [`DiagrammeR::grViz()`].
#' @rdname dag_viz
#' @details
#' `dag_graphviz()` visualizes the DAG with the **DiagrammeR** package.
#' @export
#' @examples
#' if(interactive()) {
#' dag = create_ontology_DAG_from_GO_db()
#' dag_graphviz(dag[, "GO:0010228"])
#' dag_graphviz(dag[, "GO:0010228"], 
#'     edge_param = list(color = c("is_a" = "purple", "part_of" = "darkgreen"),
#'                       style = c("is_a" = "solid", "part_of" = "dashed")),
#'     width = 800, height = 800)
#' 
#' # the DOT code for graphviz
#' dag_as_DOT(dag[, "GO:0010228"])
#' }
dag_graphviz = function(dag, 
	node_param = default_node_param, edge_param = default_edge_param, 
	rankdir = "TB", ...) {

	if(dag@n_terms > 100) {
		warning("graphviz is only efficient for visualizing small graphs.")
	}
	if(dag@n_terms > 500) {
		stop("Too many terms.")
	}
	check_pkg("DiagrammeR", bioc = FALSE)

	dot = dag_as_DOT(dag, node_param = node_param, edge_param = edge_param, rankdir = rankdir)
	DiagrammeR::grViz(dot, ...)
}

# center at (0, 0)
draw_sector = function(start, end, radius, ...) {
	if(end < start) {
		end = end + 360
	}

	theta = c(0, seq(start, end, by = 0.5), 0)
	rho = c(0, rep(radius, length(theta)-2), 0)
	
	pos = polar2Cartesian(cbind(theta, rho))
	grid.polygon(pos[, 1], pos[, 2], default.units = "native", ...)	
}

#' Filter the DAG
#' 
#' @param dag An `ontology_DAG` object.
#' @param terms A vector of term names. The sub-DAG will only contain these terms.
#' @param relations A vector of relations. The sub-DAG will only contain these relations. 
#'                  Valid values of "relations" should correspond to the values set in the 
#'                  `relations` argument in the [`create_ontology_DAG()`]. If `relations_DAG` is 
#'                  already provided, offspring relation types will all be selected. Note "is_a"
#'                  is always included.
#' @param root A vector of term names which will be used as roots of the sub-DAG. Only 
#'             these with their offspring terms will be kept. If there are multiple root terms, 
#'             a super root will be automatically added.
#' @param leaves A vector of leaf terms. Only these with their ancestor terms will be kept.
#' @param mcols_filter Filtering on columns in the meta data frame.
#' @param namespace The prefix before ":" of the term IDs.
#' 
#' @details If the DAG is reduced into several disconnected parts after the filtering, a
#'          super root is automatically added.
#' 
#' @return An `ontology_DAG` object.
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' dag_filter(dag, terms = c("b", "d", "f"))
#' dag_filter(dag, root = "b")
#' dag_filter(dag, leaves = c("c", "b"))
#' dag_filter(dag, root = "b", leaves = "e")
#' 
#' \donttest{
#' dag = create_ontology_DAG_from_GO_db()
#' dag_filter(dag, relations = "is_a")
#' }
dag_filter = function(dag, terms = NULL, relations = NULL, root = NULL, leaves = NULL,
	mcols_filter = NULL, namespace = NULL) {

	lt_children = dag@lt_children
	children = unlist(lt_children)
	parents = rep(seq_along(dag@terms), times = vapply(lt_children, length, FUN.VALUE = integer(1)))
	if(length(dag@lt_children_relations) > 0) {
		relation_levels = attr(dag@lt_children_relations, "levels")
		v_relations = unlist(dag@lt_children_relations)
		v_relations = relation_levels[v_relations]
	} else {
		v_relations = NULL
	}

	if(length(dag@annotation$list) > 0) {
		annotation = lapply(dag@annotation$list, function(x) {
			dag@annotation$names[x]
		})
		names(annotation) = dag@terms
	} else {
		annotation = NULL
	}

	l = rep(TRUE, length(parents))

	if(!is.null(namespace)) {
		terms = c(terms, grep( paste0("^", namespace, ":"), dag@terms, ignore.case = TRUE, value = TRUE))
	}
	if(!is.null(terms)) {
		terms = term_to_node_id(dag, terms)
		l = l & parents %in% terms & children %in% terms
	}

	if(!is.null(relations)) {

		relations = normalize_relation_type(relations)
		if(!"is_a" %in% relations) {
			stop("'is_a' must be included.")
		}

		if(!is.null(dag@relations_DAG)) {
			relations = merge_offspring_relation_types(dag@relations_DAG, relations)
		}

		if(!is.null(v_relations)) {
			l2 = v_relations %in% relations
			if(!any(l2)) {
				stop("Cannot find any relation.")
			}
			l = l & l2
		}
	}

	if(!is.null(root)) {
		offspring = dag_offspring(dag, root, FALSE)
		offspring = c(offspring, which(dag@terms %in% root))
		l = l & (parents %in% offspring & children %in% offspring)
	}

	if(!is.null(leaves)) {
		ancestors = dag_ancestors(dag, leaves, FALSE)
		ancestors = c(ancestors, which(dag@terms %in% leaves))
		l = l & (parents %in% ancestors & children %in% ancestors)
	}

	## filter in mcols
	df = mcols(dag)
	if(!is.null(df)) {
		l2 = eval(substitute(mcols_filter), envir = df)
		if(!is.null(l2)) {
			l2[is.na(l2)] = FALSE
			if(!is.null(l2)) {
				l = l & l2
			}
		}
	}

	if(!any(l)) {
		return(singleton_ontology("~~singleton~~"))
	}

	parents = parents[l]
	children = children[l]
	if(!is.null(v_relations)) {
		v_relations = v_relations[l]
	}

	parents = dag@terms[parents]
	children = dag@terms[children]

	all_terms = unique(c(parents, children))
	if(!is.null(annotation)) {
		annotation = annotation[all_terms]
	}

	dag2 = create_ontology_DAG(parents = parents, children = children,
		relations = v_relations, relations_DAG = dag@relations_DAG, 
		annotation = annotation, alternative_terms = dag@alternative_terms, source = dag@source)

	meta = mcols(dag)
	if(!is.null(meta)) {
		mcols(dag2) = meta[dag2@terms, , drop = FALSE]
	}

	dag2
}



#' Create sub-DAGs
#' 
#' @param x An `ontology_DAG` object.
#' @param i A single term name. The value should be a character vector. It corresponds to the roots.
#' @param j A single term name. The value should be a character vector. It corresponds to the leaves.
#' @param ... Ignored.
#' @param drop Ignored.
#' 
#' @details It returns a sub-DAG taking node `i` as the root and `j` as the leaves. If `i` is a vector, a super root will be added.
#' @return An `ontology_DAG` object.
#' 
#' @rdname subset
#' @exportMethod [
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' dag["b"]
#' dag[["b"]]
#' dag["b", "f"]
#' dag[, "f"]
setMethod("[", 
	signature = c("ontology_DAG", i = "ANY", j = "ANY", drop = "missing"),
	definition = function(x, i, j, ..., drop = FALSE) {

	if(!is.character(i)) {
		stop("Only the character term name should be used as index.")
	}

	if(!is.character(j)) {
		stop("Only the character term name should be used as index.")
	}
	
	dag_filter(x, root = i, leaves = j)
	
})


#' @rdname subset
#' @exportMethod [
setMethod("[", 
	signature = c("ontology_DAG", i = "ANY", j = "ANY", drop = "ANY"),
	definition = function(x, i, j, ..., drop = FALSE) {

	x[i, j]
	
})


#' @rdname subset
#' @exportMethod [
setMethod("[", 
	signature = c("ontology_DAG", i = "ANY", j = "missing", drop = "missing"),
	definition = function(x, i, j, ..., drop = FALSE) {

	if(!is.character(i)) {
		stop("Only the character term name should be used as index.")
	}

	dag_filter(x, root = i)
})

#' @rdname subset
#' @exportMethod [
setMethod("[", 
	signature = c("ontology_DAG", i = "ANY", j = "missing", drop = "ANY"),
	definition = function(x, i, j, ..., drop = FALSE) {

	x[i]
})

#' @rdname subset
#' @exportMethod [
setMethod("[", 
	signature = c("ontology_DAG", i = "missing", j = "ANY", drop = "missing"),
	definition = function(x, i, j, ..., drop = FALSE) {

	if(!is.character(j)) {
		stop("Only the character term name should be used as index.")
	}

	dag_filter(x, leaves = j)

})

#' @rdname subset
#' @exportMethod [
setMethod("[", 
	signature = c("ontology_DAG", i = "missing", j = "ANY", drop = "ANY"),
	definition = function(x, i, j, ..., drop = FALSE) {

	x[, j]

})

#' @rdname subset
#' @exportMethod [
setMethod("[", 
	signature = c("ontology_DAG", i = "missing", j = "missing", drop = "missing"),
	definition = function(x, i, j, ..., drop = FALSE) {

	x
	
})

#' @rdname subset
#' @exportMethod [
setMethod("[", 
	signature = c("ontology_DAG", i = "missing", j = "missing", drop = "ANY"),
	definition = function(x, i, j, ..., drop = FALSE) {

	x
	
})

#' @rdname subset
#' @exportMethod [[
setMethod("[[", 
	signature = c("ontology_DAG", "character", "missing"),
	definition = function(x, i, j, ...) {

	if(!is.character(i)) {
		stop("Only the character term name should be used as index.")
	}
	dag_filter(x, root = i)
})

#' Create the ontology_DAG object from the GO.db package
#' 
#' @param namespace One of "BP", "CC" and "MF".
#' @param relations Types of the GO term relations. In the **GO.db** package, the GO term relations can be "is_a", "part_of",
#'               "regulates", "negatively regulates", "positively regulates". Note since "regulates" is a parent relation
#'               of "negatively regulates", "positively regulates", if "regulates" is selected, "negatively regulates" and "positively regulates"
#'               are also selected. Note "is_a" is always included.
#' @param org_db The name of the organism package or the corresponding database object, e.g. `"org.Hs.eg.db"` or 
#'            directly the [`org.Hs.eg.db::org.Hs.eg.db`] object for human, then the gene annotation to GO terms will be added
#'            to the object. For other non-model organisms, consider to use the **AnnotationHub** package to find one.
#' @param evidence_code A vector of evidence codes for gene annotation to GO terms. See \url{https://geneontology.org/docs/guide-go-evidence-codes/}.
#' @param retrieve_alternative Whether to retrieve alternative/obsolete GO terms from geneontology.org?
#' @param verbose Whether to print messages.
#' 
#' @return An `ontology_DAG` object.
#' @export
#' @importFrom utils getFromNamespace
#' @examples
#' dag = create_ontology_DAG_from_GO_db()
#' dag
create_ontology_DAG_from_GO_db = function(namespace = "BP", relations = "part of", org_db = NULL, 
	evidence_code = NULL, retrieve_alternative = FALSE, verbose = simona_opt$verbose) {

	check_pkg("GO.db", bioc = TRUE)

	if(namespace == "BP") {
		df = AnnotationDbi::toTable(GO.db::GOBPCHILDREN)
	} else if(namespace == "CC") {
		df = AnnotationDbi::toTable(GO.db::GOCCCHILDREN)
	} else if(namespace == "MF") {
		df = AnnotationDbi::toTable(GO.db::GOMFCHILDREN)
	} else {
		stop("Value of `namespace` can only be one of 'BP', 'MF' and 'CC'.")
	}

	l = df[, 3] == "isa"
	df[l, 3] = "is_a"
	df[, 3] = gsub(" ", "_", df[, 3])

	if(length(relations) == 0) {
		relations = character(0)
	}

	if(identical(relations, NA)) {
		relations = character(0)
	}

	relations = c("is_a", relations)
	relations = normalize_relation_type(relations)
	if("regulates" %in% relations) {
		relations = c(relations, "negatively_regulates", "positively_regulates")
	}
	df = df[df[, 3] %in% relations, , drop = FALSE]

	if(verbose) {
		message("relations: ", paste(relations, collapse = ", "))
	}

	if(!is.null(org_db)) {
		if(is.character(org_db)) {
			check_pkg(org_db, bioc = TRUE)
			org_db = getFromNamespace(org_db, ns = org_db)
		}
	
		suppressMessages(tb <- AnnotationDbi::select(org_db, keys = AnnotationDbi::keys(org_db), columns = c("GO", "EVIDENCE", "ONTOLOGY")))
		tb = tb[tb$ONTOLOGY == namespace, , drop = FALSE]
		if(!is.null(evidence_code)) {
			tb = tb[tb$EVIDENCE %in% evidence_code, , drop = FALSE]
			if(row(tb) == 0) {
				stop("No annotation left after filtering by the evidence codes.")
			}
		}
		tb = tb[, c(1, which(colnames(tb) == "GO")), drop = FALSE]
		annotation = split(tb[, 1], tb[, 2])
		annotation = lapply(annotation, unique)
		annotation = lapply(annotation, as.character)
	} else {
		annotation = NULL
	}

	relations_DAG = create_ontology_DAG(c("regulates", "regulates"), c("negatively regulates", "positively regulates"))

	alternative_terms = list()
	if(retrieve_alternative) {
		alternative_terms = alternative_GO_terms(verbose = verbose)
	}

	go_db_version = read.dcf(system.file("DESCRIPTION", package = "GO.db"))[1, "Version"]
	dag = create_ontology_DAG(parents = df[, 2], children = df[, 1], relations = df[, 3], relations_DAG = relations_DAG,
		annotation = annotation, source = paste0("GO ", namespace, " / GO.db package ", go_db_version), alternative_terms = alternative_terms)

	go = GO.db::GOTERM[dag@terms]
	meta = data.frame(id = AnnotationDbi::GOID(go),
		        name = AnnotationDbi::Term(go),
		        definition = AnnotationDbi::Definition(go))
	rownames(meta) = dag@terms

	mcols(dag) = meta

	dag
}


#' Mappings between alternative GO terms to official GO terms
#' 
#' @param tag In the `go-basic.obo` file, there are three tags which define alternative GO terms: `replaced_by`, `alt_id` and `consider`.
#'        See https://owlcollab.github.io/oboformat/doc/GO.format.obo-1_4.html#S.2.2.1
#' @param version Version of the `go-basic.obo` file. By default it is the version for building **GO.db** package. The value is a string in the format of "2024-01-17".
#' 
#' @return A list of named vectors where names are alternative GO IDs and value vectors are current GO IDs in use.
#' @export
#' @rdname create_ontology_DAG_from_GO_db
alternative_GO_terms = function(tag = c("replaced_by", "alt_id", "consider"), version = NULL, verbose = TRUE) {

	db_info = GO.db::GO_dbInfo()
	if(is.null(version)) {
		obo_version = db_info$value[db_info$name == "GOSOURCEDATE"]
	} else {
		obo_version = version
	}

	obo_url = paste0("https://release.geneontology.org/", obo_version, "/ontology/go-basic.obo")

	if(verbose) {
		message("Use GO obo version: ", obo_version)
		message("Downloading ", obo_url, " to get the alternative terms.")
	}
	op = getOption("timeout")
	options(timeout = 999999999)
	on.exit(options(timeout = op))
	con = url(obo_url)
	ln = readLines(con)
	close(con)

	if(verbose) {
		message("Retrieving mappings between alternative terms to DAG terms.")
	}
	ind_stanza = c(grep("^\\[.*\\]$", ln), length(ln))
	ind1 = grep("^\\[Term\\]$", ln)

	ind2 = cpp_match_index(ind1, ind_stanza[-1]-1)
	n = length(ind1)

	tag = tag
	process_obo_alternative = function(ln) {

		lt = list()
		i = grep("^id:", ln)
		lt$id = gsub("^id: (\\S+)(\\s*.*)$", "\\1", ln[i])[1]

		lt$alt_id = character(0)
		lt$is_obsolete = "false"
		lt$replaced_by = character(0)
		lt$consider = character(0)
		
		if("alt_id" %in% tag) {
			i = grep("^alt_id:", ln)
			if(length(i)) {
				lt$alt_id = gsub("^alt_id: (.*)$", "\\1", ln[i])
			}
		}
		
		i = grep("^is_obsolete:", ln)
		if(length(i)) {
			lt$is_obsolete = gsub("^is_obsolete: (.*)$", "\\1", ln[i])

			if("replaced_by" %in% tag) {
				i = grep("^replaced_by:", ln)
				if(length(i)) {
					lt$replaced_by = gsub("^replaced_by: (.*)$", "\\1", ln[i])
				}
			}

			if("consider" %in% tag) {
				i = grep("^consider:", ln)
				if(length(i)) {
					lt$consider = gsub("^consider: (.*)$", "\\1", ln[i])
				}
			}
		}

		lt
	}

	lt_terms = vector("list", n)
	for(i in seq_len(n)) {
		lt_terms[[i]] = process_obo_alternative(ln[seq(ind1[i], ind2[i])])
	}

	alternative_terms1 = list()
	alternative_terms2 = list()
	alternative_terms3 = list()

	if("replaced_by" %in% tag) {
		l = sapply(lt_terms, function(x) length(x$replaced_by) > 0)
		alternative_terms1 = lt_terms[l]
		lt = lapply(alternative_terms1, function(x) {
			data.frame(id = rep(x$id, length(x$replaced_by)), replaced_by = x$replaced_by)
		})
		alternative_terms1 = do.call(rbind, lt)
		alternative_terms1 = split(alternative_terms1$replaced_by, alternative_terms1$id)
		alternative_terms1 = lapply(alternative_terms1, function(x) structure(x, names = rep("replaced_by", length(x))))
	}

	if("consider" %in% tag) {
		l = sapply(lt_terms, function(x) length(x$consider) > 0)
		alternative_terms2 = lt_terms[l]
		lt = lapply(alternative_terms2, function(x) {
			data.frame(id = rep(x$id, length(x$consider)), consider = x$consider)
		})
		alternative_terms2 = do.call(rbind, lt)
		alternative_terms2 = split(alternative_terms2$consider, alternative_terms2$id)
		alternative_terms2 = lapply(alternative_terms2, function(x) structure(x, names = rep("consider", length(x))))
	}

	if("alt_id" %in% tag) {
		l = sapply(lt_terms, function(x) length(x$alt_id) > 0)
		alternative_terms3 = lt_terms[l]
		alt_lt = lapply(alternative_terms3, function(x) {
			data.frame(id = rep(x$id, length(x$alt_id)), alt_id = x$alt_id)
		})
		alternative_terms3 = do.call(rbind, alt_lt)
		alternative_terms3 = split(alternative_terms3$id, alternative_terms3$alt_id)
		alternative_terms3 = lapply(alternative_terms3, function(x) structure(x, names = rep("alt_id", length(x))))
	}

	cn = unique(c(names(alternative_terms1), names(alternative_terms2), names(alternative_terms3)))
	lt = vector("list", length(cn))
	names(lt) = cn
	for(x in names(alternative_terms1)) {
		lt[[x]] = c(lt[[x]], alternative_terms1[[x]])
	}
	for(x in names(alternative_terms2)) {
		lt[[x]] = c(lt[[x]], alternative_terms2[[x]])
	}
	for(x in names(alternative_terms3)) {
		lt[[x]] = c(lt[[x]], alternative_terms3[[x]])
	}

	lt
}

#' Parent/child/ancestor/offspring terms
#' 
#' @param dag An `ontology_DAG` object.
#' @param term The value can be a vector of multiple term names. If it is a vector, it returns
#'             union of the upstream/downstream terms of the selected set of terms. For `dag_siblings()`,
#'             the value can only be a single term.
#' @param in_labels Whether the terms are represented in their names or as integer indices?
#' @param include_self For `dag_offspring()` and `dag_ancestors()`, this controls whether to also include the query term itself.
#' 
#' @return An integer vector or a character vector depending on the value of `in_labels`.
#' @rdname dag_terms
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' dag_parents(dag, "b")
#' dag_parents(dag, "c", in_labels = FALSE)
#' dag_children(dag, "b")
#' dag_siblings(dag, "c")
#' dag_ancestors(dag, "e")
#' dag_ancestors(dag, "b")
dag_parents = function(dag, term, in_labels = TRUE) {

	i = term_to_node_id(dag, term)

	parents = unique(unlist(dag@lt_parents[i]))
	if(in_labels) {
		dag@terms[parents]
	} else {
		parents
	}
}


#' @rdname dag_terms
#' @export
dag_children = function(dag, term, in_labels = TRUE) {

	i = term_to_node_id(dag, term)

	children = unique(unlist(dag@lt_children[i]))
	if(in_labels) {
		dag@terms[children]
	} else {
		children
	}
}

#' @rdname dag_terms
#' @export
dag_siblings = function(dag, term, in_labels = TRUE) {
	i = term_to_node_id(dag, term)

	if(length(i) != 1) {
		stop("`term` can only be length of one.")
	}

	parents = unique(unlist(dag@lt_parents[i]))
	siblings = dag_children(dag, parents, in_labels = FALSE)
	siblings = setdiff(siblings, i)

	if(in_labels) {
		dag@terms[siblings]
	} else {
		siblings
	}
}

#' @rdname dag_terms
#' @export
dag_ancestors = function(dag, term, in_labels = TRUE, include_self = FALSE) {
	if(length(term) == 1) {
		i = term_to_node_id(dag, term)

		ancestors = cpp_ancestors(dag, i, include_self)
		if(in_labels) {
			dag@terms[ancestors]
		} else {
			ancestors
		}
	} else {
		i = term_to_node_id(dag, term)

		ancestors = cpp_ancestors_of_a_group(dag, i, include_self = include_self)
		if(in_labels) {
			dag@terms[ancestors]
		} else {
			ancestors
		}
	}
}

#' @rdname dag_terms
#' @export
dag_offspring = function(dag, term, in_labels = TRUE, include_self = FALSE) {
	if(length(term) == 1) {
		i = term_to_node_id(dag, term)

		offspring = cpp_offspring(dag, i, include_self)
		if(in_labels) {
			dag@terms[offspring]
		} else {
			offspring
		}
	} else {
		i = term_to_node_id(dag, term)

		offspring = cpp_offspring_of_a_group(dag, i, include_self = include_self)
		if(in_labels) {
			dag@terms[offspring]
		} else {
			offspring
		}
	}
}

# it returns offspring for all terms, like GOBPOFFSPRING
dag_all_offspring = function(dag, in_labels = TRUE, include_self = FALSE) {
	m = cpp_all_offspring(dag, include_self)
	lt = apply(m, 1, which)
	names(lt) = dag@terms

	if(in_labels) {
		lt = lapply(lt, function(x) dag@terms[x])
	}

	lt
}

#' Number of parent/child/ancestor/offspring/leaf terms
#' 
#' @param dag An `ontology_DAG` object.
#' @param terms A vector of term names. If the value is `NULL`, it returns for all terms in the DAG.
#' @param use_cache Internally used.
#' @param include_self For `n_offspring()` and `n_ancestors()`, this controls whether to also include the query term itself.
#' 
#' @return An integer vector.
#' @rdname n_terms
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' n_parents(dag)
#' n_children(dag)
#' n_offspring(dag)
#' n_ancestors(dag)
#' n_connected_leaves(dag)
n_offspring = function(dag, terms = NULL, use_cache = TRUE, include_self = FALSE) {
	if(is.null(dag@term_env$n_offspring) || !use_cache) {
		if(dag_is_tree(dag)) {
			dag@term_env$n_offspring = cpp_n_offspring_on_tree(dag, FALSE)
		} else {
			dag@term_env$n_offspring = cpp_n_offspring(dag, FALSE)
		}
	}
	n = dag@term_env$n_offspring
	names(n) = dag@terms

	if(include_self) {
		n = n + 1
	}

	if(!is.null(terms)) {
		if(is.numeric(terms)) {
			n[terms]
		} else {
			id = term_to_node_id(dag, terms, add_name = TRUE)
			n[id[terms]]
		}
	} else {
		n
	}
}


#' @rdname n_terms
#' @export
n_ancestors = function(dag, terms = NULL, use_cache = TRUE, include_self = FALSE) {
	if(is.null(dag@term_env$n_ancestors) || !use_cache) {
		if(dag_is_tree(dag)) {
			dag@term_env$n_ancestors = cpp_n_ancestors_on_tree(dag, FALSE)
		} else {
			dag@term_env$n_ancestors = cpp_n_ancestors(dag, FALSE)
		}
	}
	n = dag@term_env$n_ancestors
	names(n) = dag@terms

	if(include_self) {
		n = n + 1
	}

	if(!is.null(terms)) {
		if(is.numeric(terms)) {
			n[terms]
		} else {
			id = term_to_node_id(dag, terms, add_name = TRUE)
			n[id[terms]]
		}
	} else {
		n
	}
}

#' @rdname n_terms
#' @details For `n_connected_leaves()`, leaf nodes have value of 1.
#' @export
n_connected_leaves = function(dag, terms = NULL, use_cache = TRUE) {
	if(is.null(dag@term_env$n_leaves) || !use_cache) {
		if(dag_is_tree(dag)) {
			dag@term_env$n_leaves = cpp_n_leaves_on_tree(dag)
		} else {
			dag@term_env$n_leaves = cpp_n_leaves(dag)
		}
	}
	n = dag@term_env$n_leaves
	names(n) = dag@terms

	if(!is.null(terms)) {
		if(is.numeric(terms)) {
			n[terms]
		} else {
			id = term_to_node_id(dag, terms, add_name = TRUE)
			n[id[terms]]
		}
	} else {
		n
	}
}

#' @rdname n_terms
#' @export
n_parents = function(dag, terms = NULL) {
	n = dag@term_env$n_parents
	names(n) = dag@terms

	if(!is.null(terms)) {
		if(is.numeric(terms)) {
			n[terms]
		} else {
			id = term_to_node_id(dag, terms, add_name = TRUE)
			n[id[terms]]
		}
	} else {
		n
	}
}

#' @rdname n_terms
#' @export
n_children = function(dag, terms = NULL) {
	n = dag@term_env$n_children
	names(n) = dag@terms

	if(!is.null(terms)) {
		if(is.numeric(terms)) {
			n[terms]
		} else {
			id = term_to_node_id(dag, terms, add_name = TRUE)
			n[id[terms]]
		}
	} else {
		n
	}
}

#' @details
#' In `avg_parents()`, root term is removed.
#' @rdname n_terms
#' @export
avg_parents = function(dag) {
	mean(n_parents(dag)[-dag_root(dag, in_labels = FALSE)])
   
}

#' @details
#' In `avg_children()`, leaf term is removed.
#' @rdname n_terms
#' @export
avg_children = function(dag) {
	mean(n_children(dag)[-dag_leaves(dag, in_labels = FALSE)])
}

dag_ancestors_of_two_groups = function(dag, group1, group2, type = "union", in_labels = FALSE, include_self = FALSE) {

	group1 = term_to_node_id(dag, group1)
	group2 = term_to_node_id(dag, group2)

	all_types = c("union" = 1, "intersect" = 2, "group 1" = 3, "group 2" = 4)
	type = all_types[tolower(type)]
	if(is.na(type)) {
		stop("Values of `type` can only be one of 'union', 'intersect', 'group 1' and 'group 2'.")
	}
	ancestors = cpp_ancestors_of_two_groups(dag, group1, group2, type, include_self)
	if(in_labels) {
		dag@terms[ancestors]
	} else {
		ancestors
	}
}



#' Depth and height in the DAG
#' 
#' @param dag An `ontology_DAG` object.
#' @param terms A vector of term names. If it is set, the returned vector will be subsetted to the terms that have been set here.
#' @param use_cache Internally used.
#' @details
#' The depth of a term in the DAG is defined as the maximal distance from the root. The height
#' of a term in the DAG is the maximal finite distance to all leaf terms.
#' 
#' `dag_shortest_dist_from_root()` and `dag_shortest_dist_to_leaves()` calculate the minimal distance from the root or to the leaves.
#' The word "from" and "to" emphasize the distancer is directinoal.
#' 
#' @return An integer vector with length the same as the number of total terms in the DAG.
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' dag_depth(dag)
#' dag_height(dag)
#' dag_shortest_dist_from_root(dag)
#' dag_shortest_dist_to_leaves(dag)
dag_depth = function(dag, terms = NULL, use_cache = TRUE) {
	if(is.null(dag@term_env$dag_depth) || !use_cache) {
		d = cpp_dag_depth(dag)
		dag@term_env$dag_depth = d
	}
	d = structure(dag@term_env$dag_depth, names = dag@terms)

	if(!is.null(terms)) {
		if(is.numeric(terms)) {
			d[terms]
		} else {
			id = term_to_node_id(dag, terms, add_name = TRUE)
			d[id[terms]]
		}
	} else {
		d
	}
}

#' @rdname dag_depth
#' @export
dag_height = function(dag, terms = NULL, use_cache = TRUE) {
	if(is.null(dag@term_env$dag_height) | !use_cache) {
		d = cpp_dag_height(dag)
		dag@term_env$dag_height = d
	}
	d = structure(dag@term_env$dag_height, names = dag@terms)

	if(!is.null(terms)) {
		if(is.numeric(terms)) {
			d[terms]
		} else {
			id = term_to_node_id(dag, terms, add_name = TRUE)
			d[id[terms]]
		}
	} else {
		d
	}
}

#' @rdname dag_depth
#' @export
dag_shortest_dist_from_root = function(dag, terms = NULL, use_cache = TRUE) {
	if(is.null(dag@term_env$dag_dist_to_root) || !use_cache) {
		d = cpp_dag_dist_from_root(dag)
		dag@term_env$dag_dist_to_root = d
	}
	d = structure(dag@term_env$dag_dist_to_root, names = dag@terms)

	if(!is.null(terms)) {
		if(is.numeric(terms)) {
			d[terms]
		} else {
			id = term_to_node_id(dag, terms, add_name = TRUE)
			d[id[terms]]
		}
	} else {
		d
	}
}

#' @rdname dag_depth
#' @export
dag_shortest_dist_to_leaves = function(dag, terms = NULL, use_cache = TRUE) {
	if(is.null(dag@term_env$dag_dist_to_leaves) || !use_cache) {
		d = cpp_dag_dist_to_leaves(dag)
		dag@term_env$dag_dist_to_leaves = d
	}
	d = structure(dag@term_env$dag_dist_to_leaves, names = dag@terms)

	if(!is.null(terms)) {
		if(is.numeric(terms)) {
			d[terms]
		} else {
			id = term_to_node_id(dag, terms, add_name = TRUE)
			d[id[terms]]
		}
	} else {
		d
	}
}



.dag_singular_dist = function(dag, from, terms = NULL, background = NULL, dist_type = "longest", towards = "ancestors") {

	if(dist_type == "longest" && towards == "ancestors") {
		f = cpp_dag_longest_dist_from_ancestors
	} else if(dist_type == "shortest" && towards == "ancestors") {
		f = cpp_dag_shortest_dist_from_ancestors
	} else if(dist_type == "longest" && towards == "offspring") {
		f = cpp_dag_longest_dist_to_offspring
	} else if(dist_type == "shortest" && towards == "offspring") {
		f = cpp_dag_shortest_dist_to_offspring
	}
	
	from = term_to_node_id(dag, from)
	if(is.null(background)) {
		d = f(dag, from)
	} else {
		background = term_to_node_id(dag, background, strict = FALSE)
		l_background = rep(FALSE, dag@n_terms)
		l_background[background] = TRUE
		d = f(dag, from, l_background)
	}
	
	names(d) = dag@terms

	if(!is.null(terms)) {
		i = term_to_node_id(dag, terms)
		d[i]
	} else {
		d
	}
}

#' Distance from all ancestors/to all offspring in the DAG
#' 
#' @param dag An `ontology_DAG` object.
#' @param from A single term name or a vector of term names.
#' @param to Same format as the `from` argument.
#' @param terms A vector of term names. If it is set, the returned vector will be subsetted to the terms that have been set here.
#' @param background A vector of terms. Then the lookup will only be applied in this set of terms.
#' 
#' @details
#' If `from` or `to` is a vector, for a specific, the longest/shortest distance among all `from`/`to` terms is taken.
#' 
#' As a special case, when `from` is the root term, `dag_longest_dist_to_offspring()` is the same as `dag_depth()`,
#' and when `to` are all leaf terms, `dag_longest_dist_to_offspring()` is the same as `dag_height()`.
#' 
#' @return An integer vector having length the same as the number of terms in the DAG. If terms are not
#'        reachable to the `from` or `to` terms, the corresponding value is -1.
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' dag_longest_dist_from_ancestors(dag, "e")
#' dag_shortest_dist_from_ancestors(dag, "e")
#' dag_longest_dist_to_offspring(dag, "b")
dag_longest_dist_to_offspring = function(dag, from, terms = NULL, background = NULL) {
	.dag_singular_dist(dag, from, terms, background, dist_type = "longest", towards = "offspring")
}

#' @rdname dag_longest_dist_to_offspring
#' @export
dag_shortest_dist_to_offspring = function(dag, from, terms = NULL, background = NULL) {
	.dag_singular_dist(dag, from, terms, background, dist_type = "shortest", towards = "offspring")
}

#' @rdname dag_longest_dist_to_offspring
#' @export
dag_longest_dist_from_ancestors = function(dag, to, terms = NULL, background = NULL) {
	.dag_singular_dist(dag, to, terms, background, dist_type = "longest", towards = "ancestors")
}

#' @rdname dag_longest_dist_to_offspring
#' @export
dag_shortest_dist_from_ancestors = function(dag, to, terms = NULL, background = NULL) {
	.dag_singular_dist(dag, to, terms, background, dist_type = "shortest", towards = "ancestors")
}

#####

#' Distinct ancestors of a list of terms
#' 
#' For a given list of terms, it returns a subset of terms which have
#' no ancestor relations to each other.
#' 
#' @param dag An `ontology_DAG` object.
#' @param terms A vector of term names.
#' @param in_labels Whether the terms are represented in their names or as integer indices?
#' @param verbose Whether to print messages.
#' 
#' Consider a subgraph that contains `terms` and their offspring terms, induced from the complete DAG.
#' the returned subset of terms are those with zero in-degree, or have no finite directional distance
#' from others in the subgraph.
#' 
#' @return An integer vector or a character vector depending on the value of `in_labels`.
#' @export
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' dag = create_ontology_DAG(parents, children)
#' dag_distinct_ancestors(dag, c("c", "d", "e", "f"))
dag_distinct_ancestors = function(dag, terms, in_labels = TRUE, verbose = simona_opt$verbose) {
	dist = shortest_distances_directed(dag, terms, verbose = verbose)

	ind = which(apply(dist, 2, function(x) all(x <= 0)))

	if(in_labels) {
		names(ind)
	} else {
		unname(ind)
	}
}


#' Test whether terms have offspring/ancestors relations
#' 
#' @param dag An `ontology_DAG` object.
#' @param offspring A vector of term names.
#' @param ancestors A vector of term names. At lease one of `offspring` and `ancestors` should have length of 1.
#' @param include_self Whether to also include the query term itself.
#' @export
#' @import fastmatch
#' @return A logical vector.
dag_is_offspring = function(dag, offspring, ancestors, include_self = TRUE) {
	if(length(offspring) == 1) {
		ancestors %fin% dag_ancestors(dag, offspring, include_self = include_self)
	} else if(length(ancestors) == 1) {
		offspring %fin% dag_offspring(dag, ancestors, include_self = include_self)
	} else if(length(offspring) > 1 && length(ancestors) > 1) {
		stop("At lease one of `offspring` and `ancestors` should have length of 1.")
	}
}

#' @rdname dag_is_offspring
#' @export
dag_is_ancestor = function(dag, ancestors, offspring, include_self = TRUE) {
	dag_is_offspring(dag, offspring, ancestors, include_self = include_self)
}

library(testthat)

## export all functions
if(!identical(topenv(), .GlobalEnv)) {
	pkg_env = asNamespace("simona")
	all_objs = ls(envir = pkg_env)
	for(obj in all_objs) {
		assign(obj, get(obj, envir = pkg_env, inherits = FALSE))
	}
}


#### test a small dag

#   b--d--f
#  / \
# a---c--e
# upstream -> downstream

parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")

dag = create_ontology_DAG(parents, children)

test_that("test transverse", {
	for(letter in c("a", "b", "c", "d", "e", "f")) {
		expect_true(all(dag_parents(dag, letter) %in% dag_ancestors(dag, letter)))
		expect_true(all(dag_children(dag, letter) %in% dag_offspring(dag, letter)))
	}
})


test_that("test dag_siblings", {
	expect_equal(dag_siblings(dag, "b"), "c")
	expect_equal(dag_siblings(dag, "c"), c("b", "d"))
	expect_error(dag_siblings(dag, c("b", "c")), "only be length of one")
})

dag = create_ontology_DAG_from_GO_db()

all_go_id = dag@terms
test_that("test transverse on GO DAG", {
	for(term in sample(all_go_id, 10)) {
		expect_true(all(dag_parents(dag, term) %in% dag_ancestors(dag, term)))
		expect_true(all(dag_children(dag, term) %in% dag_offspring(dag, term)))
	}
})


parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")

dag = create_ontology_DAG(parents, children)

test_that("test ancestor/offspring within background", {
	expect_equal(
		cpp_offspring_within_background(dag, 2, 1:4),
		intersect(cpp_offspring(dag, 2), 1:4)
	)

	expect_equal(
		cpp_ancestors_within_background(dag, 5, 2:5),
		intersect(cpp_ancestors(dag, 5), 2:5)
	)
})

test_that("test ancestor/offspring of groups", {
	expect_equal(
		cpp_ancestors_of_two_groups(dag, 1, 2, 2),
		integer(0)
	)
	expect_equal(
		cpp_ancestors_of_two_groups(dag, 1, 2, 1),
		1
	)
	expect_equal(
		cpp_ancestors_of_a_group(dag, 1),
		integer(0)
	)
	expect_equal(
		cpp_ancestors_of_a_group(dag, 3),
		c(1, 2)
	)
	expect_equal(
		cpp_offspring_of_a_group(dag, 6),
		integer(0)
	)
	expect_equal(
		cpp_offspring_of_a_group(dag, 4),
		6
	)
})

test_that("test cpp_is_reachable", {
	lm = cpp_is_reachable(dag, 1:6)
	expect_false(lm[4, 5])
	expect_true(lm[2, 3])

	lm = cpp_is_reachable(dag, 1:6, TRUE)
	expect_true(lm[2, 3])
	expect_false(lm[3, 2])
})


test_that("test topological sorting", {
	expect_equal(
		unname(dag_depth(dag)[dag@tpl_sorted]),
		unname(sort(dag_depth(dag)))
	)
})

test_that("test dag_depth", {
	expect_equal(
		unname(dag_depth(dag, use_cache = FALSE)),
		c(0, 1, 2, 2, 3, 3)
	)
})

test_that("test dag_height", {
	expect_equal(
		unname(dag_height(dag, use_cache = FALSE)),
		c(3, 2, 1, 1, 0, 0)
	)
})

test_that("test other distances", {
	expect_equal(
		unname(dag_shortest_dist_from_root(dag, use_cache = FALSE)),
		c(0, 1, 1, 2, 2, 3)
	)
	expect_equal(
		unname(dag_shortest_dist_to_leaves(dag, use_cache = FALSE)),
		c(2, 2, 1, 1, 0, 0)
	)

	expect_equal(
		unname(dag_longest_dist_to_offspring(dag, "b")),
		c(-1, 0, 1, 1, 2, 2)
	)

	expect_equal(
		dag_shortest_dist_to_offspring(dag, "a"),
		dag_shortest_dist_from_root(dag, use_cache = FALSE)
	)

	expect_equal(
		unname(dag_longest_dist_from_ancestors(dag, "e")),
		c(3, 2, 1, -1, 0, -1)
	)

	expect_equal(
		unname(dag_shortest_dist_from_ancestors(dag, "e")),
		c(2, 2, 1, -1, 0, -1)
	)
})

test_that("test n_children/n_parents/n_connected_leaves", {
	expect_equal(
		unname(n_offspring(dag)),
		c(5, 4, 1, 1, 0, 0)
	)
	expect_equal(
		unname(n_ancestors(dag)),
		c(0, 1, 2, 2, 3, 3)
	)
	expect_equal(
		unname(n_offspring(dag, include_self = TRUE)),
		c(5, 4, 1, 1, 0, 0) + 1
	)
	expect_equal(
		unname(n_ancestors(dag, include_self = TRUE)),
		c(0, 1, 2, 2, 3, 3) + 1
	)
	expect_equal(
		unname(n_connected_leaves(dag)),
		c(2, 2, 1, 1, 1, 1)
	)

	expect_equal(
		simona:::cpp_n_ancestors(dag_treelize(dag)),
		simona:::cpp_n_ancestors_on_tree(dag_treelize(dag))
	)

	expect_equal(
		simona:::cpp_n_offspring(dag_treelize(dag)),
		simona:::cpp_n_offspring_on_tree(dag_treelize(dag))
	)
})


tree = dag_treelize(dag)
test_that("test n_ancestors/n_offspring/n_connected_leaves on trees", {
	expect_equal(
		cpp_n_ancestors(tree),
		cpp_n_ancestors_on_tree(tree)
	)
	expect_equal(
		cpp_n_offspring(tree),
		cpp_n_offspring_on_tree(tree)
	)
	expect_equal(
		cpp_n_leaves(tree),
		cpp_n_leaves_on_tree(tree)
	)
})

test_that("test dag_distinct_ancestors", {
	expect_equal(
		dag_distinct_ancestors(dag, c("c", "d", "e", "f")), 
		c("c", "d")
	)
	expect_equal(
		dag_distinct_ancestors(dag, c("a", "b", "c", "d", "e", "f")), 
		c("a")
	)
})


test_that("test dag_is_offspring", {
	expect_equal(dag_is_ancestor(dag, "a", "c"), TRUE)
	expect_equal(dag_is_ancestor(dag, "a", "d"), TRUE)
	expect_equal(dag_is_ancestor(dag, "a", "a"), TRUE)
	expect_equal(dag_is_ancestor(dag, "a", "a", include_self = FALSE), FALSE)
	expect_equal(dag_is_ancestor(dag, "b", c("a", "b", "c", "d")), c(FALSE, TRUE, TRUE, TRUE))
	expect_equal(dag_is_ancestor(dag, c("a", "b", "c", "d"), "b"), c(TRUE, TRUE, FALSE, FALSE))

	expect_equal(dag_is_ancestor(dag, "a", "c"), dag_is_offspring(dag, "c", "a"))
	expect_equal(dag_is_ancestor(dag, "b", c("a", "b", "c", "d")), dag_is_offspring(dag, c("a", "b", "c", "d"), "b"))
	expect_equal(dag_is_ancestor(dag, c("a", "b", "c", "d"), "b"), dag_is_offspring(dag, "b", c("a", "b", "c", "d")))

	expect_error(dag_is_ancestor(dag, c("a", "b"), c("c", "d")))
	expect_error(dag_is_offspring(dag, c("a", "b"), c("c", "d")))

})

library(testthat)


#### test a small dag

#   b--d--f
#  / \
# a---c--e
# upstream -> downstream
annotation = list(
	"a" = 1:3,
	"b" = 3:4,
	"c" = 5,
	"d" = 7,
	"e" = 4:7,
	"f" = 8
)

parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")

dag = create_ontology_DAG(parents, children, 
	relations = c("is_a", "part_of", "is_a", "part_of", "is_a", "part_of"), 
	annotation = annotation)


IC_annotation = -c(log(8/8), log(6/8), log(4/8), log(2/8), log(4/8), log(1/8))
IC_annotation[1] = 0

test_that("test Sim_AIC_2014", {
	sw = 1/(1 + exp(-1/IC_annotation))
	sim = term_sim(dag, dag@terms, "Sim_AIC_2014")

	for(i in 1:10) {
		t = sample(dag@terms, 2)
		a1 = dag_ancestors(dag, t[1], in_labels = FALSE, include_self = TRUE)
		a2 = dag_ancestors(dag, t[2], in_labels = FALSE, include_self = TRUE)

		expect_equal(sim[t[1], t[2]], 2*sum(sw[intersect(a1, a2)])/(sum(sw[a1]) + sum(sw[a2])))
	}

})

### Sw:

#   | a      b       c    d    e   f
# -------------------------------------
# a | 1
# b | 0.7    1
# c | 0.6    0.7     1
# d | 0.42   0.6     x    1
# e | 0.42   0.49  0.7    x   1 
# f | 0.252  0.36    x  0.6   x    1

test_that("test Sim_Wang_2007", {
	m = cpp_sim_wang(dag, 1:6, c(0.7, 0.6))
	expect_equal(
		m[, 1],
		c(1, 1.7/2.7, 1.6/3.3, 1.42/3.02, 1.42/3.61, 1.252/3.212)
	)
	expect_equal(
		m[5, 6],
		(0.36+0.49+0.252+0.42)/(2.61+2.212)
	)

	m2 = Sim_Wang_2007(dag, letters[1:6], contribution_factor = c("is_a" = 0.7, "part_of" = 0.6), calc_by = "igraph")

	expect_equal(as.vector(m), as.vector(m2))

})


test_that("test Sim_Wang_edge_2012", {
	m = term_sim(dag, dag@terms, "Sim_Wang_edge_2012")

	for(i in 1:10) {
		t = sample(dag@terms, 2)
		lca = LCA_term(dag, t)[1,2]

		x1 = dag_depth(dag, lca)
		if(lca == t[1]) {
			x2 = dag_depth(dag, lca)
		} else {
			x2 = dag_depth(dag, lca) + longest_distances_via_LCA(dag, c(lca, t[1]))[2,1]
		}
		if(lca == t[2]) {
			x3 = dag_depth(dag, lca)
		} else {
			x3 = dag_depth(dag, lca) + longest_distances_via_LCA(dag, c(lca, t[2]))[2,1]
		}

		if(x1 == 0) {
			expect_equal(m[t[1], t[2]], 0)
		} else {
			expect_equal(m[t[1], t[2]], unname(x1^2/x2/x3))
		}
	}
})

test_that("test Sim_Zhong_2002", {
	m = term_sim(dag, dag@terms, "Sim_Zhong_2002", control = list(depth_via_LCA = FALSE))

	d = dag_depth(dag)

	for(i in 1:10) {
		t = sample(dag@terms, 2)
		lca = LCA_term(dag, t)[1,2]

		expect_equal(m[t[1], t[2]], unname(1 - ( 2^(-d[lca]) - 2^(-(1+d[t[1]])) - 2^(-(1+d[t[2]])) )))
	}

	m = term_sim(dag, dag@terms, "Sim_Zhong_2002", control = list(depth_via_LCA = TRUE))

	for(i in 1:10) {
		t = sample(dag@terms, 2)
		lca = LCA_term(dag, t)[1,2]

		x = 2^(-d[lca])
		if(lca == t[1]) {
			y = 1 - 2^(-(1 + 0)) - 
			        2^(-(1+longest_distances_directed(dag, c(lca, t[2]))[lca, t[2]]))
		} else if(lca == t[2]) {
			y = 1 - 2^(-(1+longest_distances_directed(dag, c(lca, t[1]))[lca, t[1]])) - 
			        2^(-(1 + 0))
		} else {
			y = 1 - 2^(-(1+longest_distances_directed(dag, c(lca, t[1]))[lca, t[1]])) - 
			        2^(-(1+longest_distances_directed(dag, c(lca, t[2]))[lca, t[2]]))
		}
		expect_equal(m[t[1], t[2]], unname(1 - x*y))
	}
})

test_that("test Sim_Shen_2010", {
	m = term_sim(dag, dag@terms, "Sim_Shen_2010")

	for(i in 1:10) {
		t = sample(dag@n_terms, 2)
		lca = LCA_term(dag, t, in_labels = FALSE)[1,2]
		path1 = cpp_tpl_shortest_path(dag, lca, t[1])
		path2 = cpp_tpl_shortest_path(dag, lca, t[2])
		
		expect_equal(m[t[1], t[2]], 1 - atan(sum(1/IC_annotation[union(path1, path2)]))/pi*2, tolerance = 1e-5)
	}	
})


test_that("test Sim_SSDD_2013", {
	m = term_sim(dag, dag@terms, "Sim_SSDD_2013")
	tot = totipotency(dag)

	for(i in 1:10) {
		t = sample(dag@n_terms, 2)
		lca = LCA_term(dag, t, in_labels = FALSE)[1,2]
		path1 = cpp_tpl_shortest_path(dag, lca, t[1])
		path2 = cpp_tpl_shortest_path(dag, lca, t[2])
		path = union(path1, path2)
		
		expect_equal(m[t[1], t[2]], 1 - atan(sum(tot[path]))/pi*2, tolerance = 1e-5)
	}
})

test_that("test Sim_XGraSM_2013", {
	m = term_sim(dag, dag@terms, "Sim_XGraSM_2013")
	ic = term_IC(dag, "IC_annotation")

	for(i in 1:10) {
		t = sample(dag@terms, 2)

		mica = MICA_term(dag, t, "IC_annotation")[2, 1]
		a = intersect(dag_ancestors(dag, t[1], include_self = TRUE),
			          dag_ancestors(dag, t[2], include_self = TRUE))
		v = ic[a]
		v = v[v > 0]
		if(length(v) > 0) {
			sim = mean(v)*2/(ic[t[1]] + ic[t[2]])
		} else {
			sim = 0
		}

		expect_equal(m[t[1], t[2]], unname(sim), tolerance = 1e-5)
	}
})



test_that("test Sim_EISI_2015", {
	m = term_sim(dag, dag@terms, "Sim_EISI_2015")
	ic = term_IC(dag, "IC_annotation")

	for(i in 1:10) {
		t = sample(dag@terms, 2)

		mica = MICA_term(dag, t, "IC_annotation")[2, 1]
		a1 = dag_ancestors(dag, t[1], include_self = TRUE)
		a2 = dag_ancestors(dag, t[2], include_self = TRUE)
		
		s = setdiff(union(a1, a2), intersect(a1, a2))
		a = intersect(a1, a2)
		l = sapply(a, function(x) {
			length(intersect(dag_children(dag, x), s)) > 0
		})
		a = a[l]
		v = ic[a]
		if(length(v) > 0) {
			sim = mean(v)*2/(ic[t[1]] + ic[t[2]])
		} else {
			sim = 0
		}

		expect_equal(m[t[1], t[2]], unname(sim), tolerance = 1e-5)
	}
})


test_that("test Sim_Ancestor", {
	m = term_sim(dag, dag@terms, "Sim_Ancestor")
	
	for(i in 1:10) {
		t = sample(dag@terms, 2)

		a1 = dag_ancestors(dag, t[1], include_self = TRUE)
		a2 = dag_ancestors(dag, t[2], include_self = TRUE)

		sim = length(intersect(a1, a2))/length(union(a1, a2))

		expect_equal(m[t[1], t[2]], unname(sim), tolerance = 1e-5)
	}
})

#' Enrichment analysis on offspring terms
#' 
#' The analysis task is to evaluate how significant a term includes `terms`. 
#' 
#' @param dag An `ontology_DAG` object.
#' @param terms A vector of term names.
#' @param min_hits Minimal number of terms in an offspring set.
#' @param min_offspring Minimal size of the offspring set.
#' 
#' @details
#' Given a list of terms in `terms`, the function tests whether they are enriched in a term's offspring terms.
#' The test is based on the hypergeometric distribution. In the following 2x2 contigency table, `S` is the set of `terms`,
#' for a term `t` in the DAG, `T` is the set of its offspring plus the `t` itself, the aim is to test whether `S` is over-represented
#' in `T`.
#' 
#' If there is a significant p-value, we can say the term `t` preferably includes terms in `term`.
#' 
#' ```
#' +----------+------+----------+-----+
#' |          | in S | not in S | all |
#' +----------+------+----------+-----+
#' | in T     |  x11 |    x12   | x10 |
#' | not in T |  x21 |    x22   | x20 |
#' +----------+------+----------+-----+
#' | all      |  x01 |    x02   |  x  |
#' +----------+------+----------+-----+
#' ``` 
#' 
#' @return A data frame with the following columns:
#' 
#' - `term`: Term names.
#' - `n_hits`: Number of terms in `terms` intersecting to `t`'s offspring terms. 
#' - `n_offspring`: Number of offspring terms of `t` (including `t` itself).
#' - `n_terms`: Number of terms in `term` intersecting to all terms in the DAG.
#' - `n_all`: Number of all terms in the DAG.
#' - `log2_fold_enrichment`: Defined as log2(observation/expected).
#' - `z_score`: Defined as (observed-expected)/sd.
#' - `p_value`: P-values from hypergeometric test.
#' - `p_adjust`: Adjusted p-values from the BH method.
#' 
#' The number of rows in the data frame is the same as the number of terms in the DAG.
#' 
#' @importFrom stats p.adjust phyper
#' @export
#' @examples
#' \dontrun{
#' dag = create_ontology_DAG_from_GO_db() 
#' terms = random_terms(dag, 100)
#' df = dag_enrich_on_offsprings(dag, terms)
#' }
#' 1
dag_enrich_on_offsprings = function(dag, terms, min_hits = 3, min_offspring = 10) {
	n = dag@n_terms
	ind = which(dag@terms %in% terms)
	m = length(ind)

	n_offspring = n_offspring(dag, include_self = TRUE)
	n_hits = cpp_n_offspring_with_intersect(dag, ind, include_self = TRUE)
	all_terms = dag@terms

	l = n_offspring >= min_offspring & n_hits >= min_hits
	n_offspring = n_offspring[l]
	n_hits = n_hits[l]
	all_terms = all_terms[l]

	p = phyper(n_hits-1, m, n - m, n_offspring, lower.tail = FALSE)
	padj = p.adjust(p, "BH")
	if("name" %in% colnames(mcols(dag))) {
		df = data.frame(term = all_terms, name = mcols(dag)[l, "name"],
			n_hits = n_hits, n_offspring = n_offspring, n_terms = m, n_all = n, 
			log2_fold_enrichment = log2(n_hits/(m*n_offspring/n)), 
			z_score = (n_hits - (m*n_offspring/n)) / sqrt(m*n_offspring/n * (n-n_offspring)/n * (n-m)/(n-1)),
			p_value = p, p_adjust = padj)
	} else {
		df = data.frame(term = all_terms, n_hits = n_hits, n_offspring = n_offspring, n_terms = m, n_all = n, 
			log2_fold_enrichment = log2(n_hits/(m*n_offspring/n)), 
			z_score = (n_hits - (m*n_offspring/n)) / sqrt(m*n_offspring/n * (n-n_offspring)/n * (n-m)/(n-1)),
			p_value = p, p_adjust = padj)
	}
	df$depth = dag_depth(dag, all_terms)
	df
}

#' Enrichment analysis on offspring terms by permutation test
#' 
#' @param dag An `ontology_DAG` object.
#' @param value A numeric value. The value should correspond to terms in `dag@terms`.
#' @param min_offspring Minimal size of the offspring set.
#' @param perm Number of permutations.
#' @param verbose Whether to print messages.
#' 
#' @details
#' In the function [`dag_enrich_on_offsprings()`], the statistic for testing is the number of terms in each category. Here
#' this funtion makes the testing procedure more general
#' 
#' The function tests whether a term `t`'s offspring terms have an over-represented pattern on values in `value`.
#' Denote `T` as the set of `t`'s offspring terms plus `t` itself, and `v` as the numeric vector of `value`, we first
#' calculate a score `s` based on values in `T`:
#' 
#' ```
#' s = mean_{terms in T}(v)
#' ```
#' 
#' To construct a random version of `s`, we randomly sample `n_T` terms from the DAG where `n_T` is the size of set `T`:
#' 
#' ```
#' sr_i = mean_{n_T randomly sampled terms}(v)
#' ```
#' 
#' where index `i` represents the i^th sampling. If we sample `k` times, the p-value is calculated as:
#' 
#' ```
#' p = sum_{i in 1..k}(I(sr_i > s))/k
#' ```
#' 
#' @return A data frame with the following columns:
#' 
#' - `term`: Term names.
#' - `stats`: The statistics of terms.
#' - `n_offspring`: Number of offspring terms of `t` (including `t` itself).
#' - `log2_fold_enrichment`: defined as `log2(s/mean)` where `mean` is calculated from random permutation.
#' - `z_score`: Defined as `(s - mean)/sd` where `mean` and `sd` are calculated from random permutation.
#' - `p_value`: P-values from permutation test.
#' - `p_adjust`: Adjusted p-values from the BH method.
#' 
#' The number of rows in the data frame is the same as the number of terms in the DAG.
#' 
#' @importFrom stats sd
#' @examples
#' \dontrun{
#' dag = create_ontology_DAG_from_GO_db() 
#' value = runif(dag_n_terms(dag)) # a set of random values
#' df = dag_enrich_on_offsprings_by_permutation(dag, value)
#' }
#' 1
dag_enrich_on_offsprings_by_permutation = function(dag, value, perm = 1000, min_offspring = 10, verbose = simona_opt$verbose) {
	n = dag@n_terms

	if(length(value) != n) {
		stop("Length of `value` should be the same as the total number of terms.")
	}

	n_offspring = n_offspring(dag)
	s = exec_under_message_condition({
		cpp_offspring_aggregate(dag, value)
	}, verbose = verbose)
	all_terms = dag@terms

	l = n_offspring >= min_offspring
	n_offspring = n_offspring[l]
	s = s[l]
	all_terms = all_terms[l]

	sr = exec_under_message_condition({
		cpp_random_aggregatioin(n_offspring, value, perm)  # columns are permutations
	}, verbose = verbose)

	p = vapply(seq_len(nrow(sr)), function(i) sum(sr[i, ] > s[i])/perm, FUN.VALUE = numeric(1))
	padj = p.adjust(p, "BH")
	z = vapply(seq_len(nrow(sr)), function(i) (s[i] - mean(sr[i, ]))/sd(sr[i, ]), FUN.VALUE = numeric(1))
	log2fe = vapply(seq_len(nrow(sr)), function(i) log2(s[i]/mean(sr[i, ])), FUN.VALUE = numeric(1))

	if("name" %in% colnames(mcols(dag))) {
		df = data.frame(term = all_terms, name = mcols(dag)[l, "name"],
			stat = s, n_offspring = unname(n_offspring), 
			log2_fold_enrichment = log2fe, z_score = z, 
			p_value = p, p_adjust = padj)
	} else {
		df = data.frame(term = all_terms, stat = s, n_offspring = unname(n_offspring), 
			log2_fold_enrichment = log2fe, z_score = z, 
			p_value = p, p_adjust = padj)
	}
	df$depth = dag_depth(dag, all_terms)
	df
}

#' Enrichment analysis on the number of annotated items
#' 
#' The analysis task is to evaluate which terms the given items are enriched to.
#' 
#' @param dag An `ontology_DAG` object.
#' @param items A vector of item names.
#' @param min_hits Minimal number of items in the term set.
#' @param min_items Minimal size of the term set.
#' 
#' @details
#' The function tests whether the list of items are enriched in terms on the DAG.
#' The test is based on the hypergeometric distribution. In the following 2x2 contigency table, `S` is the set of `items`,
#' for a term `t` in the DAG, `T` is the set of items annotated to `t` (by automatically merging from its offspring terms), 
#' the aim is to test whether `S` is over-represented in `T`.
#' 
#' The universal set `all` correspond to the full set of items annotated to the DAG.
#' 
#' ```
#' +----------+------+----------+-----+
#' |          | in S | not in S | all |
#' +----------+------+----------+-----+
#' | in T     |  x11 |    x12   | x10 |
#' | not in T |  x21 |    x22   | x20 |
#' +----------+------+----------+-----+
#' | all      |  x01 |    x02   |  x  |
#' +----------+------+----------+-----+
#' ``` 
#' 
#' @return A data frame with the following columns:
#' 
#' - `term`: Term names.
#' - `n_hits`: Number of items in `items` intersecting to `t`'s annotated items.
#' - `n_anno`: Number of annotated items of `t`. Specifically for `dag_enrich_on_genes()`, this column
#'             is renamed to `n_gs`.
#' - `n_items`: Number of items in `items` intersecting to all annotated items in the DAG. Specifically
#'             for `dag_enrich_on_genes()`, this column is renamed to `n_genes`.
#' - `n_all`: Number of all annotated items in the DAG.
#' - `log2_fold_enrichment`: Defined as log2(observation/expected).
#' - `z_score`: Defined as (observed-expected)/sd.
#' - `p_value`: P-values from hypergeometric test.
#' - `p_adjust`: Adjusted p-values from the BH method.
#' 
#' The number of rows in the data frame is the same as the number of terms in the DAG.
#' 
#' @export
#' @examples
#' \dontrun{
#' dag = create_ontology_DAG_from_GO_db(org_db = "org.Hs.eg.db") 
#' items = random_items(dag, 1000)
#' df = dag_enrich_on_items(dag, items)
#' }
#' 1
dag_enrich_on_items = function(dag, items, min_hits = 5, min_items = 10) {
	validate_dag_has_annotation(dag)

	n = length(dag@annotation$names)
	ind = which(dag@annotation$names %in% items)
	m = length(ind)

	n_anno = n_annotations(dag, uniquify = TRUE)
	n_hits = cpp_n_annotations_with_intersect(dag, ind)
	all_terms = dag@terms

	l = n_anno >= min_items & n_hits >= min_hits
	n_anno = n_anno[l]
	n_hits = n_hits[l]
	all_terms = all_terms[l]

	p = phyper(n_hits-1, m, n - m, n_anno, lower.tail = FALSE)
	padj = p.adjust(p, "BH")
	if("name" %in% colnames(mcols(dag))) {
		df = data.frame(term = all_terms, name = mcols(dag)[l, "name"],
			n_hits = n_hits, n_anno = n_anno, n_items = m, n_all = n, 
			log2_fold_enrichment = log2(n_hits/(m*n_anno/n)), 
			z_score = (n_hits - (m*n_anno/n)) / sqrt(m*n_anno/n * (n-n_anno)/n * (n-m)/(n-1)),
			p_value = p, p_adjust = padj)
	} else {
		df = data.frame(term = all_terms, n_hits = n_hits, n_anno = n_anno, n_items = m, n_all = n, 
			log2_fold_enrichment = log2(n_hits/(m*n_anno/n)), 
			z_score = (n_hits - (m*n_anno/n)) / sqrt(m*n_anno/n * (n-n_anno)/n * (n-m)/(n-1)),
			p_value = p, p_adjust = padj)
	}
	df$depth = dag_depth(dag, all_terms)
	df
}

#' @param genes A vector of gene IDs. The gene ID type can be found by directly printing the `ontology_DAG` object.
#' @param min_genes Minimal number of genes.
#' 
#' @details
#' `dag_enrich_on_genes()` is the same as `dag_enrich_on_items()` which only changes the argument `item` to `gene`.
#' 
#' @rdname dag_enrich_on_items
#' @export
dag_enrich_on_genes = function(dag, genes, min_hits = 5, min_genes = 10) {
	df = dag_enrich_on_items(dag, genes, min_hits = min_hits, min_items = min_genes)
	colnames(df)[colnames(df) == "n_items"]  = "n_genes"
	colnames(df)[colnames(df) == "n_anno"]  = "n_gs"
	df
}

#' Randomly sample terms/items
#' 
#' @param dag An `ontology_DAG` object.
#' @param n Number of terms or items.
#' 
#' @export
#' @returns A character vector of terms or items.
#' @examples
#' parents  = c("a", "a", "b", "b", "c", "d")
#' children = c("b", "c", "c", "d", "e", "f")
#' annotation = list(
#'     "a" = c("t1", "t2", "t3"),
#'     "b" = c("t3", "t4"),
#'     "c" = "t5",
#'     "d" = "t7",
#'     "e" = c("t4", "t5", "t6", "t7"),
#'     "f" = "t8"
#' )
#' dag = create_ontology_DAG(parents, children, annotation = annotation)
#' random_terms(dag, 3)
#' random_items(dag, 3)
random_terms = function(dag, n) {
	if(n > dag@n_terms) {
		stop("`n` should not be larger than the total number of terms in the DAG.")
	}
	sample(dag@terms, n)
}

#' @rdname random_terms
#' @export
random_items = function(dag, n) {
	n_anno = length(dag@annotation$names)
	if(n_anno == 0) {
		stop("annotation has not been set in the DAG.")
	}
	if(n > n_anno) {
		stop("`n` should not be larger than the total number of annotated items in the DAG.")
	}
	sample(dag@annotation$names, n)
}

library(shiny)
library(simona)
library(ComplexHeatmap)
library(InteractiveComplexHeatmap)
library(DiagrammeR)
library(GetoptLong)

HAS_MCOL = !is.null(mcols(dag))
HAS_NAME_COLUMN = if(HAS_MCOL) "name" %in% colnames(mcols(dag)) else FALSE


ui = fluidPage(
	title = "ontology_DAG browser",
	tags$style(HTML("
body {
	width: 1000px;
}
ul.term_list {
	list-style: circle;
	padding-left:15px;
}
#traverse h4 {
	text-align:center;
}
.box {
	float:left;
	border:1px solid #CCCCCC;
	border-radius:4px;
	padding:4px 8px;
	margin-right:20px;
}
.tab-content {
	margin-top:20px;
}
		")),
	h3("ontology_DAG browser"),
	tabsetPanel(
		tabPanel("Summary", 
			div(
				verbatimTextOutput("print_object"),
				plotOutput("summary", width = "1000px", height = "333px")
			)
		),
		tabPanel("Circular Vis",
			plotOutput("circular_plot", width = "900px", height = "700px")
		),
		tabPanel("Traverse", div(
				id = "traverse",
				textInput("term_search", "Term", value = random_terms(dag, 1)),
				actionButton("term_search_submit", "Submit", onclick="$('#term_search_div').show();"),
				div(id = "term_search_div",
					div(
						div(h4("Parent terms"),
							htmlOutput("traverse_parents"),
							class = "box",
							style="width:300px;height:400px;overflow:scroll;"),
						div(h4("Sibling terms"),
							htmlOutput("traverse_siblings"),
							class = "box",
							style="width:300px;height:400px;overflow:scroll;"),
						div(h4("Child terms"),
							htmlOutput("traverse_children"),
							class = "box",
							style="width:300px;height:400px;overflow:scroll;"),
						div(style="clear:both"),
						style = "margin-top:20px;"
					),
					tags$hr(),
					div(
						div(h4("Information"),
							tableOutput("traverse_term_table"), 
							class = "box",
							style="width:300px;"),
						div(h4("Upstream DAG"),
							grVizOutput("traverse_term_diagram", width = "100%", height = "550px"), 
							class = "box",
							style="width:600px;height:600px;"),
						div(style="clear:both")
					),
					style = "display:none;"
				)
			)
		),
		tabPanel("Similarity", 
			div(
				textAreaInput("term_list", "Terms", value = paste(random_terms(dag, min(400, dag_n_terms(dag))), collapse = "\n"), height = 200),
				actionButton("term_list_submit", "Submit", onclick="$('#similarity_div').show();"),
				div(id="similarity_div",
					tabsetPanel(
						tabPanel("Heatmap", 
							InteractiveComplexHeatmapOutput("similarity_heatmap")
						),
						tabPanel("Circular Vis", 
							plotOutput("circular_plot_highlight", width = "900px", height = "700px")
						)
					),
					style = "margin-top:20px;display:none;"
				)
			)
		),
		tabPanel("Common ancestors",
			div(
				textInput("term1_ca", "Term 1", value = random_terms(dag, 1)),
				textInput("term2_ca", "Term 2", value = random_terms(dag, 1)),
				actionButton("term_ca_submit", "Submit"),
				grVizOutput("term_ca_diagram", width = "600px", height = "600px")
			)
		)
	),

	hr(),
	HTML(qq('<p>Generated by <a href="https://bioconductor.org/packages/simona/" target="_blank">simona @{installed.packages()["simona", "Version"]}</a>.</p>')),
)

server = function(input, output, session) {
	output$print_object = renderPrint({
		print(dag)
	})

	output$circular_plot = renderPlot({
		showNotification("Generating circular vis...", duration = 5)
		dag_circular_viz(dag, partition_by_size = round(dag_n_terms(dag)/5))
	})

	output$summary = renderPlot({
		np = n_parents(dag)
		nc = n_children(dag)
		dp = dag_depth(dag)

		par(mfrow = c(1, 3))
		barplot(table(np), xlab = "Numbers of parents", ylab = "Counts")
		barplot(table(nc), xlab = "Numbers of children", ylab = "Counts")
		barplot(table(dp), xlab = "Depths", ylab = "Counts")
	})

	as_li = function(term_id, x = term_id, text = "") {
		if(length(term_id) == 0) {
			html = text
		} else {
			html = qq("<li><a style='color:#337ab7;text-decoration:underline;cursor:pointer;' onclick='Shiny.onInputChange(\"traverse_term\", \"@{term_id}\")'>@{x}</a></li>\n")
			html = paste0("<ul class='term_list'>\n", html, "\n</ul>")
		}
		HTML(html)
	}

	update_travese = function(dag, term) {

		if(!dag_has_terms(dag, term)) {
			throw_error(qq("Term '@{term}' does not exist in the ontology."))
			return(NULL)
		}

		updateTextInput(inputId = "term_search", value = term)

		parents = dag_parents(dag, term)
		parents = setdiff(parents, term)

		siblings = dag_siblings(dag, term)
		siblings = c(term, siblings)

		children = dag_children(dag, term)
		children = setdiff(children, term)

		if(HAS_NAME_COLUMN) {
			mc = mcols(dag)
			parent_names = mc[parents, "name"]
			sibling_names = mc[siblings, "name"]
			child_names = mc[children, "name"]
		} else {
			parent_names = parents
			sibling_names = siblings
			child_names = children
		}

		output$traverse_parents = renderUI({
			as_li(parents, parent_names, "Already root, no parent.")
		})
		output$traverse_siblings = renderUI({
			sibling_names[1] = paste0("<b>", sibling_names[1], "</b>")
			as_li(siblings, sibling_names)
		})
		output$traverse_children = renderUI({
			as_li(children, child_names, "Already leaf, no child.")
		})

		output$traverse_term_table = renderTable({
			tb = mcols(dag)
			if(is.null(tb)) {
				tb = data.frame(id = term)
			} else {
				tb = tb[term, ,drop = FALSE]
			}

			tb = t(tb)
			tb[is.na(tb)] = ""
			tb
		}, rownames = TRUE, colnames = FALSE)

		output$traverse_term_diagram = renderGrViz({
			dag_graphviz(dag[, term], node_param = list(fillcolor = structure(names = term, "red"), style = "filled"), width = 600, height = 600)
		})
	}

	observeEvent(input$term_search_submit, {
		term = input$term_search
		update_travese(dag, term)
	})

	observeEvent(input$traverse_term, {
		term = input$traverse_term
		update_travese(dag, term)
	})

	observeEvent(input$term_list_submit, {
		showNotification("Generating heatmap...", duration = 5)
		
		terms = strsplit(input$term_list, "\\s+")[[1]]

		terms = terms[dag_has_terms(dag, terms)]

		if(length(terms) < 2) {
			throw_error(qq("Terms do not exist in the ontology."))
		}

		sim = term_sim(dag, terms)
		ht = Heatmap(sim, name = "Similarity", show_row_names = FALSE, show_column_names = FALSE,
			show_row_dend = FALSE, show_column_dend = FALSE)
		makeInteractiveComplexHeatmap(input, output, session, ht, "similarity_heatmap")

		output$circular_plot_highlight = renderPlot({
			showNotification("Generating circular vis...", duration = 5)
			dag_circular_viz(dag, highlight = terms, partition_by_size = round(dag_n_terms(dag)/5))
		})
		
	})

	observeEvent(input$term_ca_submit, {
		if(input$term1_ca != "" && input$term2_ca != "") {
			term1 = input$term1_ca
			term2 = input$term2_ca

			if(!dag_has_terms(dag, term1)) {
				throw_error(qq("Term '@{term1}' does not exist in the ontology."))
				return(NULL)
			}

			if(!dag_has_terms(dag, term2)) {
				throw_error(qq("Term '@{term2}' does not exist in the ontology."))
				return(NULL)
			}

			a1 = dag_ancestors(dag, term1, include_self = TRUE)
			a2 = dag_ancestors(dag, term2, include_self = TRUE)
			aa = union(a1, a2)
			ca = intersect(a1, a2)
				
			fillcolor = structure(names = ca, rep("lightblue", length(ca)))
			fillcolor[term1] = "red"
			fillcolor[term2] = "red"
			node_param = list(fillcolor = fillcolor, style = "filled")
			output$term_ca_diagram = renderGrViz({
				dag_graphviz(dag_filter(dag, terms = aa), node_param = node_param, width = 600, height = 600)
			})
		}
	})
}

throw_error = function(message) {
	showModal(modalDialog(
        title = "error",
        p(message, style = "color:red;"),
        easyClose = FALSE,
        size = "m"
    ))
}


shinyApp(ui, server)

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructor.R
\name{add_annotation}
\alias{add_annotation}
\title{Add annotations to the DAG object}
\usage{
add_annotation(dag, annotation)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{annotation}{A list of character vectors which contain items annotated to the terms. Names of the list should be the term names. In the DAG, items
annotated to a term will also be annotated to its parents. Such merging
is applied automatically in the package.}
}
\value{
An \code{ontology_DAG} object.
}
\description{
Add annotations to the DAG object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transverse.R
\name{dag_longest_dist_to_offspring}
\alias{dag_longest_dist_to_offspring}
\alias{dag_shortest_dist_to_offspring}
\alias{dag_longest_dist_from_ancestors}
\alias{dag_shortest_dist_from_ancestors}
\title{Distance from all ancestors/to all offspring in the DAG}
\usage{
dag_longest_dist_to_offspring(dag, from, terms = NULL, background = NULL)

dag_shortest_dist_to_offspring(dag, from, terms = NULL, background = NULL)

dag_longest_dist_from_ancestors(dag, to, terms = NULL, background = NULL)

dag_shortest_dist_from_ancestors(dag, to, terms = NULL, background = NULL)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{from}{A single term name or a vector of term names.}

\item{terms}{A vector of term names. If it is set, the returned vector will be subsetted to the terms that have been set here.}

\item{background}{A vector of terms. Then the lookup will only be applied in this set of terms.}

\item{to}{Same format as the \code{from} argument.}
}
\value{
An integer vector having length the same as the number of terms in the DAG. If terms are not
reachable to the \code{from} or \code{to} terms, the corresponding value is -1.
}
\description{
Distance from all ancestors/to all offspring in the DAG
}
\details{
If \code{from} or \code{to} is a vector, for a specific, the longest/shortest distance among all \code{from}/\code{to} terms is taken.

As a special case, when \code{from} is the root term, \code{dag_longest_dist_to_offspring()} is the same as \code{dag_depth()},
and when \code{to} are all leaf terms, \code{dag_longest_dist_to_offspring()} is the same as \code{dag_height()}.
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
dag_longest_dist_from_ancestors(dag, "e")
dag_shortest_dist_from_ancestors(dag, "e")
dag_longest_dist_to_offspring(dag, "b")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructor.R
\name{dag_as_igraph}
\alias{dag_as_igraph}
\title{Convert to an igraph object}
\usage{
dag_as_igraph(dag)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}
}
\value{
An \code{\link[igraph:aaa-igraph-package]{igraph::igraph}} object.
}
\description{
Convert to an igraph object
}
\details{
If \code{relations} is already set in \code{\link[=create_ontology_DAG]{create_ontology_DAG()}}, relations are also set as an edge attribute in the \code{\link[igraph:aaa-igraph-package]{igraph::igraph}} object.
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
dag_as_igraph(dag)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructor.R
\name{dag_has_terms}
\alias{dag_has_terms}
\title{Whether the terms exist in the DAG}
\usage{
dag_has_terms(dag, terms)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{terms}{A vector of term IDs.}
}
\value{
A logical vector.
}
\description{
Whether the terms exist in the DAG
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructor.R
\docType{class}
\name{ontology_DAG-class}
\alias{ontology_DAG-class}
\alias{ontology_DAG}
\title{The ontology_DAG class}
\value{
An \code{ontology_DAG} object.
}
\description{
This class defines the DAG structure of an ontology.
}
\section{Slots}{

\describe{
\item{\code{terms}}{A character vector of length \code{n} of all term names. Other slots that store term-level information use the integer indices of terms.}

\item{\code{n_terms}}{An integer scalar of the total number of terms in the DAG.}

\item{\code{n_relations}}{An integer scalar of the total number of relations in the DAG.}

\item{\code{lt_parents}}{A list of length \code{n}. Each element in the list is an integer index vector of the parent terms of the i^th term.}

\item{\code{lt_children}}{A list of length \code{n}. Each element in the list is an integer index vector of the child terms of the i^th term.}

\item{\code{lt_children_relations}}{A list of length \code{n}. Each element is a vector of the semantic relations between the i^th term and its child terms, e.g. a child "is_a" parent.
The relations are represented as integers. The character name of the relations is in \code{attr(dag@lt_children_relations, "levels")}.}

\item{\code{relations_DAG}}{A simple \code{ontology_DAG} object but constructed for relation types.}

\item{\code{source}}{The source of the ontology. A character scalar only used as a mark of the returned object.}

\item{\code{root}}{An integer scalar of the root term.}

\item{\code{leaves}}{An integer vector of the indicies of leaf terms.}

\item{\code{alternative_terms}}{A named character vector of mappings between alternative terms to DAG terms.}

\item{\code{tpl_sorted}}{An integer vector of reordered term indices which has been topologically sorted in the DAG. Terms are sorted first by the depth (maximal
distance from root), then the number of child terms, then the number of parent terms, and last the term names.}

\item{\code{tpl_pos}}{The position of the original term in the topologically sorted path (similar as the rank), e.g. the value of the first element in the vector
is the position of term 1 in the topologically sorted path.}

\item{\code{annotation}}{A list of two elements: \code{list} and \code{names}. The \code{dag@annotation$list} element contains a list of length \code{n} and each element
is a vector of integer indices of annotated items. The full list of annotated items is in \code{dag@annotation$names}.}

\item{\code{term_env}}{An environment which contains various term-level statistics. It is mainly for cache purpose.}

\item{\code{aspect_ratio}}{A numeric vector of length two. The aspect ratio is calculated as \code{w/h}. For each term, there is a distance to root,
\code{h} is the maximal distance of all terms, \code{w} is the maximal number of items with the same distance. The two values in the \code{aspect_ratio} slot
use maximal distance to root (the height) and the shortest distance to root as the distance measure.}

\item{\code{elementMetadata}}{An additional data frame with the same number of rows as the number of terms in DAG. Order of rows should be the same as order of terms in \code{dag@terms}.}
}}

\examples{
1
# This function should not be used directly.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methods.R
\name{term_IC}
\alias{term_IC}
\title{Information content}
\usage{
term_IC(
  dag,
  method,
  terms = NULL,
  control = list(),
  verbose = simona_opt$verbose
)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{method}{An IC method. All available methods are in \code{\link[=all_term_IC_methods]{all_term_IC_methods()}}.}

\item{terms}{A vector of term names. If it is set, the returned vector will be subsetted to the terms that have been set here.}

\item{control}{A list of parameters passing to individual methods. See the subsections.}

\item{verbose}{Whether to print messages.}
}
\value{
A numeric vector.
}
\description{
Information content
}
\section{Methods}{

\subsection{IC_offspring}{

Denote \code{k} as the number of offspring terms plus the term itself and \code{N} is such value for root (or the total number of terms in the DAG), the information
content is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{IC = -log(k/N)
}\if{html}{\out{</div>}}
}


\subsection{IC_height}{

For a term \code{t} in the DAG, denote \code{d} as the maximal distance from root (i.e. the depth) and \code{h} as the maximal distance to leaves (i.e. the height),
the relative position \code{p} on the longest path from root to leaves via term \code{t} is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{p = (h + 1)/(h + d + 1)
}\if{html}{\out{</div>}}

In the formula where 1 is added gets rid of \code{p = 0}. Then the information content is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{IC = -log(p) 
   = -log((h+1)/(h+d+1))
}\if{html}{\out{</div>}}
}


\subsection{IC_annotation}{

Denote \code{k} as the number of items annotated to a term \code{t}, and \code{N} is the number of items annotated to the root (which is
the total number of items annotated to the DAG), IC for term \code{t} is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{IC = -log(k/N)
}\if{html}{\out{</div>}}

In current implementations in other tools, there is an inconsistency of defining \code{k} and \code{N}.
Please see \code{\link[=n_annotations]{n_annotations()}} for explanation.

\code{NA} is assigned to terms with no item annotated.
}


\subsection{IC_universal}{

It measures the probability of a term getting full transmission from the root. Each term is associated with a p-value and the root has
the p-value of 1.

For example, an intermediate term \code{t} has two parent terms \code{parent1} and \code{parent2}, also assume \code{parent1} has \code{k1} children
and \code{parent2} has \code{k2} children, assume a parent transmits information equally to all its children, then respectively \code{parent1} only transmits \code{1/k1} and
\code{parent2} only transmits \code{1/k2} of its content to term \code{t}, or the probability of a parent to reach \code{t} is \code{1/k1} or \code{1/k2}.
Let's say \code{p1} and \code{p2} are the accumulated contents from the root to \code{parnet1} and \code{parent2} respectively (or the probability
of the two parent terms getting full transmission from root), then the probability of reaching \code{t} via a full transmission graph from \code{parent1}
is the multiplication of \code{p1} and \code{1/k1}, which is \code{p1/k1}, and same for \code{p2/k2}. Then, for term \code{t}, if getting transmitted from \code{parent1} and
\code{parent2} are independent, the probability of \code{t} (denoted as \code{p_t}) to get transmitted from both parents is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{p_t = (p1/k1) * (p2/k2)
}\if{html}{\out{</div>}}

Since the two parents are the full set of \code{t}'s parents, \code{p_t} is the probability of \code{t} getting full transmission from root. And the final
information content is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{IC = -log(p_t)
}\if{html}{\out{</div>}}

Paper link: \doi{10.1155/2012/975783}.
}


\subsection{IC_Zhang_2006}{

It measures the number of ways from a term to reach leaf terms. E.g. in the following DAG:

\if{html}{\out{<div class="sourceCode">}}\preformatted{     a      upstream
    /|\\
   b | c
     |/
     d      downstream
}\if{html}{\out{</div>}}

term \code{a} has three ways to reach leaf, which are \code{a->b}, \code{a->d} and \code{a->c->d}.

Let's denote \code{k} as the number of ways for term \code{t} to reach leaves and \code{N} as the maximal value of \code{k} which
is associated to the root term, the information content is calculated as

\if{html}{\out{<div class="sourceCode">}}\preformatted{IC = -log(k/N) 
   = log(N) - log(k)
}\if{html}{\out{</div>}}

Paper link: \doi{10.1186/1471-2105-7-135}.
}


\subsection{IC_Seco_2004}{

It is based on the number of offspring terms of term \code{t}.
The information content is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{IC = 1 - log(k+1)/log(N)
}\if{html}{\out{</div>}}

where \code{k} is the number of offspring terms of \code{t}, or you can think \code{k+1} is the number of \code{t}'s offspring terms plus itself.
\code{N} is the total number of terms on the DAG.

Paper link: \doi{10.5555/3000001.3000272}.
}


\subsection{IC_Zhou_2008}{

It is a correction of \emph{IC_Seco_2004} which considers the depth of a term in the DAG.
The information content is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{IC = 0.5*IC_Seco + 0.5*log(depth)/log(max_depth)
}\if{html}{\out{</div>}}

where \code{depth} is the depth of term \code{t} in the DAG, defined as the maximal distance from root. \code{max_depth} is the largest depth in the DAG.
So IC is composed with two parts: the numbers of offspring terms and positions in the DAG.

Paper link: \doi{10.1109/FGCNS.2008.16}.
}


\subsection{IC_Seddiqui_2010}{

It is also a correction to \emph{IC_Seco_2004}, but considers number of relations connecting a term (i.e. number of parent terms and child terms).
The information content is defined as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{(1-sigma)*IC_Seco + sigma*log((n_parents + n_children + 1)/log((total_edges + 1))
}\if{html}{\out{</div>}}

where \code{n_parents} and \code{n_children} are the numbers of parents and children of term \code{t}. The tuning factor \code{sigma} is defined as

\if{html}{\out{<div class="sourceCode">}}\preformatted{sigma = log(total_edges+1)/(log(total_edges) + log(total_terms))
}\if{html}{\out{</div>}}

where \code{total_edges} is the number of all relations (all parent-child relations)
and \code{total_terms} is the number of all terms in the DAG.

Paper link: \doi{10.5555/1862330.1862343}.
}


\subsection{IC_Sanchez_2011}{

It measures the average contribution of term \code{t} on leaf terms. First denote \code{zeta} as the number of leaf terms that
can be reached from term \code{t} (or \code{t}'s offspring that are leaves.). Since all \code{t}'s ancestors can also
reach \code{t}'s leaves, the contribution of \code{t} on leaf terms is scaled by \code{n_ancestors} which is the number of \code{t}'s ancestor terms.
The final information content is normalized by the total number of leaves in the DAG, which is the possible maximal value of \code{zeta}.
The complete definition of information content is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{IC = -log( (zeta/n_ancestor) / n_all_leaves)
}\if{html}{\out{</div>}}

Paper link: \doi{10.1016/j.knosys.2010.10.001}.
}


\subsection{IC_Meng_2012}{

It has a complex form which takes account of the term depth and the downstream of the term.
The first factor is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{f1 = log(depth)/long(max_depth)
}\if{html}{\out{</div>}}

The second factor is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{f1 = 1 - log(1 + sum_\{x => t's offspring\}(1/depth_x))/log(total_terms)
}\if{html}{\out{</div>}}

In the equation, the summation goes over \code{t}'s offspring terms.

The final information content is the multiplication of \code{f1} and \code{f2}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{IC = f1 * f2
}\if{html}{\out{</div>}}

Paper link: \url{http://article.nadiapub.com/IJGDC/vol5_no3/6.pdf}.

There is one parameter \code{correct}. If it is set to \code{TRUE}, the first factor \code{f1} is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{f1 = log(depth + 1)/long(max_depth + 1)
}\if{html}{\out{</div>}}

\code{correct} can be set as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_IC(dag, method = "IC_Meng_2012", control = list(correct = TRUE))
}\if{html}{\out{</div>}}
}


\subsection{IC_Wang_2007}{

Each relation is weighted by a value less than 1 based on the semantic relation, i.e. 0.8 for "is_a" and 0.6 for "part_of".
For a term \code{t} and one of its ancestor term \code{a}, it first calculates an "S-value" which corresponds to a path from \code{a} to \code{t} where
the accumulated multiplication of weights along the path reaches maximal:

\if{html}{\out{<div class="sourceCode">}}\preformatted{S(a->t) = max_\{path\}(prod_\{node on the paty\}(w))
}\if{html}{\out{</div>}}

Here \code{max} goes over all possible paths from \code{a} to \code{t}, and \code{prod()} multiplies edge weights in a certain path.

The formula can be transformed as (we simply rewrite \code{S(a->t)} to \code{S}):

\if{html}{\out{<div class="sourceCode">}}\preformatted{1/S = min(prod(1/w))
log(1/S) = log(min(prod(1/w)))
         = min(sum(log(1/w)))
}\if{html}{\out{</div>}}

Since \code{w < 1}, \code{log(1/w)} is positive. According to the equation, the path (\code{a->...->t}) is actually the shortest path from \code{a} to \code{t} by taking
\code{log(1/w)} as the weight, and \code{log(1/S)} is the weighted shortest distance.

If \code{S(a->t)} can be thought as the maximal semantic contribution from \code{a} to \code{t}, the information content is calculated
as the sum from all \code{t}'s ancestors (including \code{t} itself):

\if{html}{\out{<div class="sourceCode">}}\preformatted{IC = sum_\{a in t's ancestors + t\}(S(a->t))
}\if{html}{\out{</div>}}

Paper link: \doi{10.1093/bioinformatics/btm087}.

The contribution of different semantic relations can be set with the \code{contribution_factor} parameter. The value should be a named numeric
vector where names should cover the relations defined in \code{relations} set in \code{\link[=create_ontology_DAG]{create_ontology_DAG()}}. For example, if there are two relations
"relation_a" and "relation_b" set in the DAG, the value for \code{contribution_factor} can be set as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_IC(dag, method = "IC_Wang", 
    control = list(contribution_factor = c("relation_a" = 0.8, "relation_b" = 0.6)))
}\if{html}{\out{</div>}}

Note the \strong{IC_Wang_2007} method is normally used within the \strong{Sim_Wang_2007} semantic similarity method.
}
}

\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
annotation = list(
    "a" = c("t1", "t2", "t3"),
    "b" = c("t3", "t4"),
    "c" = "t5",
    "d" = "t7",
    "e" = c("t4", "t5", "t6", "t7"),
    "f" = "t8"
)
dag = create_ontology_DAG(parents, children, annotation = annotation)
term_IC(dag, "IC_annotation")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructor.R
\name{create_ontology_DAG_from_igraph}
\alias{create_ontology_DAG_from_igraph}
\title{Create the ontology_DAG object from the igraph object}
\usage{
create_ontology_DAG_from_igraph(
  g,
  relations = NULL,
  verbose = simona_opt$verbose
)
}
\arguments{
\item{g}{An \code{\link[igraph:aaa-igraph-package]{igraph::igraph}} object.}

\item{relations}{A vector of relation types. The length of the vector should be the same as the number of edges in \code{g}.}

\item{verbose}{Whether to print messages.}
}
\value{
An \code{ontology_DAG} object.
}
\description{
Create the ontology_DAG object from the igraph object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructor.R
\name{show,ontology_DAG-method}
\alias{show,ontology_DAG-method}
\title{Print the ontology_DAG object}
\usage{
\S4method{show}{ontology_DAG}(object)
}
\arguments{
\item{object}{An \code{ontology_DAG} object.}
}
\value{
No value is returned.
}
\description{
Print the ontology_DAG object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transverse.R
\name{dag_distinct_ancestors}
\alias{dag_distinct_ancestors}
\title{Distinct ancestors of a list of terms}
\usage{
dag_distinct_ancestors(
  dag,
  terms,
  in_labels = TRUE,
  verbose = simona_opt$verbose
)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{terms}{A vector of term names.}

\item{in_labels}{Whether the terms are represented in their names or as integer indices?}

\item{verbose}{Whether to print messages.

Consider a subgraph that contains \code{terms} and their offspring terms, induced from the complete DAG.
the returned subset of terms are those with zero in-degree, or have no finite directional distance
from others in the subgraph.}
}
\value{
An integer vector or a character vector depending on the value of \code{in_labels}.
}
\description{
For a given list of terms, it returns a subset of terms which have
no ancestor relations to each other.
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
dag_distinct_ancestors(dag, c("c", "d", "e", "f"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrich.R
\name{dag_enrich_on_offsprings}
\alias{dag_enrich_on_offsprings}
\title{Enrichment analysis on offspring terms}
\usage{
dag_enrich_on_offsprings(dag, terms, min_hits = 3, min_offspring = 10)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{terms}{A vector of term names.}

\item{min_hits}{Minimal number of terms in an offspring set.}

\item{min_offspring}{Minimal size of the offspring set.}
}
\value{
A data frame with the following columns:
\itemize{
\item \code{term}: Term names.
\item \code{n_hits}: Number of terms in \code{terms} intersecting to \code{t}'s offspring terms.
\item \code{n_offspring}: Number of offspring terms of \code{t} (including \code{t} itself).
\item \code{n_terms}: Number of terms in \code{term} intersecting to all terms in the DAG.
\item \code{n_all}: Number of all terms in the DAG.
\item \code{log2_fold_enrichment}: Defined as log2(observation/expected).
\item \code{z_score}: Defined as (observed-expected)/sd.
\item \code{p_value}: P-values from hypergeometric test.
\item \code{p_adjust}: Adjusted p-values from the BH method.
}

The number of rows in the data frame is the same as the number of terms in the DAG.
}
\description{
The analysis task is to evaluate how significant a term includes \code{terms}.
}
\details{
Given a list of terms in \code{terms}, the function tests whether they are enriched in a term's offspring terms.
The test is based on the hypergeometric distribution. In the following 2x2 contigency table, \code{S} is the set of \code{terms},
for a term \code{t} in the DAG, \code{T} is the set of its offspring plus the \code{t} itself, the aim is to test whether \code{S} is over-represented
in \code{T}.

If there is a significant p-value, we can say the term \code{t} preferably includes terms in \code{term}.

\if{html}{\out{<div class="sourceCode">}}\preformatted{+----------+------+----------+-----+
|          | in S | not in S | all |
+----------+------+----------+-----+
| in T     |  x11 |    x12   | x10 |
| not in T |  x21 |    x22   | x20 |
+----------+------+----------+-----+
| all      |  x01 |    x02   |  x  |
+----------+------+----------+-----+
}\if{html}{\out{</div>}}
}
\examples{
\dontrun{
dag = create_ontology_DAG_from_GO_db() 
terms = random_terms(dag, 100)
df = dag_enrich_on_offsprings(dag, terms)
}
1
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{print.print_source}
\alias{print.print_source}
\title{Print the source}
\usage{
\method{print}{print_source}(x, ...)
}
\arguments{
\item{x}{An object in the \code{print_source} class.}

\item{...}{Other arguments.}
}
\description{
Print the source
}
\details{
Internally used.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/reorder.R
\name{dag_reorder}
\alias{dag_reorder}
\alias{dag_permutate_children}
\title{Reorder the DAG}
\usage{
dag_reorder(dag, value, verbose = simona_opt$verbose)

dag_permutate_children(dag, verbose = simona_opt$verbose)
}
\arguments{
\item{dag}{An \code{ontology_Dag} object.}

\item{value}{A vector of numeric values. See the \strong{Details} section.}

\item{verbose}{Whether to print messages.}
}
\value{
An \code{ontology_DAG} object.
}
\description{
Reorder the DAG
}
\details{
In \code{dag_reorder()}, there are two ways to set the \code{value} argument. It can be a vector corresponding
to all terms (in the same order as in \code{\link[=dag_all_terms]{dag_all_terms()}}) or a vector corresponding
to all leaf terms (in the same order as in \code{\link[=dag_leaves]{dag_leaves()}}). If \code{value} corresponds
to all terms, the score associates to each term is the average value of all its offspring terms.
And if \code{value} corresponds to all leaf terms, the score for each term is the average of all its
connectable leaves.

The reordering is simply applied on each term to reorder its child terms.

\code{dag_permutate_children()} randomly permute child terms under a term.
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
# by default, c and e locate on the left side, d and f locate on the right side
dag = create_ontology_DAG(parents, children)
dag_children(dag, "b")

# move c and e to the right side of the diagram
dag2 = dag_reorder(dag, value = c(1, 1, 10, 1, 10, 1))
dag_children(dag2, "b")

# we can also only set values for leaf terms
# there are two leaf terms c and e
# we let v(c) > v(e) to move c to the right side of the diagram
dag3 = dag_reorder(dag, value = c(10, 1))
dag_children(dag3, "b")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrich.R
\name{random_terms}
\alias{random_terms}
\alias{random_items}
\title{Randomly sample terms/items}
\usage{
random_terms(dag, n)

random_items(dag, n)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{n}{Number of terms or items.}
}
\value{
A character vector of terms or items.
}
\description{
Randomly sample terms/items
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
annotation = list(
    "a" = c("t1", "t2", "t3"),
    "b" = c("t3", "t4"),
    "c" = "t5",
    "d" = "t7",
    "e" = c("t4", "t5", "t6", "t7"),
    "f" = "t8"
)
dag = create_ontology_DAG(parents, children, annotation = annotation)
random_terms(dag, 3)
random_items(dag, 3)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/anno_gene.R
\name{ontology_kw}
\alias{ontology_kw}
\alias{ontology_chebi}
\alias{ontology_hp}
\alias{ontology_pw}
\alias{ontology_rdo}
\alias{ontology_vt}
\alias{ontology_go}
\alias{ontology_reactome}
\title{Import ontologies already having gene annotations}
\usage{
ontology_kw(
  organism = "human",
  gene_annotation = TRUE,
  verbose = simona_opt$verbose,
  ...
)

ontology_chebi(
  organism = c("human", "mouse", "rat", "pig", "dog"),
  gene_annotation = TRUE,
  verbose = simona_opt$verbose,
  ...
)

ontology_hp(
  organism = c("human", "mouse"),
  gene_annotation = TRUE,
  verbose = simona_opt$verbose,
  ...
)

ontology_pw(
  organism = c("human", "mouse", "rat", "pig", "dog", "chimpanzee"),
  gene_annotation = TRUE,
  verbose = simona_opt$verbose,
  ...
)

ontology_rdo(
  organism = c("human", "mouse", "rat", "pig", "dog", "chimpanzee"),
  gene_annotation = TRUE,
  verbose = simona_opt$verbose,
  ...
)

ontology_vt(
  organism = c("human", "mouse", "rat", "pig", "dog", "chimpanzee"),
  gene_annotation = TRUE,
  verbose = simona_opt$verbose,
  ...
)

ontology_go(...)

ontology_reactome(
  organism = "HSA",
  gene_annotation = TRUE,
  verbose = simona_opt$verbose,
  ...
)
}
\arguments{
\item{organism}{Organism.}

\item{gene_annotation}{Whether to add gene annotations to the DAG.}

\item{verbose}{Whether to print messages?}

\item{...}{Pass to \code{\link[=create_ontology_DAG]{create_ontology_DAG()}}.}
}
\description{
Import ontologies already having gene annotations
}
\details{
There are the following ontologies:
\itemize{
\item \code{ontology_kw()}: UniProt Keywords. The list of supported organisms can be found in \code{\link[UniProtKeywords:load_keyword_genesets]{UniProtKeywords::load_keyword_genesets()}}.
\item \code{ontology_chebi()}: Chemical Entities of Biological Interest.
\item \code{ontology_hp()}: The Human Phenotype Ontology.
\item \code{ontology_pw()}: Pathway Ontology.
\item \code{ontology_rdo()}: RGD Disease Ontology.
\item \code{ontology_vt()}: Vertebrate Trait Ontology.
}

The source of the original files can be found with \code{simona:::RGD_TB}.

\code{ontology_go()} is an alias of \code{\link[=create_ontology_DAG_from_GO_db]{create_ontology_DAG_from_GO_db()}}. All arguments go there.

Valid values for \code{organism} argument in \code{ontology_reactome()} are

\if{html}{\out{<div class="sourceCode">}}\preformatted{c("BTA", "CEL", "CFA", "DRE", "DDI", "DME", "GGA", "HSA", "MMU", 
  "MTU", "PFA", "RNO", "SCE", "SPO", "SSC", "XTR")
}\if{html}{\out{</div>}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filter.R
\name{dag_filter}
\alias{dag_filter}
\title{Filter the DAG}
\usage{
dag_filter(
  dag,
  terms = NULL,
  relations = NULL,
  root = NULL,
  leaves = NULL,
  mcols_filter = NULL,
  namespace = NULL
)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{terms}{A vector of term names. The sub-DAG will only contain these terms.}

\item{relations}{A vector of relations. The sub-DAG will only contain these relations.
Valid values of "relations" should correspond to the values set in the
\code{relations} argument in the \code{\link[=create_ontology_DAG]{create_ontology_DAG()}}. If \code{relations_DAG} is
already provided, offspring relation types will all be selected. Note "is_a"
is always included.}

\item{root}{A vector of term names which will be used as roots of the sub-DAG. Only
these with their offspring terms will be kept. If there are multiple root terms,
a super root will be automatically added.}

\item{leaves}{A vector of leaf terms. Only these with their ancestor terms will be kept.}

\item{mcols_filter}{Filtering on columns in the meta data frame.}

\item{namespace}{The prefix before ":" of the term IDs.}
}
\value{
An \code{ontology_DAG} object.
}
\description{
Filter the DAG
}
\details{
If the DAG is reduced into several disconnected parts after the filtering, a
super root is automatically added.
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
dag_filter(dag, terms = c("b", "d", "f"))
dag_filter(dag, root = "b")
dag_filter(dag, leaves = c("c", "b"))
dag_filter(dag, root = "b", leaves = "e")

\donttest{
dag = create_ontology_DAG_from_GO_db()
dag_filter(dag, relations = "is_a")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructor.R
\name{dag_all_terms}
\alias{dag_all_terms}
\alias{dag_n_terms}
\alias{dag_n_relations}
\alias{dag_n_leaves}
\title{Names of all terms}
\usage{
dag_all_terms(dag)

dag_n_terms(dag)

dag_n_relations(dag)

dag_n_leaves(dag)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}
}
\value{
\code{dag_all_terms()} returns a vector of term names. \code{dag_n_terms()} returns
a single iteger.
}
\description{
Names of all terms
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
dag_all_terms(dag)
dag_n_terms(dag)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00_global.R
\name{method_param}
\alias{method_param}
\title{All Papameters of a given method}
\usage{
method_param(IC_method = NULL, term_sim_method = NULL, group_sim_method = NULL)
}
\arguments{
\item{IC_method}{A single IC method name.}

\item{term_sim_method}{A single term similarity method name.}

\item{group_sim_method}{A single group similarity method name.}
}
\value{
A vector of parameter names.
}
\description{
All Papameters of a given method
}
\examples{
method_param(IC_method = "IC_annotation")
method_param(term_sim_method = "Sim_Wang_2007")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filter.R
\name{[,ontology_DAG,ANY,ANY,missing-method}
\alias{[,ontology_DAG,ANY,ANY,missing-method}
\alias{[,ontology_DAG,ANY,ANY,ANY-method}
\alias{[,ontology_DAG,ANY,missing,missing-method}
\alias{[,ontology_DAG,ANY,missing,ANY-method}
\alias{[,ontology_DAG,missing,ANY,missing-method}
\alias{[,ontology_DAG,missing,ANY,ANY-method}
\alias{[,ontology_DAG,missing,missing,missing-method}
\alias{[,ontology_DAG,missing,missing,ANY-method}
\alias{[[,ontology_DAG,character,missing-method}
\title{Create sub-DAGs}
\usage{
\S4method{[}{ontology_DAG,ANY,ANY,missing}(x, i, j, ..., drop = FALSE)

\S4method{[}{ontology_DAG,ANY,ANY,ANY}(x, i, j, ..., drop = FALSE)

\S4method{[}{ontology_DAG,ANY,missing,missing}(x, i, j, ..., drop = FALSE)

\S4method{[}{ontology_DAG,ANY,missing,ANY}(x, i, j, ..., drop = FALSE)

\S4method{[}{ontology_DAG,missing,ANY,missing}(x, i, j, ..., drop = FALSE)

\S4method{[}{ontology_DAG,missing,ANY,ANY}(x, i, j, ..., drop = FALSE)

\S4method{[}{ontology_DAG,missing,missing,missing}(x, i, j, ..., drop = FALSE)

\S4method{[}{ontology_DAG,missing,missing,ANY}(x, i, j, ..., drop = FALSE)

\S4method{[[}{ontology_DAG,character,missing}(x, i, j, ...)
}
\arguments{
\item{x}{An \code{ontology_DAG} object.}

\item{i}{A single term name. The value should be a character vector. It corresponds to the roots.}

\item{j}{A single term name. The value should be a character vector. It corresponds to the leaves.}

\item{...}{Ignored.}

\item{drop}{Ignored.}
}
\value{
An \code{ontology_DAG} object.
}
\description{
Create sub-DAGs
}
\details{
It returns a sub-DAG taking node \code{i} as the root and \code{j} as the leaves. If \code{i} is a vector, a super root will be added.
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
dag["b"]
dag[["b"]]
dag["b", "f"]
dag[, "f"]
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methods.R
\name{group_sim}
\alias{group_sim}
\title{Semantic similarity between two groups of terms}
\usage{
group_sim(
  dag,
  group1,
  group2,
  method,
  control = list(),
  verbose = simona_opt$verbose
)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{group1}{A vector of term names or a list of term vectors.}

\item{group2}{A vector of term names or a list of term vectors..}

\item{method}{A group similarity method. All available methods are in \code{\link[=all_group_sim_methods]{all_group_sim_methods()}}.}

\item{control}{A list of parameters passing to individual methods. The term similarity method is controlled by \code{term_sim_method}
and the IC method is controlled by \code{IC_method}. Other term similarity related parameters can also be specified in \code{control}. See the subsections.}

\item{verbose}{Whether to print messages.}
}
\value{
A numeric scalar, a numeric vector or a matrix depending on the dat type of \code{group1} and \code{group2}.
}
\description{
Semantic similarity between two groups of terms
}
\details{
If \code{annotation} is set in \code{create_ontology_DAG()} and you want to directly calculate semantic similarity between two
annotated items, you can first get the associated terms of the two items by \code{\link[=annotated_terms]{annotated_terms()}}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group1 = annotated_terms(dag, item1)[[1]]
group2 = annotated_terms(dag, item2)[[1]]
group_sim(dag, group1, group2, ...)
}\if{html}{\out{</div>}}
}
\section{Methods}{



\subsection{GroupSim_pairwise_avg}{

Denote \code{S(a, b)} as the semantic similarity between terms \code{a} and \code{b} where \code{a} is from \code{group1} and \code{b} is from \code{group2},
The similarity between \code{group1} and \code{group2} is the average similarity of every pair of individual terms in the two groups:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = mean_\{a in group1, b in group2\}(S(a, b))
}\if{html}{\out{</div>}}

The term semantic similarity method and the IC method can be set via \code{control} argument:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim(dag, group1, group2, method = "GroupSim_pairwise_avg"
    control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
}\if{html}{\out{</div>}}

Other parameters for the \code{term_sim_method} can also be set in the \code{control} list.

Pape link: \doi{10.1093/bioinformatics/btg153}.
}


\subsection{GroupSim_pairwise_max}{

This is the maximal \code{S(a, b)} among all pairs of terms in \code{group1} and \code{group2}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = max_\{a in group1, b in group2\}(S(a, b))
}\if{html}{\out{</div>}}

The term semantic similarity method and the IC method can be set via \code{control} argument:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim(dag, group1, group2, method = "GroupSim_pairwise_max"
    control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
}\if{html}{\out{</div>}}

Other parameters for the \code{term_sim_method} can also be set in the \code{control} list.

Paper link: \doi{10.1109/TCBB.2005.50}.
}


\subsection{GroupSim_pairwise_BMA}{

BMA stands for "best-match average". First define similarity of a term to a group of terms as

\if{html}{\out{<div class="sourceCode">}}\preformatted{S(x, group) = max_\{y in group\}(x, y)
}\if{html}{\out{</div>}}

which is the most similar terms in \code{group} to \code{x}.

Then the BMA similarity is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = 0.5*(mean_\{a in group1\}(S(a, group2)) + mean_\{b in group2\}(S(b, group1)))
}\if{html}{\out{</div>}}

So it is the average of the similarity of every term in \code{group1} to the whole \code{group2} and every term in \code{group2} to the whole \code{group1}.

The term semantic similarity method and the IC method can be set via \code{control} argument:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim(dag, group1, group2, method = "GroupSim_pairwise_BMA"
    control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
}\if{html}{\out{</div>}}

Other parameters for the \code{term_sim_method} can also be set in the \code{control} list.

Paper link: \doi{10.1155/2012/975783}.
}


\subsection{GroupSim_pairwise_BMM}{

BMM stands for "best-match max". It is defined as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = max(mean_\{a in group1\}(S(a, group2)), mean_\{b in group2\}(S(b, group1)))
}\if{html}{\out{</div>}}

The term semantic similarity method and the IC method can be set via \code{control} argument:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim(dag, group1, group2, method = "GroupSim_pairwise_BMM"
    control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
}\if{html}{\out{</div>}}

Other parameters for the \code{term_sim_method} can also be set in the \code{control} list.

Paper link: \doi{10.1186/1471-2105-7-302}.
}


\subsection{GroupSim_pairwise_ABM}{

ABM stands for "average best-match". It is defined as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = (sum_\{a in group1\}(S(a, group2)) + sum_\{b in group2\}(S(b, group1)))/(n1 + n2)
}\if{html}{\out{</div>}}

where \code{n1} and \code{n2} are the number of terms in \code{group1} and \code{group2}.

The term semantic similarity method and the IC method can be set via \code{control} argument:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim(dag, group1, group2, method = "GroupSim_pairwise_ABM"
    control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
}\if{html}{\out{</div>}}

Other parameters for the \code{term_sim_method} can also be set in the \code{control} list.

Paper link: \doi{10.1186/1471-2105-14-284}.
}


\subsection{GroupSim_pairwise_HDF}{

First define the distance of a term to a group of terms:

\if{html}{\out{<div class="sourceCode">}}\preformatted{D(x, group) = 1 - S(x, group)
}\if{html}{\out{</div>}}

Then the Hausdorff distance between two groups are:

\if{html}{\out{<div class="sourceCode">}}\preformatted{HDF = max(max_\{a in group1\}(D(a, group2)), max_\{b in group2\}(D(b, group1)))
}\if{html}{\out{</div>}}

This final similarity is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = 1 - HDF
}\if{html}{\out{</div>}}

The term semantic similarity method and the IC method can be set via \code{control} argument:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim(dag, group1, group2, method = "GroupSim_pairwise_HDF"
    control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
}\if{html}{\out{</div>}}

Other parameters for the \code{term_sim_method} can also be set in the \code{control} list.
}


\subsection{GroupSim_pairwise_MHDF}{

Instead of using the maximal distance from a group to the other group, MHDF uses mean distance:

\if{html}{\out{<div class="sourceCode">}}\preformatted{MHDF = max(mean_\{a in group1\}(D(a, group2)), mean_\{b in group2\}(D(b, group1)))
}\if{html}{\out{</div>}}

This final similarity is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = 1 - MHDF
}\if{html}{\out{</div>}}

The term semantic similarity method and the IC method can be set via \code{control} argument:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim(dag, group1, group2, method = "GroupSim_pairwise_MHDF"
    control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
}\if{html}{\out{</div>}}

Other parameters for the \code{term_sim_method} can also be set in the \code{control} list.

Paper link: \doi{10.1109/ICPR.1994.576361}.
}


\subsection{GroupSim_pairwise_VHDF}{

It is defined as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{VHDF = 0.5*(sqrt(mean_\{a in group1\}(D(a, group2)^2)) + sqrt(mean_\{b in group2\}(D(b, group1)^2)))
group_sim = 1 - VHDF
}\if{html}{\out{</div>}}

The term semantic similarity method and the IC method can be set via \code{control} argument:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim(dag, group1, group2, method = "GroupSim_pairwise_VHDF"
    control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
}\if{html}{\out{</div>}}

Other parameters for the \code{term_sim_method} can also be set in the \code{control} list.

Paper link: \doi{10.1073/pnas.0702965104}.
}


\subsection{GroupSim_pairwise_Froehlich_2007}{

The similarity is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = exp(-HDF(group1, group2))
}\if{html}{\out{</div>}}

The term semantic similarity method and the IC method can be set via \code{control} argument:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim(dag, group1, group2, method = "GroupSim_pairwise_Froehlich_2007"
    control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
}\if{html}{\out{</div>}}

Other parameters for the \code{term_sim_method} can also be set in the \code{control} list.

Paper link: \doi{10.1186/1471-2105-8-166}.
}


\subsection{GroupSim_pairwise_Joeng_2014}{

Similar to \emph{VHDF}, but it directly uses the similarity:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = 0.5*(sqrt(mean_\{a in group1\}(S(a, group2)^2)) + sqrt(mean_\{b in group2\}(S(b, group1)^2)))
}\if{html}{\out{</div>}}

The term semantic similarity method and the IC method can be set via \code{control} argument:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim(dag, group1, group2, method = "GroupSim_pairwise_Joeng_2014"
    control = list(term_sim_method = "Sim_Lin_1998", IC_method = "IC_annotation")`.
}\if{html}{\out{</div>}}

Other parameters for the \code{term_sim_method} can also be set in the \code{control} list.

Paper link: \doi{10.1109/TCBB.2014.2343963}.
}


\subsection{GroupSim_SimALN}{

It is based on the average distances between every pair of terms in the two groups:

\if{html}{\out{<div class="sourceCode">}}\preformatted{exp(-mean_\{a in group1, b in group2\}(d(a, b)))
}\if{html}{\out{</div>}}

\code{d(a, b)} is the distance between \code{a} and \code{b}, which can be the shortest distance between the two terms or
the longest distnace via LCA.

There is a parameter \code{distance} which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim(dag, group1, group2, method = "GroupSim_SimALN",
    control = list(distance = "shortest_distances_via_NCA"))
}\if{html}{\out{</div>}}

Paper link: \doi{10.1109/ISCC.2008.4625763}.
}


\subsection{GroupSim_SimGIC}{

Denote \code{A} and \code{B} as the two sets of ancestors terms of terms in \code{group1} and \code{group2} respectively,
the SimGIC is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = sum_\{x in intersect(A, B)\}(IC(x))/sum_\{x in union(A, B)\}(IC(x))
}\if{html}{\out{</div>}}

IC method can be set via \code{control = list(IC_method = ...)}.
}


\subsection{GroupSim_SimDIC}{

Similar as \emph{GroupSim_SimGIC}, it calculates the Dice coeffcient:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = 2*sum_\{x in intersect(A, B)\}(IC(x))/(sum_\{x in A\}(IC(x)) + sum_\{x in B\}(IC(x)))
}\if{html}{\out{</div>}}

IC method can be set via \code{control = list(IC_method = ...)}.
}


\subsection{GroupSim_SimUIC}{

Similar as \emph{GroupSim_SimGIC}, it is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = sum_\{x in intersect(A, B)\}(IC(x))/max(sum_\{x in A\}(IC(x)), sum_\{x in B\}(IC(x)))
}\if{html}{\out{</div>}}

IC method can be set via \code{control = list(IC_method = ...)}.
}


\subsection{GroupSim_SimUI}{

It is only based on the number of terms. \code{A} is the set of all ancestors of group1 terms and \code{B}
is the set of all ancestors of group2 terms.

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = length(intersect(A, B))/length(union(A, B))
}\if{html}{\out{</div>}}
}


\subsection{GroupSim_SimDB}{

It is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = 2*length(intersect(A, B))/(length(A) + length(B))
}\if{html}{\out{</div>}}
}


\subsection{GroupSim_SimUB}{

It is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = length(intersect(A, B))/max(length(A), length(B))
}\if{html}{\out{</div>}}
}


\subsection{GroupSim_SimNTO}{

It is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = length(intersect(A, B))/min(length(A), length(B))
}\if{html}{\out{</div>}}
}


\subsection{GroupSim_SimCOU}{

It is based on the dot product of two vectors \code{p} and \code{q} which correspond to terms in \code{group1} and \code{group2}.
\code{p} and \code{q} have the same length as the total number of terms. Value of position i in \code{p} or \code{q} corresponds to term \code{t}. The value
takes \code{IC(t)} if \code{t} is an ancestor of any term in \code{p} or \code{q}, and the value takes zero if \code{t} is not. The
similarity betweem \code{group1} terms and \code{group2} terms is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{<p,q>/||p||/||q||
}\if{html}{\out{</div>}}

where \verb{<p,q>} is the dot product between the two, and \verb{||p||} or \verb{||q||} is the norm of the vector.
The equation can be written as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = sum_\{x in intersect(A, B)\}(IC(x)^2) / 
              sqrt(sum_\{x in A\}(IC(x)^2)) / 
              sqrt(sum_\{x in B\}(IC(x)^2))
}\if{html}{\out{</div>}}

IC method can be set via \code{control = list(IC_method = ...)}.
}


\subsection{GroupSim_SimCOT}{

Similar as \emph{GroupSim_SimCOU}, the similarity is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{<p,q>/(||p||^2 + ||q||^2 - <p,q>)
}\if{html}{\out{</div>}}

And it can be rewritten as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = sum_\{x in intersect(A, B)\}(IC(x)^2) /
    (sum_\{x in A\}(IC(x)^2) + sum_\{x in B\}(IC(x)^2) - sum_\{x in intersect(A, B)\}(IC(x)^2))
}\if{html}{\out{</div>}}

IC method can be set via \code{control = list(IC_method = ...)}.
}


\subsection{GroupSim_SimLP}{

It is the longest depth for the terms in \code{intersect(A, B)}.

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = max(depth(intersect(A, B)))
}\if{html}{\out{</div>}}
}


\subsection{GroupSim_Ye_2005}{

It is a normalized version of \emph{GroupSim_SimLP}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = max(depth(intersect(A, B)))/max_depth
}\if{html}{\out{</div>}}

Since the minimal depth is zero for root.
}


\subsection{GroupSim_SimCHO}{

It is based on the annotated items. Denote \code{sigma(t)} as the total annotated items of \code{t}. The similarity is calculated as

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = log(C/sigma_max)/log(sigma_min/sigma_max)
}\if{html}{\out{</div>}}

where \code{C} is \verb{min(sigma_\{x in intersect(A, B)\}(x))}, i.e., the minimal sigma in the intersection of group1 and group2. Note
Now \code{A} and \code{B} are just two sets of terms in \code{group1} and \code{group2}.
\code{sigma_max} is the total number of items annotated to the DAG, \code{sig_min} is the minimal number of items annotated to a term, which
is mostly 1.
}


\subsection{GroupSim_SimALD}{

\code{A} and \code{B} are just two sets of terms in \code{group1} and \code{group2}. The similarity is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{group_sim = max_\{t in intersect(A, B)\}(1 - sigma(t)/N)
}\if{html}{\out{</div>}}
}


\subsection{GroupSim_Jaccard}{

Say \code{A} is the set of items annotated to terms in \code{group1} and \code{B} is the set of items annotated to \code{group2}.
This is the Jaccard coeffcient between two sets.

The universe/background can be set via \code{control = list(universe = ...)}.
}


\subsection{GroupSim_Dice}{

It is the Dice coeffcient between \code{A} and \code{B}.

The universe/background can be set via \code{control = list(universe = ...)}.
}


\subsection{GroupSim_Overlap}{

It is the Overlap coeffcient between \code{A} and \code{B}.

The universe/background can be set via \code{control = list(universe = ...)}.
}


\subsection{GroupSim_Kappa}{

The universe/background can be set via \code{control = list(universe = ...)}.
}
}

\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
annotation = list(
    "a" = c("t1", "t2", "t3"),
    "b" = c("t3", "t4"),
    "c" = "t5",
    "d" = "t7",
    "e" = c("t4", "t5", "t6", "t7"),
    "f" = "t8"
)
dag = create_ontology_DAG(parents, children, annotation = annotation)
group_sim(dag, c("c", "e"), c("d", "f"), 
    method = "GroupSim_pairwise_avg", 
    control = list(term_sim_method = "Sim_Lin_1998")
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{dag_circular_viz}
\alias{dag_circular_viz}
\alias{dag_as_DOT}
\alias{dag_graphviz}
\title{Visualize the DAG}
\usage{
dag_circular_viz(
  dag,
  highlight = NULL,
  start = 0,
  end = 360,
  partition_by_level = 1,
  partition_by_size = NULL,
  node_col = NULL,
  node_transparency = 0.4,
  node_size = NULL,
  edge_col = NULL,
  edge_transparency = default_edge_transparency(dag),
  legend_labels_from = NULL,
  legend_labels_max_width = 50,
  other_legends = list(),
  use_raster = dag_n_terms(dag) > 10000,
  newpage = TRUE,
  verbose = simona_opt$verbose
)

dag_as_DOT(
  dag,
  node_param = default_node_param,
  edge_param = default_edge_param,
  rankdir = c("TB", "LR", "BT", "RL")
)

dag_graphviz(
  dag,
  node_param = default_node_param,
  edge_param = default_edge_param,
  rankdir = "TB",
  ...
)
}
\arguments{
\item{dag}{An \code{ontology_Dag} object.}

\item{highlight}{A vector of terms to be highlighted on the DAG.}

\item{start}{Start of the circle, measured in degree.}

\item{end}{End of the circle, measured in degree.}

\item{partition_by_level}{If \code{node_col} is not set, users can cut the DAG into clusters with different node colors. The partitioning is applied by \code{\link[=partition_by_level]{partition_by_level()}}.}

\item{partition_by_size}{Similar as \code{partition_by_level}, but the partitioning is applied by \code{\link[=partition_by_size]{partition_by_size()}}.}

\item{node_col}{Colors of nodes. If the value is a vector, the order should correspond to terms in \code{\link[=dag_all_terms]{dag_all_terms()}}.}

\item{node_transparency}{Transparency of nodes. The same format as \code{node_col}.}

\item{node_size}{Size of nodes. The same format as \code{node_col}.}

\item{edge_col}{A named vector where names correspond to relation types.}

\item{edge_transparency}{A named vector where names correspond to relation types.}

\item{legend_labels_from}{If partitioning is applied on the DAG, a legend is generated showing different top
terms. By default, the legend labels are the term IDs. If there are additionally column stored
in the meta data frame of the DAG object, the column name can be set here to replace the term IDs as
legend labels.}

\item{legend_labels_max_width}{Maximal width of legend labels measured by the number of characters per line. Labels are wrapped into
multiple lines if the widths exceed it.}

\item{other_legends}{A list of legends generated by \code{\link[ComplexHeatmap:Legend]{ComplexHeatmap::Legend()}}.}

\item{use_raster}{Whether to first write the circular image into a temporary png file, then add to the plot
as a raster object?}

\item{newpage}{Whether call \code{\link[grid:grid.newpage]{grid::grid.newpage()}} to create a new plot?}

\item{verbose}{Whether to print messages.}

\item{node_param}{A list of parameters. Each parameter has the same format. The value can be
a single scalar, a full length vector with the same order as in \code{\link[=dag_all_terms]{dag_all_terms()}},
or a named vector that contains a subset of terms that need to be customized.
The full set of parameters can be found at \url{https://graphviz.org/docs/nodes/}.}

\item{edge_param}{A list of parameters. Each parameter has the same format. The value can be a single
scalar, or a named vector that contains a subset of terms that need to be customized.
The full set of parameters can be found at \url{https://graphviz.org/docs/edges/}.
If the parameter is set to a named vector, it can be named by relation types \code{c("is_a" = ...)},
or directly relations \code{c("a -> b" = ...)}. Please see the vignette for details.}

\item{rankdir}{The direction of the layout. Only four values are allowed: \code{"TB"}, \code{"LR"}, \code{"BT"} and \code{"RL"}.}

\item{...}{Pass to \code{\link[DiagrammeR:grViz]{DiagrammeR::grViz()}}.}
}
\value{
\code{dag_as_DOT()} returns a vector of DOT code.
}
\description{
Visualize the DAG
}
\details{
\code{dag_circular_viz()} uses a circular layout for visualizing large DAGs. \code{dag_graphviz()}
uses a hierarchical layout for visualizing small DAGs.

\code{dag_as_DOT()} generates the DOT code of the DAG.

\code{dag_graphviz()} visualizes the DAG with the \strong{DiagrammeR} package.
}
\examples{
\donttest{
dag = create_ontology_DAG_from_GO_db()
dag_circular_viz(dag)
}
1
if(interactive()) {
dag = create_ontology_DAG_from_GO_db()
dag_graphviz(dag[, "GO:0010228"])
dag_graphviz(dag[, "GO:0010228"], 
    edge_param = list(color = c("is_a" = "purple", "part_of" = "darkgreen"),
                      style = c("is_a" = "solid", "part_of" = "dashed")),
    width = 800, height = 800)

# the DOT code for graphviz
dag_as_DOT(dag[, "GO:0010228"])
}
}
\seealso{
\url{http://magjac.com/graphviz-visual-editor/} is nice place to try the DOT code.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/partition.R
\name{partition_by_level}
\alias{partition_by_level}
\alias{partition_by_size}
\title{Partition the DAG}
\usage{
partition_by_level(dag, level = 1, from = NULL, term_pos = NULL)

partition_by_size(dag, size = round(dag_n_terms(dag)/5))
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{level}{Depth in the DAG to cut. The DAG is cut below terms (or cut the links to their child terms) with \code{depth == level}.}

\item{from}{A list of terms to cut. If it is set, \code{level} is ignored.}

\item{term_pos}{Internally used.}

\item{size}{Number of terms in a cluster. The splitting stops on a term if all its child-trees are smaller than \code{size}.}
}
\value{
A character vector of top terms in each partition.
}
\description{
Partition the DAG
}
\details{
Let's call the terms below the \code{from} term as "top terms" because they will be on top of the sub-DAGs after the partitioning.
It is possible that a term in the middle of the DAG can be traced back to more than one top terms.
To partition all terms exclusively, a term partitioned to the sub-DAG from the top term with the largest distance to the term.
If a term has the same largest distances to several top terms, a random top term is selected.

In \code{partition_by_size()}, the DAG is first reduced to a tree where a child term only has one parent.
The partition is done recursively by cutting into its child-trees.
The splitting stops when all the child-trees have size less than \code{size}.

\code{NA} is assigned to the \code{from} terms, their ancestor terms, and terms having infinite directed distance to \code{from} terms.
}
\examples{
\donttest{
dag = create_ontology_DAG_from_GO_db()
pa = partition_by_level(dag)
table(pa)
pa = partition_by_size(dag, size = 1000)
table(pa)
}
1
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotation.R
\name{term_annotations}
\alias{term_annotations}
\alias{annotated_terms}
\title{Term-item associations}
\usage{
term_annotations(dag, terms, return = "list")

annotated_terms(dag, anno, return = "list")
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{terms}{A vector of term names.}

\item{return}{Whether the returned object is a list or a matrix?}

\item{anno}{A vector of annotated item names.}
}
\value{
A list or a binary matrix showing annotation relations between terms and items.
}
\description{
Term-item associations
}
\details{
If an item is annotated to a term, all this term's ancestor terms are also annotated.
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
annotation = list(
    "a" = c("t1", "t2", "t3"),
    "b" = c("t3", "t4"),
    "c" = "t5",
    "d" = "t7",
    "e" = c("t4", "t5", "t6", "t7"),
    "f" = "t8"
)
dag = create_ontology_DAG(parents, children, annotation = annotation)
term_annotations(dag, letters[1:6])
term_annotations(dag, letters[1:6], return = "matrix")
annotated_terms(dag, c("t1", "t2", "t3"))
annotated_terms(dag, c("t1", "t2", "t3"), return = "matrix")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tree.R
\name{dag_treelize}
\alias{dag_treelize}
\alias{dag_as_dendrogram}
\alias{print.ontology_tree}
\title{Reduce the DAG to a tree}
\usage{
dag_treelize(dag, verbose = simona_opt$verbose)

dag_as_dendrogram(dag)

\method{print}{ontology_tree}(x, ...)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{verbose}{Whether to print messages.}

\item{x}{An \code{ontology_DAG} object.}

\item{...}{Ignored.}
}
\value{
A tree is also an \code{ontology_DAG} object.
}
\description{
Reduce the DAG to a tree
}
\details{
A tree is a reduced DAG where a child only has one parent. The reducing is applied by a breadth-first searching

Starting from the root and on a certain depth (the depth is the maximal distance to root), for every term \code{t} on this depth,
its child term \code{c} and parent-child relation are kept only when \code{depth(c) == depth(t) + 1}. If \code{c} is selected, it is
marked as visited and will not be checked again.

In this way, depths of all terms in the orignal DAG are still identical to the depths in the tree (see the Examples section).

\code{dag_as_dendrogram()} coverts the tree to a \code{dendrogram} object.
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
tree = dag_treelize(dag)
d1 = dag_depth(dag)
d2 = dag_depth(tree)
identical(d1, d2)

dend = dag_as_dendrogram(tree)
dend
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/common_ancestor.R
\name{MICA_term}
\alias{MICA_term}
\alias{MICA_IC}
\alias{LCA_term}
\alias{LCA_depth}
\alias{NCA_term}
\alias{max_ancestor_v}
\alias{max_ancestor_id}
\alias{max_ancestor_path_sum}
\alias{CA_terms}
\title{Various types of common ancestors}
\usage{
MICA_term(
  dag,
  terms,
  IC_method,
  in_labels = TRUE,
  distance = "longest",
  verbose = simona_opt$verbose
)

MICA_IC(dag, terms, IC_method, verbose = simona_opt$verbose)

LCA_term(
  dag,
  terms,
  in_labels = TRUE,
  distance = "longest",
  verbose = simona_opt$verbose
)

LCA_depth(dag, terms, verbose = simona_opt$verbose)

NCA_term(dag, terms, in_labels = TRUE, verbose = simona_opt$verbose)

max_ancestor_v(dag, terms, value, verbose = simona_opt$verbose)

max_ancestor_id(
  dag,
  terms,
  value,
  in_labels = FALSE,
  distance = "longest",
  verbose = simona_opt$verbose
)

max_ancestor_path_sum(
  dag,
  terms,
  value,
  add_v,
  distance = "longest",
  verbose = simona_opt$verbose
)

CA_terms(dag, term1, term2, in_labels = TRUE)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{terms}{A vector of term names.}

\item{IC_method}{An IC method. Valid values are in \code{\link[=all_term_IC_methods]{all_term_IC_methods()}}.}

\item{in_labels}{Whether the terms are represented in their names or as integer indices?}

\item{distance}{If there are multiple LCA or MICA of two terms, whether to take the one with
the longest distance of shortest distance to the two terms. Possible values are "longest" and "shortest".}

\item{verbose}{Whether to print messages.}

\item{value}{A numeric vector. The elements should corrrespond to terms in \code{dag_all_terms()} (should have the same length as the number of terms in the DAG).}

\item{add_v}{Values to be added along the path to the MICA or LCA. The same format as \code{value}.}

\item{term1}{A single term ID.}

\item{term2}{A single term ID.}
}
\value{
\itemize{
\item \code{MICA_term()} returns an integer or a character matrix of the MICA terms depending on the value of \code{in_labels}.
\item \code{MICA_IC()} returns a numeric matrix of the IC of the MICA terms.
\item \code{LCA_term()} returns an integer or a character matrix of the LCA term depending on the value of \code{in_labels}.
\item \code{LCA_depth()} returns an integer matrix of the depth of the LCA terms.
\item \code{NCA_term()} returns an integer or a character matrix of the NCA term depending on the value of \code{in_labels}. The shortest distance from NCA terms can be calculated by \code{\link[=shortest_distances_via_NCA]{shortest_distances_via_NCA()}}.
\item \code{max_ancestor_v()} returns a numeric matrix.
\item \code{max_ancestor_id()} returns an integer or a character matrix.
\item \code{CA_terms()} returns a vector of term IDs.
}
}
\description{
Various types of common ancestors
}
\details{
There are the following three types of common ancestors:
\itemize{
\item MICA (most informative common ancestor): The common ancestor with the highest IC value.
\item LCA (lowest common ancestor): The common ancestor with the largest depth (The depth of a term is the maximal distance from the root term). If there are multiple ancestors having
the same max depth, the ancestor with the smallest distance to the two terms is used.
\item NCA (nearest common ancestor): The common ancestor with the smallest distance to the two terms. If there are multiple
ancestors with the same smallest distance, the ancestor with the largest depth is used.
}

\code{max_ancestor_v()} and \code{max_ancestor_id()} are more general functions which return common ancestors with
the highest value in \code{value}.

Given a path connecting two terms and their MICA/LCA, \code{max_ancestor_path_sum()} calculates the sum of terms along the path. The values
to be added in specified in \code{add_v} argument.
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
MICA_term(dag, letters[1:6], "IC_universal")
MICA_IC(dag, letters[1:6], "IC_universal")
LCA_term(dag, letters[1:6])
LCA_depth(dag, letters[1:6])
NCA_term(dag, letters[1:6])
CA_terms(dag, "c", "d")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrich.R
\name{dag_enrich_on_offsprings_by_permutation}
\alias{dag_enrich_on_offsprings_by_permutation}
\title{Enrichment analysis on offspring terms by permutation test}
\usage{
dag_enrich_on_offsprings_by_permutation(
  dag,
  value,
  perm = 1000,
  min_offspring = 10,
  verbose = simona_opt$verbose
)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{value}{A numeric value. The value should correspond to terms in \code{dag@terms}.}

\item{perm}{Number of permutations.}

\item{min_offspring}{Minimal size of the offspring set.}

\item{verbose}{Whether to print messages.}
}
\value{
A data frame with the following columns:
\itemize{
\item \code{term}: Term names.
\item \code{stats}: The statistics of terms.
\item \code{n_offspring}: Number of offspring terms of \code{t} (including \code{t} itself).
\item \code{log2_fold_enrichment}: defined as \code{log2(s/mean)} where \code{mean} is calculated from random permutation.
\item \code{z_score}: Defined as \code{(s - mean)/sd} where \code{mean} and \code{sd} are calculated from random permutation.
\item \code{p_value}: P-values from permutation test.
\item \code{p_adjust}: Adjusted p-values from the BH method.
}

The number of rows in the data frame is the same as the number of terms in the DAG.
}
\description{
Enrichment analysis on offspring terms by permutation test
}
\details{
In the function \code{\link[=dag_enrich_on_offsprings]{dag_enrich_on_offsprings()}}, the statistic for testing is the number of terms in each category. Here
this funtion makes the testing procedure more general

The function tests whether a term \code{t}'s offspring terms have an over-represented pattern on values in \code{value}.
Denote \code{T} as the set of \code{t}'s offspring terms plus \code{t} itself, and \code{v} as the numeric vector of \code{value}, we first
calculate a score \code{s} based on values in \code{T}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{s = mean_\{terms in T\}(v)
}\if{html}{\out{</div>}}

To construct a random version of \code{s}, we randomly sample \code{n_T} terms from the DAG where \code{n_T} is the size of set \code{T}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sr_i = mean_\{n_T randomly sampled terms\}(v)
}\if{html}{\out{</div>}}

where index \code{i} represents the i^th sampling. If we sample \code{k} times, the p-value is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{p = sum_\{i in 1..k\}(I(sr_i > s))/k
}\if{html}{\out{</div>}}
}
\examples{
\dontrun{
dag = create_ontology_DAG_from_GO_db() 
value = runif(dag_n_terms(dag)) # a set of random values
df = dag_enrich_on_offsprings_by_permutation(dag, value)
}
1
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00_global.R
\name{simona_opt}
\alias{simona_opt}
\title{Global options}
\usage{
simona_opt(..., RESET = FALSE, READ.ONLY = NULL, LOCAL = FALSE, ADD = FALSE)
}
\arguments{
\item{...}{Name-value pairs for options.}

\item{RESET}{Reset to default option values.}

\item{READ.ONLY}{Only return read only options.}

\item{LOCAL}{Only return local options.}

\item{ADD}{Add new options.}
}
\value{
A single option value.
}
\description{
Global options
}
\details{
There are the following global options:
\itemize{
\item \code{use_cache}: By default, information content of all terms is cached and reused. If \code{use_cache} is set to \code{FALSE}, IC will be re-calculated.
\item \code{verbose}: Whether to print messages?
\item \code{anno_uniquify}: In the annotation-based IC method, the union of items annotated to the term as well as all its offspring terms is used, which means
the set of annotated items for the term is uniquified. If \code{anno_uniquify} is set to \code{FALSE}, the uniquification is not applied, we simply add the number
of items annotated to the term and the numbers of items annotated to each of its offspring terms.
\item \code{robot_jar}: Path of the \code{robot.jar} file. The file can be found from \url{https://github.com/ontodev/robot/releases}.
}

To set an option, you can use \code{$}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{simona_opt$verbose = FALSE
}\if{html}{\out{</div>}}

or use it as a function:

\if{html}{\out{<div class="sourceCode">}}\preformatted{simona_opt(verbose = FALSE)
}\if{html}{\out{</div>}}
}
\examples{
simona_opt
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotation.R
\name{n_annotations}
\alias{n_annotations}
\alias{has_annotation}
\title{Number of annotated items}
\usage{
n_annotations(
  dag,
  terms = NULL,
  uniquify = simona_opt$anno_uniquify,
  use_cache = simona_opt$use_cache
)

has_annotation(dag)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{terms}{A vector of term names. If it is set, the returned vector will be subsetted to the terms that have been set here.}

\item{uniquify}{Whether to uniquify items that are annotated to the term? See \strong{Details}. It is suggested to always be \code{TRUE}.}

\item{use_cache}{Internally used.}
}
\value{
\code{n_annotations()} returns an integer vector.

\code{has_annotation()} returns a logical scalar.
}
\description{
Number of annotated items
}
\details{
Due to the nature of the DAG, a parent term includes all annotated items of its child terms, and an ancestor term includes
all annotated items from its offspring recursively. In current tools, there are two different implementations to deal with
such recursive merging.

For a term \code{t}, denote \code{S_1}, \code{S_2}, ... as the sets of annotated items for its child 1, 2, ..., also denote \code{S_t} as the set
of items that are \strong{directly} annotated to \code{t}. The first method takes the union of annotated items on \code{t} and all its child terms:

\if{html}{\out{<div class="sourceCode">}}\preformatted{n = length(union(S_t, S_1, S_2, ...))
}\if{html}{\out{</div>}}

And the second method takes the sum of numbers of items on \code{t} and on all its child terms:

\if{html}{\out{<div class="sourceCode">}}\preformatted{n = sum(length(s_t) + length(S_1) + length(S_2) + ...)
}\if{html}{\out{</div>}}

In \code{n_annotations()}, when \code{uniquify = TRUE}, the first method is used; and when \code{uniquify = FALSE}, the second method is used.

For some annotation sources, it is possible that an item is annotated to multiple terms, thus, the second method which simply
adds numbers of all its child terms may not be proper because an item may be counted duplicatedly, thus over-estimating \code{n}. The two methods
are identical only if an item is annotated to a unique term in the DAG.

We suggest to always set \code{uniquify = TRUE} (the default), and the scenario of \code{uniquify = FALSE} is only for the testing or benchmarking purpose.
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
annotation = list(
    "a" = c("t1", "t2", "t3"),
    "b" = c("t3", "t4"),
    "c" = "t5",
    "d" = "t7",
    "e" = c("t4", "t5", "t6", "t7"),
    "f" = "t8"
)
dag = create_ontology_DAG(parents, children, annotation = annotation)
n_annotations(dag)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transverse.R
\name{dag_parents}
\alias{dag_parents}
\alias{dag_children}
\alias{dag_siblings}
\alias{dag_ancestors}
\alias{dag_offspring}
\title{Parent/child/ancestor/offspring terms}
\usage{
dag_parents(dag, term, in_labels = TRUE)

dag_children(dag, term, in_labels = TRUE)

dag_siblings(dag, term, in_labels = TRUE)

dag_ancestors(dag, term, in_labels = TRUE, include_self = FALSE)

dag_offspring(dag, term, in_labels = TRUE, include_self = FALSE)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{term}{The value can be a vector of multiple term names. If it is a vector, it returns
union of the upstream/downstream terms of the selected set of terms. For \code{dag_siblings()},
the value can only be a single term.}

\item{in_labels}{Whether the terms are represented in their names or as integer indices?}

\item{include_self}{For \code{dag_offspring()} and \code{dag_ancestors()}, this controls whether to also include the query term itself.}
}
\value{
An integer vector or a character vector depending on the value of \code{in_labels}.
}
\description{
Parent/child/ancestor/offspring terms
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
dag_parents(dag, "b")
dag_parents(dag, "c", in_labels = FALSE)
dag_children(dag, "b")
dag_siblings(dag, "c")
dag_ancestors(dag, "e")
dag_ancestors(dag, "b")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/go.R
\name{create_ontology_DAG_from_GO_db}
\alias{create_ontology_DAG_from_GO_db}
\alias{alternative_GO_terms}
\title{Create the ontology_DAG object from the GO.db package}
\usage{
create_ontology_DAG_from_GO_db(
  namespace = "BP",
  relations = "part of",
  org_db = NULL,
  evidence_code = NULL,
  retrieve_alternative = FALSE,
  verbose = simona_opt$verbose
)

alternative_GO_terms(
  tag = c("replaced_by", "alt_id", "consider"),
  version = NULL,
  verbose = TRUE
)
}
\arguments{
\item{namespace}{One of "BP", "CC" and "MF".}

\item{relations}{Types of the GO term relations. In the \strong{GO.db} package, the GO term relations can be "is_a", "part_of",
"regulates", "negatively regulates", "positively regulates". Note since "regulates" is a parent relation
of "negatively regulates", "positively regulates", if "regulates" is selected, "negatively regulates" and "positively regulates"
are also selected. Note "is_a" is always included.}

\item{org_db}{The name of the organism package or the corresponding database object, e.g. \code{"org.Hs.eg.db"} or
directly the \code{\link[org.Hs.eg.db:org.Hs.egBASE]{org.Hs.eg.db::org.Hs.eg.db}} object for human, then the gene annotation to GO terms will be added
to the object. For other non-model organisms, consider to use the \strong{AnnotationHub} package to find one.}

\item{evidence_code}{A vector of evidence codes for gene annotation to GO terms. See \url{https://geneontology.org/docs/guide-go-evidence-codes/}.}

\item{retrieve_alternative}{Whether to retrieve alternative/obsolete GO terms from geneontology.org?}

\item{verbose}{Whether to print messages.}

\item{tag}{In the \code{go-basic.obo} file, there are three tags which define alternative GO terms: \code{replaced_by}, \code{alt_id} and \code{consider}.
See https://owlcollab.github.io/oboformat/doc/GO.format.obo-1_4.html#S.2.2.1}

\item{version}{Version of the \code{go-basic.obo} file. By default it is the version for building \strong{GO.db} package. The value is a string in the format of "2024-01-17".}
}
\value{
An \code{ontology_DAG} object.

A list of named vectors where names are alternative GO IDs and value vectors are current GO IDs in use.
}
\description{
Create the ontology_DAG object from the GO.db package

Mappings between alternative GO terms to official GO terms
}
\examples{
dag = create_ontology_DAG_from_GO_db()
dag
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dist.R
\name{shortest_distances_via_NCA}
\alias{shortest_distances_via_NCA}
\alias{longest_distances_via_LCA}
\alias{shortest_distances_directed}
\alias{longest_distances_directed}
\title{Distance on the DAG}
\usage{
shortest_distances_via_NCA(dag, terms, verbose = simona_opt$verbose)

longest_distances_via_LCA(dag, terms, verbose = simona_opt$verbose)

shortest_distances_directed(dag, terms, verbose = simona_opt$verbose)

longest_distances_directed(dag, terms, verbose = simona_opt$verbose)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{terms}{A vector of term names.}

\item{verbose}{Whether to print messages.}
}
\value{
A numeric distance matrix.
}
\description{
Distance on the DAG
}
\details{
Denote two terms as \code{a} and \code{b}, a common ancestor as \code{c}, and the distance function \code{d()} calculates the longest
distance or the shortest distance depending on the function.
\itemize{
\item \code{shortest_distances_via_NCA()}: It calculates the smallest \code{d(c, a) + d(c, b)} where \code{d()} calculates the shortest distance between two terms. In this case,
\code{c} is the NCA (nearest common ancestor) of \code{a} and \code{b}.
\item \code{longest_distances_via_LCA()}: It calculates the largest \code{d(c, a) + d(c, b)} where \code{d()} calculates the longest distance between two terms \emph{via the LCA (lowest common ancestor) term}. In this case,
\code{c} is the LCA of \code{a} and \code{b}.
\item \code{shortest_distances_directed()}: It calculates \code{d(a, b)} where \code{d()} calculates the shortest distance between two terms. The distance is only calculated when \code{a} is an ancestor of \code{b}, otherwise the distance value is -1.
\item \code{longest_distances_directed()}: It calculates \code{d(a, b)} where \code{d()} calculates the longest distance between two terms. The distance is only calculated when \code{a} is an ancestor of \code{b}, otherwise the distance value is -1.
}
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
shortest_distances_via_NCA(dag, letters[1:6])
longest_distances_via_LCA(dag, letters[1:6])
shortest_distances_directed(dag, letters[1:6])
longest_distances_directed(dag, letters[1:6])
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/random.R
\name{dag_random_tree}
\alias{dag_random_tree}
\alias{dag_add_random_children}
\alias{dag_random}
\title{Generate a random DAG}
\usage{
dag_random_tree(
  n_children = 2,
  p_stop = 0,
  max = 2^10 - 1,
  verbose = simona_opt$verbose
)

dag_add_random_children(
  dag,
  p_add = 0.1,
  new_children = c(1, 4),
  add_random_children_fun = NULL,
  verbose = simona_opt$verbose
)

dag_random(
  n_children = 2,
  p_stop = 0,
  max = 2^10 - 1,
  p_add = 0.1,
  new_children = c(1, 4),
  verbose = simona_opt$verbose
)
}
\arguments{
\item{n_children}{Number of children of a term. The value can also be a vector of
length two representing the range of the number of child terms.}

\item{p_stop}{The probability of a term to stop growing.}

\item{max}{Maximal number of terms.}

\item{verbose}{Whether to print messages.}

\item{dag}{An \code{ontology_DAG} object.}

\item{p_add}{The probability to add children on each term.}

\item{new_children}{The number or range of numbers of new children if a term is selected to add more children.}

\item{add_random_children_fun}{A function to randomly add children from the DAG.}
}
\value{
An \code{ontology_DAG} object.
}
\description{
Generate a random DAG
}
\details{
\code{dag_random_tree()} generates a random DAG tree from the root term. In a certain step of
the growing, let's denote the set of all leaf terms as L, then in the next round of growing,
\code{floor(length(L)*p_stop)} leaf terms stop growing, and for the remaining leaf terms that
continue to grow, each term will add child terms with number in uniformly sampled within \verb{[ n_children[1], n_children[2] ]}.
The growing stops when the total number of terms in the DAG exceeds \code{max}.

\code{dag_add_random_children()} adds more links in a DAG. Each term is associated with a probability \code{p_add}
to add new links where the term, if it is selected, is as a parent term, linking to other terms in the DAG.
The number of new child terms is controlled by \code{new_children} which can be a single number of a range. By default,
new child terms of a term \code{t} are randomly selected from other terms that are lower than the term \code{t}
(check the function \code{simona:::add_random_children}). The way how to randomly select new child terms for \code{t}
can be controlled by a self-defined function for the \code{add_random_children_fun} argument.

\code{dag_random()}: it simply wraps \code{dag_random_tree()} and \code{dag_add_random_children()}.
}
\examples{
tree = dag_random_tree()
dag = dag_random()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00_global.R
\name{all_term_IC_methods}
\alias{all_term_IC_methods}
\alias{all_term_sim_methods}
\alias{all_group_sim_methods}
\title{Supported methods}
\usage{
all_term_IC_methods(require_anno = NULL)

all_term_sim_methods(require_anno = NULL)

all_group_sim_methods(require_anno = NULL)
}
\arguments{
\item{require_anno}{If it is set to \code{TRUE}, methods that require external annotations are only returned. If
it is set to \code{FALSE}, methods that do not require annotations are returned. A value of \code{NULL} returns both.}
}
\value{
A character vector of all supported methods.
}
\description{
Supported methods
}
\details{
\itemize{
\item \code{all_term_IC_methods()}: A vector of all supported IC methods.
\item \code{all_term_sim_methods()}: A vector of all supported term similarity methods.
\item \code{all_group_sim_methods()}: A vector of all supported group similarity methods.
}
}
\examples{
all_term_IC_methods()
all_term_sim_methods()
all_group_sim_methods()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrich.R
\name{dag_enrich_on_items}
\alias{dag_enrich_on_items}
\alias{dag_enrich_on_genes}
\title{Enrichment analysis on the number of annotated items}
\usage{
dag_enrich_on_items(dag, items, min_hits = 5, min_items = 10)

dag_enrich_on_genes(dag, genes, min_hits = 5, min_genes = 10)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{items}{A vector of item names.}

\item{min_hits}{Minimal number of items in the term set.}

\item{min_items}{Minimal size of the term set.}

\item{genes}{A vector of gene IDs. The gene ID type can be found by directly printing the \code{ontology_DAG} object.}

\item{min_genes}{Minimal number of genes.}
}
\value{
A data frame with the following columns:
\itemize{
\item \code{term}: Term names.
\item \code{n_hits}: Number of items in \code{items} intersecting to \code{t}'s annotated items.
\item \code{n_anno}: Number of annotated items of \code{t}. Specifically for \code{dag_enrich_on_genes()}, this column
is renamed to \code{n_gs}.
\item \code{n_items}: Number of items in \code{items} intersecting to all annotated items in the DAG. Specifically
for \code{dag_enrich_on_genes()}, this column is renamed to \code{n_genes}.
\item \code{n_all}: Number of all annotated items in the DAG.
\item \code{log2_fold_enrichment}: Defined as log2(observation/expected).
\item \code{z_score}: Defined as (observed-expected)/sd.
\item \code{p_value}: P-values from hypergeometric test.
\item \code{p_adjust}: Adjusted p-values from the BH method.
}

The number of rows in the data frame is the same as the number of terms in the DAG.
}
\description{
The analysis task is to evaluate which terms the given items are enriched to.
}
\details{
The function tests whether the list of items are enriched in terms on the DAG.
The test is based on the hypergeometric distribution. In the following 2x2 contigency table, \code{S} is the set of \code{items},
for a term \code{t} in the DAG, \code{T} is the set of items annotated to \code{t} (by automatically merging from its offspring terms),
the aim is to test whether \code{S} is over-represented in \code{T}.

The universal set \code{all} correspond to the full set of items annotated to the DAG.

\if{html}{\out{<div class="sourceCode">}}\preformatted{+----------+------+----------+-----+
|          | in S | not in S | all |
+----------+------+----------+-----+
| in T     |  x11 |    x12   | x10 |
| not in T |  x21 |    x22   | x20 |
+----------+------+----------+-----+
| all      |  x01 |    x02   |  x  |
+----------+------+----------+-----+
}\if{html}{\out{</div>}}

\code{dag_enrich_on_genes()} is the same as \code{dag_enrich_on_items()} which only changes the argument \code{item} to \code{gene}.
}
\examples{
\dontrun{
dag = create_ontology_DAG_from_GO_db(org_db = "org.Hs.eg.db") 
items = random_items(dag, 1000)
df = dag_enrich_on_items(dag, items)
}
1
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/import.R
\name{import_obo}
\alias{import_obo}
\alias{import_owl}
\alias{import_ontology}
\alias{import_ttl}
\title{Import ontology file to an ontology_DAG object}
\usage{
import_obo(
  file,
  relation_type = character(0),
  inherit_relations = TRUE,
  verbose = simona_opt$verbose,
  ...
)

import_owl(
  file,
  relation_type = character(0),
  inherit_relations = TRUE,
  verbose = simona_opt$verbose,
  ...
)

import_ontology(
  file,
  robot_jar = simona_opt$robot_jar,
  JAVA_ARGS = "",
  verbose = simona_opt$verbose,
  ...
)

import_ttl(file, relation_type = "part_of", verbose = simona_opt$verbose, ...)
}
\arguments{
\item{file}{Path of the ontology file or an URL.}

\item{relation_type}{Semantic relation types to include. Note \code{is_a} relation is always included.}

\item{inherit_relations}{Relations may also be structured as a DAG. It controls whether to merge with a relations's offspring relations.}

\item{verbose}{Whether to print messages.}

\item{...}{Pass to \code{\link[=create_ontology_DAG]{create_ontology_DAG()}}.}

\item{robot_jar}{The path of the \code{robot.jar} file. It can be downloaded from https://github.com/ontodev/robot/releases.
Internally, the file is converted to the obo format and parsed by \code{import_obo()}. The value of \code{robot_jar} can be
set as a global option \code{simona_opt$robot_jar = ...}.}

\item{JAVA_ARGS}{Options for \code{java}. For example you can set \code{-Xmx20G} if you want to increase the memory to 20G for java.}
}
\value{
An \code{ontology_DAG} object.
}
\description{
Import ontology file to an ontology_DAG object
}
\details{
Public bio-ontologies can be obtained from \href{http://obofoundry.org/}{Ontology Foundry} or \href{https://bioportal.bioontology.org/}{BioPortal}.

The \code{import_obo()} function parses the ontology file in \code{.obo} format. To parse other formats, external tool \code{robot.jar} is required.

\code{import_owl()} only recognizes \verb{<owl:Class>} and \verb{<owl:ObjectProperty>}. If the .owl file does not contain these tags,
please use \code{import_ontology()} directly.

\code{robot.jar} can automatically recognize the following formats:
\itemize{
\item \code{json}: OBO Graphs JSON
\item \code{obo}: OBO Format
\item \code{ofn}: OWL Functional
\item \code{omn}: Manchester
\item \code{owl}: RDF/XML
\item \code{owx}: OWL/XML
\item \code{ttl}: Turtle
}

The description of the ROBOT tool is at \url{http://robot.obolibrary.org/convert}.

\code{import_ttl()} is a simple parser for the \code{.ttl} format files. It only recognizes
terms that have the \code{owl:Class} object. The "is_a" relation is recognized by the predicate \code{rdfs:subClassOf}
or an ontology-specific predicate that contains \verb{.*/isa}. Other relation types are defined with
the predicate \code{owl:ObjectProperty}. The format is parsed by a Perl script \code{system.file("scripts", "parse_ttl.pl", package = "simona")}.
}
\examples{
\donttest{
# The plant ontology: http://obofoundry.org/ontology/po.html 
import_obo("https://raw.githubusercontent.com/Planteome/plant-ontology/master/po.obo")
}
\donttest{
import_owl("http://purl.obolibrary.org/obo/po.owl") 
}
\dontrun{
# The plant ontology: http://obofoundry.org/ontology/po.html 
dag = import_ontology("http://purl.obolibrary.org/obo/po.owl", robot_jar = ...)
}
\donttest{
# file is from https://bioportal.bioontology.org/ontologies/MSTDE
import_ttl("https://jokergoo.github.io/simona/MSTDE.ttl")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transverse.R
\name{n_offspring}
\alias{n_offspring}
\alias{n_ancestors}
\alias{n_connected_leaves}
\alias{n_parents}
\alias{n_children}
\alias{avg_parents}
\alias{avg_children}
\title{Number of parent/child/ancestor/offspring/leaf terms}
\usage{
n_offspring(dag, terms = NULL, use_cache = TRUE, include_self = FALSE)

n_ancestors(dag, terms = NULL, use_cache = TRUE, include_self = FALSE)

n_connected_leaves(dag, terms = NULL, use_cache = TRUE)

n_parents(dag, terms = NULL)

n_children(dag, terms = NULL)

avg_parents(dag)

avg_children(dag)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{terms}{A vector of term names. If the value is \code{NULL}, it returns for all terms in the DAG.}

\item{use_cache}{Internally used.}

\item{include_self}{For \code{n_offspring()} and \code{n_ancestors()}, this controls whether to also include the query term itself.}
}
\value{
An integer vector.
}
\description{
Number of parent/child/ancestor/offspring/leaf terms
}
\details{
For \code{n_connected_leaves()}, leaf nodes have value of 1.

In \code{avg_parents()}, root term is removed.

In \code{avg_children()}, leaf term is removed.
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
n_parents(dag)
n_children(dag)
n_offspring(dag)
n_ancestors(dag)
n_connected_leaves(dag)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transverse.R
\name{dag_depth}
\alias{dag_depth}
\alias{dag_height}
\alias{dag_shortest_dist_from_root}
\alias{dag_shortest_dist_to_leaves}
\title{Depth and height in the DAG}
\usage{
dag_depth(dag, terms = NULL, use_cache = TRUE)

dag_height(dag, terms = NULL, use_cache = TRUE)

dag_shortest_dist_from_root(dag, terms = NULL, use_cache = TRUE)

dag_shortest_dist_to_leaves(dag, terms = NULL, use_cache = TRUE)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{terms}{A vector of term names. If it is set, the returned vector will be subsetted to the terms that have been set here.}

\item{use_cache}{Internally used.}
}
\value{
An integer vector with length the same as the number of total terms in the DAG.
}
\description{
Depth and height in the DAG
}
\details{
The depth of a term in the DAG is defined as the maximal distance from the root. The height
of a term in the DAG is the maximal finite distance to all leaf terms.

\code{dag_shortest_dist_from_root()} and \code{dag_shortest_dist_to_leaves()} calculate the minimal distance from the root or to the leaves.
The word "from" and "to" emphasize the distancer is directinoal.
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
dag_depth(dag)
dag_height(dag)
dag_shortest_dist_from_root(dag)
dag_shortest_dist_to_leaves(dag)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructor.R
\name{mcols,ontology_DAG-method}
\alias{mcols,ontology_DAG-method}
\alias{mcols<-,ontology_DAG-method}
\title{Get or set meta columns on DAG}
\usage{
\S4method{mcols}{ontology_DAG}(x, use.names = TRUE, ...)

\S4method{mcols}{ontology_DAG}(x, ...) <- value
}
\arguments{
\item{x}{An \code{ontology_DAG} object.}

\item{use.names}{Please ignore.}

\item{...}{Other argument. For \code{mcols()}, it can be a vector of column names in the meta data frame.}

\item{value}{A data frame or a matrix where rows should correspond to terms in \code{x@terms}.}
}
\value{
A data frame.
}
\description{
Get or set meta columns on DAG
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
mcols(dag) = data.frame(id = letters[1:6], v = 1:6)
mcols(dag)
mcols(dag, "id")
dag
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shiny.R
\name{dag_shiny}
\alias{dag_shiny}
\title{A shiny app for the DAG}
\usage{
dag_shiny(dag)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}
}
\description{
A shiny app for the DAG
}
\examples{
if(FALSE) {
    dag = create_ontology_DAG_from_GO_db()
    dag_shiny(dag)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methods.R
\name{term_sim}
\alias{term_sim}
\title{Semantic similarity}
\usage{
term_sim(dag, terms, method, control = list(), verbose = simona_opt$verbose)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{terms}{A vector of term names.}

\item{method}{A term similarity method. All available methods are in \code{\link[=all_term_sim_methods]{all_term_sim_methods()}}.}

\item{control}{A list of parameters passing to individual methods. See the subsections.}

\item{verbose}{Whether to print messages.}
}
\value{
A numeric symmetric matrix.
}
\description{
Semantic similarity
}
\section{Methods}{

\subsection{Sim_Lin_1998}{

The similarity between two terms \code{a} and \code{b} is calculated as the IC of their MICA term \code{c} normalized by the average of the IC of the two terms:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = IC(c)/((IC(a) + IC(b))/2) 
    = 2*IC(c)/(IC(a) + IC(b))
}\if{html}{\out{</div>}}

Although any IC method can be used here, in more applications, it is normally used together with the \emph{IC_annotation} method.

Paper link: \doi{10.5555/645527.657297}.
}


\subsection{Sim_Resnik_1999}{

The IC method is fixed to \code{IC_annotation}.

The original Resnik similarity is the IC of the MICA term. There are three ways to normalize the Resnik similarity into the scale of \verb{[0, 1]}:
\enumerate{
\item \emph{Nunif}
}

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = IC(c)/log(N)
}\if{html}{\out{</div>}}

where \code{N} is the total number of items annotated to the whole DAG, i.e. number of items annotated to the root. Then the IC
of a term with only one item annotated is \code{-log(1/N)} = log(N)` which is the maximal IC value in the DAG.
\enumerate{
\item \emph{Nmax}
}

\code{IC_max} is the maximal IC of all terms. If there is a term with only one item annotated, \code{Nmax} is identical to the `Nunif* method.

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = IC(c)/IC_max
}\if{html}{\out{</div>}}
\enumerate{
\item \emph{Nunivers}
}

The IC is normalized by the maximal IC of term \code{a} and \code{b}.

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = IC(c)/max(IC(a), IC(b))
}\if{html}{\out{</div>}}

Paper link: \doi{10.1613/jair.514}, \doi{10.1186/1471-2105-9-S5-S4}, \doi{10.1186/1471-2105-11-562}, \doi{10.1155/2013/292063}.

The normalization method can be set with the \code{norm_method} parameter:

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, control = list(norm_method = "Nmax"))
}\if{html}{\out{</div>}}

Possible values for the \code{norm_method} parameter are "Nunif", "Nmax", "Nunivers" and "none".
}


\subsection{Sim_FaITH_2010}{

It is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = IC(c)/(IC(a) + IC(b) - IC(c))
}\if{html}{\out{</div>}}

The relation between \emph{FaITH_2010} similarity and \emph{Lin_1998} similarity is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim_FaITH = sim_Lin/(2 - sim_Lin)
}\if{html}{\out{</div>}}

Paper link: \doi{10.1007/978-3-642-17746-0_39}.
}


\subsection{Sim_Relevance_2006}{

The IC method is fixed to \code{IC_annotation}.

If thinking \emph{Lin_1998} is a measure of how close term \code{a} and \code{b} to their MICA term \code{c}, the relevance method corrects it by multiplying
a factor which considers the specificity of how \code{c} brings the information. The factor is calculated as \code{1-p(c)} where \code{p(c)} is the annotation-based
probability \code{p(c) = k/N} where \code{k} is the number of items annotated to \code{c} and \code{N} is the total number of items annotated to the DAG. Then
the Relevance semantic similarity is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = (1 - p(c)) * IC_Lin 
    = (1 - p(c)) * 2*IC(c)/(IC(a) + IC(b))
}\if{html}{\out{</div>}}

Paper link: \doi{10.1186/1471-2105-7-302}.
}


\subsection{Sim_SimIC_2010}{

The IC method is fixed to \code{IC_annotation}.

The SimIC method is an improved correction method of the Relevance method because the latter works bad when \code{p(c)} is very small. The SimIC
correction factor for MICA term \code{c} is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{1 - 1/(1 + IC(c))
}\if{html}{\out{</div>}}

Then the similarity is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = (1 - 1/(1 + IC(c))) * IC_Lin 
    = (1 - 1/(1 + IC(c))) * 2*IC(c)/(IC(a) + IC(b))
}\if{html}{\out{</div>}}

Paper link: \doi{10.48550/arXiv.1001.0958}.
}


\subsection{Sim_XGraSM_2013}{

The IC method is fixed to \code{IC_annotation}.

Being different from the "Relevance" and "SimIC_2010" methods that only use the IC of the MICA term, the \emph{XGraSM_2013} uses IC of all common ancestor terms of \code{a} and \code{b}.
First it calculates the mean IC of all common ancestor terms with positive IC values:

\if{html}{\out{<div class="sourceCode">}}\preformatted{IC_mean = mean_t(IC(t)) where t is an ancestor of both a and b, and IC(t) > 0
}\if{html}{\out{</div>}}

then similar to the \emph{Lin_1998} method, normalize to the average IC of \code{a} and \code{b}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = IC_mean*2/(IC(a) + IC(b))
}\if{html}{\out{</div>}}

Paper link: \doi{10.1186/1471-2105-14-284}.
}


\subsection{Sim_EISI_2015}{

The IC method is fixed to \code{IC_annotation}.

It also selects a subset of common ancestors of terms \code{a} and \code{b}. It only selects common ancestors which can reach \code{a} or \code{b} via one of its child terms
that does not belong to the common ancestors. In other words, from the common ancestor, there exist a path where
the information is uniquely transmitted to \code{a} or \code{b}, not passing the other.

Then the mean IC of the subset common ancestors is calculated and normalized by the \emph{Lin_1998} method.

Paper link: \doi{10.1016/j.gene.2014.12.062}.
}


\subsection{Sim_AIC_2014}{

It uses the aggregate information content from ancestors. First define the semantic weight (\code{Sw}) of a term \code{t} in the DAG:

\if{html}{\out{<div class="sourceCode">}}\preformatted{Sw = 1/(1 + exp(-1/IC(t)))
}\if{html}{\out{</div>}}

Then calculate the aggregation only in the common ancestors and the aggregationn
in the ancestors of the two terms \code{a} and \code{b} separatedly:

\if{html}{\out{<div class="sourceCode">}}\preformatted{SV_\{common ancestors\} = sum_\{t in common ancestors\}(Sw(t))
SV_a = sum\{a' in a's ancestors\}(Sw(a'))
SV_b = sum\{b' in b's ancestors\}(Sw(b'))
}\if{html}{\out{</div>}}

The similarity is calculated as the ratio between the aggregation on the common ancestors and the average on \code{a}'s ancestors and \code{b}'s ancestors separatedly.

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = 2*SV_\{common_ancestors\}/(SV_a + SV_b)
}\if{html}{\out{</div>}}

Paper link: \doi{10.1109/tcbb.2013.176}.
}


\subsection{Sim_Zhang_2006}{

It uses the \emph{IC_Zhang_2006} IC method and the \emph{Lin_1998} method to calculate similarities:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = 2*IC_zhang(c)/(IC_zhang(a) + IC_zhang(b))
}\if{html}{\out{</div>}}
}


\subsection{Sim_universal}{

It uses the \emph{IC_universal} IC method and the \emph{Nunivers} method to calculate similarities:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = IC_universal(c)/max(IC_universal(a), IC_universal(b))
}\if{html}{\out{</div>}}
}


\subsection{Sim_Wang_2007}{

First, S-value of an ancestor term \code{c} on a term \code{a} (\code{S(c->a)}) is calculated (the definition of the S-value can be found in the help page of \code{\link[=term_IC]{term_IC()}}).
Similar to the \emph{Sim_AIC_2014}, aggregation only to common ancestors, to \code{a}'s ancestors and to \code{b}'s ancestors are calculated.

\if{html}{\out{<div class="sourceCode">}}\preformatted{SV_\{common ancestors\} = sum_\{c in common ancestors\}(S(c->a) + S(c->b))
SV_a = sum\{a' in a's ancestors\}(S(a'->a))
SV_b = sum\{b' in b's ancestors\}(S(b'->b))
}\if{html}{\out{</div>}}

Then the similarity is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = SV_\{common_ancestors\}*2/(SV_a + SV_b)
}\if{html}{\out{</div>}}

Paper link: \doi{10.1093/bioinformatics/btm087}.

The contribution of different semantic relations can be set with the \code{contribution_factor} parameter. The value should be a named numeric
vector where names should cover the relations defined in \code{relations} set in \code{\link[=create_ontology_DAG]{create_ontology_DAG()}}. For example, if there are two relations
"relation_a" and "relation_b" set in the DAG, the value for \code{contribution_factor} can be set as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_Wang_2007", 
    control = list(contribution_factor = c("relation_a" = 0.8, "relation_b" = 0.6)))
}\if{html}{\out{</div>}}
}


\subsection{Sim_GOGO_2018}{

It is very similar as \emph{Sim_Wang_2007}, but with a corrected contribution factor when calculating the S-value.
From a parent term to a child term, \emph{Sim_Wang_2007} directly uses a weight for the relation between the parent
and the child, e.g. 0.8 for "is_a" relation type and 0.6 for "part_of" relation type. In \emph{Sim_GOGO_2018}, the weight
is also scaled by the total number of children of that parent:

\if{html}{\out{<div class="sourceCode">}}\preformatted{w = 1/(c + nc) + w_0
}\if{html}{\out{</div>}}

where w_0 is the original contribution factor, \code{nc} is the number of child terms of the parent, \code{c} is calculated to ensure that
maximal value of \code{w} is no larger than 1, i.e. \code{c = max(w_0)/(1 - max(w_0))}, assuming minimal value of \code{nc} is 1. By default \emph{Sim_GOGO_2018}
sets contribution factor of 0.4 for "is_a" and 0.3 for "part_of", then \code{w = 1/(2/3 + nc) + w_0}.

Paper link: \doi{10.1038/s41598-018-33219-y}.

The contribution of different semantic relations can be set with the \code{contribution_factor} parameter. The value should be a named numeric
vector where names should cover the relations defined in \code{relations} set in \code{\link[=create_ontology_DAG]{create_ontology_DAG()}}. For example, if there are two relations
"relation_a" and "relation_b" set in the DAG, the value for \code{contribution_factor} can be set as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_GOGO_2018", 
    control = list(contribution_factor = c("relation_a" = 0.4, "relation_b" = 0.3)))
}\if{html}{\out{</div>}}
}


\subsection{Sim_Rada_1989}{

It is based on the distance between term \code{a} and \code{b}. It is defined as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = 1/(1 + d(a, b))
}\if{html}{\out{</div>}}

The distance can be the shortest distance between \code{a} and \code{b} or the longest distance via the LCA term.

Paper link: \doi{10.1109/21.24528}.

There is a parameter \code{distance} which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_Rada_1989",
    control = list(distance = "shortest_distances_via_NCA"))
}\if{html}{\out{</div>}}
}


\subsection{Sim_Resnik_edge_2005}{

It is also based on the distance between term \code{a} and \code{b}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = 1 - d(a, b)/2/max_depth
}\if{html}{\out{</div>}}

where \code{max_depth} is the maximal depth (maximal distance from root) in the DAG. Similarly, \code{d(a, b)} can be the shortest
distance or the longest distance via LCA.

Paper link: \doi{10.1145/1097047.1097051}.

There is a parameter \code{distance} which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_Resnik_edge_2005",
    control = list(distance = "shortest_distances_via_NCA"))
}\if{html}{\out{</div>}}
}


\subsection{Sim_Leocock_1998}{

It is similar as the \emph{Sim_Resnik_edge_2005} method, but it applies log-transformation on the distance and the depth:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = 1 - log(d(a, b) + 1)/log(2*max_depth + 1)
}\if{html}{\out{</div>}}

Paper link: \doi{10.1186/1471-2105-13-261}.

There is a parameter \code{distance} which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_Leocock_1998",
    control = list(distance = "shortest_distances_via_NCA"))
}\if{html}{\out{</div>}}
}


\subsection{Sim_WP_1994}{

It is based on the depth of the LCA term \code{c} and the longest distance between term \code{a} and \code{b}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = 2*depth(c)/(len_c(a, b) + 2*depth(c))
}\if{html}{\out{</div>}}

where \code{len_c(a, b)} is the longest distance between \code{a} and \code{b} via LCA \code{c}. The denominator in the equation can also be written as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{len_c(a, b) + 2*depth(c) = depth(c) + len(c, a) + depth(c) + len(c, b)
                         = depth_c(a) + depth_c(b)
}\if{html}{\out{</div>}}

where \code{depth_c(a)} is the longest distance from root to \code{a} passing through \code{c}.

Paper link: \doi{10.3115/981732.981751}.
}


\subsection{Sim_Slimani_2006}{

It is a correction of the \emph{Sim_WP_1994} method. The correction factor for term \code{a} and \code{b} regarding to their LCA \code{t} is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{CF(a, b) = (1-lambda)*(min(depth(a), depth(b)) - depth(c)) + 
           lambda/(1 + abs(depth(a) - depth(b)))
}\if{html}{\out{</div>}}

\code{lambda} takes value of 1 if \code{a} and \code{b} are in ancestor-offspring relation, or else it takes 0.

Paper link: \url{https://zenodo.org/record/1075130}.
}


\subsection{Sim_Shenoy_2012}{

It is a correction of the \emph{Sim_WP_1994} method. The correction factor for term \code{a} and \code{b} is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{CF(a, b) = exp(-lambda*d(a, b)/max_depth)
}\if{html}{\out{</div>}}

\code{lambda} takes value of 1 if \code{a} and \code{b} are in ancestor-offspring relation, or else it takes 0. `d(a, b)

Paper link: \doi{10.48550/arXiv.1211.4709}.

There is a parameter \code{distance} which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_Leocock_1998",
    control = list(distance = "shortest_distances_via_NCA"))
}\if{html}{\out{</div>}}
}


\subsection{Sim_Pekar_2002}{

It is very similar to the \emph{Sim_WP_1994} method:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = depth(c)/(len_c(a, b) + depth(c))
    = d(root, c)/(d(c, a) + d(c, b) + d(root, c))
}\if{html}{\out{</div>}}

where \code{d(a, b)} is the longest distance between \code{a} and \code{b}.

Paper link: \url{https://aclanthology.org/C02-1090/}.
}


\subsection{Sim_Stojanovic_2001}{

It is purely based on the depth of term \code{a}, \code{b} and their LCA \code{c}.

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = depth(c)/(depth(a) + depth(b) - depth(c))
}\if{html}{\out{</div>}}

The similarity value might be negative because there is no restrction that the path from root to \code{a} or \code{b} must pass \code{c}.

Paper link: \doi{10.1145/500737.500762}.
}


\subsection{Sim_Wang_edge_2012}{

It is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = depth(c)^2/depth_c(a)/depth_c(b)
}\if{html}{\out{</div>}}

where \code{depth_c(a)} is the longest distance between root to \code{a} passing through \code{c}.

Paper link: \doi{10.1186/1477-5956-10-s1-s18}.
}


\subsection{Sim_Zhong_2002}{

For a term \code{x}, it first calculates a "mile-stone" value as

\if{html}{\out{<div class="sourceCode">}}\preformatted{m(x) = 0.5/2^depth(x)
}\if{html}{\out{</div>}}

The the distance bewteen term \code{a} and \code{b} via LCA term \code{c} is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{D(c, a) + D(c, b) = m(c) - m(a) + m(c) - m(b)
                  = 2*m(c) - m(a) - m(b)
                  = 1/2^depth(c) - 0.5/2^depth(a) - 0.5/2^depth(b)
}\if{html}{\out{</div>}}

We change the original \code{depth(a)} to let it go through LCA term \code{c} when calculating the depth:

\if{html}{\out{<div class="sourceCode">}}\preformatted{1/2^depth(c) - 0.5/2^depth(a) - 0.5/2^depth(b) 
    = 1/2^depth(c)- 0.5/2^(depth(c) + len(c, a)) - 0.5/2^(depth(c) + len(c, b))
    = 1/2^depth(c) * (1 - 1/2^(len(c, a) + 1) - 1/2^(len(c, b) + 1))
    = 2^-depth(c) * (1 - 2^-(len(c, a) + 1) - 2^-(len(c, b) + 1))
}\if{html}{\out{</div>}}

And the final similarity is \code{1 - distance}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = 1 - 2^-depth(c) * (1 - 2^-(len(c, a) + 1) - 2^-(len(c, b) + 1))
}\if{html}{\out{</div>}}

Paper link: \doi{10.1007/3-540-45483-7_8}.

There is a parameter \code{depth_via_LCA} that can be set to \code{TRUE} or \code{FALSE}. IF it is set to \code{TRUE}, \code{depth(a)} is re-defined
as should pass the LCA term \code{c}. If it is \code{FALSE}, it goes to the original similarity definition in the paper and note the
similarity might be negative.

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_Zhong_2002",
    control = list(depth_via_LCA = FALSE))
}\if{html}{\out{</div>}}
}


\subsection{Sim_AlMubaid_2006}{

It also takes accout of the distance between term \code{a} and \code{b}, and the depth of the LCA term \code{c} in the DAG.
The distance is calculated as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{D(a, b) = log(1 + d(a, b)*(max_depth - depth(c)))
}\if{html}{\out{</div>}}

Here \code{d(a, b)} can be the shortest distance between \code{a} and \code{b} or the longst distance via LCA \code{c}.

Then the distance is transformed into the similarity value scaled by the possible maximal and minimal values of \code{D(a, b)} from the DAG:

\if{html}{\out{<div class="sourceCode">}}\preformatted{D_max = log(1 + 2*max_depth * max_depth)
}\if{html}{\out{</div>}}

And the minimal value of \code{D(a, b)} is zero when \code{a} is identical to \code{b}. Then the similarity value is scaled as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = 1 - D(a, b)/D_max
}\if{html}{\out{</div>}}

Paper link: \doi{10.1109/IEMBS.2006.259235}.

There is a parameter \code{distance} which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_AlMubaid_2006",
    control = list(distance = "shortest_distances_via_NCA"))
}\if{html}{\out{</div>}}
}


\subsection{Sim_Li_2003}{

It is similar to the \emph{Sim_AlMubaid_2006} method, but uses a non-linear form:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = exp(0.2*d(a, b)) * atan(0.6*depth(c))
}\if{html}{\out{</div>}}

where \code{d(a, b)} can be the shortest distance or the longest distance via LCA.

Paper link: \doi{10.1109/TKDE.2003.1209005}.

There is a parameter \code{distance} which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_Li_2003",
    control = list(distance = "shortest_distances_via_NCA"))
}\if{html}{\out{</div>}}
}


\subsection{Sim_RSS_2013}{

The similarity is adjusted by the positions of term \code{a}, \code{b} and the LCA term \code{c} in the DAG. The similarity is defined as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = max_depth/(max_depth + d(a, b)) * alpha/(alpha + beta)
}\if{html}{\out{</div>}}

where \code{d(a, b)} is the distance between \code{a} and \code{b} which can be the shortest distance or the longest distance via LCA.

In the tuning factor, \code{alpha} is the distance of LCA to root, which is \code{depth(c)}. \code{beta} is the distance to leaves, which
is the minimal distance (or the minimal height) of term \code{a} and \code{b}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{alpha/(alpha + beta) = depth(c)/(depth(c) + min(height(a), height(b)))
}\if{html}{\out{</div>}}

Paper link: \doi{10.1371/journal.pone.0066745}.

There is a parameter \code{distance} which takes value of "longest_distances_via_LCA" (the default) or "shortest_distances_via_NCA":

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_RSS_2013",
    control = list(distance = "shortest_distances_via_NCA"))
}\if{html}{\out{</div>}}
}


\subsection{Sim_HRSS_2013}{

It is similar as the \emph{Sim_RSS_2013} method, but it uses information content instead of the distance to adjust the similarity.

It first defines the semantic distance between term \code{a} and \code{b} as the sum of the distance to their MICA term \code{c}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{D(a, b) = D(c, a) + D(c, b)
}\if{html}{\out{</div>}}

And the distance between an ancestor to a term is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{D(c, a) = IC(a) - IC(c)  # if c is an ancestor of a
D(a, b) = D(c, a) + D(c, b) = IC(a) + IC(b) - 2*IC(c) # if c is the MICA of a and b
}\if{html}{\out{</div>}}

Similarly, the similarity is also corrected by the position of MICA term and \code{a} and \code{b} in the DAG:

\if{html}{\out{<div class="sourceCode">}}\preformatted{1/(1 + D(a, b)) * alpha/(alph + beta)
}\if{html}{\out{</div>}}

Now \code{alpha} is the IC of the MICA term:

\if{html}{\out{<div class="sourceCode">}}\preformatted{alpha = IC(c)
}\if{html}{\out{</div>}}

And \code{beta} is the average of the maximal semantic distance of \code{a} and \code{b} to leaves.

\if{html}{\out{<div class="sourceCode">}}\preformatted{beta = 0.5*(IC(l_a) - IC(a) + IC(l_b) - IC(b))
}\if{html}{\out{</div>}}

where \code{l_a} is the leaf that \code{a} can reach with the highest IC (i.e. most informative leaf), and so is \code{l_b}.

Paper link: \doi{10.1371/journal.pone.0066745}.
}


\subsection{Sim_Shen_2010}{

It is based on the information content of terms on the path connecting term \code{a} and \code{b} via their MICA term \code{c}.

Denote a list of terms \verb{a, ..., c, ..., b} which are composed by the shortest path from \code{a} to \code{c} and from \code{b} to \code{c}, the difference
between \code{a} and \code{b} is the sum of \code{1/IC} of the terms on the path:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sum_\{x in the path\}(1/IC(x))
}\if{html}{\out{</div>}}

Then the distance is scaled into \verb{[0, 1]} by an arctangent tarnsformation:

\if{html}{\out{<div class="sourceCode">}}\preformatted{atan(sum_\{x in the path\}(1/IC(x)))/(pi/2)
}\if{html}{\out{</div>}}

And finally the similarity is:

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = 1 - atan(sum_\{x in the path\}(1/IC(x)))/(pi/2)
}\if{html}{\out{</div>}}

Paper link: \doi{10.1109/BIBM.2010.5706623}.
}


\subsection{Sim_SSDD_2013}{

It is similar as the \emph{Sim_Shen_2010} which also sums content along the path passing through LCA term.
Instead of summing the information content, the \emph{Sim_SSDD_2013} sums up a so-called "T-value":

\if{html}{\out{<div class="sourceCode">}}\preformatted{sim = 1 - atan(sum_\{x in the path\}(T(x)))/(pi/2)
}\if{html}{\out{</div>}}

Each term has a T-value and it measures the semantic content a term averagely inherited from its parents
and distributed to its offsprings. The T-value of root is 1. Assume a term \code{t} has two parents \code{p1} and \code{p1},
The T-value for term \code{t} is averaged from its

\if{html}{\out{<div class="sourceCode">}}\preformatted{(w1*T(p1) + w2*T(p2))/2
}\if{html}{\out{</div>}}

Since the parent may have other child terms, a factor \code{w1} or \code{w2} is multiplied to \code{T(p1)} and \code{T(p2)}. Taking
\code{p1} as an example, it has \code{n_p} offsprings (including itself) and \code{t} has \code{n_t} offsprings (including itself),
this means \code{n_t/n_p} of information is transmitted from \code{p1} to downstream via \code{t}, thus \code{w1} is defined as \code{n_t/n_p}.

Paper link: \doi{10.1016/j.ygeno.2013.04.010}.
}


\subsection{Sim_Jiang_1997}{

First semantic distance between term \code{a} and \code{b} via MICA term \code{c} is defined as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{D(a, b) = IC(a) + IC(b) - 2*IC(c)
}\if{html}{\out{</div>}}

Then there are several normalization method to change the distance to similarity and to scale it into the range of \verb{[0, 1]}.
\itemize{
\item max: \code{1 - D(a, b)/2/IC_max}
\item Couto: \code{min(1, D(a, b)/IC_max)}
\item Lin: \code{1 - D(a, b)/(IC(a) + IC(b))} which is the same as the \emph{Sim_Lin_1998} method
\item Garla: \code{1 - log(D(a, b) + 1)/log(2*IC_max + 1)}
\item log-Lin: \code{1 - log(D(a, b) + 1)/log(IC(a) + IC(b) + 1)}
\item Rada: \code{1/(1 + D(a, b))}
}

Paper link: \url{https://aclanthology.org/O97-1002/}.

There is a parameter \code{norm_method} which takes value in "max", "Couto", "Lin", "Carla", "log-Lin", "Rada":

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_Jiang_1997",
    control = list(norm_method = "Lin"))
}\if{html}{\out{</div>}}
}


\subsection{Sim_Kappa}{

Denote two sets \code{A} and \code{B} as the items annotated to term \code{a} and \code{b}. The similarity value is \href{https://en.wikipedia.org/wiki/Cohen\%27s_kappa}{the kappa coeffcient}
of the two sets.

The universe or the background can be set via parameter \code{anno_universe}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_kappa",
    control = list(anno_universe = ...))
}\if{html}{\out{</div>}}
}


\subsection{Sim_Jaccard}{

Denote two sets \code{A} and \code{B} as the items annotated to term \code{a} and \code{b}. The similarity value is the Jaccard coeffcient
of the two sets, defined as \code{length(intersect(A, B))/length(union(A, B))}.

The universe or the background can be set via parameter \code{anno_universe}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_Jaccard",
    control = list(anno_universe = ...))
}\if{html}{\out{</div>}}
}


\subsection{Sim_Dice}{

Denote two sets \code{A} and \code{B} as the items annotated to term \code{a} and \code{b}. The similarity value is the Dice coeffcient
of the two sets, defined as \code{2*length(intersect(A, B))/(length(A) + length(B))}.

The universe or the background can be set via parameter \code{anno_universe}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_Dice",
    control = list(anno_universe = ...))
}\if{html}{\out{</div>}}
}


\subsection{Sim_Overlap}{

Denote two sets \code{A} and \code{B} as the items annotated to term \code{a} and \code{b}. The similarity value is the overlap coeffcient
of the two sets, defined as \code{length(intersect(A, B))/min(length(A), length(B))}.

The universe or the background can be set via parameter \code{anno_universe}:

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_Overlap",
    control = list(anno_universe = ...))
}\if{html}{\out{</div>}}
}


\subsection{Sim_Ancestor}{

Denote \code{S_a} and \code{S_b} are two sets of ancestor terms of term \code{a} and \code{b} (including \code{a} and \code{b}), the
semantic similarity is defined as:

\if{html}{\out{<div class="sourceCode">}}\preformatted{length(intersect(S_a, S_b))/length(union(S_a, S_b))
}\if{html}{\out{</div>}}

\if{html}{\out{<div class="sourceCode">}}\preformatted{term_sim(dag, terms, method = "Sim_Ancestor")
}\if{html}{\out{</div>}}
}
}

\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
annotation = list(
    "a" = 1:3,
    "b" = 3:4,
    "c" = 5,
    "d" = 7,
    "e" = 4:7,
    "f" = 8
)
dag = create_ontology_DAG(parents, children, annotation = annotation)
term_sim(dag, dag_all_terms(dag), method = "Sim_Lin_1998")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructor.R
\name{create_ontology_DAG}
\alias{create_ontology_DAG}
\title{Create the ontology_DAG object}
\usage{
create_ontology_DAG(
  parents,
  children,
  relations = NULL,
  relations_DAG = NULL,
  source = "Ontology",
  annotation = NULL,
  remove_cyclic_paths = FALSE,
  remove_rings = FALSE,
  alternative_terms = list(),
  verbose = simona_opt$verbose
)
}
\arguments{
\item{parents}{A character vector of parent terms. You can also construct the \code{ontology_DAG} object by a list of parent-child links. See \strong{Examples}.}

\item{children}{A character vector of child terms.}

\item{relations}{A character vector of parent-child relations, e.g. "is_a", "part_of", or self-defined semantic relations.
If it is set, it should have the same length as \code{parents} and \code{children}.}

\item{relations_DAG}{If the relation types have hierarchical relations, it can also be constructed by \code{create_ontology_DAG()} first. See \strong{Examples}.
When the DAG for relation types is provided, the ancestor/offspring relationship of relation types will be taken into consideration automatically.}

\item{source}{Source of the ontology. It is only used as a label of the object.}

\item{annotation}{A list of character vectors which contain items annotated to the terms. Names of the list should be the term names. In the DAG, items
annotated to a term will also be annotated to its parents. Such merging
is applied automatically in the package.}

\item{remove_cyclic_paths}{Whether to remove cyclic paths If a cyclic path is represented as \verb{[a, b, ..., z, a]},
the last link (i.e. \code{z->a}) is simply removed. If the value is set to \code{FALSE} and if there are cyclic paths, there
will be an error that lists all cyclic paths.}

\item{remove_rings}{There might be rings that are isolated to the main DAG where there are no roots on the rings, thus they cannot be attached to the main DAG. If the value
of \code{remove_rings} is set to \code{TRUE}, such rings are removed.}

\item{alternative_terms}{A named list or vector that contains mappings from alternative term IDs to terms used in the DAG. In an ontology, there
might be old terms IDs marked as "replaced_by", "consider" or "alt_id" in ".obo" file. You can provide mappings from old term iDs to current term IDs with this argument.
If it is a one-to-one mapping, the mapping
can be a named vector where alternative term IDs are names and DAG term IDs are values. It it is a one-to-many mapping, the variable
should be a named list where each member vector will first be matched to the DAG terms. If the mapping is still one-to-many, the first one is selected.}

\item{verbose}{Whether to print messages.}
}
\value{
An \code{ontology_DAG} object.
}
\description{
Create the ontology_DAG object
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)

# with annotations
annotation = list(
    "a" = c("t1", "t2", "t3"),
    "b" = c("t3", "t4"),
    "c" = "t5",
    "d" = "t7",
    "e" = c("t4", "t5", "t6", "t7"),
    "f" = "t8"
)
dag = create_ontology_DAG(parents, children, annotation = annotation)

# with relations
dag = create_ontology_DAG(parents, children, 
    relations = c("is_a", "part_of", "is_a", "part_of", "is_a", "part_of"))

# with relations_DAG
relations_DAG = create_ontology_DAG(c("r2", "r2"), c("r3", "r4"))
dag = create_ontology_DAG(parents, children, 
    relations = c("r1", "r2", "r1", "r3", "r1", "r4"),
    relations_DAG = relations_DAG)

# with a list of parent-child relations
dag = create_ontology_DAG(c("a-b", "a-c", "b-c", "b-d", "c-e", "e-f"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructor.R
\name{dag_root}
\alias{dag_root}
\alias{dag_leaves}
\alias{dag_is_leaf}
\title{Root or leaves of the DAG}
\usage{
dag_root(dag, in_labels = TRUE)

dag_leaves(dag, in_labels = TRUE)

dag_is_leaf(dag, terms)
}
\arguments{
\item{dag}{An \code{ontology_DAG} object.}

\item{in_labels}{Whether the terms are represented in their names or as integer indices?}

\item{terms}{A vector of term names.}
}
\value{
A character or an integer vector.
}
\description{
Root or leaves of the DAG
}
\examples{
parents  = c("a", "a", "b", "b", "c", "d")
children = c("b", "c", "c", "d", "e", "f")
dag = create_ontology_DAG(parents, children)
dag_root(dag)
dag_leaves(dag)
}
